/* 
 * $COPYRIGHT$
 * $Id: CameleonJavaAttribute.java,v 1.2 2001/12/01 20:18:28 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8;


import org.media.mn8.event.*;
import org.media.mn8.concepts.*;

import java.lang.reflect.Field;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2001/12/01 20:18:28 $
 */
public class CameleonJavaAttribute extends FieldConcept {

    private int _cameleonConceptPosition;
    private String _conceptType = null;
    private FieldConcept _originalField = null;
    
    public CameleonJavaAttribute() {}


    public CameleonJavaAttribute ( String conceptType,
                                   int conceptPosition,
                                   FieldConcept attribute ) {
        _name = attribute.getName();
        _label = attribute.getLabel();
        _isStatic = attribute.isStatic();
        _conceptType = conceptType;
        _initialValue = attribute.getInitialValue();
        _field = attribute.getField();
        _cameleonConceptPosition = conceptPosition;
        _originalField = attribute;
    }


    public Concept getValue( Concept on ) {
        if ( on instanceof mn8Concept && _conceptType.equals( on.getConceptType().toString() )) {
            return super.getValue( ((mn8Concept) on).getCameleonConcept( _cameleonConceptPosition));
        }
        else 
            return super.getValue( on);
    }


     public void setValue( Concept on, Concept value) {
        if ( on instanceof mn8Concept && _conceptType.equals( on.getConceptType().toString() )) {
            super.setValue( ((mn8Concept) on).getCameleonConcept( _cameleonConceptPosition), value);
        }
        else 
            super.setValue( on, value);
     }


    public Concept newInstance() {
        return _originalField.newInstance();
    }

}
