/* 
 * $COPYRIGHT$
 * $Id: CameleonJavaElement.java,v 1.1 2001/11/15 20:33:19 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8;


import org.media.mn8.event.*;
import org.media.mn8.concepts.*;

import java.lang.reflect.Field;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.1 $ $Date: 2001/11/15 20:33:19 $
 */
public class CameleonJavaElement extends FieldConcept {

    private int _cameleonConceptPosition;
    private String _conceptType = null;

    
    public CameleonJavaElement() {}


    public CameleonJavaElement ( String conceptType,
                                 int conceptPosition,
                                 FieldConcept element ) {
        _name = element.getName();
        _label = element.getLabel();
        _isStatic = element.isStatic();
        _conceptType = conceptType;
        _initialValue = element.getInitialValue();
        _field = element.getField();
        _cameleonConceptPosition = conceptPosition;
        
    }


    public Concept getValue( Concept on ) {
        if ( on instanceof mn8Concept && _conceptType.equals( on.getConceptType().toString() )) {
            return super.getValue( ((mn8Concept) on).getCameleonConcept( _cameleonConceptPosition));
        }
        else 
            return super.getValue( on);
    }


     public void setValue( Concept on, Concept value) {
        if ( on instanceof mn8Concept && _conceptType.equals( on.getConceptType().toString() )) {
            super.setValue( ((mn8Concept) on).getCameleonConcept( _cameleonConceptPosition), value);
        }
        else 
            super.setValue( on, value);
     }
}
