/* 
 * $COPYRIGHT$
 * $Id: ConceptConceptDefinition.java,v 1.23 2002/05/02 18:29:11 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8;


import org.media.mn8.concepts.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.23 $ $Date: 2002/05/02 18:29:11 $
 */
public class ConceptConceptDefinition extends ConceptDefinition {
    
    private static StringConcept _type = new StringConcept("Concept");
    private static StringConcept _label = new StringConcept("");
    private static SeriesConcept _inheritedConcepts = new SeriesConcept();
    private static Concept _errorHandler = null;
    private static ConceptConceptDefinition _reference = new ConceptConceptDefinition();
    
    protected ConceptConceptDefinition() {
        try {

            putOperator(new mn8JavaMethod("org.media.mn8.JavaConcept", false,
                                        "opEQ:org.media.mn8.concepts.NilConcept",
                                        "==:Nil", "Concept", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.JavaConcept", false,
                                        "create:",
                                        "create:", "Concept", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.JavaConcept", false,
                                        "toXML:",
                                        "toXML:", "Concept", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.Concept", false,
                                        "cloneConcept:",
                                        "cloneConcept:", "Concept", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.JavaConcept", false,
                                        "toTXT:",
                                        "toTXT:", "Concept", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.JavaConcept", false,
                                        "equals:org.media.mn8.Concept",
                                        "equals:Concept", "Concept", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptConceptDefinition", true,
                                        "getConceptType:",
                                        "getConceptType:", "Concept", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptConceptDefinition", true,
                                        "getConceptLabel:",
                                        "getConceptLabel:", "Concept", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.Concept", false,
                                        "setConceptLabel:org.media.mn8.concepts.StringConcept",
                                        "setConceptLabel:String", "Concept", null));
            
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptMethods:",
                                        "getConceptMethods:", "Concept", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptMethod:org.media.mn8.concepts.StringConcept",
                                        "getConceptMethod:String", "Concept", "Method"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptOperators:",
                                        "getConceptOperators:", "Concept", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptConstructors:",
                                        "getConceptConstructors:", "Concept", "Series"));
            
            /*                             ATTRIBUTE Related                                    */

            // STATIC getConceptAttributeFields: TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptAttributeFields:",
                                        "getConceptAttributeFields:", "Concept", "Series"));

            // STATIC getConceptAttributeField:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptAttributeField:org.media.mn8.concepts.StringConcept",
                                        "getConceptAttributeField:String", "Concept", "Concept"));

            // getConceptAttribute:String TYPEOF Attribute
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "getConceptAttribute:org.media.mn8.concepts.StringConcept",
                                        "getConceptAttribute:String", "Concept", "Concept"));

            // getConceptAttributes: TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "getConceptAttributes:",
                                        "getConceptAttributes:", "Concept", "Series"));

            // STATIC hasConceptAttribute:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "hasConceptAttribute:org.media.mn8.concepts.StringConcept",
                                        "hasConceptAttribute:String", "Concept", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "getConceptElements:",
                                        "getConceptElements:", "Concept", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "hasConceptElement:org.media.mn8.concepts.StringConcept",
                                        "hasConceptElement:String", "Concept", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "hasConceptMethod:org.media.mn8.concepts.StringConcept",
                                        "hasConceptMethod:String", "Concept", "Logical"));

            // STATIC getConceptElementFields: TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptElementFields:",
                                        "getConceptElementFields:", "Concept", "Series"));

            // STATIC getConceptElementField:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptElementField:org.media.mn8.concepts.StringConcept",
                                        "getConceptElementField:String", "Concept", "Concept"));


            // getConceptElement:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "getConceptElement:org.media.mn8.concepts.StringConcept",
                                        "getConceptElement:String", "Concept", "Concept"));

            // hasPath:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.Concept", false,
                                        "hasPath:org.media.mn8.concepts.StringConcept",
                                        "hasPath:String", "Concept", "Logical"));

            // getConceptsAtPath:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "getConceptsAtPath:org.media.mn8.concepts.StringConcept",
                                        "getConceptsAtPath:String", "Concept", "Series"));


            // getInheritedConcepts: TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptConceptDefinition", true,
                                        "getInheritedConcepts:",
                                        "getInheritedConcepts:", "Concept", "Series"));

            // getAllInheritedConcepts: TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getAllInheritedConcepts:",
                                        "getAllInheritedConcepts:", "Concept", "Series"));
            
            // extends:Concept TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "extendsConcept:org.media.mn8.concepts.StringConcept",
                                        "extendsConcept:String", "Concept", "Logical"));

            // loadContent:Concept TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "loadContent:org.media.mn8.Concept",
                                        "loadContent:Concept", "Concept", null));

            // fromXML:String TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptConceptDefinition", true,
                                        "fromXML:org.media.mn8.concepts.StringConcept",
                                        "fromXML:String", "Concept", "Concept"));

            // isHidden: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "isHidden:",
                                        "isHidden:", "Concept", "Logical"));

            // setHidden:Logical
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "setHidden:org.media.mn8.concepts.LogicalConcept",
                                        "setHidden:Logical", "Concept", null));            

            // showEmpty: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "showEmpty:",
                                        "showEmpty:", "Concept", "Logical"));

            // setShowEmpty:Logical
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "setShowEmpty:org.media.mn8.concepts.LogicalConcept",
                                        "setShowEmpty:Logical", "Concept", null));            
            
            // setErrorHandler:String 
            putMethod(new mn8JavaMethod("org.media.mn8.Concept", 
                                        "setErrorHandler:org.media.mn8.Concept",
                                        "setErrorHandler:Concept", "Concept", null));

            // getErrorHandler: TYPEOF Concept 
            putMethod(new mn8JavaMethod("org.media.mn8.Concept", 
                                        "getErrorHandler:",
                                        "getErrorHandler:", "Concept", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptConceptDefinition", true,
                                        "setErrorHandler:org.media.mn8.Concept",
                                        "setErrorHandler:Concept", "Concept", null));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptConceptDefinition", true,
                                        "getErrorHandler:",
                                        "getErrorHandler:", "Concept", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "printFields:",
                                        "printFields:", "Concept", null));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }




    public Concept fromXML(StringConcept xmlDocument) {
        mn8XMLReader reader = new mn8XMLReader();
        ElementConcept flex = reader.getFlexFromXML(xmlDocument);

        if( mn8RuntimeFlags.isDebug()) {
            System.err.println("Loading XML from string:");
	    //            flex.printFields("", flex); // used only for testing
        }
        if(! (getConceptType().toString().equalsIgnoreCase("element") ||
              getConceptType().toString().equalsIgnoreCase("concept"))) {
            Concept instance = mn8Loader.instantiateConcept(getConceptType().toString());
            instance.loadContent(flex);
            return instance;
        }
        return flex;
    }


    public Concept getConceptInstance() {
        return new JavaConcept();
    }


    public StringConcept getConceptLabel() {
        return _label;
    }


    public static void setErrorHandler( Concept handler ) {
        _errorHandler = handler;
    }
    

    public static Concept getErrorHandler() {
        return _errorHandler;
    }

    public StringConcept getConceptType() {
        return _type;
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }

}
