/* 
 * $COPYRIGHT$
 * $Id: DummyFieldConcept.java,v 1.3 2002/02/03 19:24:20 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8;


import org.media.mn8.event.*;
import org.media.mn8.concepts.*;

import java.lang.reflect.Field;

/** 
 * It's a dummy concept representation of a Field. Used especially
 * to create elements or attributes for an concept run time. As an 
 * example, in a Series concept element added to the Series can be
 * accessed also as valid elements $i/1,$i/2 even if they are not
 * valid elements.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/02/03 19:24:20 $
 */
public class DummyFieldConcept extends FieldConcept {
    
    protected Concept _value = null;
    protected boolean _isElement = true;
    
    public DummyFieldConcept() {}


    public DummyFieldConcept ( String name,
                               Concept value,
                               boolean isStatic,
                               String label,
                               String type) {                         
        _name = name;
        _value = value;
        _isStatic = isStatic;
        _label = label;
        _conceptType = type;
        _initialValue = value;
    }


    public DummyFieldConcept ( String name,
                               Concept value,
                               boolean isStatic,
                               String label,
                               String type,
                               boolean isElement) {
        this(name, value, isStatic, label, type);
        _isElement = isElement;
    }


    public boolean isAttribute() {
        return !_isElement;
    }
    

    public boolean isElement() {
        return _isElement;
    }


    public Concept getValue( Concept on ) {
        return _value;
    }


    public void setValue( Concept on, Concept value) {
        _value = value;
    }
}
