/* 
 * $COPYRIGHT$
 * $Id: Eacher.java,v 1.2 2002/03/25 14:48:23 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8;


import org.media.mn8.concepts.*;
import org.media.mn8.event.*;
import org.media.mn8.parser.mn8TreeWalker;
import java.util.Vector;
import antlr.collections.AST;
import antlr.RecognitionException;

/** 
 * Helping with the each blocks.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/03/25 14:48:23 $
 */
public class Eacher {
    Vector _elements = null;
    long _idxPos;
    mn8TreeWalker _walker = null;
    boolean _isLastItem = false;
    AST _ident = null;
    int _curentIndex;
    Series _in = null;
    AST _block = null;
    Vector _breakExpr = null;

    public Eacher (Vector elements, long idxPos, 
                   mn8TreeWalker walker, AST ident,
                   Series in, AST block, Vector breakExpr ) {
        _elements = elements;
        _idxPos = idxPos;
        _walker = walker;
        _ident  = ident;
        _in = in;
        _block = block;
        _breakExpr = breakExpr;
    }
    

    public void doEachBlock() throws RecognitionException {
        Concept result;

        for(int cnt = 0; cnt < _elements.size();  cnt ++ ){
            _in.next();
            if( cnt == _elements.size() -1 ) _isLastItem = true;
            result = (Concept)_elements.elementAt(cnt);
            _walker.getStack().insertInstance( _ident.getText(), (Concept)result);
            _curentIndex = cnt;
            _walker.statementBlock(_block);
        }
        _in.setIndex(_idxPos);
        _walker.cleanFirstOfTableElements( _breakExpr );
        _isLastItem = false;
    }


    public boolean isLastItem() {
        return _isLastItem;
    }


    public long getCurentIndex() {
       return  _curentIndex;
    }
}
