/* 
 * $COPYRIGHT$
 * $Id: JavaConcept.java,v 1.20 2002/04/29 17:13:40 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8;


import java.util.Vector;
import java.util.Hashtable;

import org.media.mn8.concepts.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.20 $ $Date: 2002/04/29 17:13:40 $
 */
public class JavaConcept extends Concept  {


    public Concept create() {
        return this;
    }

    public boolean equals(Object obj) {
        if( obj instanceof org.media.mn8.JavaConcept ) {
            return equals( (Concept) obj ).getValue() ;
        }
        return false;
    }

    public LogicalConcept opEQ(NilConcept value) {
        if( getConceptDefinition().getConceptType().toString().equalsIgnoreCase("nil")) {
            return new LogicalConcept(true);
        } else {
            return new LogicalConcept(false);
        }
    }

    public LogicalConcept equals( Concept target ) {
        Vector myElements = getConceptElements().getVector();
        Vector trgElements = target.getConceptElements().getVector();
        Vector myAttributes = getConceptAttributes().getVector(); 
        Vector trgAttributes = target.getConceptAttributes().getVector();
        String myLabel = getConceptLabel().toString();
        String trgLabel = target.getConceptLabel().toString();
        if ( !myLabel.equals(trgLabel) ) return new LogicalConcept( false );
        if ( !myAttributes.equals( trgAttributes) ) return new LogicalConcept(false);
        if ( !myElements.equals(trgElements ) ) return new LogicalConcept(false);
        return new LogicalConcept( true );
    }


    public StringConcept toXML() {
        if( isHidden().getValue() ) {
            return new StringConcept();
        }

        String name = getConceptLabel().toString();

        StringBuffer value = new StringBuffer();
        Vector elements = getConceptElements().getVector();
        String elValue = null;
        for(int i =0 ; i < elements.size(); i++) { 
            Concept concept  = (Concept) elements.elementAt(i);
            mn8Method method = concept.getConceptDefinition().getConceptMethod("toXML:");            
            elValue = method.invoke(concept, null).toString();
            if( !elValue.trim().equals("")) {
                value.append( elValue  + mn8Interpreter.EOL);
            }
        }
        String result = "";
        
        if( !showEmpty().getValue() && value.toString().trim().equals("") 
            && getConceptAttributes().toXML().toString().trim().equals("")) {
            return new StringConcept();
        }
        
        result= "<" + name + getConceptAttributes().toXML().toString() + ">"; 
        if(  Helper.hasEOL(value.toString())) {
            result += mn8Interpreter.EOL;
        }
        result += value.toString();
        result += "</" + name + ">";
        return new StringConcept(result);
    }


    public StringConcept toTXT() {

        if( isHidden().getValue() ) {
            return new StringConcept();
        }

        String name = getConceptLabel().toString();

        StringBuffer value = new StringBuffer();
        Vector elements = getConceptElements().getVector();

        for(int i =0 ; i < elements.size(); i++) {
            value.append( ((Concept) elements.elementAt(i)).toTXT().toString() + mn8Interpreter.EOL);
        }

        if( !showEmpty().getValue() && value.toString().trim().equals("")
            && getConceptAttributes().toXML().toString().trim().equals("")) {

            return new StringConcept();
        }

        String result = "";
        
        result= name + mn8Interpreter.EOL + getConceptAttributes().toTXT().toString() + mn8Interpreter.EOL; 
        result += value.toString();
        return new StringConcept(result);
    }
    

    public ConceptDefinition getConceptDefinition() {
        return ConceptConceptDefinition.getReference();
    }


    public Object clone() {
        return new JavaConcept();
    }
}

