/* 
 * $COPYRIGHT$
 * $Id: AttributeDefinition.java,v 1.6 2002/04/17 16:21:22 atech Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.6 $ $Date: 2002/04/17 16:21:22 $
 */

public class AttributeDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private AttributeDefinition _reference = new AttributeDefinition();
    
    private AttributeDefinition() {
        super();
        try {            
            // create:String,Concept TYPEOF Element
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                        "create:org.media.mn8.concepts.StringConcept,org.media.mn8.Concept",
                                        "create:String,Concept", "Attribute", "Attribute"));

            // getName: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                        "getName:",
                                        "getName:", "Attribute", "String"));

            // getLabel: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                        "getLabel:",
                                        "getLabel:", "Attribute", "String"));

            // setLabel:String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                        "setLabel:org.media.mn8.concepts.StringConcept",
                                        "setLabel:String", "Attribute", null));

            // getValue: TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                        "getValue:",
                                        "getValue:", "Attribute", "Concept"));

            // getValueType: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                        "getValueType:",
                                        "getValueType:", "Attribute", "String"));

            // setValue:Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                        "setValue:org.media.mn8.Concept",
                                        "setValue:Concept", "Attribute", null));

            // toXML: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                        "toXML:",
                                        "toXML:", "Attribute", "String"));

            // equals:Attribute TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                        "equals:org.media.mn8.concepts.AttributeConcept",
                                        "equals:Attribute", "Attribute", "Logical"));

           // ==:Attribute TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.AttributeConcept",
                                          "opEquals:org.media.mn8.concepts.AttributeConcept",
                                          "==:Attribute", "Attribute", "Logical"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new AttributeConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Attribute");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Attribute");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }

}


