/* 
 * $COPYRIGHT$
 * $Id: AttributeSeries.java,v 1.3 2002/02/26 14:15:58 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import org.media.mn8.util.SimpleExpression;

import java.util.Vector;
import java.util.Enumeration;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/02/26 14:15:58 $
 */
public class AttributeSeries extends SeriesConcept{
    
    public AttributeSeries() {}

    public AttributeSeries( Vector values ) {
        _contents = values;
        _length.setValue( values.size() );        
        updateNameCache();
        updateNavigationFans();
    }


    public StringConcept toTXT() {

        if( isHidden().getValue() ) {
            return new StringConcept();
        }

        StringBuffer buffer = new StringBuffer();
        String atVal = null;
        for( int cnt = 0 ; cnt < _contents.size() ; cnt ++) {
            atVal = ((Concept)_contents.elementAt(cnt)).toTXT().toString();
            if( !atVal.trim().equals("") ) {
                buffer.append("\t");
                buffer.append(atVal);
            }
        }

        if( showEmpty().getValue() && buffer.toString().trim().equals("") ) {
            return new StringConcept();
        }

        return new StringConcept(buffer.toString());
    }



    public StringConcept toXML() {

        if( isHidden().getValue() ) {
            return new StringConcept();
        }

        StringBuffer buffer = new StringBuffer();
        String atVal = null;
        for( int cnt = 0 ; cnt < _contents.size() ; cnt ++) {
            atVal = ((Concept)_contents.elementAt(cnt)).toXML().toString();
            if( !atVal.trim().equals("") ) {
                buffer.append( " ");
                buffer.append( atVal );
            }
        }

        if( showEmpty().getValue() && buffer.toString().trim().equals("") ) {
            return new StringConcept();
        }

        return new StringConcept(buffer.toString());
    }

    
    public Object clone() {
        return new AttributeSeries( (Vector)_contents.clone() );
    }
}


