/*
 * $COPYRIGHT$
 * $Id: BEEPClientConceptDefinition.java,v 1.3 2002/02/20 13:05:56 crow Exp $
 *
 * Date        Author            Changes
 * IAN 24 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;
       
import org.media.mn8.*;
import org.media.mn8.event.*;
       
/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.3 $ $Date: 2002/02/20 13:05:56 $
 */
 
public class BEEPClientConceptDefinition extends ConceptConceptDefinition {
 
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private BEEPClientConceptDefinition _reference = new BEEPClientConceptDefinition();
	 
	 
    private BEEPClientConceptDefinition() {
        super();
        try {
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.BEEPClientConcept", false,
                                         "create:org.media.mn8.concepts.StringConcept",
                                         "create:String", "BEEPClient", "BEEPClient" ) );

            putMethod( new mn8JavaMethod("org.media.mn8.concepts.BEEPClientConcept", 
                                         "execute:org.media.mn8.concepts.StringConcept",
                                         "execute:String", "BEEPClient", "String" ) );
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
						 
    
    public static ConceptDefinition getReference() {
        return _reference;
    }
								 
				 
    public Concept getConceptInstance() {
        return new BEEPClientConcept();
    }
										 

    public StringConcept getConceptLabel() {
        return new StringConcept("BEEPClient");
    }
												 
												 
    public StringConcept getConceptType() {
        return new StringConcept("BEEPClient");
    }
    
    
    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
