/* 
 * $COPYRIGHT$
 * $Id: BEEPHandlerDefinition.java,v 1.5 2002/05/20 10:57:29 neuro Exp $
 *
 * Date        Author           Changes 
 * IAN 24 2002 Szabo Csaba      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URL;
import java.net.MalformedURLException;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.5 $ $Date: 2002/05/20 10:57:29 $
 */
public class BEEPHandlerDefinition extends URIHandlerDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private BEEPHandlerDefinition _reference = new BEEPHandlerDefinition();
    
    protected BEEPHandlerDefinition () {
        super();
        try {            
            _inheritedConcepts.add( new StringConcept("URIHandler") );

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.BEEPHandler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "BEEPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.BEEPHandler",
                                        "closeConnection:",
                                        "closeConnection:", "BEEPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.BEEPHandler",
                                        "openConnection:",
                                        "openConnection:", "BEEPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.BEEPHandler",
                                        "getContent:",
                                        "getContent:", "BEEPHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.BEEPHandler",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "BEEPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.BEEPHandler", 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "BEEPHandler", "BEEPHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.BEEPHandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "BEEPHandler", "Logical"));
        
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }


    public LogicalConcept acceptsURI( StringConcept uri ) {
        try {
            URL url = new URL( uri.toString() );
            if( url.getProtocol().equalsIgnoreCase("beep"))
                return new LogicalConcept(true);
            else 
                return new LogicalConcept(false);
        } catch (MalformedURLException ex) {
            // we might be in Tomcat and the costom uri's don't work
            if( uri.toString().toLowerCase().startsWith("beep:")){
                return new LogicalConcept(true);
            }
        }
        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new BEEPHandler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("BEEPHandler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("BEEPHandler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
