/* 
 * $COPYRIGHT$
 * $Id: CharacterDefinition.java,v 1.4 2002/04/28 14:50:05 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.4 $ $Date: 2002/04/28 14:50:05 $
 */
public class CharacterDefinition extends ConceptConceptDefinition {

    private static StringConcept _characterType = new StringConcept("Character");
    private static StringConcept _characterLabel = new StringConcept("Character");
    private static SeriesConcept _characterInheritedConcepts = new SeriesConcept();
    static private CharacterDefinition _reference = new CharacterDefinition();

    private CharacterDefinition() {
        super();
        try {            
            _characterInheritedConcepts.add(new StringConcept("Concept"));

            Class _class = Class.forName("org.media.mn8.concepts.CharacterConcept");
            putMethod(new mn8JavaMethod(_class.getDeclaredMethod("toStringConcept", null), 
                                        null, "Character", "String"));

            // +:Character TYPEOF String
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "opPlus:org.media.mn8.concepts.CharacterConcept",
                                          "+:Character", "Character", "String"));
            // ==:Character TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "opEquals:org.media.mn8.concepts.CharacterConcept",
                                          "==:Character", "Character", "Logical"));

            // <:Character TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "opLT:org.media.mn8.concepts.CharacterConcept",
                                          "<:Character", "Character", "Logical"));

            // >:Character TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "opGT:org.media.mn8.concepts.CharacterConcept",
                                          ">:Character", "Character", "Logical"));

            // +:Nil TYPEOF Character
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "opPlus:org.media.mn8.concepts.NilConcept",
                                          "+:Nil", "Character", "Character"));

            // isDigit: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "isDigit:",
                                          "isDigit:", "Character", "Logical"));

            // isLetter: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "isLetter:",
                                          "isLetter:", "Character", "Logical"));

            // isLetterOrDigit: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "isLetterOrDigit:",
                                          "isLetterOrDigit:", "Character", "Logical"));

            // isWhitespace: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "isWhitespace:",
                                          "isWhitespace:", "Character", "Logical"));

            // isControl: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "isControl:",
                                          "isControl:", "Character", "Logical"));

            // isLowerCase: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "isLowerCase:",
                                          "isLowerCase:", "Character", "Logical"));

            // toLowerCase: TYPEOF Character
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "toLowerCase:",
                                          "toLowerCase:", "Character", "Character"));

            // isUpperCase: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "isUpperCase:",
                                          "isUpperCase:", "Character", "Logical"));

            // toUpperCase: TYPEOF Character
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "toUpperCase:",
                                          "toUpperCase:", "Character", "Character"));

            // getEOLChar: TYPEOF Character
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterDefinition", true, 
                                        "getEOLChar:",
                                        "getEOLChar:", "Character", "String"));

            // getNumericValue: TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "getUnicodeNumericValue:",
                                          "getUnicodeNumericValue:", "Character", "Integer"));

            // toIntegerConcept: TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "toIntegerConcept:",
                                          "toIntegerConcept:", "Character", "Integer"));

            // getType: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CharacterConcept",
                                          "getType:",
                                          "getType:", "Character", "String"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new CharacterConcept();
    }


    public StringConcept getEOLChar() {
        return new StringConcept(mn8Interpreter.EOL);
    }


    public StringConcept getConceptLabel() {
        return _characterLabel;
    }


    public StringConcept getConceptType() {
        return _characterType;
    }


    public SeriesConcept getInheritedConcepts() {
        return _characterInheritedConcepts;
    }

}

