/* 
 * $COPYRIGHT$
 * $Id: CookieDefinition.java,v 1.4 2002/05/28 15:58:06 atech Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import org.media.mn8.protocol.http.*;
import java.io.File;
import java.util.Vector;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.4 $ $Date: 2002/05/28 15:58:06 $
 */
public class CookieDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private CookieDefinition _reference = new CookieDefinition();
    
    private CookieDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.CookieConcept");


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "toXML:",
                                        "toXML:", "Cookie", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "setName:org.media.mn8.concepts.StringConcept",
                                        "setName:String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "setValue:org.media.mn8.concepts.StringConcept",
                                        "setValue:String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "setDomain:org.media.mn8.concepts.StringConcept",
                                        "setDomain:String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "setPath:org.media.mn8.concepts.StringConcept",
                                        "setPath:String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "setExpires:org.media.mn8.concepts.StringConcept",
                                        "setExpires:String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "setSecure:org.media.mn8.concepts.StringConcept",
                                        "setSecure:String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "toTXT:",
                                        "toTXT:", "Cookie", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "storeCookie:",
                                        "storeCookie:", "Cookie", null));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept",
                                        "saveCookie:org.media.mn8.concepts.StringConcept",
                                        "saveCookie:String", "Cookie", null));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept", 
                                        "create:",
                                        "create:", "Cookie", "Concept"));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieConcept", 
                                        "create:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "create:String,String", "Cookie", "Cookie"));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieDefinition", true,
                                        "convertNetscapeCookies:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "convertNetscapeCookies:String,String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieDefinition", true,
                                        "convertExplorerCookies:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "convertExplorerCookies:String,String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieDefinition", true,
                                        "convertOperaCookies:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "convertOperaCookies:String,String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieDefinition", true,
                                        "convertKonquerorCookies:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "convertKonquerorCookies:String,String", "Cookie", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieDefinition", true,
                                        "getCookiesFromDB:org.media.mn8.concepts.StringConcept",
                                        "getCookiesFromDB:String", "Cookie", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.CookieDefinition", true,
                                        "getCookieString:org.media.mn8.concepts.StringConcept",
                                        "getCookieString:String", "Cookie", "String"));

            putAttribute(new FieldConcept("domain", _class.getDeclaredField("domain"),
                                          false, "domain", "String", null));

            putAttribute(new FieldConcept("name", _class.getDeclaredField("name"),
                                          false, "name", "String", null));

            putAttribute(new FieldConcept("value", _class.getDeclaredField("value"),
                                          false, "value", "String", null));

            putAttribute(new FieldConcept("path", _class.getDeclaredField("path"),
                                          false, "path", "String", null));

            putAttribute(new FieldConcept("expires", _class.getDeclaredField("expires"),
                                          false, "expires", "String", null));

            putAttribute(new FieldConcept("secure", _class.getDeclaredField("secure"),
                                          false, "secure", "String", null));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    

    public static void convertNetscapeCookies(StringConcept cookieFile, StringConcept cookieDir) {
        DefaultCookie cook = new NetscapeCookie();
        cook.writeCookiesToXML(cookieFile.toString(), cookieDir.toString());
    }


    public static void convertExplorerCookies(StringConcept cookieFile, StringConcept cookieDir) {
        DefaultCookie cook = new ExplorerCookie();
        cook.writeCookiesToXML(cookieFile.toString(), cookieDir.toString());
    }


    public static void convertOperaCookies(StringConcept cookieFile, StringConcept cookieDir) {
        DefaultCookie cook = new OperaCookie();
        cook.writeCookiesToXML(cookieFile.toString(), cookieDir.toString());
    }


    public static void convertKonquerorCookies(StringConcept cookieFile, StringConcept cookieDir) {
        DefaultCookie cook = new KonquerorCookie();
        cook.writeCookiesToXML(cookieFile.toString(), cookieDir.toString());
    }


    public SeriesConcept getCookiesFromDB(StringConcept uri) {
        if( uri == null || uri.toString() ==null ) return new SeriesConcept();

        String cookiedb = CookieConcept.COOKIE_DB;
        SeriesConcept result = new SeriesConcept();
        Vector cook = (new Cookie()).readCookiesFromXML( uri.toString(), cookiedb, false);
        for( int i =0 ; i < cook.size(); i++ ) {
            result.add( new CookieConcept((Cookie) cook.elementAt(i)));
        }
        return result;
    }


    public StringConcept getCookieString( StringConcept uri) {
        String cookiedb = CookieConcept.COOKIE_DB;
        return new StringConcept( (new Cookie()).getCookieString( uri.toString(), cookiedb, false));
    }
   

    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new CookieConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Cookie");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Cookie");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



