/*
 * $COPYRIGHT$
 * $Id: CronDefinition.java,v 1.4 2002/05/21 14:10:50 neuro Exp $
 *
 * Date        Author            Changes
 * May 16 2002 Antal Attila      Created
 */

package org.media.mn8.concepts;
       
import org.media.mn8.*;
import org.media.mn8.event.*;
       
/**
 * @author <a href="mailto:atech@nolimits.ro">Antal Attila</a>
 * @version $Revision: 1.4 $ $Date: 2002/05/21 14:10:50 $
 */
 
public class CronDefinition extends ConceptConceptDefinition {
 
    static private SeriesConcept  _inheritedConcepts = new SeriesConcept("Concept");
    static private CronDefinition _reference = new CronDefinition();
	 
	 
    private CronDefinition() {
        super();
        try {
            Class _class = Class.forName("org.media.mn8.concepts.CronConcept");

            //getInstance:
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.CronConcept", true,
                                         "getInstance:",
                                         "getInstance:", "Cron", "Cron" ) );

            //addTask:String, String 
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.CronConcept", true,
                                         "addTask:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "addTask:String,String", "Cron", "Integer" ) );

            //getTasks:
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.CronConcept", true,
                                         "getTasks:",
                                         "getTasks:", "Cron", "Series" ) );

            //removeTask:Integer
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.CronConcept", true, 
                                         "removeTask:org.media.mn8.concepts.IntegerConcept",
                                         "removeTask:Integer", "Cron", null ) );

            //start:
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.CronConcept", true,
                                         "start:",
                                         "start:", "Cron", null ) );
            //stop:
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.CronConcept", true,
                                         "stop:",
                                         "stop:", "Cron", null ) );
            
            //will be contain the tasks that you will be addedwit addTask
            putElement( new FieldConcept( "task", _class.getDeclaredField("task"), 
                                          false, "task", "Series", null ) );
            
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }
    
    
    public Concept getConceptInstance() {
        return CronConcept.getInstance();
    }
    
    
    public StringConcept getConceptLabel() {
        return new StringConcept("Cron");
    }
												 
												 
    public StringConcept getConceptType() {
        return new StringConcept("Cron");
    }
    
    
    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
