/*
 * $COPYRIGHT$
 * $Id: DSClientDefinition.java,v 1.4 2002/06/03 14:43:31 crow Exp $
 *
 * Date        Author            Changes
 * FEB 11 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;
       
import org.media.mn8.*;
import org.media.mn8.event.*;
       
/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.4 $ $Date: 2002/06/03 14:43:31 $
 */
 
public class DSClientDefinition extends ConceptConceptDefinition {
 
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private DSClientDefinition    _reference = new DSClientDefinition();
	 
	 
    private DSClientDefinition() {
        super();
        try {

            //connect to specified HOST and PORT
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "create:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "create:String,String", "DSClient", "DSClient" ) );

            //connect to specified HOST and default PORT(10288)
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "create:org.media.mn8.concepts.StringConcept",
                                         "create:String", "DSClient", "DSClient" ) );
            
            //connect to default HOST(localhost) and PORT(10288)
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "create:",
                                         "create:", "DSClient", "DSClient" ) );
            
            //login to specified DBNAME with specified USER and PASSWD
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "login:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.StringConcept",
                                         "login:String,String,String", "DSClient", "Logical" ) );

            //login to specified DBNAME with default USER(guest) and PASSWD(guest)
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "login:org.media.mn8.concepts.StringConcept",
                                         "login:String", "DSClient", "Logical" ) );

            //logout form DataStore server.
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "logout:",
                                         "logout:", "DSClient", "Logical" ) );

            
            //chmod for specified document
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "chmod:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.LogicalConcept",
                                         "chmod:String,String,Logical", "DSClient", "DSResponse" ) );
            
            //chown for specified document
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "chown:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.LogicalConcept",
                                         "chown:String,String,Logical", "DSClient", "DSResponse" ) );
            
            //create specified subtree
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "makeSubtree:org.media.mn8.concepts.StringConcept",
                                         "makeSubtree:String", "DSClient", "DSResponse" ) );
            //remove specified subtree
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "removeSubtree:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.LogicalConcept",
                                         "removeSubtree:String,Logical", "DSClient", "DSResponse" ) );
            
            //list specified subtree
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "list:org.media.mn8.concepts.StringConcept",
                                         "list:String", "DSClient", "DSResponse" ) );

            //copy specified subtree to specified destination
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "copy:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.LogicalConcept",
                                         "copy:String,String,Logical", "DSClient", "DSResponse" ) );
            
            //move specified subtree to specified destination
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "move:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "move:String,String", "DSClient", "DSResponse" ) );
	    
            //change storeType for specified subtree 
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "changeStoreType:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.LogicalConcept",
                                         "changeStoreType:String,String,Logical", "DSClient", "DSResponse" ) );

            //set namingFlag for specified subtree 
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "setNamingFlag:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.LogicalConcept",
                                         "setNamingFlag:String,String,Logical", "DSClient", "DSResponse" ) );
            
            //add specified group to DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "addGroup:org.media.mn8.concepts.StringConcept",
                                         "addGroup:String", "DSClient", "DSResponse" ) );
	    
            //modify specified groupName
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "modGroup:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "modGroup:String,String", "DSClient", "DSResponse" ) );
            
            //remove specified group from DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "delGroup:org.media.mn8.concepts.StringConcept",
                                         "delGroup:String", "DSClient", "DSResponse" ) );
            
            //list specified group to DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "listGroup:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "listGroup:String,String", "DSClient", "DSResponse" ) );
            
            //add specified USER to DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "addUser:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.StringConcept",
                                         "addUser:String,String,String,String,String", "DSClient", "DSResponse" ) );

            //modify specified USER to DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "modUser:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "modUser:String,String,String,String,String,String", "DSClient", "DSResponse" ) );

            //remove specified USER from DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "delUser:org.media.mn8.concepts.StringConcept",
                                         "delUser:String", "DSClient", "DSResponse" ) );

            //list specified USER from DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "listUser:org.media.mn8.concepts.StringConcept",
                                         "listUser:String", "DSClient", "DSResponse" ) );
            
            //block specified USER in DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "blockUser:org.media.mn8.concepts.StringConcept",
                                         "blockUser:String", "DSClient", "DSResponse" ) );
            
            //unblock specified USER in DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "unblockUser:org.media.mn8.concepts.StringConcept",
                                         "unblockUser:String", "DSClient", "DSResponse" ) );
	    
            //fetch specified subtree in DS DataBase
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "fetch:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.StringConcept",
                                         "fetch:String,String,String", "DSClient", "DSResponse" ) );

            //store specified block in specified subtree
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSClientConcept", false,
                                         "store:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,"+
                                         "org.media.mn8.concepts.StringConcept",
                                         "store:String,String,String", "DSClient", "DSResponse" ) );
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
						 
    
    public static ConceptDefinition getReference() {
        return _reference;
    }
    
    
    public Concept getConceptInstance() {
        return new DSClientConcept();
    }
    
    
    public StringConcept getConceptLabel() {
        return new StringConcept("DSClient");
    }
												 
												 
    public StringConcept getConceptType() {
        return new StringConcept("DSClient");
    }
    
    
    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
