package org.media.mn8.concepts;

import org.media.mn8.*;
import java.util.Enumeration;

public class DSResponseConcept extends JavaConcept {

    private boolean hasAdditional = false;
    private boolean hasError      = false;
    private boolean hasBlock      = false;
    private boolean hasInfo       = false;
    private boolean hasWarning    = false; 

    public ElementConcept additional = new ElementConcept("additional", "additional", new NilConcept(), null );
    public ElementConcept      error = new ElementConcept("error", "error", new NilConcept(), null );
    public ElementConcept      block = new ElementConcept("block", "block", new NilConcept(), null );


    public static DSResponseConcept getResponse( String txt ) {
        DSResponseConcept dsResp = new DSResponseConcept();
        Concept resp = ((ConceptConceptDefinition)ElementDefinition.getReference()).fromXML( new StringConcept( txt ) );

        for ( Enumeration e = resp.getConceptElements().getVector().elements(); e.hasMoreElements(); ) {
            ElementConcept elem = (ElementConcept)e.nextElement();

            if ( elem.getName().toString().equalsIgnoreCase("additional") ) {
                dsResp.additional.addValue( elem.getValue() );
                for ( Enumeration e1 = elem.getValue().getConceptElements().getVector().elements();e1.hasMoreElements(); ) {
                    ElementConcept elem1 = (ElementConcept)e1.nextElement();
                    if ( elem1.getName().toString().equalsIgnoreCase("info") ) dsResp.setInfo( true );
                    else if ( elem1.getName().toString().equalsIgnoreCase("warning") ) dsResp.setWarning( true );
                }
                dsResp.setAdditional( true );
            }
            else if ( elem.getName().toString().equalsIgnoreCase("error") ) {
                dsResp.error.addValue( elem.getValue() );
                dsResp.setError( true );
            }
            else if ( elem.getName().toString().equalsIgnoreCase("block") ) {
                dsResp.block.addValue( elem.getValue() );
                dsResp.setBlock( true );
            }
        }
        
        return dsResp;
    }
 

    public void setAdditional( boolean flag ) {
        hasAdditional = flag;
    }

    
    public void setError( boolean flag ) {
        hasError = flag;
    }


    public void setBlock( boolean flag ) {
        hasBlock = flag;
    }


    public void setInfo( boolean flag ) {
        hasInfo = flag;
    }


    public void setWarning( boolean flag ) {
        hasWarning = flag;
    }


    public LogicalConcept hasAdditional() {
        return new LogicalConcept( hasAdditional );
    }
    

    public LogicalConcept hasError() {
        return new LogicalConcept( hasError );
    }

    
    public LogicalConcept hasBlock() {
        return new LogicalConcept( hasBlock );
    }    


    public LogicalConcept hasInfo() {
        return new LogicalConcept( hasInfo );
    }
    

    public LogicalConcept hasWarning() {
        return new LogicalConcept( hasWarning );
    }


    public ConceptDefinition getConceptDefinition() {
        return DSResponseDefinition.getReference();
    }
    

    public Object clone() {
        return this;
    }
}
