/*
 * $COPYRIGHT$
 * $Id: DSResponseDefinition.java,v 1.1 2002/05/23 15:14:37 crow Exp $
 *
 * Date        Author            Changes
 * MAY 22 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;
       
import org.media.mn8.*;
import org.media.mn8.event.*;
       
/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.1 $ $Date: 2002/05/23 15:14:37 $
 */
 
public class DSResponseDefinition extends ConceptConceptDefinition {
 
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private DSResponseDefinition    _reference = new DSResponseDefinition();
	 
	 
    private DSResponseDefinition() {
        super();
        try {
            Class _class = Class.forName("org.media.mn8.concepts.DSResponseConcept");
            
            //verify if DSReponse has Additional element
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSResponseConcept", false,
                                         "hasAdditional:",
                                         "hasAdditional:", "DSResponse", "Logical" ) );
 
            //verify if DSReponse has Info element
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSResponseConcept", false,
                                         "hasInfo:",
                                         "hasInfo:", "DSResponse", "Logical" ) );

            //verify if DSReponse has Warning element
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSResponseConcept", false,
                                         "hasWarning:",
                                         "hasWarning:", "DSResponse", "Logical" ) );

             //verify if DSReponse has Error element
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSResponseConcept", false,
                                         "hasError:",
                                         "hasError:", "DSResponse", "Logical" ) );

            //verify if DSReponse has Block element
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.DSResponseConcept", false,
                                         "hasBlock:",
                                         "hasBlock:", "DSResponse", "Logical" ) );
   
            putElement(new FieldConcept("additional", _class.getDeclaredField("additional"),
                                        false, "additional", "Series", null));
            
            putElement(new FieldConcept("error", _class.getDeclaredField("error"),
                                        false, "error", "Series", null));
            
            putElement(new FieldConcept("block", _class.getDeclaredField("block"),
                                        false, "block", "Series", null));
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
 

    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new DSResponseConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("DSResponse");
    }


    public StringConcept getConceptType() {
        return new StringConcept("DSResponse");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
