/* 
 * $COPYRIGHT$
 * $Id: DateDefinition.java,v 1.7 2002/05/21 14:10:14 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 * IAN 16 2002 Szabo Csaba       Added functionality
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.7 $ $Date: 2002/05/21 14:10:14 $
 */

public class DateDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private DateDefinition _reference = new DateDefinition();
    
    
    private DateDefinition() {
        super();
        try {
            //create:String, String TYPEOF Date
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.DateConcept",  
                                        "create:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "create:String,String", "Date", "Date" ));
	    
            //create:Integer TYPEOF Date				
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.DateConcept", 
                                        "create:org.media.mn8.concepts.IntegerConcept",
                                        "create:Integer", "Date", "Date" ));
	    
            //getToday: TYPEOF Date
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.DateDefinition", true, 
                                        "getToday:",
                                        "getToday:", "Date", "Date" ));
	    
            //toTXT: TYPEOF String			
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.DateConcept",  
                                        "getDate:",
                                        "toTXT:", "Date", "String" ));

            //toXML: TYPEOF String			
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.DateConcept",  
                                        "getDate:",
                                        "toXML:", "Date", "String" ));
	    
            //getDate:String TYPEOF String				
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.DateConcept",  
                                        "getDate:org.media.mn8.concepts.StringConcept",
                                        "getDate:String", "Date", "String" ));

            //getTime: TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.DateConcept",  
                                        "getTime:",
                                        "getTime:", "Date", "Integer" ));

            //setDate:String, String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.DateConcept",  
                                        "setDate:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "setDate:String,String", "Date", null ));
	    
            //setDate:Integer				
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.DateConcept", 
                                        "setDate:org.media.mn8.concepts.IntegerConcept",
                                        "setDate:Integer", "Date", null ));


            // ==:Date TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.DateConcept",
                                          "opEQ:org.media.mn8.concepts.DateConcept",
                                          "==:Date", "Date", "Logical"));


            // >:Date TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.DateConcept",
                                          "opGT:org.media.mn8.concepts.DateConcept",
                                          ">:Date", "Date", "Logical"));

            // <:Date TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.DateConcept",
                                          "opLT:org.media.mn8.concepts.DateConcept",
                                          "<:Date", "Date", "Logical"));
            
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
  
    
    public DateConcept getToday() {
        return new DateConcept( new IntegerConcept( System.currentTimeMillis() ) );
    }
    
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new DateConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Date");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Date");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
