/* 
 * $COPYRIGHT$
 * $Id: ElementDefinition.java,v 1.8 2002/04/28 13:43:52 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.8 $ $Date: 2002/04/28 13:43:52 $
 */

public class ElementDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private ElementDefinition _reference = new ElementDefinition();
    
    private ElementDefinition() {
        super();
        try {            
            // getName: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "getName:",
                                        "getName:", "Element", "String"));

            // getLabel: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "getLabel:",
                                        "getLabel:", "Element", "String"));

            // isMulti: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "isMulti:",
                                        "isMulti:", "Element", "Logical"));

            // setLabel:String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "setLabel:org.media.mn8.concepts.StringConcept",
                                        "setLabel:String", "Element", null));

            // getValue: TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "getValue:",
                                        "getValue:", "Element", "Concept"));

            // getValueType: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "getValueType:",
                                        "getValueType:", "Element", "String"));

            // setValue:Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "setValue:org.media.mn8.Concept",
                                        "setValue:Concept", "Element", null));

            // setValue:Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "addValue:org.media.mn8.Concept",
                                        "addValue:Concept", "Element", null));

            // setAttributes:Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "setAttributes:org.media.mn8.concepts.SeriesConcept",
                                        "setAttributes:Series", "Element", null));

           // addAttribute: Attribute
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "addAttribute:org.media.mn8.concepts.AttributeConcept",
                                        "addAttribute:Attribute", "Element",  null));

            // addAttribute:String, String, Concept           
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "addAttribute:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,org.media.mn8.Concept",
                                        "addAttribute:String,String,Concept", "Element",  null));

            // create: TYPEOF Element
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "create:org.media.mn8.concepts.StringConcept,org.media.mn8.Concept",
                                        "create:String,Concept", "Element", "Element"));


            // getAttributes: TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "getAttributes:",
                                        "getAttributes:", "Element", "Series"));


            // toXML: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "toXML:",
                                        "toXML:", "Element", "String"));

            // STATIC getConceptElementFields: TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptElementFields:",
                                        "getConceptElementFields:", "Element", "Series"));

            // STATIC getConceptElementField:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptElementField:org.media.mn8.concepts.StringConcept",
                                        "getConceptElementField:String", "Element", "Concept"));

            // loadContent:Concept TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "loadContent:org.media.mn8.Concept",
                                        "loadContent:Concept", "Element", null));


            putMethod(new mn8JavaMethod("org.media.mn8.ConceptConceptDefinition", true,
                                        "getConceptType:",
                                        "getConceptType:", "Element", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptConceptDefinition", true,
                                        "getConceptLabel:",
                                        "getConceptLabel:", "Element", "String"));

            // STATIC getConceptAttributeFields: TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptAttributeFields:",
                                        "getConceptAttributeFields:", "Element", "Series"));

            // STATIC getConceptAttributeField:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "getConceptAttributeField:org.media.mn8.concepts.StringConcept",
                                        "getConceptAttributeField:String", "Element", "Concept"));

            // getConceptAttribute:String TYPEOF Attribute
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "getConceptAttribute:org.media.mn8.concepts.StringConcept",
                                        "getConceptAttribute:String", "Element", "Concept"));

            // getConceptAttributes: TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "getConceptAttributes:",
                                        "getConceptAttributes:", "Element", "Series"));

            // STATIC hasConceptAttribute:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "hasConceptAttribute:org.media.mn8.concepts.StringConcept",
                                        "hasConceptAttribute:String", "Element", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "getConceptElements:",
                                        "getConceptElements:", "Element", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.ConceptDefinition", true,
                                        "hasConceptElement:org.media.mn8.concepts.StringConcept",
                                        "hasConceptElement:String", "Element", "Logical"));


            // getConceptElement:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.Concept",
                                        "getConceptElement:org.media.mn8.concepts.StringConcept",
                                        "getConceptElement:String", "Element", "Concept"));

            // equals:Element TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                        "equals:org.media.mn8.concepts.ElementConcept",
                                        "equals:Element", "Element", "Logical"));

           // ==:Element TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.ElementConcept",
                                          "opEquals:org.media.mn8.concepts.ElementConcept",
                                          "==:Element", "Element", "Logical"));


        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new ElementConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Element");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Element");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }

}


