/* 
 * $COPYRIGHT$
 * $Id: EnvHandlerDefinition.java,v 1.4 2002/05/20 10:57:59 neuro Exp $
 *
 * Date        Author            Changes 
 * FEB 06 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URL;
import java.net.MalformedURLException;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.4 $ $Date: 2002/05/20 10:57:59 $
 */

public class EnvHandlerDefinition extends URIHandlerDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private EnvHandlerDefinition _envReference = new EnvHandlerDefinition();
    
    protected EnvHandlerDefinition() {
        super();
        try {            
            _inheritedConcepts.add(new StringConcept("URIHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.EnvHandler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "EnvHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.EnvHandler",
                                        "closeConnection:",
                                        "closeConnection:", "EnvHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.EnvHandler",
                                        "openConnection:",
                                        "openConnection:", "EnvHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.EnvHandler",
                                        "getContent:",
                                        "getContent:", "EnvHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.EnvHandler", 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "EnvHandler", "EnvHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.EnvHandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "EnvHandler", "Logical"));
        
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
  

    public LogicalConcept acceptsURI( StringConcept uri ) {
        try {
            URL url = new URL( uri.toString() );
            if( url.getProtocol().equalsIgnoreCase("env"))
                return new LogicalConcept(true);
            else 
                return new LogicalConcept(false);
        } catch (MalformedURLException ex) {
            // we might be in Tomcat and the costom uri's don't work
            if( uri.toString().toLowerCase().startsWith("env:"))
                return new LogicalConcept(true);
        }
        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _envReference;
    }
    
    
    public Concept getConceptInstance() {
        return new EnvHandler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("EnvHandler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("EnvHandler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
