/* 
 * $COPYRIGHT$
 * $Id: ErrorDefinition.java,v 1.7 2002/06/03 11:34:50 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Antal Attila      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

import java.io.PrintStream;
import java.lang.Thread;

/** 
 * @author <a href="mailto:atech@nolimits.ro">Antal Attila</a>
 * @version $Revision: 1.7 $ $Date: 2002/06/03 11:34:50 $
 */
public class ErrorDefinition extends ConceptConceptDefinition {

    private static StringConcept _errorType = new StringConcept("Error");
    private static StringConcept _errorLabel = new StringConcept("ERROR");
    private static SeriesConcept _errorInheritedConcepts = new SeriesConcept();
    static private ErrorDefinition _reference = new ErrorDefinition();

    private ErrorDefinition() {
        super();
        try {            
            //create:String, String, String TYPEOF Error
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorConcept", 
                                        "create:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "create:String,String,String", "Error", "Error" ));
            
            //create:String, String, String, Concept TYPEOF Error
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorConcept", 
                                        "create:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,org.media.mn8.Concept",
                                        "create:String,String,String,Concept", "Error", "Error" ));
            
            // getID: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorConcept",
                                        "getID:", 
                                        "getID:", "Error", "String"));
            // getMSG: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorConcept",
                                        "getMSG:", 
                                        "getMSG:", "Error", "String"));

            // getLineNr: TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorConcept",
                                        "getLineNr:", 
                                        "getLineNr:", "Error", "Integer"));

            // getConcept: TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorConcept",
                                        "getConcept:", 
                                        "getConcept:", "Error", "Concept"));
            // setType:String 
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorConcept",
                                        "setType:org.media.mn8.concepts.StringConcept", 
                                        "setType:String", "Error", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorDefinition", true,
                                        "print:org.media.mn8.concepts.StringConcept", 
                                        "print:String", "Error", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorDefinition", true,
                                        "println:org.media.mn8.concepts.StringConcept", 
                                        "println:String", "Error", null));

            // setMSG:String 
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ErrorConcept",
                                        "setMSG:org.media.mn8.concepts.StringConcept", 
                                        "setMSG:String", "Error", null));


        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public void print( StringConcept msg ) {
        PrintStream _err = mn8Interpreter.getErr( Thread.currentThread());
        _err.print(msg.toString());
    }


    public void println( StringConcept msg ) {
        PrintStream _err = mn8Interpreter.getErr( Thread.currentThread());
        _err.println(msg.toString());
    }
    

    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new ErrorConcept();
    }


    public StringConcept getConceptLabel() {
        return _errorLabel;
    }


    public StringConcept getConceptType() {
        return _errorType;
    }


    public SeriesConcept getInheritedConcepts() {
        return _errorInheritedConcepts;
    }

}

