/* 
 * $COPYRIGHT$
 * $Id: ExpressionDefinition.java,v 1.3 2002/01/31 20:26:22 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import org.apache.oro.text.regex.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/01/31 20:26:22 $
 */
public class ExpressionDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private ExpressionDefinition _reference = new ExpressionDefinition();
    
    protected ExpressionDefinition() {
        super();
        try {            

            // create:String TYPEOF Expression
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionConcept",
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "Expression", "Expression"));

            // create TYPEOF Expression
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionConcept", 
                                        "create:",
                                        "create:", "Expression", "Concept"));

            // getPattern: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionConcept",
                                        "getPattern:",
                                        "getPattern:", "Expression", "String"));

            // setPattern:String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionConcept",
                                        "setPattern:org.media.mn8.concepts.StringConcept",
                                        "setPattern:String", "Expression", null));

            // matches:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionConcept",
                                        "matches:org.media.mn8.concepts.StringConcept",
                                        "matches:String", "Expression", "Logical"));

            // contains:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionConcept",
                                        "contains:org.media.mn8.concepts.StringConcept",
                                        "contains:String", "Expression", "Logical"));

            // matches:String,String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionDefinition", true,
                                        "matches:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "matches:String,String", "Expression", "Logical"));

            // contains:String,String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionDefinition", true,
                                        "contains:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "contains:String,String", "Expression", "Logical"));

            // getMatches:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionConcept",
                                        "getMatches:org.media.mn8.concepts.StringConcept",
                                        "getMatches:String", "Expression", "Series"));

            // STATIC getMatches:String,String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ExpressionDefinition", true,
                                        "getMatches:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "getMatches:String,String", "Expression", "Series"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public LogicalConcept matches( StringConcept pattern, StringConcept string) throws MalformedPatternException {
        return (new ExpressionConcept(pattern)).matches( string);
    }


    public LogicalConcept contains( StringConcept pattern, StringConcept string) throws MalformedPatternException {
        return (new ExpressionConcept(pattern)).contains( string);
    }


    public SeriesConcept getMatches( StringConcept pattern, StringConcept string) throws MalformedPatternException {
        return (new ExpressionConcept(pattern)).getMatches( string);
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new ExpressionConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Expression");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Expression");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



