/* 
 * $COPYRIGHT$
 * $Id: FTPClientConceptDefinition.java,v 1.3 2002/01/23 13:06:22 neuro Exp $
 *
 * Date        Author            Changes 
 * IAN 18 2002 Szabo Csaba       Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.3 $ $Date: 2002/01/23 13:06:22 $
 */
 
public class FTPClientConceptDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private FTPClientConceptDefinition _reference = new FTPClientConceptDefinition();

        
    private FTPClientConceptDefinition() {
        super();
        try {
            Class _class = Class.forName("org.media.mn8.concepts.FTPClientConcept");
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "openConnection:org.media.mn8.concepts.StringConcept",
                                         "openConnection:String", "FTPClient", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "closeConnection:",
                                         "closeConnection:", "FTPClient", "null" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "login:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "login:String,String", "FTPClient", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "logout:",
                                         "logout:", "FTPClient", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "getWorkingDirectory:",
                                         "getWorkingDirectory:", "FTPClient", "String" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "changeWorkingDirectory:org.media.mn8.concepts.StringConcept",
                                         "changeWorkingDirectory:String", "FTPClient", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "mkdir:org.media.mn8.concepts.StringConcept",
                                         "mkdir:String", "FTPClient", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "delete:org.media.mn8.concepts.StringConcept",
                                         "delete:String", "FTPClient", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "rename:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "rename:String,String", "FTPClient", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "getLinks:",
                                         "getLinks:", "FTPClient", "Series" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "getLinks:org.media.mn8.concepts.StringConcept",
                                         "getLinks:String", "FTPClient", "Series" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "getFile:org.media.mn8.concepts.StringConcept",
                                         "getFile:String", "FTPClient", "String" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "putFile:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "putFile:String,String", "FTPClient", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "setBinaryMode:org.media.mn8.concepts.LogicalConcept",
                                         "setBinaryMode:Logical", "FTPClient", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.FTPClientConcept",
                                         "isPositiveCompletion:",
                                         "isPositiveCompletion:", "FTPClient", "Logical" ) );
            
            putAttribute( new FieldConcept( "errorMessage", _class.getDeclaredField("errorMessage"),
                                            false, "errorMessage", "String", null ) );
            
            putAttribute( new FieldConcept( "errorCode", _class.getDeclaredField("errorCode"),
                                            false, "errorCode", "Integer", null ) );
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
    
    
    public static ConceptDefinition getReference() {
        return _reference;
    }
    

    public Concept getConceptInstance() {
        return new FTPClientConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("FTPClient");
    }

    
    public StringConcept getConceptType() {
        return new StringConcept("FTPClient");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
