/* 
 * $COPYRIGHT$
 * $Id: FTPFileConceptDefinition.java,v 1.5 2002/02/20 17:47:01 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.5 $ $Date: 2002/02/20 17:47:01 $
 */
public class FTPFileConceptDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private FTPFileConceptDefinition _reference = new FTPFileConceptDefinition();
    
    private FTPFileConceptDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.FTPFileConcept");

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPFileConcept",
                                        "getContent:",
                                        "getContent:", "FTPFile", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPFileConcept",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "FTPFile", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPFileConcept",
                                        "exists:",
                                        "exists:", "FTPFile", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPFileConcept",
                                        "isFile:",
                                        "isFile:", "FTPFile", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPFileConcept",
                                        "getLinks:",
                                        "getLinks:", "FTPFile", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPFileConcept",
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "FTPFile", "FTPFile"));
            
            putAttribute(new FieldConcept("url", _class.getDeclaredField("url"),
                                          false, "url", "String", null));

            putAttribute(new FieldConcept("length", _class.getDeclaredField("length"),
                                          false, "length", "Integer", null));

            putAttribute(new FieldConcept("contentType", _class.getDeclaredField("contentType"),
                                          false, "contentType", "String", null));

            putElement(new FieldConcept("content", _class.getDeclaredField("content"),
                                          false, "content", "String", null));
        
        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new FTPFileConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("FTPFile");
    }


    public StringConcept getConceptType() {
        return new StringConcept("FTPFile");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
