/* 
 * $COPYRIGHT$
 * $Id: FTPHandlerDefinition.java,v 1.5 2002/02/07 12:26:30 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URL;
import java.net.MalformedURLException;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.5 $ $Date: 2002/02/07 12:26:30 $
 */
public class FTPHandlerDefinition extends URIHandlerDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private FTPHandlerDefinition _fileReference = new FTPHandlerDefinition();
    
    protected FTPHandlerDefinition () {
        super();
        try {            
            _inheritedConcepts.add(new StringConcept("URIHandler"));
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPHandler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "FTPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPHandler",
                                        "closeConnection:",
                                        "closeConnection:", "FTPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPHandler",
                                        "openConnection:",
                                        "openConnection:", "FTPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPHandler",
                                        "getContent:",
                                        "getContent:", "FTPHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPHandler",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "FTPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPHandler", 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "FTPHandler", "FTPHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FTPHandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "FTPHandler", "Logical"));
        
        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
 

    public LogicalConcept acceptsURI(StringConcept uri ) {
        try {
            URL url = new URL( uri.toString());
            if( url.getProtocol().equalsIgnoreCase("ftp"))
                return new LogicalConcept(true);
            else 
                return new LogicalConcept(false);
        } catch (MalformedURLException ex) {
        }
        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _fileReference;
    }


    public Concept getConceptInstance() {
        return new FTPHandler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("FTPHandler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("FTPHandler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
