/* 
 * $COPYRIGHT$
 * $Id: FieldConceptDefinition.java,v 1.4 2002/04/04 22:07:13 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.4 $ $Date: 2002/04/04 22:07:13 $
 */

public class FieldConceptDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private FieldConceptDefinition _reference = new FieldConceptDefinition();
    
    private FieldConceptDefinition() {
        super();
        try {            
            // getInitialValue: TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.FieldConcept",
                                        "getInitialValue:",
                                        "getInitialValue:", "Field", "Concept"));

            // getFieldName: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.FieldConcept",
                                        "getFieldName:",
                                        "getName:", "Field", "String"));

            // getFieldLabel: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.FieldConcept",
                                        "getFieldLabel:",
                                        "getFieldLabel:", "Field", "String"));

            // getValue: TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.FieldConcept",
                                        "getValue:org.media.mn8.Concept",
                                        "getValue:Concept", "Field", "Concept"));

            // setValue: Concept, Concept
            putMethod(new mn8JavaMethod("org.media.mn8.FieldConcept",
                                        "setValue:org.media.mn8.Concept,org.media.mn8.Concept",
                                        "setValue:Concept, Concept", "Field", null));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    

    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new FieldConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Field");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Field");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}

