/* 
 * $COPYRIGHT$
 * $Id: FileConceptDefinition.java,v 1.9 2002/03/14 19:25:35 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.io.File;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.9 $ $Date: 2002/03/14 19:25:35 $
 */
public class FileConceptDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private FileConceptDefinition _reference = new FileConceptDefinition();
    
    private FileConceptDefinition() {
        super();

        try {            
            Class _class = Class.forName("org.media.mn8.concepts.FileConcept");



            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "readContent:",
                                        "readContent:", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "getContent:",
                                        "getContent:", "File", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "exists:",
                                        "exists:", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "delete:",
                                        "delete:", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "setReadOnly:",
                                        "setReadOnly:", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "canRead:",
                                        "canRead:", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "canWrite:",
                                        "canWrite:", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "isHidden:",
                                        "isHidden:", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "isFile:",
                                        "isFile:", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept",
                                        "getLinks:",
                                        "getLinks:", "File", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept", false,
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "File", "File"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConceptDefinition", true,
                                        "mkdir:org.media.mn8.concepts.StringConcept",
                                        "mkdir:String", "File", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConceptDefinition", true,
                                        "getSeparator:",
                                        "getSeparator:", "File", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileConcept", 
                                        "rename:org.media.mn8.concepts.StringConcept",
                                        "rename:String", "File", "Logical") );
            
            putAttribute(new FieldConcept("url", _class.getDeclaredField("url"),
                                          false, "url", "String", null));

            putAttribute(new FieldConcept("length", _class.getDeclaredField("length"),
                                          false, "length", "Integer", null));

            putAttribute(new FieldConcept("contentType", _class.getDeclaredField("contentType"),
                                          false, "contentType", "String", null));

            putElement(new FieldConcept("content", _class.getDeclaredField("content"),
                                          false, "content", "String", null));
        
        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    


    public LogicalConcept mkdir( StringConcept url ) {
        return new FileConcept( url.toString() ).mkdir();
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }

    
    public static StringConcept getSeparator() {
        return new StringConcept(File.separator);
    }


    public Concept getConceptInstance() {
        return new FileConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("File");
    }


    public StringConcept getConceptType() {
        return new StringConcept("File");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



