/* 
 * $COPYRIGHT$
 * $Id: FileHandlerDefinition.java,v 1.7 2002/05/02 18:28:18 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URL;
import java.io.File;
import java.net.MalformedURLException;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.7 $ $Date: 2002/05/02 18:28:18 $
 */
public class FileHandlerDefinition extends URIHandlerDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private FileHandlerDefinition _fileReference = new FileHandlerDefinition();
    
    protected FileHandlerDefinition() {
        super();
        try {            
            _inheritedConcepts.add(new StringConcept("URIHandler"));
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileHandler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "FileHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileHandler",
                                        "closeConnection:",
                                        "closeConnection:", "FileHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileHandler",
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "FileHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileHandler",
                                        "getContent:",
                                        "getContent:", "FileHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileHandler",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "FileHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileHandler", 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "FileHandler", "FileHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FileHandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "FileHandler", "Logical"));
        
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
  

    public LogicalConcept acceptsURI( StringConcept uri ) {
        try {
            URL url = (new File(uri.toString())).toURL();
            if( url.getProtocol().equalsIgnoreCase("file"))
                return new LogicalConcept(true);
            else 
                return new LogicalConcept(false);
        } catch ( MalformedURLException ex ) {
            // it's just not good enough :)
        }
        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _fileReference;
    }


    public Concept getConceptInstance() {
        return new FileHandler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("FileHandler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("FileHandler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
