/* 
 * $COPYRIGHT$
 * $Id: FlexConcept.java,v 1.4 2002/02/26 14:16:47 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;


/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.4 $ $Date: 2002/02/26 14:16:47 $
 */
public class FlexConcept extends JavaConcept {
    protected StringConcept _label = FlexDefinition.getReference().getConceptLabel();
    protected AttributeSeries _attributes = new AttributeSeries();
    protected SeriesConcept _elements = new SeriesConcept();
    

    public void setLabel(StringConcept label) {
        _label = label;
    }

    
    public StringConcept getConceptLabel() {
        return _label;
    }


    public void addAttribute(Attribute attribute) {
        _attributes.add((Concept)attribute);
    }


    public void addAttribute(StringConcept name, StringConcept label, Concept value) {
        _attributes.add( new AttributeConcept(name.toString(), label.toString(), value));
    }


    public SeriesConcept getConceptAttributeFields() {
        return _attributes.getConceptElementFields();
    }


    public boolean hasConceptAttribute(String name) {
        return _attributes.hasConceptElement(name);
    }


    public FieldDefinition getConceptAttributeField( String attrName ) {
        return _attributes.getConceptElementField(attrName);
    }


    public Concept getConceptAttribute( String name ) {
        return _attributes.getConceptElement(name);        
    }

    
    public void addElement(Concept element) {
        _elements.add( element ); 
    }


    public void addElement(StringConcept name, StringConcept label,
                           Concept value, SeriesConcept attributes ) {
        _elements.add( new ElementConcept( name.toString(), 
                                           label.toString(), 
                                           value, 
                                           attributes));
    }


    public SeriesConcept getConceptElementFields() {
        return _elements.getConceptElementFields();
    }


    public boolean hasConceptElement(String name) {
        return _elements.hasConceptElement(name);
    }


    public FieldDefinition getConceptElementField( String attrName ) {
        return _elements.getConceptElementField(attrName);
    }


    public Concept getConceptElement( String name ) {
        return _elements.getConceptElement(name);        
    }


    public String toString() {
        return toTXT().toString();
    }


    public ConceptDefinition getConceptDefinition() {
        return FlexDefinition.getReference();
    }


    public Object clone() {
        return this;
    }

    
}
