/* 
 * $COPYRIGHT$
 * $Id: FlexDefinition.java,v 1.3 2002/02/03 19:25:05 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/02/03 19:25:05 $
 */

public class FlexDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private FlexDefinition _reference = new FlexDefinition();
    
    private FlexDefinition() {
        super();
        try {            

            // getConceptLabel:Integer TYPEOF Character
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FlexConcept",
                                        "setLabel:org.media.mn8.concepts.StringConcept",
                                        "setLabel:String", "Flex",  null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FlexConcept",
                                        "addAttribute:org.media.mn8.concepts.Attribute",
                                        "addAttribute:Attribute", "Flex",  null));
            
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FlexConcept",
                                        "addAttribute:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,org.media.mn8.Concept",
                                        "addAttribute:String,String,Concept", "Flex",  null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FlexConcept",
                                        "addElement:org.media.mn8.Concept",
                                        "addElement:Concept", "Flex",  null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.FlexConcept",
                                        "addElement:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept,org.media.mn8.Concept,org.media.mn8.concepts.SeriesConcept",
                                        "addElement:String,String,Concept,Series", "Flex",  null));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new FlexConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Flex");
    }

    
    public StringConcept getConceptType() {
        return new StringConcept("Flex");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



