/* 
 * $COPYRIGHT$
 * $Id: HTMLFormDefinition.java,v 1.8 2002/05/28 15:58:06 atech Exp $
 *
 * Date        Author            Changes 
 * IAN 29 2002 Szabo Csaba       Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import org.media.mn8.protocol.http.*;
import java.io.File;
import java.util.Vector;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.8 $ $Date: 2002/05/28 15:58:06 $
 */
public class HTMLFormDefinition extends MapDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private HTMLFormDefinition _reference = new HTMLFormDefinition();
    
    private HTMLFormDefinition() {
        super();
	
        _inheritedConcepts.add( new StringConcept("Map") );

        try {
            Class _class = Class.forName("org.media.mn8.concepts.HTMLFormConcept");

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept",
                                        "setURL:org.media.mn8.concepts.StringConcept",
                                        "setURL:String", "HTMLForm", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept",
                                        "setMethod:org.media.mn8.concepts.StringConcept",
                                        "setMethod:String", "HTMLForm", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept",
                                        "setName:org.media.mn8.concepts.StringConcept",
                                        "setName:String", "HTMLForm", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept",
                                        "setTarget:org.media.mn8.concepts.StringConcept",
                                        "setTarget:String", "HTMLForm", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept",
                                        "setEncoding:org.media.mn8.concepts.StringConcept",
                                        "setEncoding:String", "HTMLForm", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept",
                                        "storeForm:",
                                        "storeForm:", "HTMLForm", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept", true,
                                        "getStoredForms:org.media.mn8.concepts.StringConcept",
                                        "getStoredForms:String", "HTMLForm", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept", true,
                                        "getStoredForms:org.media.mn8.concepts.ExpressionConcept",
                                        "getStoredForms:Expression", "HTMLForm", "Series"));


            // loadContent:Concept TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept",
                                        "loadContent:org.media.mn8.Concept",
                                        "loadContent:Concept", "HTMLForm", null));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLFormConcept",
                                        "getAsEncodedURL:",
                                        "getAsEncodedURL:", "HTMLForm", "String"));


            putAttribute(new FieldConcept("url", _class.getDeclaredField("url"),
                                          false, "url", "String", null));

            putAttribute(new FieldConcept("method", _class.getDeclaredField("method"),
                                          false, "method", "String", null));

            putAttribute(new FieldConcept("name", _class.getDeclaredField("name"),
                                          false, "name", "name", null));

            putAttribute(new FieldConcept("target", _class.getDeclaredField("target"),
                                          false, "target", "String", null));

            putAttribute(new FieldConcept("encoding", _class.getDeclaredField("encoding"),
                                          false, "encoding", "String", null));
	    
            putAttribute(new FieldConcept("id", _class.getDeclaredField("id"),
                                          false, "id", "String", null));
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
 

    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new HTMLFormConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("HTMLForm");
    }


    public StringConcept getConceptType() {
        return new StringConcept("HTMLForm");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
