/* 
 * $COPYRIGHT$
 * $Id: HTMLPageConceptDefinition.java,v 1.6 2002/05/29 15:52:28 atech Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.6 $ $Date: 2002/05/29 15:52:28 $
 */
public class HTMLPageConceptDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private HTMLPageConceptDefinition _reference = new HTMLPageConceptDefinition();
    
    private HTMLPageConceptDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.HTMLPageConcept");

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getContent:",
                                        "getContent:", "HTMLPage", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getHeaders:",
                                        "getHeaders:", "HTMLPage", "Map"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getCookies:",
                                        "getCookies:", "HTMLPage", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getTags:",
                                        "getTags:", "HTMLPage", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getTagsWithText:",
                                        "getTagsWithText:", "HTMLPage", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getLinks:",
                                        "getLinks:", "HTMLPage", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getForms:",
                                        "getForms:", "HTMLPage", "Series"));
	    
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getURIs:",
                                        "getURIs:", "HTMLPage", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept", false,
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "HTMLPage", "HTMLPage"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept", false,
                                        "create:org.media.mn8.concepts.HTMLFormConcept",
                                        "create:HTMLForm", "HTMLPage", "HTMLPage"));
            
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getResponseMessage:",
                                        "getResponseMessage:", "HTMLPage", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept",
                                        "getResponseCode:",
                                        "getResponseCode:", "HTMLPage", "Integer"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept", true,
                                        "setFollowRedirects:org.media.mn8.concepts.LogicalConcept",
                                        "setFollowRedirects:Logical", "HTMLPage", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HTMLPageConcept", true,
                                        "isFollowRedirects:",
                                        "isFollowRedirects:", "HTMLPage", "Logical"));



            putAttribute(new FieldConcept("url", _class.getDeclaredField("url"),
                                          false, "url", "String", null));
            
            putAttribute(new FieldConcept("length", _class.getDeclaredField("length"),
                                          false, "length", "Integer", null));

            putAttribute(new FieldConcept("contentType", _class.getDeclaredField("contentType"),
                                          false, "contentType", "String", null));

            putAttribute(new FieldConcept("lastModified", _class.getDeclaredField("lastModified"),
                                          false, "lastModified", "Integer", null));

            putAttribute(new FieldConcept("title", _class.getDeclaredField("title"),
                                          false, "title", "integer", null));

            putElement(new FieldConcept("content", _class.getDeclaredField("content"),
                                          false, "content", "String", null));
        
        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new HTMLPageConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("HTMLPage");
    }


    public StringConcept getConceptType() {
        return new StringConcept("HTMLPage");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



