/* 
 * $COPYRIGHT$
 * $Id: HttpHandlerDefinition.java,v 1.6 2002/02/21 10:13:01 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URL;
import java.net.MalformedURLException;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.6 $ $Date: 2002/02/21 10:13:01 $
 */
public class HttpHandlerDefinition extends URIHandlerDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private HttpHandlerDefinition _fileReference = new HttpHandlerDefinition();
    
    protected HttpHandlerDefinition() {
        super();
        try {            
            _inheritedConcepts.add(new StringConcept("URIHandler"));
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HttpHandler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "HttpHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HttpHandler",
                                        "closeConnection:",
                                        "closeConnection:", "HttpHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HttpHandler",
                                        "openConnection:",
                                        "openConnection:", "HttpHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HttpHandler",
                                        "getContent:",
                                        "getContent:", "HttpHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HttpHandler",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "HttpHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HttpHandler", false,
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "HttpHandler", "HttpHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.HttpHandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "HttpHandler", "Logical"));
        
        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
  

    public LogicalConcept acceptsURI(StringConcept uri ) {
        try {
            URL url = new URL( uri.toString());
            if( url.getProtocol().equalsIgnoreCase("http"))
                return new LogicalConcept(true);
            else 
                return new LogicalConcept(false);
        } catch (MalformedURLException ex) {
        }
        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _fileReference;
    }


    public Concept getConceptInstance() {
        return new HttpHandler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("HttpHandler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("HttpHandler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
