/* 
 * $COPYRIGHT$
 * $Id: IntegerConcept.java,v 1.15 2002/05/02 18:26:58 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;


/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.15 $ $Date: 2002/05/02 18:26:58 $
 */
public class IntegerConcept extends RealConcept {
    
    protected long _value=0 ;


    public IntegerConcept( ){
    }


    public IntegerConcept( long value ){
        _value = value;
    }


    public IntegerConcept( String value) {
        fromString(new StringConcept(value));
    }


    public void fromIntegerConcept(long value) {
        _value = value;
    }


    public Concept create ( StringConcept value ) {
        return fromString(value);
    }
 

    public IntegerConcept fromString( StringConcept value) {
        _value = (new Long(value.toString())).longValue();
        return this;
    }


    public IntegerConcept opIntegerINC() {
        ++_value;
        return new IntegerConcept( _value );
    }


    public IntegerConcept opIntegerDEC() {
        --_value;
        return new IntegerConcept( _value );
    }


    public IntegerConcept opPlus(IntegerConcept value) {
        return new IntegerConcept(_value + value.getLong() );
    }


    public IntegerConcept opMinus(IntegerConcept value) {
        return new IntegerConcept(_value - value.getLong() );
    }


    public IntegerConcept opSTAR(IntegerConcept value) {
        return new IntegerConcept(_value * value.getLong() );
    }
    

    public Concept abs() {
        return new IntegerConcept( Math.abs( getLong() ) );
    }


    public Concept max(IntegerConcept value) {
        return new IntegerConcept( Math.max( getLong(), value.getLong() ) );
    }

 
    public Concept min(IntegerConcept value) {
        return new IntegerConcept( Math.min( getLong(), value.getLong() ) );
    }


    public StringConcept toStringConcept() {
        return new StringConcept("" + _value);
    }


    public StringConcept toTXT() {
        return toStringConcept();
    }


    public StringConcept toXML() {
        return toStringConcept();
    }


    public long getLong() {
        return _value;
    }


    public int getInt() {
        return (int) _value;
    }
    

    public float getFloat() {
        return (float) _value;
    }


    public void setValue( long value ) {
        _value = value;
    }


    public boolean equals (Object obj) {
        if( obj instanceof org.media.mn8.concepts.IntegerConcept ) 
            if ( ( (IntegerConcept)obj).getLong() == _value ) {
                return true;
            }
        return false;
    }


    public ConceptDefinition getConceptDefinition() {
        return IntegerDefinition.getReference();
    }


    public void main ( SeriesConcept param ) {
        System.out.println(_value);
    }


    public Object clone() {
        return new IntegerConcept( getLong() );
    }
}
