/* 
 * $COPYRIGHT$
 * $Id: IntegerDefinition.java,v 1.6 2002/04/30 17:56:38 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.6 $ $Date: 2002/04/30 17:56:38 $
 */

public class IntegerDefinition extends RealDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private IntegerDefinition _reference = new IntegerDefinition();
    
    protected IntegerDefinition() {
        super();
        _inheritedConcepts.add(new StringConcept("Real"));
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.IntegerConcept");
	    
            //create:String TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept", false, 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "Integer", "Integer" ));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept",
                                        "fromString:org.media.mn8.concepts.StringConcept",
                                        "fromString:String", "Integer", "Integer"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept",
                                        "abs:",
                                        "abs:", "Integer", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept",
                                        "max:org.media.mn8.concepts.IntegerConcept",
                                        "max:Integer", "Integer", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept",
                                        "min:org.media.mn8.concepts.IntegerConcept",
                                        "min:Integer", "Integer", "Concept"));

            // +:Integer TYPEOF Integer
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept",
                                          "opPlus:org.media.mn8.concepts.IntegerConcept",
                                          "+:Integer", "Integer", "Integer"));

            // ++: TYPEOF Integer
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept",
                                          "opIntegerINC:",
                                          "++:", "Integer", "Integer"));

            // -:Integer TYPEOF Integer
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept",
                                          "opMinus:org.media.mn8.concepts.IntegerConcept",
                                          "-:Integer", "Integer", "Integer"));

            // --: TYPEOF Integer
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept",
                                          "opIntegerDEC:",
                                          "--:", "Integer", "Integer"));

            // *:Integer TYPEOF Integer
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.IntegerConcept",
                                          "opSTAR:org.media.mn8.concepts.IntegerConcept",
                                          "*:Integer", "Integer", "Integer"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new IntegerConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Integer");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Integer");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



