/*
 * $COPYRIGHT$
 * $Id: JabberClientDefinition.java,v 1.2 2002/04/11 16:02:44 crow Exp $
 *
 * Date        Author            Changes
 * APR 09 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;
       
import org.media.mn8.*;
import org.media.mn8.event.*;
       
/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.2 $ $Date: 2002/04/11 16:02:44 $
 */
 
public class JabberClientDefinition extends ConceptConceptDefinition {
 
    static private SeriesConcept  _inheritedConcepts = new SeriesConcept("Concept");
    static private JabberClientDefinition _reference = new JabberClientDefinition();
	 
	 
    private JabberClientDefinition() {
        super();
        try {
            Class _class = Class.forName("org.media.mn8.concepts.JabberClientConcept");

            //create connection to specified Jabber server
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.JabberClientConcept", 
                                         "create:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.IntegerConcept",
                                         "create:String,Integer", "JabberClient", "JabberClient" ) );

            //login into specified Jabber server
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.JabberClientConcept", 
                                         "login:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "login:String,String", "JabberClient", null ) );
            //send message to specified user
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.JabberClientConcept", 
                                         "send:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "send:String,String", "JabberClient", null ) );

            //send message to specified user
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.JabberClientConcept", 
                                         "send:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept"+
                                             ",org.media.mn8.concepts.StringConcept",
                                         "send:String,String,String", "JabberClient", null ) );
            //add handler to your concept
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.JabberClientConcept", 
                                         "addHandler:org.media.mn8.Concept,org.media.mn8.concepts.StringConcept",
                                         "addHandler:Concept,String", "JabberClient", null ) );
            
            //will be contain responses that you will be received from server
            putElement( new FieldConcept( "response", _class.getDeclaredField("response"), 
                                            false, "response", "Series", null ) );
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
						 
    
    public static ConceptDefinition getReference() {
        return _reference;
    }
    
    
    public Concept getConceptInstance() {
        return new JabberClientConcept();
    }
    
    
    public StringConcept getConceptLabel() {
        return new StringConcept("JabberClient");
    }
												 
												 
    public StringConcept getConceptType() {
        return new StringConcept("JabberClient");
    }
    
    
    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
