/* 
 * $COPYRIGHT$
 * $Id: LocaleConcept.java,v 1.1 2002/05/23 13:58:09 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.util.Locale;


/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.1 $ $Date: 2002/05/23 13:58:09 $
 */
public class LocaleConcept extends JavaConcept {
    private Locale _value  = null;


    public LocaleConcept( ){
    }


    public LocaleConcept( Locale value ){
        _value = value;
    }


    public Concept create() {
        _value = LocaleDefinition.getDefault().getValue();
        return this;
    }


    public Concept create( StringConcept language, StringConcept country ) {
        _value = new Locale( language.toString(), country.toString() );
        return this;
    }


    public Concept create( StringConcept language, StringConcept country,  StringConcept variant ) {
        _value = new Locale( language.toString(), country.toString(), variant.toString() );
        return this;
    }


    public StringConcept getCountry () {
        if( _value != null ) {
            return new StringConcept( _value.getCountry());
        }
        return new StringConcept();
    }


    public StringConcept getLanguage () {
        if( _value != null ) {
            return new StringConcept( _value.getLanguage());
        }
        return new StringConcept();
    }


    public StringConcept getVariant () {
        if( _value != null ) {
            return new StringConcept( _value.getLanguage());
        }
        return new StringConcept();
    }


    public StringConcept getISO3Country () {
        if( _value != null ) {
            return new StringConcept( _value.getISO3Country());
        }
        return new StringConcept();
    }


    public StringConcept getISO3Language () {
        if( _value != null ) {
            return new StringConcept( _value.getISO3Language());
        }
        return new StringConcept();
    }


    public StringConcept getDisplayCountry () {
        if( _value != null ) {
            return new StringConcept( _value.getDisplayCountry());
        }
        return new StringConcept();
    }


    public StringConcept getDisplayLanguage () {
        if( _value != null ) {
            return new StringConcept( _value.getDisplayLanguage());
        }
        return new StringConcept();
    }


    public StringConcept getDisplayName () {
        if( _value != null ) {
            return new StringConcept( _value.getDisplayName());
        }
        return new StringConcept();
    }


    public StringConcept getDisplayVariant () {
        if( _value != null ) {
            return new StringConcept( _value.getDisplayVariant());
        }
        return new StringConcept();
    }


    public void setDefault( LocaleConcept value ) {
        LocaleDefinition.setDefault(value);
    }


    public LocaleConcept getDefault() {
        return LocaleDefinition.getDefault();
    }


    public SeriesConcept getAvailableLocales() {
        return LocaleDefinition.getAvailableLocales();
    }


    public SeriesConcept getISOCountries() {
        return LocaleDefinition.getISOCountries();
    }


    public SeriesConcept getISOLanguages() {
        return LocaleDefinition.getISOLanguages();
    }


    public StringConcept getDisplayCountry(LocaleConcept locale) {
        if( _value != null && locale != null && locale.getValue() != null ) {
            return new StringConcept( _value.getDisplayCountry( locale.getValue()));
        }
        return new StringConcept();
    }


    public StringConcept getDisplayName(LocaleConcept locale) {
        if( _value != null && locale != null && locale.getValue() != null ) {
            return new StringConcept( _value.getDisplayName( locale.getValue()));
        }
        return new StringConcept();
    }


    public StringConcept getDisplayLanguage(LocaleConcept locale) {
        if( _value != null && locale != null && locale.getValue() != null ) {
            return new StringConcept( _value.getDisplayLanguage( locale.getValue()));
        }
        return new StringConcept();
    }


    public StringConcept getDisplayVariant(LocaleConcept locale) {
        if( _value != null && locale != null && locale.getValue() != null ) {
            return new StringConcept( _value.getDisplayVariant( locale.getValue()));
        }
        return new StringConcept();
    }


    public StringConcept toTXT() {
        return new StringConcept( _value.toString());
    }


    public StringConcept toXML() {
        return toTXT();
    }
    


    public void setValue(Locale value) {
        _value = value;
    }


    public Locale getValue() {
        return _value;
    }


    public ConceptDefinition getConceptDefinition() {
        return LocaleDefinition.getReference();
    }


    public boolean equals( Object obj ) {
        if( obj instanceof LocaleConcept && ((LocaleConcept)obj).getValue().equals(_value)) {
            return true;
        }
        return false;    
    }


    public Object clone() {
        return new LocaleConcept( _value );
    }
}
