/* 
 * $COPYRIGHT$
 * $Id: LogicalConcept.java,v 1.9 2002/04/07 22:16:19 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;


/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.9 $ $Date: 2002/04/07 22:16:19 $
 */
public class LogicalConcept extends JavaConcept {


    public final static LogicalConcept FALSE = new LogicalConcept(false);
    public final static LogicalConcept TRUE = new LogicalConcept(true);
    
    private boolean _value = true;


    public LogicalConcept( ){
    }

    public LogicalConcept( boolean value ){
        _value = value;
    }


    public StringConcept toTXT() {
        return new StringConcept("" + _value );
    }


    public StringConcept toXML() {
        return toTXT();
    }
    

    public LogicalConcept opAND(LogicalConcept value) {
        return new LogicalConcept( _value && value.getValue() );
    }


    public LogicalConcept opEQ(LogicalConcept value) {
        return new LogicalConcept( _value == value.getValue() );
    }


    public LogicalConcept opOR(LogicalConcept value) {
        return new LogicalConcept( _value || value.getValue() );
    }


    public LogicalConcept opNOT() {
        return new LogicalConcept( !_value);
    }


    public void setValue(boolean value) {
        _value = value;
    }


    public boolean getValue() {
        return _value;
    }


    public ConceptDefinition getConceptDefinition() {
        return LogicalDefinition.getReference();
    }


    public Object clone() {
        return new LogicalConcept( _value );
    }
}
