/* 
 * $COPYRIGHT$
 * $Id: LogicalDefinition.java,v 1.3 2001/12/24 19:11:33 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2001/12/24 19:11:33 $
 */

public class LogicalDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private LogicalDefinition _reference = new LogicalDefinition();
    
    private LogicalDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.LogicalConcept");



            // ==:Logical TYPEOF Logica
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.LogicalConcept",
                                          "opEQ:org.media.mn8.concepts.LogicalConcept",
                                          "==:Logical", "Logical", "Logical"));

            // and:Logical TYPEOF Logica
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.LogicalConcept",
                                          "opAND:org.media.mn8.concepts.LogicalConcept",
                                          "and:Logical", "Logical", "Logical"));

            // or:Logical TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.LogicalConcept",
                                          "opOR:org.media.mn8.concepts.LogicalConcept",
                                          "or:Logical", "Logical", "Logical"));

            // not:Logical TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.LogicalConcept",
                                          "opNOT:",
                                          "not:", "Logical", "Logical"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new LogicalConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Logical");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Logical");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



