/* 
 * $COPYRIGHT$
 * $Id: Map.java,v 1.1 2001/12/14 00:11:28 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;

import org.media.mn8.Concept;
/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.1 $ $Date: 2001/12/14 00:11:28 $
 */
public interface Map {
    
    Concept nextKey();

    Concept nextValue();

    Concept getKeyAt(IntegerConcept position);

    Concept getValueAt(IntegerConcept position);

    Concept getValue( Concept key);

    LogicalConcept containsKey( Concept key) ;

    LogicalConcept containsValue( Concept value);

    IntegerConcept indexOfKey( Concept key);
    
    IntegerConcept indexOfValue( Concept value);
    
    void remove( Concept key );

    void clear();

    boolean hasNext();

    boolean hasPrevious();

    int getLength();

    int getIndex();

    void setIndex( int idx );

    void add( Concept key, Concept value );

    void insert( Concept key, Concept concept );

    void insert( IntegerConcept position, Concept key, Concept concept );

    void sort( Concept sorter );

    SeriesConcept getKeys();

    SeriesConcept getValues();
}
