/* 
 * $COPYRIGHT$
 * $Id: MapDefinition.java,v 1.7 2002/04/24 13:42:00 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.7 $ $Date: 2002/04/24 13:42:00 $
 */

public class MapDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private MapDefinition _reference = new MapDefinition();
    
    protected MapDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.MapConcept");

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "insert:org.media.mn8.Concept,org.media.mn8.Concept",
                                        "insert:Concept,Concept", "Map", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "nextKey:",
                                        "nextKey:", "Map", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "nextValue:",
                                        "nextValue:", "Map", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "getKeyAt:org.media.mn8.concepts.IntegerConcept",
                                        "getKeyAt:Integer", "Map", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "getValueAt:org.media.mn8.concepts.IntegerConcept",
                                        "getValueAt:Integer", "Map", "Concept"));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "remove:org.media.mn8.Concept",
                                        "remove:Concept", "Map", null));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "containsKey:org.media.mn8.Concept",
                                        "containsKey:Concept", "Map", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "getValue:org.media.mn8.Concept",
                                        "getValue:Concept", "Map", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "containsValue:org.media.mn8.Concept",
                                        "containsValue:Concept", "Map", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "indexOfKey:org.media.mn8.Concept",
                                        "indexOfKey:Concept", "Map", "Integer"));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "indexOfValue:org.media.mn8.Concept",
                                        "indexOfValue:Concept", "Map", "Integer"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "clear:",
                                        "clear:", "Map", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "getKeys:",
                                        "getKeys:", "Map", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "getValues:",
                                        "getValues:", "Map", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "add:org.media.mn8.Concept,org.media.mn8.Concept",
                                        "add:Concept,Concept", "Map", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "insert:org.media.mn8.Concept,org.media.mn8.Concept",
                                        "insert:Concept,Concept", "Map", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "insert:org.media.mn8.concepts.IntegerConcept,org.media.mn8.Concept,org.media.mn8.Concept",
                                        "insert:Integer,Concept,Concept", "Map", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept",
                                        "setIndex:org.media.mn8.concepts.IntegerConcept",
                                        "setIndex:Integer", "Map", null ));

            // getConceptElementFields
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept", false,
                                        "getConceptElements:",
                                        "getConceptElements:", "Map", "Series"));

            // getConceptElement:String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MapConcept", false,
                                        "getConceptElement:org.media.mn8.concepts.StringConcept",
                                        "getConceptElement:String", "Map", "Concept"));

            // @length
            putAttribute(new FieldConcept("length", _class.getDeclaredField("length"),
                                          false, "Length", "Integer", null));
            // @index
            putAttribute(new FieldConcept("index", _class.getDeclaredField("index"),
                                          false, "Index", "Integer", null));
            
            // @hasNext
            putAttribute(new FieldConcept("hasNext", _class.getDeclaredField("hasNext"),
                                          false, "Has next ", "Logical", null));
            // @hasPrevious
            putAttribute(new FieldConcept("hasPrevious", _class.getDeclaredField("hasPrevious"),
                                          false, "Has previous ", "Logical", null));


        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new MapConcept();
    }

    public StringConcept getConceptLabel() {
        return new StringConcept("Map");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Map");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }

}



