/* 
 * $COPYRIGHT$
 * $Id: MemHandlerDefinition.java,v 1.3 2002/05/20 10:58:09 neuro Exp $
 *
 * Date        Author            Changes 
 * FEB 07 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URL;
import java.net.MalformedURLException;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.3 $ $Date: 2002/05/20 10:58:09 $
 */

public class MemHandlerDefinition extends URIHandlerDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private MemHandlerDefinition _memReference = new MemHandlerDefinition();
    
    protected MemHandlerDefinition() {
        super();
        try {            
            _inheritedConcepts.add(new StringConcept("URIHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MemHandler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "MemHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MemHandler",
                                        "closeConnection:",
                                        "closeConnection:", "MemHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MemHandler",
                                        "openConnection:",
                                        "openConnection:", "MemHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MemHandler",
                                        "getContent:",
                                        "getContent:", "MemHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MemHandler",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "MemHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MemHandler", 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "MemHandler", "MemHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.MemHandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "MemHandler", "Logical"));
        
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
  

    public LogicalConcept acceptsURI( StringConcept uri ) {
        try {
            URL url = new URL( uri.toString() );
            if( url.getProtocol().equalsIgnoreCase("mem"))
                return new LogicalConcept(true);
            else 
                return new LogicalConcept(false);
        } catch (MalformedURLException ex) {
            // we might be in Tomcat and the costom uri's don't work
            if( uri.toString().toLowerCase().startsWith("mem:")){
                return new LogicalConcept(true);
            }
        }
        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _memReference;
    }


    public Concept getConceptInstance() {
        return new MemHandler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("MemHandler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("MemHandler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
