/* 
 * $COPYRIGHT$
 * $Id: MethodDefinition.java,v 1.7 2002/03/04 00:00:20 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.7 $ $Date: 2002/03/04 00:00:20 $
 */

public class MethodDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private MethodDefinition _reference = new MethodDefinition();
    
    private MethodDefinition() {
        super();
        try {            
            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                          "invoke:org.media.mn8.Concept,org.media.mn8.concepts.SeriesConcept",
                                          "invoke:Concept,Series", "Method", "Concept"));

            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                          "getMethodSignature:",
                                          "getMethodSignature:", "Method", "String"));


            // getName: TYPEOF String
            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                          "getName:",
                                          "getName:", "Method", "String"));

            // getDeclaringConcept: TYPEOF String
            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                         "getDeclaringConcept:",
                                         "getDeclaringConcept:", "Method", "String"));


            // getReturnType: TYPEOF String
            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                          "getReturnType:",
                                          "getReturnType:", "Method", "String"));

            // hasReturn: TYPEOF Logical
            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                          "hasReturn:",
                                          "hasReturn:", "Method", "Logical"));

            // isStatic: TYPEOF Logical
            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                          "isStatic:",
                                          "isStatic:", "Method", "Logical"));

            // getParamaterTypes: TYPEOF Series
            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                          "getParameterTypes:",
                                          "getParameterTypes:", "Method", "Series"));

            // getModifiers: TYPEOF Series
            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                          "getModifiers:",
                                          "getModifiers:", "Method", "Series"));


            // toTXT: TYPEOF String
            putMethod (new mn8JavaMethod("org.media.mn8.mn8JavaMethod",
                                          "toTXT:",
                                          "toTXT:", "Method", "String"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new mn8ScriptMethod();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Method");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Method");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}

