/* 
 * $COPYRIGHT$
 * $Id: NilConcept.java,v 1.7 2001/12/19 22:01:06 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;


/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.7 $ $Date: 2001/12/19 22:01:06 $
 */
public class NilConcept extends JavaConcept {
    

    
    public LogicalConcept opEquals( Concept value) {
        if( value instanceof NilConcept )
            return new LogicalConcept(true);
        else 
            return new LogicalConcept(false);
    }


    public String toString() {
        return "";
    }


    public StringConcept toTXT() {
        return new StringConcept(toString());
    }


    public Concept opPlus( Concept value ) {
        return value;
    }

    public ConceptDefinition getConceptDefinition() {
        return NilDefinition.getReference();
    }

  
    public StringConcept toXML() {
        return toTXT();
    }


    public Object clone() {
        return new NilConcept();
    }
}
