/* 
 * $COPYRIGHT$
 * $Id: NilDefinition.java,v 1.4 2002/02/26 14:17:36 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.4 $ $Date: 2002/02/26 14:17:36 $
 */

public class NilDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private NilDefinition _reference = new NilDefinition();
    
    private NilDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.NilConcept");

            // ==:Concept TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.NilConcept",
                                          "opEquals:org.media.mn8.Concept",
                                          "==:Concept", "Nil", "Logical"));

            // +:Concept TYPEOF Concept
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.NilConcept",
                                          "opPlus:org.media.mn8.Concept",
                                          "+:Concept", "Nil", "Concept"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new NilConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Nil");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Nil");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



