/* 
 * $COPYRIGHT$
 * $Id: POP3ClientConceptDefinition.java,v 1.2 2002/02/21 10:46:59 crow Exp $
 *
 * Date        Author            Changes 
 * IAN 25 2002 Szabo Csaba       Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.2 $ $Date: 2002/02/21 10:46:59 $
 */
 
public class POP3ClientConceptDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private POP3ClientConceptDefinition _reference = new POP3ClientConceptDefinition();

        
    private POP3ClientConceptDefinition() {
        super();
        try {
            Class _class = Class.forName("org.media.mn8.concepts.POP3ClientConcept");
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.POP3ClientConcept",
                                         "openConnection:org.media.mn8.concepts.StringConcept",
                                         "openConnection:String", "POP3Client", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.POP3ClientConcept",
                                         "closeConnection:",
                                         "closeConnection:", "POP3Client", "null" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.POP3ClientConcept",
                                         "login:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "login:String,String", "POP3Client", "Logical" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.POP3ClientConcept",
                                         "logout:",
                                         "logout:", "POP3Client", "Logical" ) );

            putMethod( new mn8JavaMethod("org.media.mn8.concepts.POP3ClientConcept",
                                         "getLinks:",
                                         "getLinks:", "POP3Client", "Series" ) );
            
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.POP3ClientConcept",
                                         "getLinks:org.media.mn8.concepts.IntegerConcept",
                                         "getLinks:Integer", "POP3Client", "String" ) );
  
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.POP3ClientConcept",
                                         "delete:org.media.mn8.concepts.IntegerConcept",
                                         "delete:Integer", "POP3Client", "Logical" ) );
	
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.POP3ClientConcept",
                                         "getMessage:org.media.mn8.concepts.IntegerConcept",
                                         "getMessage:Integer", "POP3Client", "String" ) );
    
            putAttribute( new FieldConcept( "errorMessage", _class.getDeclaredField("errorMessage"),
                                            false, "errorMessage", "String", null ) );
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
    
    
    public static ConceptDefinition getReference() {
        return _reference;
    }
    

    public Concept getConceptInstance() {
        return new POP3ClientConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("POP3Client");
    }

    
    public StringConcept getConceptType() {
        return new StringConcept("POP3Client");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
