/* 
 * $COPYRIGHT$
 * $Id: POP3HandlerDefinition.java,v 1.5 2002/05/20 10:58:19 neuro Exp $
 *
 * Date        Author           Changes 
 * IAN 28 2002 Szabo Csaba      Created
 */

package org.media.mn8.concepts;

import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URL;
import java.net.MalformedURLException;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.5 $ $Date: 2002/05/20 10:58:19 $
 */

public class POP3HandlerDefinition extends URIHandlerDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private POP3HandlerDefinition _reference = new POP3HandlerDefinition();
    
    protected POP3HandlerDefinition () {
        super();
        try {            
            _inheritedConcepts.add( new StringConcept("URIHandler") );

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.POP3Handler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "POP3Handler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.POP3Handler",
                                        "closeConnection:",
                                        "closeConnection:", "POP3Handler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.POP3Handler",
                                        "openConnection:",
                                        "openConnection:", "POP3Handler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.POP3Handler",
                                        "getContent:",
                                        "getContent:", "POP3Handler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.POP3Handler",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "POP3Handler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.POP3Handler", 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "POP3Handler", "POP3Handler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.POP3HandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "POP3Handler", "Logical"));
        
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }


    public LogicalConcept acceptsURI( StringConcept uri ) {
        try {
            URL url = new URL( uri.toString() );
            if( url.getProtocol().equalsIgnoreCase("pop3"))
                return new LogicalConcept(true);
            else 
                return new LogicalConcept(false);
        } catch (MalformedURLException ex) {
            // we might be in Tomcat and the costom uri's don't work
            if( uri.toString().toLowerCase().startsWith("pop3:")){
                return new LogicalConcept(true);
            }
        }
        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new POP3Handler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("POP3Handler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("POP3Handler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
