/* 
 * $COPYRIGHT$
 * $Id: ProcessDefinition.java,v 1.1 2002/02/28 20:29:02 crow Exp $
 *
 * Date        Author            Changes 
 * FEB 28 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;

import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.1 $ $Date: 2002/02/28 20:29:02 $
 */

public class ProcessDefinition extends ConceptConceptDefinition {
       
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private ProcessDefinition     _reference = new ProcessDefinition();

    
    private ProcessDefinition() {
        super();
        try {
            Class _class = Class.forName("org.media.mn8.concepts.ProcessConcept" );

            putMethod( new mn8JavaMethod("org.media.mn8.concepts.ProcessConcept", false,
                                         "setInput:org.media.mn8.concepts.StringConcept",
                                         "setInput:String", "Process", null ) );

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ProcessConcept", false,
                                        "exec:org.media.mn8.concepts.StringConcept",
                                        "exec:String", "Process", "Process" ) );

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ProcessConcept", false,
                                        "exec:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "exec:String,String", "Process", "Process" ) );

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ProcessConcept", false,
                                        "exec:org.media.mn8.concepts.SeriesConcept",
                                        "exec:Series", "Process", "Process" ) );

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.ProcessConcept", false,
                                        "exec:org.media.mn8.concepts.SeriesConcept,org.media.mn8.concepts.StringConcept",
                                        "exec:Series,String", "Process", "Process" ) );

            putAttribute( new FieldConcept("exitValue", _class.getDeclaredField("exitValue") ,
                                           false, "exitValue", "String", null ) );

            putElement( new FieldConcept("error", _class.getDeclaredField("error"),
                                          false, "error", "String", null) );
 
            putElement( new FieldConcept("input", _class.getDeclaredField("input"),
                                         false, "input", "String", null) );
            
            putElement( new FieldConcept("output", _class.getDeclaredField("output"),
                                         false, "output", "String", null) );
        } 
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
     

    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new ProcessConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Process");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Process");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
