/* 
 * $COPYRIGHT$
 * $Id: RealDefinition.java,v 1.11 2002/05/02 18:25:43 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.11 $ $Date: 2002/05/02 18:25:43 $
 */

public class RealDefinition extends ConceptConceptDefinition {

    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private RealDefinition _reference = new RealDefinition();

    protected RealDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.RealConcept");

            //create:String TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept", false, 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "Real", "Real" ));

            // toStringConcept: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "toStringConcept:",
                                        "toStringConcept:", "Real", "String"));


            // toLogicalConcept: TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "toLogicalConcept:",
                                        "toLogicalConcept:", "Real", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "round:",
                                        "round:", "Real", "Integer"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "abs:",
                                        "abs:", "Real", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "max:org.media.mn8.concepts.RealConcept",
                                        "max:Real", "Real", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "min:org.media.mn8.concepts.RealConcept",
                                        "min:Real", "Real", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "acos:",
                                        "acos:", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "asin:",
                                        "asin:", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "atan:",
                                        "atan:", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "ceil:",
                                        "ceil:", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "cos:",
                                        "cos:", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "exp:",
                                        "exp:", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "floor:",
                                        "floor:", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "log:",
                                        "log:", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "pow:org.media.mn8.concepts.RealConcept",
                                        "pow:Real", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "sin:",
                                        "sin:", "Real", "Real"));
 
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "tan:",
                                        "tan:", "Real", "Real"));
 
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "toDegrees:",
                                        "toDegrees:", "Real", "Real"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "toRadians:",
                                        "toRadians:", "Real", "Real"));
             // main: Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "main:org.media.mn8.concepts.SeriesConcept",
                                        "main:Series", "Real", null));

            // +:Real TYPEOF Real
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opPlus:org.media.mn8.concepts.RealConcept",
                                          "+:Real", "Real", "Real"));

            // ++:Real TYPEOF Real
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opRealINC:",
                                          "++:", "Real", "Real"));

            // -:Real TYPEOF Real
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opMinus:org.media.mn8.concepts.RealConcept",
                                          "-:Real", "Real", "Real"));

            // --:Real TYPEOF Real
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opRealDEC:",
                                          "--:", "Real", "Real"));

            // *:Real TYPEOF Real
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opSTAR:org.media.mn8.concepts.RealConcept",
                                          "*:Real", "Real", "Real"));

            // /:Real TYPEOF Real
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opDIV:org.media.mn8.concepts.RealConcept",
                                          "/:Real", "Real", "Real"));

            // ==:Real TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opEqual:org.media.mn8.concepts.RealConcept",
                                          "==:Real", "Real", "Logical"));

            // >:Real TYPEOF  Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opGT:org.media.mn8.concepts.RealConcept",
                                          ">:Real", "Real", "Logical"));

            // >=:Real TYPEOF  Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opGE:org.media.mn8.concepts.RealConcept",
                                          ">=:Real", "Real", "Logical"));

            // <:Real TYPEOF Real
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opLT:org.media.mn8.concepts.RealConcept",
                                          "<:Real", "Real", "Logical"));

            // <=:Real TYPEOF Real
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                          "opLE:org.media.mn8.concepts.RealConcept",
                                          "<=:Real", "Real", "Logical"));
            // sqrt TYPEOF Real
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "sqrt:",
                                        "sqrt:", "Real", "Real"));

            // mod:Real TYPEOF Real
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RealConcept",
                                        "mod:org.media.mn8.concepts.RealConcept",
                                        "mod:Real", "Real", "Real"));
        }catch (Exception ex) {
            ex.printStackTrace();
        }

     }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new RealConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Real");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Real");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }

}

