/* 
 * $COPYRIGHT$
 * $Id: RegexpConcept.java,v 1.2 2002/01/29 23:04:15 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import org.apache.oro.text.regex.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/01/29 23:04:15 $
 */
public class RegexpConcept extends ExpressionConcept {

    private Pattern _pattern = null;

    public RegexpConcept( ){
    }

    
    public RegexpConcept( StringConcept pattern ) throws MalformedPatternException {
        _pattern = (new Perl5Compiler()).compile( pattern.toString());
    }


    public ExpressionConcept create( StringConcept pattern ) throws MalformedPatternException {
        _pattern = (new Perl5Compiler()).compile( pattern.toString());
        return this;
    }
    

    public void setPattern( StringConcept pattern ) throws MalformedPatternException {
        _pattern = (new Perl5Compiler()).compile( pattern.toString());
    }

    
    public StringConcept getPattern () {
        if( _pattern == null )
            return new StringConcept();

        return new StringConcept(_pattern.getPattern());
    }


    public LogicalConcept matches( StringConcept string ) {
        Perl5Matcher matcher = new Perl5Matcher();
        return new LogicalConcept( matcher.matches( string.toString(), _pattern));
    }


    public LogicalConcept contains( StringConcept string ) {
        Perl5Matcher matcher = new Perl5Matcher();
        return new LogicalConcept( matcher.contains( string.toString(), _pattern));      
    }

    
    public SeriesConcept getMatches( StringConcept string ) {
        SeriesConcept result = new SeriesConcept();
        PatternMatcherInput input = new PatternMatcherInput( string.toString());
        Perl5Matcher matcher = new Perl5Matcher();
        MatchResult tmpResult = null;
        
        while(matcher.contains(input, _pattern)) {
            tmpResult = matcher.getMatch();

            if( tmpResult.groups() > 2 ) {
                SeriesConcept tempRes = new SeriesConcept();
                for( int i=1; i < tmpResult.groups(); i++ ) {
                    if( tmpResult.group(i) != null )
                        tempRes.add( new StringConcept( tmpResult.group(i)));
                }
                result.add( tempRes );
            } else if ( tmpResult.groups() ==2 && tmpResult.group(1) != null ) {
                result.add( new StringConcept(tmpResult.group(1)));
            }
        }
        return result;
    }

    
    public StringConcept toTXT() {
        return getPattern();
    }

 
    public Object clone() {
        try {
            if( _pattern != null )
                return new RegexpConcept( getPattern());
            else
                return new RegexpConcept();
        } catch ( MalformedPatternException ex ) {
            // this can not happen if already passed the pattern test it will pass again
            ex.printStackTrace();
            return null;
        }
    }

    
    public ConceptDefinition getConceptDefinition() {
        return RegexpDefinition.getReference();
    }
}
