/* 
 * $COPYRIGHT$
 * $Id: RegexpDefinition.java,v 1.3 2002/01/29 23:04:22 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import org.apache.oro.text.regex.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/01/29 23:04:22 $
 */
public class RegexpDefinition extends ExpressionDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private RegexpDefinition _reference = new RegexpDefinition();
    
    private RegexpDefinition() {
        super();
        try {            
            
            _inheritedConcepts.add( new StringConcept("Expression"));
            // create:String TYPEOF Regexp
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RegexpConcept", false,
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "Regexp", "Regexp"));

            // getPattern: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RegexpConcept",
                                        "getPattern:",
                                        "getPattern:", "Regexp", "String"));

            // setPattern:String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RegexpConcept",
                                        "setPattern:org.media.mn8.concepts.StringConcept",
                                        "setPattern:String", "Regexp", null));

            // matches:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RegexpConcept",
                                        "matches:org.media.mn8.concepts.StringConcept",
                                        "matches:String", "Regexp", "Logical"));

            // contains:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RegexpConcept",
                                        "contains:org.media.mn8.concepts.StringConcept",
                                        "contains:String", "Regexp", "Logical"));

            // matches:String,String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RegexpDefinition", true,
                                        "matches:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "matches:String,String", "Regexp", "Logical"));

            // contains:String,String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RegexpDefinition", true,
                                        "contains:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "contains:String,String", "Regexp", "Logical"));

            // getMatches:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RegexpConcept",
                                        "getMatches:org.media.mn8.concepts.StringConcept",
                                        "getMatches:String", "Regexp", "Series"));

            // STATIC getMatches:String,String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.RegexpDefinition", true,
                                        "getMatches:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "getMatches:String,String", "Regexp", "Series"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public LogicalConcept matches( StringConcept pattern, StringConcept string) throws MalformedPatternException {
        return (new RegexpConcept(pattern)).matches( string);
    }


    public LogicalConcept contains( StringConcept pattern, StringConcept string) throws MalformedPatternException {
        return (new RegexpConcept(pattern)).contains( string);
    }


    public SeriesConcept getMatches( StringConcept pattern, StringConcept string) throws MalformedPatternException {
        return (new RegexpConcept(pattern)).getMatches( string);
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new RegexpConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Regexp");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Regexp");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



