/* 
 * $COPYRIGHT$
 * $Id: SMTPHandlerDefinition.java,v 1.5 2002/05/20 10:58:29 neuro Exp $
 *
 * Date        Author           Changes 
 * IAN 28 2002 Szabo Csaba      Created
 */

package org.media.mn8.concepts;

import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URL;
import java.net.MalformedURLException;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.5 $ $Date: 2002/05/20 10:58:29 $
 */

public class SMTPHandlerDefinition extends URIHandlerDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private SMTPHandlerDefinition _reference = new SMTPHandlerDefinition();
    
    protected SMTPHandlerDefinition () {
        super();
        try {            
            _inheritedConcepts.add( new StringConcept("URIHandler") );

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SMTPHandler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "SMTPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SMTPHandler",
                                        "closeConnection:",
                                        "closeConnection:", "SMTPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SMTPHandler",
                                        "openConnection:",
                                        "openConnection:", "SMTPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SMTPHandler",
                                        "getContent:",
                                        "getContent:", "SMTPHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SMTPHandler",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "SMTPHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SMTPHandler", 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "SMTPHandler", "SMTPHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SMTPHandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "SMTPHandler", "Logical"));
        
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
 

    public LogicalConcept acceptsURI( StringConcept uri ) {
        try {
            URL url = new URL( uri.toString() );
            if( url.getProtocol().equalsIgnoreCase("smtp"))
                return new LogicalConcept(true);
            else 
                return new LogicalConcept(false);
        } catch (MalformedURLException ex) {
            // we might be in Tomcat and the costom uri's don't work
            if( uri.toString().toLowerCase().startsWith("smtp:")){
                return new LogicalConcept(true);
            }
        }

        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new SMTPHandler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("SMTPHandler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("SMTPHandler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
