/* 
 * $COPYRIGHT$
 * $Id: SeriesDefinition.java,v 1.11 2002/04/26 09:40:30 atech Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.11 $ $Date: 2002/04/26 09:40:30 $
 */

public class SeriesDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private SeriesDefinition _reference = new SeriesDefinition();
    
    protected SeriesDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.SeriesConcept");
            // toTXT:
            putMethod(new mn8JavaMethod(_class.getDeclaredMethod("toTXT", null), 
                                        null, "Series", "String"));
            // toXML:
            putMethod(new mn8JavaMethod(_class.getDeclaredMethod("toXML", null), 
                                        null, "Series", "String"));            
            // next:
            putMethod(new mn8JavaMethod(_class.getDeclaredMethod("next", null), 
                                        null, "Series", "Concept"));
            // current:
            putMethod(new mn8JavaMethod(_class.getDeclaredMethod("current", null), 
                                        null, "Series", "Concept"));
            // previous:
            putMethod(new mn8JavaMethod(_class.getDeclaredMethod("previous", null), 
                                        null, "Series", "Concept"));            
            // add:Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "add:org.media.mn8.Concept",
                                        "add:Concept", "Series", null));

            // insert:Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "insert:org.media.mn8.Concept",
                                        "insert:Concept", "Series", null));
            // remove: TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "remove:",
                                        "remove:", "Series", "Concept"));

            // remove: Integer TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "remove:org.media.mn8.concepts.IntegerConcept",
                                        "remove:Integer", "Series", "Concept"));

            // elementAt:Integer TYPEOF Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "elementAt:org.media.mn8.concepts.IntegerConcept",
                                        "elementAt:Integer", "Series", "Concept"));
            // sort:Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "sort:org.media.mn8.Concept",
                                        "sort:Concept", "Series", null));

            // setIndex:Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "setIndex:org.media.mn8.concepts.IntegerConcept",
                                        "setIndex:Integer", "Series", null));

            // insert:Integer, Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "insert:org.media.mn8.concepts.IntegerConcept,org.media.mn8.Concept",
                                        "insert:Integer,Concept", "Series", null));
            // insert:Concept
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "insert:org.media.mn8.Concept",
                                        "insert:Concept", "Series", null));

            // getConceptElementFields
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept", false,
                                        "getConceptElements:",
                                        "getConceptElements:", "Series", "Series"));

            // getConceptElement:String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept", false,
                                        "getConceptElement:org.media.mn8.concepts.StringConcept",
                                        "getConceptElement:String", "Series", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "contains:org.media.mn8.Concept",
                                        "contains:Concept", "Series", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                        "indexOf:org.media.mn8.Concept",
                                        "IndexOf:Concept", "Series", "Integer"));

            // @length
            putAttribute(new FieldConcept("length", _class.getDeclaredField("length"),
                                          false, "Length", "Integer", null));
            // @index
            putAttribute(new FieldConcept("index", _class.getDeclaredField("index"),
                                          false, "Index", "Integer", null));
            
            // @hasNext
            putAttribute(new FieldConcept("hasNext", _class.getDeclaredField("hasNext"),
                                          false, "Has next ", "Logical", null));
            // @hasPrevious
            putAttribute(new FieldConcept("hasPrevious", _class.getDeclaredField("hasPrevious"),
                                          false, "Has previous ", "Logical", null));

           // ==:Series TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.SeriesConcept",
                                          "equals:org.media.mn8.concepts.SeriesConcept",
                                          "==:Series", "Series", "Logical"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new SeriesConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Series");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Series");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }

}



