/* 
 * $COPYRIGHT$
 * $Id: SimplexConcept.java,v 1.3 2002/03/22 16:37:22 atech Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import org.apache.oro.text.regex.MalformedPatternException;
import org.media.mn8.util.SimpleExpression;
import java.util.Collection;
import java.util.Iterator;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/03/22 16:37:22 $
 */
public class SimplexConcept extends ExpressionConcept {

    private String _pattern = null;

    public SimplexConcept( ){
    }

    
    public SimplexConcept( StringConcept pattern ) throws MalformedPatternException {
        _pattern = pattern.toString();
    }

    
    public void setPattern( StringConcept pattern ) throws MalformedPatternException {
        _pattern = pattern.toString();
    }



    public ExpressionConcept create( StringConcept pattern ) throws MalformedPatternException {
        setPattern(pattern);
        return this;
    }

    
    public StringConcept getPattern () {
        return new StringConcept(_pattern);
    }


    public LogicalConcept matches( StringConcept string ) {
           return new LogicalConcept( SimpleExpression.match( string.toString(), _pattern));
    }


    public LogicalConcept contains( StringConcept string ) {
          return new LogicalConcept( SimpleExpression.contains( string.toString(), _pattern));      
    }

    
    public SeriesConcept getMatches( StringConcept string ) {
        SeriesConcept result = new SeriesConcept();
        Collection matches = SimpleExpression.select(string.toString(), _pattern);
        return collectionToSeries( result, matches);
    }

    
    private SeriesConcept collectionToSeries(SeriesConcept in, Collection from) {
        Object inst = null;
        SeriesConcept currRes = in;

        if( from != null ) {
            Iterator matIter = from.iterator();
            while( matIter.hasNext() ) {
                inst = matIter.next();
                if( inst instanceof String[] ) {
                    String[] res = (String[]) inst;
                    for( int i=0; i < res.length; i++){
                        currRes.add( new StringConcept( res[i]));
                    }
                } else if( inst instanceof String ) {
                    currRes.add( new StringConcept( (String) inst ));
                } else if( inst instanceof Collection ) {
                    currRes.add(collectionToSeries( new SeriesConcept(), (Collection) inst));
                }
            }
        }
        return currRes;
    }
 

    public Object clone() {
        try {
            if( _pattern != null )
                return new SimplexConcept( getPattern());
            else
                return new SimplexConcept();
        } catch ( MalformedPatternException ex ) {
            // this can not happen if already passed the pattern test it will pass again
            ex.printStackTrace();
            return null;
        }
    }


    public StringConcept toTXT() {
        return getPattern();
    }

    
    public ConceptDefinition getConceptDefinition() {
        return SimplexDefinition.getReference();
    }
}
