/* 
 * $COPYRIGHT$
 * $Id: StringDefinition.java,v 1.13 2002/05/20 10:58:46 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.13 $ $Date: 2002/05/20 10:58:46 $
 */

public class StringDefinition extends ConceptConceptDefinition {

    private static StringConcept _stringType = new StringConcept("String");
    private static StringConcept _stringLabel = new StringConcept("String");
    private static SeriesConcept _stringInheritedConcepts = new SeriesConcept("Concept");
    static private StringDefinition _reference = new StringDefinition();

    private StringDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.StringConcept");
            putMethod(new mn8JavaMethod(_class.getDeclaredMethod("toStringConcept", null), 
                                        null, "String", "String"));

            // charAt:Integer TYPEOF Character
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "charAt:org.media.mn8.concepts.IntegerConcept",
                                        "charAt:Integer", "String", "Character"));

            // equalsIgoreCase:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "equalsIgnoreCase:org.media.mn8.concepts.StringConcept",
                                        "equalsIgnoreCase:String", "String", "Logical"));

            // compareTo:String TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "compareTo:org.media.mn8.concepts.StringConcept",
                                        "compareTo:String", "String", "Integer"));

            // startWith:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "startsWith:org.media.mn8.concepts.StringConcept",
                                        "startsWith:String", "String", "Logical"));


            // startWith:String,Integer TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "startsWith:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.IntegerConcept",
                                        "startsWith:String,Integer", "String", "Logical"));

            // endsWith:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "endsWith:org.media.mn8.concepts.StringConcept",
                                        "endsWith:String", "String", "Logical"));

            // indexOf:String, Integer TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "indexOf:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.IntegerConcept",
                                        "indexOf:String,Integer", "String", "Integer"));

            // indexOf:String TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "indexOf:org.media.mn8.concepts.StringConcept",
                                        "indexOf:String", "String", "Integer"));

            // lastIndexOf:String TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "lastIndexOf:org.media.mn8.concepts.StringConcept",
                                        "lastIndexOf:String", "String", "Integer"));

            // lastIndexOf:String, Integer TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "lastIndexOf:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.IntegerConcept",
                                        "lastIndexOf:String,Integer", "String", "Integer"));

            // substring:Integer, Integer TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "substring:org.media.mn8.concepts.IntegerConcept,org.media.mn8.concepts.IntegerConcept",
                                        "substring:Integer,Integer", "String", "String"));

            // substring:Integer TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "substring:org.media.mn8.concepts.IntegerConcept",
                                        "substring:Integer", "String", "String"));


            // replace:Character, Characte TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "replace:org.media.mn8.concepts.CharacterConcept,org.media.mn8.concepts.CharacterConcept",
                                        "replace:Character,Character", "String", "String"));

            // trim: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "trim:",
                                        "trim:", "String", "String"));

            // toLowerCase: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "toLowerCase:",
                                        "toLowerCase:", "String", "String"));

            // toUpperCase: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "toUpperCase:",
                                        "toUpperCase:", "String", "String"));

            // getTokens:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "getTokens:org.media.mn8.concepts.StringConcept",
                                        "getTokens:String", "String", "Series"));

            // getTokensWithDelimiters:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "getTokensWithDelimiters:org.media.mn8.concepts.StringConcept",
                                        "getTokensWithDelimiters:String", "String", "Series"));

            // getLines:String TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "getLines:",
                                        "getLines:", "String", "Series"));

            // wrap: TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "wrap:",
                                        "wrap:", "String", "String"));

            // wrap:Integer TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "wrap:org.media.mn8.concepts.IntegerConcept",
                                        "wrap:Integer", "String", "String"));

            // wrap:Integer,String TYPEOF String
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "wrap:org.media.mn8.concepts.IntegerConcept,org.media.mn8.concepts.StringConcept",
                                        "wrap:Integer,String", "String", "String"));

            // select:Expression TYPEOF Series
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "select:org.media.mn8.concepts.ExpressionConcept",
                                        "select:Expression", "String", "Series"));

            // matches:Expression TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "matches:org.media.mn8.concepts.ExpressionConcept",
                                        "matches:Expression", "String", "Logical"));

            // contains:Expression TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "contains:org.media.mn8.concepts.ExpressionConcept",
                                        "contains:Expression", "String", "Logical"));

            // contains:String TYPEOF Logical
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "contains:org.media.mn8.concepts.StringConcept",
                                        "contains:String", "String", "Logical"));

            // +:String TYPEOF String
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opPlus:org.media.mn8.concepts.StringConcept",
                                          "+:String", "String", "String"));
            // +:Integer TYPEOF String
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opPlus:org.media.mn8.concepts.IntegerConcept",
                                          "+:Integer", "String", "String"));
            // +:Real TYPEOF String
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opPlus:org.media.mn8.concepts.RealConcept",
                                          "+:Real", "String", "String"));
            // +:Logical TYPEOF String
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opPlus:org.media.mn8.concepts.LogicalConcept",
                                          "+:Logical", "String", "String"));
            // +:Character TYPEOF String
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opPlus:org.media.mn8.concepts.CharacterConcept",
                                          "+:Character", "String", "String"));

            // +:Concept TYPEOF String
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opPlus:org.media.mn8.Concept",
                                          "+:Concept", "String", "String"));

            // ==:String TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opEquals:org.media.mn8.concepts.StringConcept",
                                          "==:String", "String", "Logical"));

            // <:String TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opLT:org.media.mn8.concepts.StringConcept",
                                          "<:String", "String", "Logical"));

            // >:String TYPEOF Logical
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opGT:org.media.mn8.concepts.StringConcept",
                                          ">:String", "String", "Logical"));

            // +:Nil TYPEOF String
            putOperator(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                          "opPlus:org.media.mn8.concepts.NilConcept",
                                          "+:Nil", "String", "String"));
            // getLength: TYPEOF Integer
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.StringConcept",
                                        "getLength:",
                                        "getLength:", "String", "Integer"));

      
        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new StringConcept();
    }


    public StringConcept getConceptLabel() {
        return _stringLabel;
    }


    public StringConcept getConceptType() {
        return _stringType;
    }


    public SeriesConcept getInheritedConcepts() {
        return _stringInheritedConcepts;
    }

}

