/* 
 * $COPYRIGHT$
 * $Id: Tag.java,v 1.2 2002/01/31 20:30:04 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;

import org.media.mn8.Concept;
import org.media.mn8.JavaConcept;
import org.media.mn8.ConceptDefinition;
import java.util.Vector;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/01/31 20:30:04 $
 */
public class Tag extends JavaConcept {

    public AttributeConcept isClosing = new AttributeConcept("isClosing", "isClosing", new LogicalConcept(false));
    public AttributeConcept name = new AttributeConcept("name", "name", new StringConcept());
    
    protected AttributeSeries attributes = new AttributeSeries();

    public Tag( ){

    }
  
    
    public Concept create() {
        return this;
    }


    public Tag( String name, boolean isClosing, Vector attributes ) {
        this.name.setAttributeValue(new StringConcept(name));
        this.isClosing.setAttributeValue(new LogicalConcept(isClosing));
        if( attributes != null )
            this.attributes = new AttributeSeries(attributes);
    }

    public SeriesConcept getAttributes() {
        return attributes;
    }


    public void setAttributes( SeriesConcept value ) {
        attributes = new AttributeSeries( value.getVector());
    }


    public Object clone() {
        return new Tag( name.getAttributeValue().toTXT().toString(),
                        ((LogicalConcept)isClosing.getAttributeValue()).getValue(),
                        attributes.getVector());
    }


    public ConceptDefinition getConceptDefinition() {
        return TagDefinition.getReference();
    }


    public StringConcept toTXT() {
        return toXML();
    }
    

    public int hashCode() {
        return name.getAttributeValue().toTXT().toString().hashCode();
    }


    public boolean equals(Object obj) {
        if( obj instanceof Tag ) {
            return hashCode() == obj.hashCode();
        }
        return false;
    }


    public StringConcept toXML() {

        boolean closing = ((LogicalConcept)isClosing.getAttributeValue()).getValue();
        String tname = name.getAttributeValue().toTXT().toString();

        if(closing) {
            if( tname.startsWith("?")) {
                return new StringConcept("<" + tname + ">");
            } else if( tname.startsWith("!--")) {
                return new StringConcept("<" + tname + ">");
            } else if( tname.startsWith("!")) {
                return new StringConcept("<" + tname + ">");
            }else if( attributes.getVector().size() == 0 ) {
                return new StringConcept("</" + tname + ">");
            }else {
                return new StringConcept("<" + tname + attributes.toXML().toString() + "/>");
            }
        }else {
                return new StringConcept("<" + tname + attributes.toXML().toString() +  ">");
        }
    }
}
