/* 
 * $COPYRIGHT$
 * $Id: TagDefinition.java,v 1.4 2002/01/31 20:30:14 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import org.media.mn8.protocol.http.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.4 $ $Date: 2002/01/31 20:30:14 $
 */
public class TagDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private TagDefinition _reference = new TagDefinition();
    
    private TagDefinition() {
        super();
        try {            
            Class _class = Class.forName("org.media.mn8.concepts.Tag");

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.Tag",
                                        "getAttributes:",
                                        "getAttributes:", "Tag", "Series"));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.Tag",
                                        "toXML:",
                                        "toXML:", "Tag", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.Tag",
                                        "toTXT:",
                                        "toTXT:", "Tag", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.Tag", false,
                                        "setAttributes:org.media.mn8.concepts.SeriesConcept",
                                        "setAttributes:Series", "Tag", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.Tag", 
                                        "create:",
                                        "create:", "Tag", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TagDefinition", true,
                                        "extractTags:org.media.mn8.concepts.StringConcept",
                                        "extractTags:String", "Tag", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TagDefinition", true,
                                        "extractTagsWithText:org.media.mn8.concepts.StringConcept",
                                        "extractTagsWithText:String", "Tag", "Series"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TagDefinition", true,
                                        "getStrippedText:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.LogicalConcept",
                                        "getStrippedText:String,Logical", "Tag", "String"));
            
            putAttribute(new FieldConcept("isClosing", _class.getDeclaredField("isClosing"),
                                          false, "isClosing", "Logical", null));

            putAttribute(new FieldConcept("name", _class.getDeclaredField("name"),
                                          false, "name", "String", null));

        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
  
    
    public StringConcept getStrippedText(StringConcept taggedText, LogicalConcept withLinks) {
        return new StringConcept( TagStriper.strip_tags(taggedText.toString(), withLinks.getValue()));
    }

    public SeriesConcept extractTags(StringConcept value) {
        TagExtractor extractor = new TagExtractor(null, false);
        return new SeriesConcept( extractor.parsePage( value.toString()));
    }


    public SeriesConcept extractTagsWithText(StringConcept value) {
        TagExtractor extractor = new TagExtractor(null, true);
        return new SeriesConcept( extractor.parsePage( value.toString()));
    }

    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new Tag();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("Tag");
    }


    public StringConcept getConceptType() {
        return new StringConcept("Tag");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



