/*
 * $COPYRIGHT$
 * $Id: TarDefinition.java,v 1.1 2002/02/27 19:15:42 crow Exp $
 *
 * Date        Author            Changes
 * FEB 25 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;
       
import org.media.mn8.*;
import org.media.mn8.event.*;
       
/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.1 $ $Date: 2002/02/27 19:15:42 $
 */
 
public class TarDefinition extends ConceptConceptDefinition {
 
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private TarDefinition         _reference = new TarDefinition();
	 
	 
    private TarDefinition() {
        super();
        try {

            //create specified TAR file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.TarConcept", 
                                         "create:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.LogicalConcept",
                                         "create:String,Logical", "Tar", "Tar" ) );

            //add specified file or directory to Tar file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.TarConcept", 
                                         "add:org.media.mn8.concepts.StringConcept",
                                         "add:String", "Tar", null ) );
            
            //add specified string to Tar file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.TarConcept", 
                                         "add:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "add:String,String", "Tar", null ) );
         
            //list specified Tar file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.TarConcept", 
                                         "list:",
                                         "list:", "Tar", "Series" ) );

            //view specified file from Tar file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.TarConcept", 
                                         "view:org.media.mn8.concepts.StringConcept",
                                         "view:String", "Tar", "Series" ) );

            //delete specified file from Tar file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.TarConcept", 
                                         "delete:org.media.mn8.concepts.StringConcept",
                                         "delete:String", "Tar", "Series" ) );

            //extract all files from Tar file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.TarConcept", 
                                         "extractAll:org.media.mn8.concepts.StringConcept",
                                         "extractAll:String", "Tar", null ) );
 
           //extract specified  file from Tar file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.TarConcept", 
                                         "extract:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "extract:String,String", "Tar", null ) );

        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
						 
    
    public static ConceptDefinition getReference() {
        return _reference;
    }
    
    
    public Concept getConceptInstance() {
        return new TarConcept();
    }
    
    
    public StringConcept getConceptLabel() {
        return new StringConcept("Tar");
    }
												 
												 
    public StringConcept getConceptType() {
        return new StringConcept("Tar");
    }
    
    
    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
