/* 
 * $COPYRIGHT$
 * $Id: TransparentElement.java,v 1.7 2002/06/05 14:54:49 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;

import org.media.mn8.Concept;
import org.media.mn8.mn8Method;
import org.media.mn8.mn8Loader;
import org.media.mn8.mn8Concept;
import org.media.mn8.Helper;
import org.media.mn8.mn8RuntimeFlags;
import java.util.Vector;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.7 $ $Date: 2002/06/05 14:54:49 $
 */
public class TransparentElement extends ElementConcept {


    public TransparentElement(){
        super();
    }
    

    public TransparentElement( String name, String label, Concept value, SeriesConcept attributes ) {
        super( name, label, value, attributes);
        if( value != null ) {
            _showEmpty = value.showEmpty().getValue();
            _isHidden = value.isHidden().getValue();
        }
    }


    public TransparentElement( String name, String label, Concept value, SeriesConcept attributes, boolean multi, String multiType ) {
        super( name, label, value, attributes, multi, multiType );
        if( value != null ) {
            _showEmpty = value.showEmpty().getValue();
            _isHidden = value.isHidden().getValue();
        }
    }


    public StringConcept toTXT() {
        if( isHidden().getValue() ) {
            return new StringConcept();
        }

        StringConcept result = _value.toTXT();
        if( !showEmpty().getValue() && result.toString().trim().equals("")
            && _value.getConceptAttributes().toXML().toString().trim().equals("")){

            return new StringConcept();
        }

        return result;
    }


    public void setShowEmpty(LogicalConcept showEmpty) {
        super.setShowEmpty(showEmpty);
        _value.setShowEmpty(showEmpty);
    }


    public void setHidden(LogicalConcept isHidden) {
        super.setHidden(isHidden);
        _value.setHidden(isHidden);
    }
  

    public StringConcept toXML() {
        if( isHidden().getValue() ) {
            return new StringConcept();
        }
        _value.setConceptLabel( getConceptLabel());

        StringConcept result = _value.toXML();
        if( !showEmpty().getValue() && result.toString().trim().equals("")
            && _value.getConceptAttributes().toXML().toString().trim().equals("")){
            return new StringConcept();
        }

        return result;
    }
   
    public StringConcept getConceptType() {
        return _value.getConceptType();
    }
        
    
    public void loadContent(Concept concept) {
        if( _value == null ) return;

        if( concept instanceof TransparentElement ) {
            _value.loadContent( ((TransparentElement)concept).getValue());
        } else {
            _value.loadContent(concept);
        }
    }


    public Object clone() {
        TransparentElement result=  new TransparentElement( _name.toString(), 
                                                            _label.toString(), 
                                                            _value, 
                                                            _attribs);
        result.setShowEmpty(showEmpty());
        result.setHidden(isHidden());
        return result;
    }

}
