/* 
 * $COPYRIGHT$
 * $Id: TypedSeriesDefinition.java,v 1.4 2002/05/02 22:11:27 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.4 $ $Date: 2002/05/02 22:11:27 $
 */

public class TypedSeriesDefinition extends SeriesDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private TypedSeriesDefinition _reference = new TypedSeriesDefinition();
    
    protected TypedSeriesDefinition() {
        super();
        _inheritedConcepts.add(new StringConcept("Series"));
        try {            
    	    
            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TypedSeries", 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "TypedSeries", "TypedSeries" ));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TypedSeries", 
                                        "create:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.SeriesConcept",
                                        "create:String,Series", "TypedSeries", "TypedSeries" ));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TypedSeries",
                                        "createNewEntry:",
                                        "createNewEntry:", "TypedSeries", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TypedSeries",
                                        "addEntry:org.media.mn8.Concept",
                                        "addEntry:Concept", "TypedSeries", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TypedSeries",
                                        "lastEntry:",
                                        "lastEntry:", "TypedSeries", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TypedSeries",
                                        "getType:",
                                        "getType:", "TypedSeries", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.TypedSeries",
                                        "setType:org.media.mn8.concepts.StringConcept",
                                        "setType:String", "TypedSeries", null));


        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new TypedSeries();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("TypedSeries");
    }


    public StringConcept getConceptType() {
        return new StringConcept("TypedSeries");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



