/* 
 * $COPYRIGHT$
 * $Id: URIDefinition.java,v 1.3 2002/05/02 18:25:12 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URLEncoder;
import java.net.URLDecoder;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/05/02 18:25:12 $
 */
public class URIDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private URIDefinition _reference = new URIDefinition();
    
    private URIDefinition() {
        super();
        try {            

            Class _class = Class.forName("org.media.mn8.concepts.URI");

            putAttribute(new FieldConcept("uri", _class.getDeclaredField("uri"),
                                          false, "uri", "String", null));

            putAttribute(new FieldConcept("length", _class.getDeclaredField("length"),
                                          false, "length", "Integer", null));

            putAttribute(new FieldConcept("contentType", _class.getDeclaredField("contentType"),
                                          false, "contentType", "Integer", null));

            putElement(new FieldConcept("opt", _class.getDeclaredField("options"),
                                          false, "opt", "Map", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URI", false,
                                        "setUri:org.media.mn8.concepts.StringConcept",
                                        "setUri:String", "URI", null));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URI", false,
                                        "getURIHandler:",
                                        "getURIHandler:", "URI", "URIHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URIDefinition", true,
                                        "urlEncode:org.media.mn8.concepts.StringConcept",
                                        "urlEncode:String", "URI", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URIDefinition", true,
                                        "urlDecode:org.media.mn8.concepts.StringConcept",
                                        "urlDecode:String", "URI", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URI", false,
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "URI", "URI"));
        
        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    

    
    
    public StringConcept urlEncode(StringConcept value) {
        return new StringConcept( URLEncoder.encode( value.toString()));
    }


    public StringConcept urlDecode(StringConcept value) {
        return new StringConcept( URLDecoder.decode( value.toString()));
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new URI();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("URI");
    }


    public StringConcept getConceptType() {
        return new StringConcept("URI");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



