/* 
 * $COPYRIGHT$
 * $Id: URIHandlerDefinition.java,v 1.2 2002/01/31 20:30:43 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/01/31 20:30:43 $
 */
public class URIHandlerDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private URIHandlerDefinition _reference = new URIHandlerDefinition();
    
    protected URIHandlerDefinition() {
        super();
        try {            

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URIHandler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "URIHandler", "Logical"));


            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URIHandler",
                                        "closeConnection:",
                                        "closeConnection:", "URIHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URIHandler",
                                        "openConnection:",
                                        "openConnection:", "URIHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URIHandler",
                                        "getContent:",
                                        "getContent:", "URIHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URIHandler",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "URIHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URIHandler", false,
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "URIHandler", "URIHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.URIHandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "URIHandler", "Logical"));
        
        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
 

    public LogicalConcept acceptsURI(StringConcept uri ) {
        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new URIHandler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("URIHandler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("URIHandler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



