/*
 * $COPYRIGHT$
 * $Id: XMLRPCClientConceptDefinition.java,v 1.4 2002/03/12 15:54:14 atech Exp $
 *
 * Date        Author            Changes
 * IAN 22 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;
       
import org.media.mn8.*;
import org.media.mn8.event.*;
       
/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.4 $ $Date: 2002/03/12 15:54:14 $
 */
 
public class XMLRPCClientConceptDefinition extends ConceptConceptDefinition {
 
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private XMLRPCClientConceptDefinition _reference = new XMLRPCClientConceptDefinition();
	 
	 
    private XMLRPCClientConceptDefinition() {
        super();
        try {
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.XMLRPCClientConcept", 
                                         "create:org.media.mn8.concepts.StringConcept",
                                         "create:String", "XMLRPCClient", "XMLRPCClient" ) );

            putMethod( new mn8JavaMethod("org.media.mn8.concepts.XMLRPCClientConcept", 
                                         "executeCmd:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.SeriesConcept",
                                         "executeCmd:String,Series", "XMLRPCClient", "Concept" ) );
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
    
    
    public static ConceptDefinition getReference() {
        return _reference;
    }
    
    
    public Concept getConceptInstance() {
        return new XMLRPCClientConcept();
    }
    
    
    public StringConcept getConceptLabel() {
        return new StringConcept("XMLRPCClient");
    }
    
    
    public StringConcept getConceptType() {
        return new StringConcept("XMLRPCClient");
    }
    
    
    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
