/* 
 * $COPYRIGHT$
 * $Id: XMLRPCHandlerDefinition.java,v 1.5 2002/05/20 10:59:43 neuro Exp $
 *
 * Date        Author           Changes 
 * IAN 23 2002 Szabo Csaba      Created
 */
package org.media.mn8.concepts;


import org.media.mn8.*;
import org.media.mn8.event.*;
import java.net.URL;
import java.net.MalformedURLException;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.5 $ $Date: 2002/05/20 10:59:43 $
 */
public class XMLRPCHandlerDefinition extends URIHandlerDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private XMLRPCHandlerDefinition _reference = new XMLRPCHandlerDefinition();
    
    protected XMLRPCHandlerDefinition () {
        super();
        try {            
            _inheritedConcepts.add( new StringConcept("URIHandler") );

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.XMLRPCHandler",
                                        "initialize:org.media.mn8.concepts.MapConcept",
                                        "initialize:Map", "XMLRPCHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.XMLRPCHandler",
                                        "closeConnection:",
                                        "closeConnection:", "XMLRPCHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.XMLRPCHandler",
                                        "openConnection:",
                                        "openConnection:", "XMLRPCHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.XMLRPCHandler",
                                        "getContent:",
                                        "getContent:", "XMLRPCHandler", "Concept"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.XMLRPCHandler",
                                        "setContent:org.media.mn8.Concept",
                                        "setContent:Concept", "XMLRPCHandler", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.XMLRPCHandler", 
                                        "create:org.media.mn8.concepts.StringConcept",
                                        "create:String", "XMLRPCHandler", "XMLRPCHandler"));

            putMethod(new mn8JavaMethod("org.media.mn8.concepts.XMLRPCHandlerDefinition", true,
                                        "acceptsURI:org.media.mn8.concepts.StringConcept",
                                        "acceptsURI:String", "XMLRPCHandler", "Logical"));
        
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
  

    public LogicalConcept acceptsURI( StringConcept uri ) {
        try {
            URL url = new URL( uri.toString() );
            if( url.getProtocol().equalsIgnoreCase("xmlrpc"))
                return new LogicalConcept(true);
            else 
                return new LogicalConcept(false);

        } catch (MalformedURLException ex) {
            // we might be in Tomcat and the costom uri's don't work
            if( uri.toString().toLowerCase().startsWith("xmlrpc:")){
                return new LogicalConcept(true);
            }
        }
        return new LogicalConcept(false);
    }


    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new XMLRPCHandler();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("XMLRPCHandler");
    }


    public StringConcept getConceptType() {
        return new StringConcept("XMLRPCHandler");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
