/*
 * $COPYRIGHT$
 * $Id: ZipDefinition.java,v 1.1 2002/02/22 19:31:24 crow Exp $
 *
 * Date        Author            Changes
 * FEB 21 2002 Szabo Csaba       Created
 */

package org.media.mn8.concepts;
       
import org.media.mn8.*;
import org.media.mn8.event.*;
       
/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.1 $ $Date: 2002/02/22 19:31:24 $
 */
 
public class ZipDefinition extends ConceptConceptDefinition {
 
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private ZipDefinition         _reference = new ZipDefinition();
	 
	 
    private ZipDefinition() {
        super();
        try {

            //create specified ZIP file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.ZipConcept", 
                                         "create:org.media.mn8.concepts.StringConcept",
                                         "create:String", "Zip", "Zip" ) );

            //add specified file or directory to ZIP file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.ZipConcept", 
                                         "add:org.media.mn8.concepts.StringConcept",
                                         "add:String", "Zip", null ) );
            
            //add specified string to ZIP file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.ZipConcept", 
                                         "add:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "add:String,String", "Zip", null ) );
         
            //list specified ZIP file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.ZipConcept", 
                                         "list:",
                                         "list:", "Zip", "Series" ) );

            //view specified file from ZIP file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.ZipConcept", 
                                         "view:org.media.mn8.concepts.StringConcept",
                                         "view:String", "Zip", "Series" ) );

            //delete specified file from ZIP file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.ZipConcept", 
                                         "delete:org.media.mn8.concepts.StringConcept",
                                         "delete:String", "Zip", "Series" ) );

            //extract all files from ZIP file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.ZipConcept", 
                                         "extractAll:org.media.mn8.concepts.StringConcept",
                                         "extractAll:String", "Zip", null ) );
 
           //extract specified  file from ZIP file
            putMethod( new mn8JavaMethod("org.media.mn8.concepts.ZipConcept", 
                                         "extract:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                         "extract:String,String", "Zip", null ) );

        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
						 
    
    public static ConceptDefinition getReference() {
        return _reference;
    }
    
    
    public Concept getConceptInstance() {
        return new ZipConcept();
    }
    
    
    public StringConcept getConceptLabel() {
        return new StringConcept("Zip");
    }
												 
												 
    public StringConcept getConceptType() {
        return new StringConcept("Zip");
    }
    
    
    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}
