/* 
 * $COPYRIGHT$
 * $Id: ContextConf.java,v 1.4 2002/06/04 17:10:38 atech Exp $
 *
 * Date        Author            Changes 
 * FEB 06 2002 Szabo Csaba       Created
 */
package org.media.mn8.conf;


import org.media.mn8.NamingManager;
import org.media.mn8.concepts.StringConcept;
import org.media.mn8.event.mn8SystemException;
import org.media.mn8.mn8RuntimeFlags;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import java.util.Hashtable;
import java.util.Iterator;
import javax.naming.NamingException;

/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.4 $ $Date: 2002/06/04 17:10:38 $
 */

public class ContextConf {

    private static ContextConf _reference = new ContextConf();
    private static Hashtable  _bindsTable = new Hashtable();

    protected ContextConf() {
    }


    public void cleanAll() {
        _bindsTable.clear();
    }


    public void initialize( Element element ) {
        Node node = element.getFirstChild();

        while( node != null ) {
            if( node.getNodeType() == Node.ELEMENT_NODE && 
                ((Element)node).getTagName().equalsIgnoreCase("bind")) 
                extractBind( node );
            node = node.getNextSibling();
        }
    }


    public static ContextConf getRef() {
        return _reference;
    }

    
    public void uploadBinds() {
        Iterator keys = _bindsTable.keySet().iterator();
        Object    key = null;

        while( keys.hasNext() ) {
            key = keys.next();
            try {
                if( ((String)key).toLowerCase().startsWith("env:")) {
                    NamingManager.getReference().envBind( (String)key, new StringConcept ( (String)_bindsTable.get( key ) ) );
                }

                if( ((String)key).toLowerCase().startsWith("mem:")) {
                    NamingManager.getReference().bind( (String)key, new StringConcept ( (String)_bindsTable.get( key ) ) );
                }

            } 
            catch ( NamingException nex ) {
                if( mn8RuntimeFlags.isDebug() ) nex.printStackTrace();
            }
        }
    }


    protected void extractBind( Node pathNode ) {
        String path = ((Element)pathNode).getAttribute("path");
        String value = ((Element)pathNode).getAttribute("value");
 
        if( path != null && value != null ) _bindsTable.put( path, value);
    } 
}
