/* 
 * $COPYRIGHT$
 * $Id: JavaConceptsConf.java,v 1.5 2002/06/05 14:54:57 neuro Exp $
 *
 * Date        Author            Changes 
 * May 04 2001 Remus Pereni      Created
 */

package org.media.mn8.conf;

import org.media.mn8.NamingManager;
import org.media.mn8.concepts.StringConcept;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import java.util.Hashtable;
import java.util.Iterator;
import javax.naming.NamingException;
import java.io.Serializable;

/**
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.5 $ $Date: 2002/06/05 14:54:57 $
 */

public class JavaConceptsConf  {

    private static JavaConceptsConf _reference = new JavaConceptsConf();
    private static Hashtable _javaConceptsTable = new Hashtable();

    protected JavaConceptsConf(){
    }



    public void cleanAll() {
        _javaConceptsTable.clear();
    }


    public void initialize( Element element ) {
        Node node = element.getFirstChild();

        while( node != null ) {
            if( node.getNodeType() == Node.ELEMENT_NODE &&
                ((Element)node).getTagName().equalsIgnoreCase("concept") )
                extractJavaConcept( node );
            node = node.getNextSibling();
        }
    }


    public static JavaConceptsConf getRef() {
        return _reference;
    }

    
    public void uploadJavaConcepts() {
        Iterator keys = _javaConceptsTable.keySet().iterator();
        Object    key = null;

        while( keys.hasNext() ) {
            key = keys.next();
            try {
                NamingManager.getReference().envBind("env://concept/javaConcepts/" + key,
                                                     new StringConcept( (String)_javaConceptsTable.get( key ) ) );
            } 
            catch (NamingException nex) {
                System.err.println(nex.getMessage());
            }
        }
    }
    

    protected void extractJavaConcept(Node pathNode) {
        String name = ((Element)pathNode).getAttribute("name");
        String className = ((Element)pathNode).getAttribute("class");

        if( name != null && className != null )
	    _javaConceptsTable.put( name, className);
    }
}
