/* 
 * $COPYRIGHT$
 * $Id: JavaPropertiesConf.java,v 1.2 2002/02/06 13:07:08 crow Exp $
 *
 * Date        Author            Changes 
 * FEB 05 2002 Szabo Csaba       Created
 */
package org.media.mn8.conf;


import org.media.mn8.NamingManager;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import java.util.Vector;
import javax.naming.NamingException;
import java.io.Serializable;

/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.2 $ $Date: 2002/02/06 13:07:08 $
 */
public class JavaPropertiesConf {
   
    private static JavaPropertiesConf _reference = new JavaPropertiesConf();

    protected JavaPropertiesConf(){
    }


    public void initialize( Element element ) {
        Node node = element.getFirstChild();

        while( node != null ) {
            if( node.getNodeType() == Node.ELEMENT_NODE &&
                ((Element)node).getTagName().equalsIgnoreCase("property")) {
                extractJavaProperty( node );
            }
            node = node.getNextSibling();
        }
    }


    public static JavaPropertiesConf getRef() {
        return _reference;
    }


    protected void extractJavaProperty( Node pathNode ) {
        String name = ((Element)pathNode).getAttribute("name");
        String value = ((Element)pathNode).getAttribute("value");
        String currentProp = System.getProperty( name );

        if( currentProp != null ) value = currentProp + "|" + value;
        System.setProperty( name, value );
    }
}
