/* 
 * $COPYRIGHT$
 * $Id: ManPathConf.java,v 1.5 2002/06/04 17:10:38 atech Exp $
 *
 * Date        Author            Changes 
 * FEB 06 2002 Szabo Csaba       Created
 */

package org.media.mn8.conf;

import org.media.mn8.NamingManager;
import org.media.mn8.concepts.StringConcept;
import org.media.mn8.concepts.SeriesConcept;
import org.media.mn8.Helper;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import java.io.File;
import java.util.Vector;
import java.util.Enumeration;
import javax.naming.NamingException;
import java.io.Serializable;

/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.5 $ $Date: 2002/06/04 17:10:38 $
 */

public class ManPathConf extends Vector implements Serializable {
    
    private static ManPathConf _reference = new ManPathConf();
    private static Vector        _manuals = new Vector();

    protected ManPathConf(){
    }


    public void cleanAll() {
        _manuals.clear();
    }


    public void initialize( Element element ) {
        Node node = element.getFirstChild();
      
        while( node != null ) {
            if( node.getNodeType() == Node.ELEMENT_NODE &&
                ((Element)node).getTagName().equalsIgnoreCase("path")) {
                extractPath( node );
            }
            node = node.getNextSibling();
        }
    }
    

    public static ManPathConf getRef() {
        return _reference;
    }
    
    
    public void uploadManPaths() {
        String _path;
        for ( Enumeration e = _manuals.elements();e.hasMoreElements(); ) {
            _path = (String)e.nextElement();           
            add( new StringConcept( Helper.fillWithValues( _path ) ));
        }
        
        if( NamingManager.getReference() != null ) {
            try {
                NamingManager.getReference().envBind("env://concept/man", new SeriesConcept ( _reference ) );
            } catch ( NamingException nex ) {
                System.err.println( nex.getMessage() );
            }
        }
    }
    
    
    protected void extractPath( Node pathNode ) {
        Node node = pathNode.getFirstChild();
        _manuals.add( node.getNodeValue() );
    }
}
