/* 
 * $COPYRIGHT$
 * $Id: SearchPathConf.java,v 1.8 2002/06/04 17:10:38 atech Exp $
 *
 * Date        Author            Changes 
 * May 04 2001 Remus Pereni      Created
 */

package org.media.mn8.conf;


import org.media.mn8.NamingManager;
import org.media.mn8.Helper;
import org.media.mn8.concepts.StringConcept;
import org.media.mn8.concepts.SeriesConcept;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import java.io.File;
import java.util.Vector;
import java.util.Enumeration;
import javax.naming.NamingException;
import java.io.Serializable;

/**
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.8 $ $Date: 2002/06/04 17:10:38 $
 */

public class SearchPathConf extends Vector implements Serializable {
    
    private static SearchPathConf _reference = new SearchPathConf();
    private static Vector              paths = new Vector();

    protected SearchPathConf(){
    }


    public void cleanAll() {
        paths.clear();
    }


    public void initialize( Element element ) {
        Node node = element.getFirstChild();
        while( node != null ) {
            if( node.getNodeType() == Node.ELEMENT_NODE &&
                ((Element)node).getTagName().equalsIgnoreCase("path")) {
                extractPath( node );
            }
            node = node.getNextSibling();
        }
    }


    public static SearchPathConf getRef() {
        return _reference;
    }


    public void uploadSearchPaths() {
        String _path;
        for ( Enumeration e = paths.elements();e.hasMoreElements(); ) {
            _path = (String)e.nextElement();
            add( new StringConcept( Helper.fillWithValues( _path) ) );
        }
        
        if( NamingManager.getReference() != null ) {
            try {
                NamingManager.getReference().envBind("env://concept/path", new SeriesConcept ( _reference ) );
            } catch ( NamingException nex ) {
                System.err.println( nex.getMessage() );
            }
        }	
    }
        
    
    protected void extractPath( Node pathNode ) {
        Node node = pathNode.getFirstChild();
        paths.add( node.getNodeValue() );
    }
}
