/* 
 * $COPYRIGHT$
 * $Id: StaticSystemSetup.java,v 1.12 2002/06/04 17:10:38 atech Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.conf;

/** 
 * @see java.net.URL#URL
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.12 $ $Date: 2002/06/04 17:10:38 $
 */

public class StaticSystemSetup {

    /**
     * The public entry in this class. Once, at the starting of the
     * system this method has to be executed. It will call all
     * the other system setup method it has to. Like configuring the
     * suplementary network protocols handlers package in the Java
     * system properties.
     */

    public static void setup() {
        JavaConceptsConf.getRef().uploadJavaConcepts();
        ContextConf.getRef().uploadBinds();
        SearchPathConf.getRef().uploadSearchPaths();
        ManPathConf.getRef().uploadManPaths();
    }


    public static void cleanAll() {
        JavaConceptsConf.getRef().cleanAll();
        ContextConf.getRef().cleanAll();
        SearchPathConf.getRef().cleanAll();
        ManPathConf.getRef().cleanAll();
    }
    

}
