/* 
 * $COPYRIGHT$
 * $Id: SystemConceptsTable.java,v 1.36 2002/05/23 15:15:15 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.conf;

import org.media.mn8.*;
import org.media.mn8.concepts.*;
import java.util.Hashtable;
import java.util.Map;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.36 $ $Date: 2002/05/23 15:15:15 $
 */
public class SystemConceptsTable {


    public static Map getSystemConcepts() {
        Hashtable sysConcepts = new Hashtable();

        sysConcepts.put("concept", ConceptConceptDefinition.getReference());
        sysConcepts.put("character", CharacterDefinition.getReference());
        sysConcepts.put("string", StringDefinition.getReference());
        sysConcepts.put("logical", LogicalDefinition.getReference());
        sysConcepts.put("date", DateDefinition.getReference());
        sysConcepts.put("series", SeriesDefinition.getReference());
        sysConcepts.put("integer", IntegerDefinition.getReference());
        sysConcepts.put("real", RealDefinition.getReference());
        sysConcepts.put("nil", NilDefinition.getReference());
        sysConcepts.put("attribute", AttributeDefinition.getReference());
        sysConcepts.put("element", ElementDefinition.getReference());
        sysConcepts.put("method", MethodDefinition.getReference());
        sysConcepts.put("field", FieldConceptDefinition.getReference());
        sysConcepts.put("system", SystemDefinition.getReference());
        sysConcepts.put("expression", ExpressionDefinition.getReference());
        sysConcepts.put("regexp", RegexpDefinition.getReference());
        sysConcepts.put("simplex", SimplexDefinition.getReference());
        sysConcepts.put("map", MapDefinition.getReference());
        sysConcepts.put("urihandler", URIHandlerDefinition.getReference());
        sysConcepts.put("filehandler", FileHandlerDefinition.getReference());
        sysConcepts.put("envhandler", EnvHandlerDefinition.getReference());
        sysConcepts.put("memhandler", MemHandlerDefinition.getReference());
        sysConcepts.put("ftphandler", FTPHandlerDefinition.getReference());
        sysConcepts.put("httphandler", HttpHandlerDefinition.getReference());
        sysConcepts.put("xmlrpchandler", XMLRPCHandlerDefinition.getReference());
        sysConcepts.put("beephandler", BEEPHandlerDefinition.getReference());
        sysConcepts.put("pop3handler", POP3HandlerDefinition.getReference());
        sysConcepts.put("smtphandler", SMTPHandlerDefinition.getReference());
        sysConcepts.put("file", FileConceptDefinition.getReference());
        sysConcepts.put("ftpfile", FTPFileConceptDefinition.getReference());
        sysConcepts.put("ftpclient", FTPClientConceptDefinition.getReference());
        sysConcepts.put("xmlrpcclient", XMLRPCClientConceptDefinition.getReference());
        sysConcepts.put("beepclient", BEEPClientConceptDefinition.getReference());
        sysConcepts.put("dsclient", DSClientDefinition.getReference());
        sysConcepts.put("dsresponse", DSResponseDefinition.getReference());
        sysConcepts.put("pop3client", POP3ClientConceptDefinition.getReference());
        sysConcepts.put("htmlpage", HTMLPageConceptDefinition.getReference());
        sysConcepts.put("htmlform", HTMLFormDefinition.getReference());
        sysConcepts.put("uri", URIDefinition.getReference());
        sysConcepts.put("tag", TagDefinition.getReference());
        sysConcepts.put("cookie", CookieDefinition.getReference());
        sysConcepts.put("error", ErrorDefinition.getReference());
        sysConcepts.put("typedseries", TypedSeriesDefinition.getReference());
        sysConcepts.put("zip", ZipDefinition.getReference());
        sysConcepts.put("tar", TarDefinition.getReference());
        sysConcepts.put("process", ProcessDefinition.getReference());
        sysConcepts.put("jabberclient", JabberClientDefinition.getReference());
        return sysConcepts;
    }
}
