/* 
 * $COPYRIGHT$
 * $Id: AttributeNotFoundException.java,v 1.2 2002/04/28 23:30:55 neuro Exp $
 *
 * Date        Author            Changes 
 * Apr 22 2001 Remus Pereni      Created
 */
package org.media.mn8.event;

import org.media.mn8.MessageFormatter;

/**
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/04/28 23:30:55 $
 * @see org.media.mn8.LogManager
 */

public class AttributeNotFoundException extends mn8Warning {
    
    public static final String id = "noSuchAttribute";

    public AttributeNotFoundException( String conceptName, String attributeName ) {
        this.conceptName = conceptName;
        this.itemName = attributeName;
    }


    public AttributeNotFoundException( String conceptName, String attributeName, int errorLine ) {
        this.conceptName = conceptName;
        this.itemName = attributeName;
        this.lineNr = errorLine;
    }


    public String getSimpleMessage() {
        return " Concept type: " + conceptName + " does not have attribute: " + itemName;  
    }
}
