/* 
 * $COPYRIGHT$
 * $Id: ElementNotFoundException.java,v 1.2 2002/04/28 19:17:46 neuro Exp $
 *
 * Date        Author            Changes 
 * Apr 22 2001 Remus Pereni      Created
 */
package org.media.mn8.event;

import org.media.mn8.MessageFormatter;

/**
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/04/28 19:17:46 $
 * @see org.media.mn8.LogManager
 */

public class ElementNotFoundException extends mn8Warning {
    
    public static final String id = "noSuchElement";

    public ElementNotFoundException( String conceptName, String elementName ) {
        this.conceptName = conceptName;
        this.itemName = elementName;
    }


    public ElementNotFoundException( String conceptName, String elementName, int errorLine ) {
        this.conceptName = conceptName;
        this.itemName = elementName;
        this.lineNr = errorLine;
    }


    public String getSimpleMessage() {
        return " Concept type: " + conceptName + " does not have element: " + itemName;  
    }
}
