/* 
 * $COPYRIGHT$
 * $Id: NotStaticAttributeException.java,v 1.1 2002/04/28 23:31:53 neuro Exp $
 *
 * Date        Author            Changes 
 * Apr 22 2001 Remus Pereni      Created
 */
package org.media.mn8.event;

import org.media.mn8.MessageFormatter;
import org.media.mn8.mn8Interpreter;

/**
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.1 $ $Date: 2002/04/28 23:31:53 $
 * @see org.media.mn8.LogManager
 */

public class NotStaticAttributeException extends mn8Warning {
    
    public static final String id = "notStatiAttribute";

    public NotStaticAttributeException( String conceptName, String attributeName ) {
        this.conceptName = conceptName;
        this.itemName = attributeName;
    }


    public NotStaticAttributeException( String conceptName, String attributeName, int errorLine ) {
        this.conceptName = conceptName;
        this.itemName = attributeName;
        this.lineNr = errorLine;
    }


    public String getSimpleMessage() {
        return "Attribute " + itemName + " on " + conceptName + " is not static therefore" + mn8Interpreter.EOL +
            "can not be invoked directly, create an instance first.";
    }
}
