/* 
 * $COPYRIGHT$
 * $Id: NotStaticElementException.java,v 1.1 2002/04/28 23:31:46 neuro Exp $
 *
 * Date        Author            Changes 
 * Apr 22 2001 Remus Pereni      Created
 */
package org.media.mn8.event;

import org.media.mn8.MessageFormatter;
import org.media.mn8.mn8Interpreter;

/**
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.1 $ $Date: 2002/04/28 23:31:46 $
 * @see org.media.mn8.LogManager
 */

public class NotStaticElementException extends mn8Warning {
    
    public  static final String id = "notStaticElement";

    public NotStaticElementException( String conceptName, String elementName ) {
        this.conceptName = conceptName;
        this.itemName = elementName;
    }


    public NotStaticElementException( String conceptName, String elementName , int errorLine) {
        this.conceptName = conceptName;
        this.itemName = elementName;
        this.lineNr = errorLine;
    }


    public String getSimpleMessage() {
        return "Element " + itemName + " on " + conceptName + " is not static therefore" + mn8Interpreter.EOL +
            "can not be invoked directly, create an instance first.";
     }

}
