/* 
 * $COPYRIGHT$
 * $Id: mn8ExitEvent.java,v 1.2 2002/05/04 18:59:27 neuro Exp $
 *
 * Date        Author            Changes 
 * Apr 22 2001 Remus Pereni      Created
 */
package org.media.mn8.event;

import org.media.mn8.concepts.NilConcept;
import org.media.mn8.Concept;
import org.media.mn8.concepts.IntegerConcept;

/** 
 * Exception thrown for general system related errors or warnings.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/05/04 18:59:27 $
 * @see org.media.mn8.LogManager
 */

public class mn8ExitEvent extends RuntimeException {
    public static int RETURN_EVENT = 1;
    public static int EXIT_EVENT = 0;

    protected Concept _value;
    protected int _type = 0;

    public mn8ExitEvent(int type, Concept value) {
        _type = type;
        _value = value;
    }


    public mn8ExitEvent(int type) {
        _type = type;
        _value = new IntegerConcept(0);
    }

    
    public int getType() {
        return _type;
    }

    public Concept getEventValue() {
        if (_value == null ) {
            return new NilConcept();
        } else {
            return _value;
        }
    }
}
