/* 
 * $COPYRIGHT$
 * $Id: mn8Concept.java,v 1.12 2002/04/17 16:21:22 atech Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8;


import org.media.mn8.concepts.*;
import org.media.mn8.event.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.12 $ $Date: 2002/04/17 16:21:22 $
 */
public class mn8Concept extends JavaConcept {
    
    private  mn8ConceptDefinition _conceptDef = null;

    private ScopeStack _scopeStack = null;

    private Concept[] _inheritedConcepts;


    public mn8Concept( mn8ConceptDefinition conceptDef,
                       ScopeStack scopeStack ) {
        _conceptDef = conceptDef;
        _scopeStack = scopeStack;
    }


    public mn8Concept( mn8ConceptDefinition conceptDef,
                       ScopeStack scopeStack,
                       Concept[] inheritedJavaConcepts ) {
        _conceptDef = conceptDef;
        _scopeStack = scopeStack;
        _inheritedConcepts = inheritedJavaConcepts;
    }



    public StringConcept getConceptType() {
        return _conceptDef.getConceptType();
    }


    public  Concept getConceptInstance() {
        return _conceptDef.getConceptInstance();
    }


    public ScopeStack getScopeStack() {
        return _scopeStack;
    }


    public ConceptDefinition getConceptDefinition() {        
        return _conceptDef;
    }


    Concept getCameleonConcept(int position) {
        return _inheritedConcepts[position];
    }


    public boolean hasConceptElement(String name) {
        boolean result = super.hasConceptElement(name);
        if( result ) return result;
        if( _inheritedConcepts != null && _inheritedConcepts.length > 0 ) {
            for( int i = 0 ; i < _inheritedConcepts.length ; i++)
                if( _inheritedConcepts[i].hasConceptElement(name)) return true;
            
        }
        return false;
    }


    public SeriesConcept getConceptElementFields() {
        SeriesConcept result = super.getConceptElementFields();
        
        if( _inheritedConcepts != null && _inheritedConcepts.length > 0 ) {
            for( int i = 0 ; i < _inheritedConcepts.length ; i++)
                result.addSeries(_inheritedConcepts[i].getConceptElementFields());
            
        }
        
        return result;
    }


    public FieldDefinition getConceptElementField(String name) {
        if( super.hasConceptElement(name)) 
            return super.getConceptElementField(name);

        if( _inheritedConcepts != null && _inheritedConcepts.length > 0 ) {
            for( int i = 0 ; i < _inheritedConcepts.length ; i++){
                if(_inheritedConcepts[i].hasConceptElement(name))
                    return _inheritedConcepts[i].getConceptElementField(name);
            }
        }
        return null;
    }

    public Object clone() {
         if ( _inheritedConcepts != null )
            return new mn8Concept( _conceptDef, (ScopeStack)_scopeStack.clone(), (Concept[]) _inheritedConcepts.clone());
        else 
            return new mn8Concept( _conceptDef, (ScopeStack)_scopeStack.clone(), null);
    }

}
