/* 
 * $COPYRIGHT$
 * $Id: mn8.g,v 1.72 2002/06/05 14:55:06 neuro Exp $
 *
 * Date        Author            Changes 
 * Apr 10 2001 Remus Pereni      Created
 */
header {
package org.media.mn8.parser;

import org.media.mn8.*;
import org.media.mn8.concepts.*;
import java.util.Vector;
import antlr.CommonAST;
}


/** 
 * The parser for mn8.<br>
 * This class is automaticaly generated by 
 * <a href="http://www.antlr.org">ANTLR</a>.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.72 $ $Date: 2002/06/05 14:55:06 $
 */
class mn8Parser extends Parser;
options {
    k = 2;                           // two token lookahead
    exportVocab = mn8;               // Call its vocabulary "mn8"
//  codeGenMakeSwitchThreshold = 2;  // Some optimizations
//  codeGenBitsetTestThreshold = 3;
    buildAST = true;
}

{
    public String conceptFile = null;
    private String _conceptName = null;
    boolean debug=false;
    mn8ConceptDefinition _conceptDef = null;
	Vector deepElementType = new Vector();

    AST cloneASTNode( AST node ) {
        AST result = new CommonAST();
        result.initialize( node );
        if( node.getFirstChild() != null ) {
            result.setFirstChild( cloneASTNode( node.getFirstChild() ));
        }
        
        if( node.getNextSibling() != null) {
            result.setNextSibling( cloneASTNode( node.getNextSibling() ));
        }
        
        return result;
    }


}

imaginaryTokens 
    : 
        CONCEPT_DEFINITION
        METHOD_DEFINITION   
        IMPLEMENTS_CLAUSE
        BLOCK
        ARRAY_DECLARATOR
        TYPE
        UNARY_MINUS 
        UNARY_PLUS
        ATTRIDENT
        ELMETIDENTIFIER
        EXPR
        ELIST
		OLIST
        METHOD_CALL
        POST_INC
        POST_DEC
        CONDITION
        IF_BLOCK
        ELSE_BLOCK
        ELIF_BLOCK
        FIND_FIRST
        FIND_LAST
        SOURCE
        ELEM
        METH
        DEBUG_INFO;


mn8ScriptFile [String conceptName]
{ _conceptName = conceptName; }
	:	(eol)?
		(
			(DEFINE) => (conceptDefinition)*	
		|	(statement)*
		)
	;

conceptDefinition
{ Vector extendsList = null; String label = null; }
      :  d:DEFINE^ type:IDENT 
        ( label = labelDeclaration )?  
        ( extendsList = extendsDeclaration) ?
            LBRACK! eol

        {     
            if( _conceptName == null ) _conceptName = #type.getText();
            if( type == null ) 
            throw new RecognitionException(" you have to have a name for the new concept", "", #d.getLine());
			deepElementType.clear();
			deepElementType.add(#type.getText());
			label =  label == null ? #type.getText() : label;
        
            if( _conceptName.equalsIgnoreCase(#type.getText())) {
                _conceptDef = new mn8ConceptDefinition(#type.getText(), label, extendsList);
            } else {
                _conceptDef = null;   
            }
            int pos = #type.getText().indexOf(":");
            if( pos != -1 ) {
                conceptFile = #type.getText().substring(0, pos) + ".mn8";
            } else {
                conceptFile = #type.getText() + ".mn8";
            }
        }
            (conceptBodyComponent)*
            RBRACK! eol
        {
            if( _conceptDef != null ) {
                _conceptDef.setTokenNames(getTokenNames());
                ConceptRegister.getReference().register(#type.getText(), _conceptDef);
            }
        }
    ;


labelDeclaration returns [String label] 
{ label = null; }
    : LABEL^ lb:STRING_LITERAL
        { if( #lb != null ) 
            label = #lb.getText();
          else
            label = null;
        }
    ;


extendsDeclaration returns [Vector extendsList]
{ extendsList = null; }
    : EXTENDS^ extendsList = extendedConceptsList
    ;


extendedConceptsList returns [Vector extendsList]
{ extendsList = new Vector(); }
    : i:IDENT 
        { 
            if( !#i.getText().equalsIgnoreCase("concept")) {
                extendsList.add(new StringConcept(#i.getText())); 
            }
        }
            ( COMMA! r:IDENT 
            {  
                if( #r != null) {   
                    if( !#r.getText().equalsIgnoreCase("concept")) {
                        extendsList.add(new StringConcept(#r.getText()));
                    }
                } 
            }
            )*
    ;


conceptBodyComponent
{ 
	mn8ScriptAttribute attribute = null; 
	mn8ScriptElement element = null;
}
    :   
    (sta:STATIC)?           
        (   attribute = attributeDeclaration[sta] { if( _conceptDef != null ) _conceptDef.putAttribute( attribute ); }
        |   element = elementDeclaration[sta, _conceptDef] { if( _conceptDef != null) _conceptDef.putElement( element); }
        |   methodDeclaration[sta]
        )
    ;


attributeDeclaration [Token isStatic] returns [mn8ScriptAttribute attribute]
{ attribute = null; }
    : ATTR^ name:IDENT (hidden:NOT | showEmpty:QUESTION)? (ASSIGN initial:constant)? (TYPEOF type:IDENT)? (LABEL label:STRING_LITERAL)? eol
        {   if( _conceptDef != null ) {        
                attribute = new mn8ScriptAttribute(  #name.getText(),
                                                     null,
                                                    ( #isStatic == null ? false : true ),
                                                    ( #label == null ? #name.getText() : #label.getText()),
                                                    ( #type == null ? "Nil" : #type.getText() ),
								    				_conceptDef.getConceptType().toString(),
                                                    #initial);
                if( #hidden != null ) attribute.setHidden(new LogicalConcept(true));
                if( #showEmpty != null ) attribute.setShowEmpty(new LogicalConcept(true));

			    if( attribute.isStatic() )
				    GlobalScope.getReference().insertGlobalInstance( _conceptDef.getConceptType().toString(),
					    											 "@" + #name.getText(),
						    										 attribute.newInstance());
		    }
        }
    ;


elementDeclaration [Token isStatic, ConceptDefinition conceptDef] returns [mn8ScriptElement element]
{ element = null; mn8ScriptAttribute attribute = null; mn8ScriptElement innerElement = null; }
    : name:IDENT (multi:STAR)? (hidden:NOT | showEmpty:QUESTION)? (ASSIGN initial:constant)? (TYPEOF type:IDENT)? (LABEL label:STRING_LITERAL)? 

      {     if( _conceptDef != null ) {      
                element = new mn8ScriptElement( #name.getText(),
				    							null,
                                                ( #isStatic == null ? false : true ),
                                                ( #label == null ? #name.getText() : #label.getText()),
                                                ( #type == null ? "Element" : #type.getText() ),
								    			conceptDef.getConceptType().toString(),
                                                 #initial,
										    	( #multi != null ? true : false ) );

                if( #hidden != null ) element.setHidden(new LogicalConcept(true));
                if( #showEmpty != null ) element.setShowEmpty(new LogicalConcept(false));

			    if( element.isStatic() )
				    GlobalScope.getReference().insertGlobalInstance( conceptDef.getConceptType().toString(),
					    											 #name.getText(),
						    										 element.newInstance());
		    }
        }

        (
            LBRACK! eol 
			{ 	
			    if( _conceptDef != null ) {
				if( #type != null ) 
					throw new RuntimeException("Warning:" + #type.getLine() + ": Elements containing an subtype concept definition " +
					"can not explicitely declare a type.");

				if( #initial != null ) 
					throw new RuntimeException("Warning:" + #initial.getLine() + ": Elements containing an subtype concept definition " +
					"can not declari initial values to them.");

				deepElementType.add( #name.getText());
				String elemInstantType= "";
				for( int i = 0 ; i < deepElementType.size(); i++) {
					if( i > 0) elemInstantType += ":";
					elemInstantType+= (String)deepElementType.elementAt(i);
				}

				element = new mn8ScriptElement( #name.getText(),
											  null,
											( isStatic == null ? false : true ),
                                            ( #label == null ? #name.getText() : #label.getText()),
                                            ( elemInstantType ),
											  conceptDef.getConceptType().toString(),
                                              #initial,
											( #multi != null ? true : false) );
                
                if( #hidden != null ) element.setHidden(new LogicalConcept(true));
                if( #showEmpty != null ) element.setShowEmpty(new LogicalConcept(false));

				if( element.isStatic() )
					GlobalScope.getReference().insertGlobalInstance( conceptDef.getConceptType().toString(),
																 #name.getText(),
																 element.newInstance());

				conceptDef = new mn8ConceptDefinition( elemInstantType, 
													   #label == null ? #name.getText() : #label.getText(),
													   null );

                }
			}
            (
                attribute = attributeDeclaration[isStatic] { if ( _conceptDef != null ) conceptDef.putAttribute( attribute); }
            |   innerElement = elementDeclaration[isStatic, conceptDef] 
                {
                if( _conceptDef != null ) conceptDef.putElement( innerElement ); 
                }
            )* 
			{   if( _conceptDef != null ) {
				    _conceptDef.setTokenNames(getTokenNames());
				    ConceptRegister.getReference().register(conceptDef.getConceptType().toString(), conceptDef);
				    deepElementType.remove( #name.getText());
				}
			}
            RBRACK!
        )?

        eol
    ;


methodDeclaration [Token isStatic]
{ Vector paramNames = new Vector(); Vector paramTypes = new Vector(); }
    : COLON^ name:IDENT (LPAREN!)? (parameterList[paramNames, paramTypes])? ( RPAREN! )? 
            codeBlock:block (TYPEOF returnType:IDENT)? e:eol
        {   if ( _conceptDef != null ) {
            mn8ScriptMethod method = new mn8ScriptMethod( #name.getText(),
                                                        ( #isStatic == null ? false : true ),
                                                        paramTypes,
                                                        paramNames,
                                                        _conceptDef,
                                                        ( #returnType == null ? null : #returnType.getText()) );
            method.lineNr = #COLON.getLine();
    
            if( #name.getText().equalsIgnoreCase("create") ) {
                if( #isStatic != null ) {
                    System.err.println(conceptFile + ":" + #COLON.getLine() + ":" +
                        "You don't have to declare a constructor static, ignoring!");
                }

                if( #returnType != null ) {
                    System.err.println(conceptFile + ":" + #COLON.getLine() + ":" +
                        "You don't have to declare a returning type for a constructor, ignoring!");
                }

            }
            if( codeBlock_AST != null && codeBlock_AST.getFirstChild() != null) {
                AST node = cloneASTNode( codeBlock_AST.getFirstChild());
                method.setCodeAST( node );
            }
            _conceptDef.putMethod( method );
            }   
        }
    ;


parameterList [Vector paramNames, Vector paramTypes]
    : parameter[paramNames, paramTypes] (COMMA! parameter[paramNames, paramTypes])*
    ; 

parameter [Vector paramName, Vector paramType]
    : name:IDENT TYPEOF^ type:IDENT
        { paramName.add( new StringConcept(#name.getText())); 
          paramType.add( new StringConcept(#type.getText())); }
    ;

statement
	: 	(expression TO) => toStatement
    |   (IDENT TYPEOF) => typeofStatement
    |   expression eol
	|	fromStatement
    |   printStatement
    |   statementBlock
    |   caseBlock
    |   exitStatement
    |   whileDoLoopBlock
    |   doWhileLoopBlock
    |   ifThenBlock
    |   findStatement
    |   returnStatement
    |   eachBlock
    ;

exitStatement
    :   (EXIT LPAREN)=> EXIT^ LPAREN! expression RPAREN! eol
    |   EXIT^ eol
    ;

returnStatement
    : RETURN^ expression eol
    ;


caseBlock
    : s:SWITCH! expr:expression LBRACK! (eol!)? (caseItem)+ (elseBlock)? RBRACK! eol!
        { #caseBlock = #( #[SWITCH, "SWITCH"], #caseBlock); }     
    ;


caseItem
    :! c:CASE cnt:expression blk:statementBlock
        { ## = #( #[CASE, "CASE"],    
                  #(#[CONDITION, "CONDITION"], cnt),
                  blk ); }
    ;


findStatement
    :! f:FIND (fi:FIRST | la:LAST) id:IDENT source:sourceExpression (w:WHERE expr:expression)? (b:breakExpression)? eol
        {   if ( fi != null ){
                if( w == null ) {
                {## = #( #[FIND_FIRST, "FIND_FIRST"],
                        id,
                        source, 
                        b );}
                }
                else {
                {## = #( #[FIND_FIRST, "FIND_FIRST"],
                        id,
                        source, b,
                        #(#[CONDITION, "CONDITION"], expr));} 
                }               
            }
            else {
                if( w == null ) {
                {## = #( #[FIND_LAST, "FIND_LAST"],
                        id,
                        source,
                        b );}
                }
                else {
                {## = #( #[FIND_LAST, "FIND_LAST"],
                        id,
                        source, b,
                        #(#[CONDITION, "CONDITION"], expr));} 
                }
            }
        }
    ;


eachBlock
    :! e:EACH id:IDENT source:sourceExpression 
        (w:WHERE expr:expression)? 
        (b:breakExpression)? 
        DO blk:statementBlock

        {   
            if( w == null ) {
                {## = #( #[EACH, "EACH"], id, source, b, blk );}
            }
            else {
                {## = #( #[EACH, "EACH"],
                        id, source, b,
                        #(#[CONDITION, "CONDITION"], expr),                 
                        blk );} 
            }
            
        }
    ;


sourceExpression
    : in:IN^ {#in.setType(SOURCE);} expression
    | fromExpression 
    ;


breakExpression
    : BREAK^ byExpression (byExpression)*
    ;   


byExpression
    :! by:BY pe:postfixExpression (as:ASCENDING | des:DESCENDING)?      
        { AST type = null;
            if( #as == null && #des == null )
                #type = #[ASCENDING, "ASCENDING"];          
            if( #as != null )
                #type = #as;
            if( #des != null )
                #type = #des;

            #type.addChild( #pe );
            ## = #( #[BY, "BY"], type);
        }                   
    ;

whileDoLoopBlock
    :!  w:WHILE expr:expression DO blk:statementBlock
        { ## = #( #[WHILE, "WHILE"],  
                  #(#[CONDITION, "CONDITION"], expr),
                  blk ); }
    ;


doWhileLoopBlock
    :! d:DO blk:block WHILE expr:expression eol
        { ##= #( #[DO, "DO"], 
                 blk,
                 #(#[CONDITION, "CONDITION"], expr)); }
    ;


ifThenBlock 
    :   (
          (ifBlock elseBlock) => ifBlock elseBlock
        | (ifBlock elifBlock) => ifBlock (elifBlock)* (eol!)? (elseBlock)?
        | ifBlock eol
        )   
        { #ifThenBlock = #( #[IF, "IF"], #ifThenBlock); }     
    ;


ifBlock
    :!  IF expr:expression
        THEN blk:block
        { ## = #( #[IF_BLOCK, "IF_BLOCK"],    
                  #(#[CONDITION, "CONDITION"], expr),
                  blk ); }
    ;


elifBlock
    :!  ELIF expr:expression THEN blk:block
        { ## = #( #[ELIF_BLOCK, "ELIF_BLOCK"],    
                  #(#[CONDITION, "CONDITION"], expr),
                  blk ); }
    ;


elseBlock
    :!  ELSE blk:statementBlock
        { ## = #( #[ELSE_BLOCK, "ELSE_BLOCK"],    
                  blk ); }
    ;


statementBlock
    : block eol!        
    ;


block
    : bl:LBRACK^ {#bl.setType(BLOCK); #bl.setText("BLOCK");} 
        (eol)? 
        (statement)* 
        RBRACK! 
    ;


printStatement
    : PRINT^ expressionList (SEMI)? eol
    ;


toStatement
	: expression TO^ additiveExpression (optionsBlock)? eol!
	;


fromStatement
	: i:IDENT from:fromExpression eol!
		{	
			AST assign = #[ASSIGN, "="];
			assign.setLine(#i.getLine());
			#i.setNextSibling(#from);
			assign.setFirstChild(#i);			
			## = assign;
		}
	;


fromExpression
	: FROM^ additiveExpression (optionsBlock)?
	;


optionsBlock
	:	OPTIONS^ optionList
	;


optionList
	: optionItem (COMMA! optionItem)*
	;


optionItem 
    : STRING_LITERAL ASSIGN^ expression
    ;


typeofStatement
    : IDENT TYPEOF^ assignmentExpression eol
    ;


expressionList 
    : expression (COMMA! expression)*
        {#expressionList = #([ELIST, "ELIST"], expressionList); } 
    ;


expression
    :   assignmentExpression
    ;


assignmentExpression
    :   logicalOrExpression
        (   (   ASSIGN^
            |   PLUS_ASSIGN^
            |   MINUS_ASSIGN^
            |   STAR_ASSIGN^
            |   DIV_ASSIGN^
            )
            assignmentExpression
        )?
    ;


logicalOrExpression
    :   logicalAndExpression (LOR^ logicalAndExpression)*
    ;


logicalAndExpression
    :   equalityExpression (LAND^ equalityExpression)*
    ;


equalityExpression
    :   relationalExpression ((NOT_EQUAL^ | EQUAL^) relationalExpression)*
    ;


relationalExpression
    :   additiveExpression
        (   (   (   LT^
                |   GT^
                |   LE^
                |   GE^
                )
                additiveExpression
            )*
        )
    ;


additiveExpression
    :   multiplicativeExpression 
        ( ( PLUS^ | MINUS^ ) multiplicativeExpression )*
    ;


multiplicativeExpression
    : unaryExpression
        ( (STAR^ | DIV^) unaryExpression )*
    ;


unaryExpression
    :   INC^ unaryExpression
    |   DEC^ unaryExpression
    |   MINUS! {#MINUS.setType(UNARY_MINUS);} ue:unaryExpression! 
        {
            if( #ue.getType() == mn8TreeWalker.NUM_INT ) {
                try {
                    int val = (new Integer(#ue.getText())).intValue();
                    #ue.setText("" + val * -1);
                    ## = #ue;
                } catch (Exception ex) {
                    ## = #ue;
                }
            } else if( #ue.getType() == mn8TreeWalker.NUM_REAL ) {
                try {
                    float val = (new Float(#ue.getText())).floatValue();
                    #ue.setText("" + val * -1);
                    ## = #ue;
                } catch (Exception ex) {
                    ## = #ue;
                }
            } else {
                ## = #ue;
            }
        }
    |   PLUS^  {#PLUS.setType(UNARY_PLUS);} unaryExpression
    |   LNOT^ unaryExpression
    |   FIRST^ postfixExpression
    |   LAST^ postfixExpression
    |   seriesExpression
    ;


seriesExpression
    : ( identOrConstant  RANGE^ identOrConstant (COLON! identOrConstant)?)
    | postfixExpression
    ;


postfixExpression
{ AST dot=null;}
    : (DOT) => {dot = #(#[DOT, "DOT"]);}  (me:methodInvocation! 
            (ela:elementOrAttribute! {#me.addChild(#ela);})*  {dot.addChild(#me);} )+ {##=dot;}
        (   dec1:DEC^ {#dec1.setType(POST_DEC);}
        |   inc1:INC^ {#inc1.setType(POST_INC);}
        |   //nothing
        )
    |  pi:primaryExpression (m:methodInvocation! {#pi.addChild(#m);} | ea:elementOrAttribute! {#pi.addChild(#ea);} )*
        (   dec:DEC^ {#dec.setType(POST_DEC);}
        |   inc:INC^ {#inc.setType(POST_INC);}
        |   //nothing
        )
    ;

methodInvocation
{  AST method = null; }
    : DOT! id:IDENT!
        { 
           ## =#( #[METH, id.getText()]); 
           ##.setLine(id.getLine()); 
        }
        ( LPAREN! arg:argList! RPAREN! { ##.setFirstChild(#arg);} )?
    ;


elementOrAttribute
    :  (s:SEP! (elid:IDENT! | elint:NUM_INT!))
        {  AST elemAST = null;
            if( #elid != null ) {
                ## = #( #[ELEM, #elid.getText()]);
            }else if( #elint != null ){
                ## = #( #[ELEM, #elint.getText()]);
            }
            ##.setLine( #s.getLine());
            #elid =null; #elint=null;
        }
    |!  (a:ATTR! atid:IDENT!)
        {   ## = #(#[ATTR, atid.getText()]);
            ##.setLine( #a.getLine());
        }        
    ;

argList
    :   (    expressionList
        |   // nothing
            {#argList = #[ELIST,"ELIST"];}
        )
    ;


primaryExpression
    : 	identOrConstant
	|   SUPER
    |   THIS
    |   TRUE
    |   FALSE
    |   LPAREN! assignmentExpression RPAREN!
	|!  a:ATTR ai:IDENT { ## = #( #[ATTR, ai.getText()]); ##.setLine(#a.getLine());}
	|!  e:SEP ei:IDENT { ## = #( #[ELEM, ei.getText()]); ##.setLine(#e.getLine());}
    ;


identOrConstant
    : constant
    | IDENT
    ;


constant
    :   NUM_INT
    |   CHAR_LITERAL
    |   STRING_LITERAL 
    |   NUM_REAL
    |   NIL
    ;

eol
    :
    (
        options {
				warnWhenFollowAmbig = false;
        }
		:EOL!
    )+
    ;

/** 
 * The lexer for mn8.
 * This class is automaticaly generated by 
 * <a href="http://www.antlr.org">ANTLR</a>.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.72 $ $Date: 2002/06/05 14:55:06 $
 */
class mn8Lexer extends Lexer;
options {
    exportVocab=mn8;       // call the vocabulary "mn8"
    testLiterals=false;    // don't automatically test for literals
    k=2;                   // four characters of lookahead
    charVocabulary='\u0003'..'\uFFFF';
    caseSensitiveLiterals = false;
    caseSensitive = false;
}

// KEYWORDS
tokens {
    NIL = "nil";
    THIS = "this";
    TYPEOF = "typeof";
    DEFINE = "define";
    LABEL = "label";
    EXTENDS = "extends";
    STATIC = "static";
    TO = "to";
    OPTIONS = "options";
    FROM = "from";
    ASCENDING = "ascending";
    DESCENDING = "descending";
    RETURN = "return";
    TIMEOUT = "timeout";
    IF = "if";
    THEN = "then";
    ELIF = "elif";
    ELSE = "else";
    SWITCH = "switch";
    CASE = "case";
    WHILE = "while";
    DO = "do";
    EACH = "each";
    WHERE = "where";
    BREAK = "break";
    BY = "by";
    FIND = "find";
    IN="in";
    FIRST = "first";
    LAST = "last";
    INCLUDE = "include";
    TRUE = "true";
    FALSE = "false";
    SUPER = "super";
    PRINT = "print";
    LAND = "and";
    LOR = "or";
    LNOT = "not";
    EXIT = "exit";
}


// OPERATORS
QUESTION        :   '?'     ;
LPAREN          :   '('     ;
RPAREN          :   ')'     ;
LBRACK          :   '['     ;
RBRACK          :   ']'     ;
LCURLY          :   '{'     ;
RCURLY          :   '}'     ;
COLON           :   ':'     ;
COMMA           :   ','     ;
PLUS_ASSIGN     :   "+="    ;
ASSIGN          :   '='     ;
EQUAL           :   "=="    ;
NOT_EQUAL       :   "!="    ;
NOT             :   "!"    ;
DIV_ASSIGN      :   "/="    ;
PLUS            :   '+'     ;
INC             :   "++"    ;
MINUS           :   '-'     ;
MINUS_ASSIGN    :   "-="    ;
DEC             :   "--"    ;
STAR            :   '*'     ;
STAR_ASSIGN     :   "*="    ;
MOD             :   '%'     ;
MOD_ASSIGN      :   "%="    ;
GE              :   ">="    ;
GT              :   ">"     ;
LE              :   "<="    ;
LT              :   '<'     ;
SEMI            :   ';'     ;
ATTR            :   '@'     ;

DIV             
    : '/' {
            if ( LA(1) == ' '  ||
                LA(1) == '\t' ||
                LA(1) == '\f' ||
                ( LA(1) == '\r' && LA(2) == '\n' ) ||
                LA(1) == '\r' ||
                LA(1) == '\n' ) {
                $setType(DIV);
            } else { $setType(SEP);}
            
        }           
    ;


LCONT
    : '\\'(WS)* EOL 
    ;


// Single-line comments
SL_COMMENT
    :   "#"
        (~('\n'|'\r'))* ('\n'|'\r'('\n')?)
        {$setType(EOL); 
         newline();
        }
    ;

// character literals
CHAR_LITERAL
    :   '\''! ( ESC | ~'\'' ) '\''!
    ;


STRING_LITERAL
    :   '"'! (ESC|~('"'|'\\'))* '"'!
    ;


protected
ESC
    :   '\\'
        (   'n' {$setText('\n');}
        |   'r' {$setText('\r');}
        |   't' {$setText('\t');}
        |   'b' {$setText('\b');}
        |   'f' {$setText('\f');}
        |   '"' {$setText('\"');}
        |   '\'' {$setText('\'');}
        |   '\\' {$setText('\\');}
        |   ('u')+ HEX_DIGIT HEX_DIGIT HEX_DIGIT HEX_DIGIT
        |   ('0'..'3')
            (
                options {
                    warnWhenFollowAmbig = false;
                }
            :   ('0'..'7')
                (   
                    options {
                        warnWhenFollowAmbig = false;
                    }
                :   '0'..'7'
                )?
            )?
        |   ('4'..'7')
            (
                options {
                    warnWhenFollowAmbig = false;
                }
            :   ('0'..'9')
            )?
        )
    ;

EOL :
        ( "\r\n"  // Evil DOS
        | '\r'    // Macintosh
        | '\n'    // Unix (the right way)
        )   { newline(); }
    ;


// Whitespace 
WS  :   (' '
        |   '\t'
        |   '\f'
        ) 
;   


// a numeric literal
NUM_INT
    :   ".." {_ttype = RANGE;}

    |   '.'  {_ttype = DOT;}
        (('0'..'9')+ (EXPONENT)? { _ttype = NUM_REAL; })?

    |   (   '0'
        |   ('1'..'9') ('0'..'9')* // non-zero decimal
        )
        // only check to see if it's a float if looks like decimal so far
        (   { !(LA(1) == '.' && (LA(2) == '.' || Character.isLetter(LA(2)))) }?
            (   '.' ('0'..'9')* (EXPONENT)?
            |   EXPONENT
            )
            { _ttype = NUM_REAL; }
        )?
    ;


// a dummy rule to force vocabulary to be all characters (except special
//   ones that ANTLR uses internally (0 to 2)
protected
VOCAB
    :   '\3'..'\377'
    ;


// an identifier.  Note that testLiterals is set to true!  This means
// that after we match the rule, we look in the literals table to see
// if it's a literal or really an identifer
IDENT
	options {testLiterals=true;}
    :   ('a'..'z'|'_'|'$') ('a'..'z'|'_'|'0'..'9'|':')*
    ;


// hexadecimal digit (again, note it's protected!)
protected
HEX_DIGIT
    :('0'..'9'|'a'..'f')
    ;


// a couple protected methods to assist in matching floating point numbers
protected
EXPONENT
    :   'e' ('+'|'-')? ('0'..'9')+
    ;



