/* 
 * $COPYRIGHT$
 * $Id: mn8TreeWalker.g,v 1.85 2002/06/05 14:55:15 neuro Exp $
 *
 * Date        Author            Changes 
 * Apr 10 2001 Remus Pereni      Created
 */
header {
package org.media.mn8.parser;

import org.media.mn8.*;
import org.media.mn8.event.*;
import org.media.mn8.concepts.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Stack;
import java.lang.Thread;
import antlr.*;

import java.io.PrintStream;
}


/** 
 * The final Tree Walker for mn8. This is responsible
 * of the interpretation.<br>
 * This class is automaticaly generated by 
 * <a href="http://www.antlr.org">ANTLR</a>.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.85 $ $Date: 2002/06/05 14:55:15 $
 */
class mn8TreeWalker extends TreeParser;
options {
    importVocab = mn8;
}
{
    boolean debug = mn8RuntimeFlags.isDebug();
	boolean verbose = mn8RuntimeFlags.isVerbose();
    private ScopeStack _stack = null;
    private Hashtable  _firstOfTable = new Hashtable();
    public  static int lineNr = -1;
    public  boolean readyToReturn = false;
	private mn8Concept _thisConcept  = null;
	private mn8ScriptMethod _thisMethod = null;
    private Vector superList = null;
    private String _scriptName = mn8Loader.getScriptName();
    private ElementConcept _previousElem = null;
    private int _curentLineNr = 0;
    private Stack _eachLevel = new Stack();
    private Stack _eachBySignature = new Stack();
    private PrintStream _out = null;
    private PrintStream _err = null;

    public void exit() {
        readyToReturn = true;
    }


    public void reportWarning( String message ) {
        System.err.println("__debug:" + message);
    }


    public void reportError( String message ) {
        System.err.println("__debug:" + message);
    }

    
    private void setLineNr(int lineNr) {
        this.lineNr = lineNr;
       _curentLineNr = lineNr;
    }


    private void addByToSignatureStack(String bySig) {
         _eachBySignature.setElementAt(_eachBySignature.peek().toString() + " " + bySig + " ",
                                       _eachBySignature.size()-1);
    }
    

    private int getByEachIndex( String bySig ) {
        for( int i = _eachBySignature.size() -1; i >= 0 ; i--) {
            if( _eachBySignature.elementAt(i).toString().indexOf(" " + bySig + " ") >= 0){
                return i;
            }
        }
        return -1;
    }
    
    public ScopeStack getStack() {
        return _stack;
    }

    
    boolean checkExpression( AST expr ) throws RecognitionException {
        Concept concept = expression( expr );
        if( concept instanceof LogicalConcept ) {
            return ((LogicalConcept) concept).getValue();
        } else { 
            LogicalConcept logValue = null;
            if( concept.hasConceptMethod(new StringConcept("toLogicalConcept:")).getValue()) {
                logValue = (LogicalConcept) executeMethod("toLogicalConcept:", concept, null);
            }
            if(  logValue != null ) {
                return logValue.getValue();
            }
            else {
                throw new NotLogicalExpressionException (concept.getConceptType().getValue(), expr.getLine());
            }  
        }        
    }


    Concept executeOp(String op, JavaConcept op1, JavaConcept op2, int line) 
                                                            throws RecognitionException {
        Concept result = new NilConcept(); 
        mn8Method method = getConceptDefinition(op1).getConceptOperator(op + ":" 
                                        + op2.getConceptType().getValue());
        if( method == null ) {
            throw new RecognitionException("Unsuported operation: " +  
                                           op1.getConceptType().getValue() + " " + op + " "  +
                                           op2.getConceptType().getValue(), "", line );
        } else {            
            SeriesConcept param = new SeriesConcept();
            param.getVector().add(op2);
            result = method.invoke( op1, (SeriesConcept)param.clone() );
            return result;
        }
    }


    Concept executeOp(String op, JavaConcept op1, int line) 
                                                            throws RecognitionException {
        Concept result = new NilConcept(); 
        mn8Method method = getConceptDefinition(op1).getConceptOperator(op + ":");
        if( method == null ) {
            throw new RecognitionException("Unsuported operation: " +  
                                           op1.getConceptType().getValue() + " " + op,
                                           "", line );
        } else {            
            SeriesConcept param = new SeriesConcept();
            result = method.invoke( op1, (SeriesConcept)param.clone() );
            return result;
        }
    }

    
    public static ConceptDefinition getConceptDefinition(Concept forConcept) {
        return mn8Loader.getConceptDefinition( forConcept.getConceptType().getValue() );
    }


    public Concept executeStaticMethod( String methodSig, String concetType, SeriesConcept param) {
        return executeStaticMethod(methodSig, concetType, param, _curentLineNr);
    }


    public static Concept executeStaticMethod (String methodSig, String conceptType, SeriesConcept param, int lineNr) {
        Concept result = null;
        ConceptDefinition concDef = mn8Loader.getConceptDefinition( conceptType );
		mn8Method method = null;

		if( !methodSig.trim().toLowerCase().startsWith("create:") ) {
			method = concDef.getConceptMethod( methodSig.toLowerCase() );
		} else {
            Concept instance = mn8Loader.getConceptDefinition(conceptType).getConceptInstance();
            return executeMethod(methodSig, instance, param, lineNr);
		}


        if( method != null && method.isStatic().getValue()) {
            method.setLineNr(lineNr);
            result = method.invoke( conceptType,  param == null ? null : (SeriesConcept)param.clone() );          
            return result;
        } else {
            throw new NotStaticMethodException( conceptType, methodSig);
        }     
    }
    

    public Concept executeMethod(String methodSig, Concept on, SeriesConcept param) {
        return executeMethod( methodSig, on, param, _curentLineNr);
    }


    public static Concept executeMethod(String methodSig, Concept on, SeriesConcept param, int lineNr) {
        Concept result = null;
		mn8Method method = null;

		if( !methodSig.trim().toLowerCase().startsWith("create:") ) {
			method = getConceptDefinition(on).getConceptMethod( methodSig.toLowerCase() );
		} else {
			method = getConceptDefinition(on).getConceptConstructor( methodSig.toLowerCase() );
		}

        if( method != null ) {
            method.setLineNr(lineNr);
            result = method.invoke( on,  param == null ? null : (SeriesConcept)param.clone() );           
            return result;
        } else {
            throw new MethodNotFoundException( on.getConceptType().toString(), methodSig);
        }
    }


    public Concept executeInheritedMethod(String inhConceptType, String methodSig, Concept on, SeriesConcept param) {
        Concept result = null;
		mn8Method method = null;

		if( methodSig.trim().toLowerCase().startsWith("create:") ) {
            method = mn8Loader.getConceptDefinition(inhConceptType).getConceptConstructor( methodSig.toLowerCase() );
		} else {
            method = mn8Loader.getConceptDefinition(inhConceptType).getConceptMethod( methodSig.toLowerCase() );
        }

        if( method != null ) {
            method.setLineNr(_curentLineNr);
            result = method.invoke( on,  param == null ? null : (SeriesConcept)param.clone() );           
            return result;
        } else {
            throw new MethodNotFoundException( on.getConceptType().toString(), methodSig);
        }
    }
    
    
    public Concept resolveIdentifier( AST i) {
        Concept result = null;
        if( verbose ) _err.println("Resolving identifier :" + i.getText());           
        if( i.getText().startsWith("$") ) {
            if( _stack.isInstance( i.getText() ))
                result = _stack.getInstance( i.getText());
            else {
                _stack.insertInstance( i.getText(), new NilConcept() );
                result = _stack.getInstance( i.getText());
            }
        } 
        return result;
    }


    public void cleanFirstOfTableElements(Vector by) {
        if( by == null) return;

        for(int i = 0 ; i < by.size() ; i++)
            _firstOfTable.remove( getIdentifierSignature( (AST) by.elementAt(i)));
    }


    private boolean isAscending( AST node ) {
        if( node.getText().toLowerCase().equals("ascending") )
            return true;
        else 
            return false;
    }


    private String getIdentifierSignature ( AST node ) {
        String result = null;
        AST child = node.getFirstChild();
        result = child.getText();
        child = child.getFirstChild();
        while( child != null ) {
            if( child.getType() == mn8TokenTypes.METH )
                result += "." + child.getText();

            if( child.getType() == mn8TokenTypes.ELEM )
                result += "/" + child.getText();

            if( child.getType() == mn8TokenTypes.ATTR )
                result += "@" + child.getText();

            child = child.getNextSibling();
        }
        return result;
    }


    private SeriesConcept sort(SeriesConcept what, Vector by) throws RecognitionException {
        Vector sortVect = what.getVector();
        if( sortVect == null || sortVect.size() < 2 ) {
            return what;
        }

        if( isAscending( (AST)by.elementAt(0) )) {
            sortVect = quickSort(sortVect, by, 0, 0, sortVect.size() -1);
        } else  {
            sortVect = quickSortDescending(sortVect, by, 0, 0, sortVect.size()-1);
        }

        sortVect= deepSort(sortVect, by, 0, 0, sortVect.size()-1);
        computeFirstOfPositions(sortVect, by, 0);
        return new SeriesConcept(sortVect);
    }


    private Vector quickSort(Vector what, Vector by, int byPos, int left, int right) throws RecognitionException {

        if( left >= right ) return what;

        if(right == left + 1 ) {
            if( compareMoreThan(byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(left)), 
                                byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(right)))) {
                quickSortSwap(what, left, right);                
            }
            return what;
        } 

        // The pivot is left
        Concept o1 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(left));
        quickSortSwap(what, left, right);
        int upTo = left;
        int downTo = right - 1;
        
        do {
            // get me the first one from the left which is greater than pivot
            while( upTo <= downTo && compareLessThanOrEqual(byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(upTo)), o1)) {
                upTo++;
            }
            
            // get me the first one from right which is less or equals than pivot
            while( upTo <= downTo && compareMoreThan( byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(downTo)), o1)) {
                downTo-- ;
            }
                    
            if( upTo < downTo ) {
                quickSortSwap(what, downTo, upTo);
            }
        } while ( upTo < downTo );

        quickSortSwap(what, right, upTo);
        what = quickSort(what, by, byPos, left, upTo-1);
        what = quickSort(what, by, byPos, upTo+1, right);
        return what;
    }


    private Vector quickSortDescending(Vector what, Vector by, int byPos, int left, int right) 
                                                                throws RecognitionException {

        if( left >= right ) return what;

        if(right == left + 1 ) {
            if( compareLessThan(byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(left)), 
                                byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(right)))) {
                quickSortSwap(what, left, right);                
            }
            return what;
        } 

        // The pivot is left
        Concept o1 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(left));
        quickSortSwap(what, left, right);
        int upTo = left;
        int downTo = right - 1;
        
        do {
            // get me the first one from the left which is less or equals than pivot
            while( upTo <= downTo && compareMoreThan(byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(upTo)), o1)) {
                upTo++;
            }
            
            // get me the first one from right which is more than pivot
            while( upTo <= downTo && compareLessThanOrEqual( byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(downTo)), o1)) {
                downTo-- ;
            }            
        
            if( upTo < downTo ) {
                quickSortSwap(what, downTo, upTo);
            }
        } while ( upTo < downTo );

        quickSortSwap(what, right, upTo);
        what = quickSortDescending(what, by, byPos, left, upTo-1);
        what = quickSortDescending(what, by, byPos, upTo+1, right);

        return what;
   }


    private Vector quickSortSwap(Vector vector, int pos1, int pos2) {
        Object obj = vector.elementAt(pos1);
        vector.setElementAt(vector.elementAt(pos2), pos1);
        vector.setElementAt(obj, pos2);
        return vector;
    }


    private Vector deepSort( Vector what, Vector by, int byPos, int left, int right)  throws RecognitionException {
        if( byPos > by.size() - 1 || what.size() < 2 )
            return what;

        Concept c1 = null;
        Concept c2 = null;
        int start = left;
        int stop;

        while ( start < right - 1) {
            stop = start;
            c1 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(start));

            do {
                stop++;
                c2 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(stop));
            } while ( stop < right && compareEqual(c1, c2) );

            if( stop > start + 1) {
                int endPos = stop - 1;
                if( compareEqual(c1, c2) ) {
                    endPos = stop;
                }

                if( byPos < by.size() -1){
                    if( isAscending( (AST)by.elementAt(byPos + 1) )) {
                        what = quickSort(what, by, byPos+1, start, endPos);
                        what = deepSort( what, by, byPos+1, start, endPos);
                    } else  {
                        what = quickSortDescending(what, by, byPos+1, start, endPos);
                        what = deepSort( what, by, byPos+1, start, endPos);
                    }
                }
            } 
            start = stop;
        }
        return what;
    }


    private void computeFirstOfPositions (Vector what, Vector by, int byPos ) throws RecognitionException {
        Vector firstOfPositions = new Vector();
        Concept c1 = null;
        Concept c2 = null;
        int start = 0;
        int stop;

        while ( start < what.size() ) {
            stop = start;
            c1 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(start));
            firstOfPositions.add(""+start);

            do {
                stop++;
                if( stop < what.size() ) {
                    c2 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(stop));
                }
            } while ( stop < what.size()  && compareEqual(c1, c2) );

            start = stop;
        }

        _firstOfTable.put( getIdentifierSignature( (AST) by.elementAt(byPos)), firstOfPositions);

        if( byPos < by.size() -1 ) {
            computeFirstOfPositions(what, by, ++byPos);
        }
    }
    

    private boolean compareLessThan(Object obj1, Object obj2) throws RecognitionException{
        return ((LogicalConcept)executeOp("<", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue();
    }


    private boolean compareMoreThan(Object obj1, Object obj2) throws RecognitionException{
        return ((LogicalConcept)executeOp(">", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue();
    }


    private boolean compareLessThanOrEqual(Object obj1, Object obj2) throws RecognitionException {
        return ( ((LogicalConcept)executeOp("<", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue() ||
                 ((LogicalConcept)executeOp("==", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue());

    }


    private boolean compareEqual(Object obj1, Object obj2) throws RecognitionException {
        return ((LogicalConcept)executeOp("==", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue();
    }



    private boolean compareMoreThanOrEqual(Object obj1, Object obj2) throws RecognitionException {
        return ( ((LogicalConcept)executeOp(">", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue() ||
                 ((LogicalConcept)executeOp("==", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue());

    }

        
    private String rangeCompareTypes( Concept from, Concept to ){
        if( from.getConceptType().toString().equals( to.getConceptType().toString())) {
            return from.getConceptType().toString();
        } 
        else {
            return null;
        }
    }


	private FieldDefinition getElementField( String elName, Concept on, int ifErrorLine) {
		FieldDefinition field = null;
        if( elName.startsWith("$") && _stack.isInstance(elName) ) {
            elName = _stack.getInstance(elName).toTXT().toString();
        }
		if( on.hasConceptElement( elName)){
			field  = on.getConceptElementField( elName );
			return field;
		}else {
            if( on != null &&  Helper.isElement(on) && ((Element)on).getElementName().equalsIgnoreCase(elName)) {
                ElementConcept elem = (ElementConcept) on;
                _previousElem = elem;
                return new DummyFieldConcept( elem.getElementName(),
                                              elem,
                                              false,
                                              elem.getElementLabel(),
                                              elem.getConceptType().toString());                
            }
            throw new ElementNotFoundException( on.getConceptType().toString(), elName, ifErrorLine);
		}					
	}

	
	private FieldDefinition getStaticElementField( String elName, String conceptType, int ifErrorLine ) {
		FieldDefinition field = null;
		if( mn8Loader.getConceptDefinition(conceptType).hasConceptElement( elName )){
			field  = mn8Loader.getConceptDefinition(conceptType).getConceptElementField( elName );
			if( field.isStatic() ) {
				return field;
			} else {
                throw new NotStaticElementException( conceptType , elName, ifErrorLine);
            }
		}else {
            throw new ElementNotFoundException( conceptType , elName, ifErrorLine);
		}					
	}


	private FieldDefinition getElementField( String elName, Concept on, String conceptType, int ifErrorLine ) {
		if( on != null ) {			// not static
			return getElementField( elName, on, ifErrorLine);
		} else { 					// static 
			return getStaticElementField( elName, conceptType, ifErrorLine);
		}		
	}


	private void setElementValue( FieldDefinition elField, Concept on, String conceptType, Concept value, int ifErrorLine ) {
		if( on != null ) {
			Element element = (Element)elField.getValue(on);
			element.setElementValue(value);
			elField.setValue(on, (ElementConcept)element);
		} else if ( elField.isStatic() ) {
			Element element = (Element)elField.getValue(null);
			element.setElementValue(value);
			elField.setValue(null, (ElementConcept)element);
		} else {
                throw new NotStaticElementException( conceptType , elField.getName(), ifErrorLine);
		}
	}


	private Concept getElementValue( FieldDefinition elField, Concept on, String conceptType, int ifErrorLine ) {
		mn8Method method = null;
		if( on != null ) {
			try {
				method = on.getConceptDefinition().getConceptMethod("get" + elField.getName().toLowerCase() + ":");
			} catch (RuntimeException rex) {}
			if( method == null ) {				
                Element element = (Element)elField.getValue(on);
                return element.getElementValue();
			} else {
				return method.invoke(on, null);
			}
		} else if ( elField.isStatic() ) {
			try {
				method = mn8Loader.getConceptDefinition(conceptType).getConceptMethod("get" + elField.getName().toLowerCase() +  ":");
			} catch (RuntimeException rex) {}
			if( method == null ) {
                Element element = (Element)elField.getValue(null);
                return element.getElementValue();
			} else {
				return method.invoke(on, null);
			}                
		} else {
            throw new NotStaticElementException( conceptType , elField.getName(), ifErrorLine);
		}
	}


	private FieldDefinition getAttributeField( String atName, Concept on, int ifErrorLine) {
		FieldDefinition field = null;

		if( on.hasConceptAttribute( atName )){
			field  = on.getConceptAttributeField( new StringConcept(atName) );
			return field;
		}else {
            if( _previousElem != null && _previousElem.hasConceptAttribute(new StringConcept(atName)).getValue()) {
                return _previousElem.getConceptAttributeField(new StringConcept(atName));
            }
            throw new AttributeNotFoundException( on.getConceptType().toString(), atName, ifErrorLine);
		}					
	}

	
	private FieldDefinition getStaticAttributeField( String atName, String conceptType, int ifErrorLine ) {
		FieldDefinition field = null;
		if( mn8Loader.getConceptDefinition(conceptType).hasConceptAttribute( atName )){
			field  = mn8Loader.getConceptDefinition(conceptType).getAttributeField( atName );
			if( field.isStatic() ) {
				return field;
			} else { 
                throw new NotStaticAttributeException( conceptType, atName, ifErrorLine);
            }
		}else {
            throw new AttributeNotFoundException( conceptType, atName, ifErrorLine);
		}					
	}


	private FieldDefinition getAttributeField( String atName, Concept on, String conceptType, int ifErrorLine ) {
		if( on != null ) {			// not static
			return getAttributeField( atName, on, ifErrorLine);
		} else { 					// static 
			return getStaticAttributeField( atName, conceptType, ifErrorLine);
		}		
	}


	private void setAttributeValue( FieldDefinition attrField, Concept on, String conceptType, Concept value, int ifErrorLine ) {
		mn8Method method = null;
		if( on != null ) {
			try {
                if( !( attrField instanceof DummyFieldConcept ))
				method = on.getConceptDefinition().getConceptMethod("set" 
                    + attrField.getName().toLowerCase() + ":" + value.getConceptType().toString().toLowerCase());
			} catch (RuntimeException rex) {}

			if( method == null ) {
				Attribute attribute = (Attribute)attrField.getValue(on);
				attribute.setAttributeValue(value);
				attrField.setValue(on, (AttributeConcept)attribute);
			} else {
				SeriesConcept param = new SeriesConcept();
				param.add(value);
				method.invoke(on, param);
			}
		} else if ( attrField.isStatic() ) {
			try {
				method = mn8Loader.getConceptDefinition(conceptType).getConceptMethod("set" 
							+ attrField.getName().toLowerCase() + ":" + value.getConceptType().toString().toLowerCase());
			} catch (RuntimeException rex) {}
			
			if( method == null ) {
				Attribute attribute = (Attribute)attrField.getValue(null);
				attribute.setAttributeValue(value);
				attrField.setValue(null, (AttributeConcept)attribute);
			} else {
				SeriesConcept param = new SeriesConcept();
				param.add(value);
				method.invoke(on, param);
			}
		} else {
            throw new NotStaticAttributeException(conceptType, attrField.getName(), ifErrorLine);
		}
	}


	private Concept getAttributeValue( FieldDefinition attrField, Concept on, String conceptType, int ifErrorLine ) {
		mn8Method method = null;
		if( on != null ) {
			try {
                if( !(attrField instanceof DummyFieldConcept))
				    method = on.getConceptDefinition().getConceptMethod("get" + attrField.getName().toLowerCase() + ":");
			} catch (RuntimeException rex) {}

			if( method == null ) {
				Attribute attribute = (Attribute)attrField.getValue(on);
				return attribute.getAttributeValue();
			} else {
				return method.invoke(on, null);
			}
		} else if ( attrField.isStatic() ) {
			try {
				method = mn8Loader.getConceptDefinition(conceptType).getConceptMethod("get" + attrField.getName().toLowerCase() +  ":");
			} catch (RuntimeException rex) {}

			if( method == null ) {
				Attribute attribute = (Attribute)attrField.getValue(null);
				return attribute.getAttributeValue();
			} else {
				return method.invoke(on, null);
			}
		} else {
            throw new NotStaticAttributeException(conceptType, attrField.getName(), ifErrorLine);
		}
	}


    private Concept assign( AST as, AST id, AST attr, AST elem, Concept result) throws RecognitionException {
			if( #elem != null ) {
				FieldDefinition initialElem = getElementField(#elem.getText(), _thisConcept, 
					                                          _thisMethod.getDeclaringConcept().toString(), 
													          #elem.getLine());
				if( #elem.getFirstChild() == null ) {
					setElementValue( initialElem, _thisConcept,
									 _thisMethod.getDeclaringConcept().toString(), (Concept)result.clone(), #elem.getLine());
				}
				else {
					Concept on = null ;
					String conceptType = #elem.getText();

					if( (on = getElementValue(initialElem, _thisConcept, _thisMethod.getDeclaringConcept().toString(), #elem.getLine())) != null ) 
						conceptType = on.getConceptType().toString();

					// if it is composed line $test/name@initials we must anvigate and 
					// then resolve and assign
					AST firstItem = #elem.getFirstChild();
					AST parent  = #elem;
					while( firstItem.getNextSibling() != null ) {					
						on = oneDeepPostfixedConceptValue(firstItem, on, parent);
						parent = firstItem;
						firstItem = firstItem.getNextSibling();
					}
					
					conceptType  = parent.getText();
					FieldDefinition field = postfixPaths( firstItem, on, conceptType );
					if( field.isAttribute() )
						setAttributeValue( field, on, conceptType, (Concept)result.clone(), #as.getLine() );
					else if( field.isElement() )
						setElementValue( field, on, conceptType, (Concept)result.clone(), #as.getLine() );
				}
			}


			if( #attr != null ) {
				FieldDefinition initialAttrib = getAttributeField(#attr.getText(), _thisConcept, 
					                                              _thisMethod.getDeclaringConcept().toString(), 
													              #attr.getLine());

				if( #attr.getFirstChild() == null ) {
					setAttributeValue( initialAttrib, _thisConcept,
									   _thisMethod.getDeclaringConcept().toString(), (Concept)result.clone(), #attr.getLine());
				} else {
					Concept on = null ;
					String conceptType = #attr.getText();

					if( (on = getAttributeValue(initialAttrib, _thisConcept, _thisMethod.getDeclaringConcept().toString(), #attr.getLine())) != null ) 
						conceptType = on.getConceptType().toString();

					// if it is composed line $test/name@initials we must anvigate and 
					// then resolve and assign
					AST firstItem = #attr.getFirstChild();
					AST parent  = #attr;
					while( firstItem.getNextSibling() != null ) {					
						on = oneDeepPostfixedConceptValue(firstItem, on, parent);
						parent = firstItem;
						firstItem = firstItem.getNextSibling();
					}
					
					conceptType  = parent.getText();
					FieldDefinition field = postfixPaths( firstItem, on, conceptType );
					if( field.isAttribute() )
						setAttributeValue( field, on, conceptType, (Concept)result.clone(), #as.getLine() );
					else if( field.isElement() )
						setElementValue( field, on, conceptType, (Concept)result.clone(), #as.getLine() );
				}
			}
			
			if( #id != null ) {
				if( #id.getFirstChild() != null ) {
					Concept on = null ;
					String conceptType = #id.getText();

					if( (on = resolveIdentifier(#id)) != null ) 
						conceptType = on.getConceptType().toString();

					// if it is composed line $test/name@initials we must anvigate and 
					// then resolve and assign
					AST firstItem = #id.getFirstChild();
					AST parent  = #id;
					while( firstItem.getNextSibling() != null ) {					
						on = oneDeepPostfixedConceptValue(firstItem, on, parent);
						parent = firstItem;
						firstItem = firstItem.getNextSibling();
					}
					
					conceptType  = parent.getText();
					FieldDefinition field = postfixPaths( firstItem, on, conceptType );
					if( field.isAttribute() ) {
						setAttributeValue( field, on, conceptType, (Concept)result.clone(), #as.getLine() );
					}
					else if( field.isElement() ){
						setElementValue( field, on, conceptType, (Concept)result.clone(), #as.getLine() );
					}
			}
			else if( #id.getFirstChild() == null ) { 
					if( result == null )
						_stack.insertInstance( #id.getText(), new NilConcept());                
					else 
						_stack.insertInstance( #id.getText(), (Concept)result.clone());

					result = _stack.getInstance( #id.getText() );
				
			}	
        }
        return result;
    }

}


interpretationUnit [ mn8Concept concept, mn8ScriptMethod thisMethod, ScopeStack scopeStack] returns [Concept result]
{
    result = null;
	_thisConcept = concept;
    if( concept != null ) {
    	  _stack = concept.getScopeStack();
    } else {
        _stack = scopeStack;
    }
    _thisMethod = thisMethod;
    _out = mn8Interpreter.getOut( Thread.currentThread());
    _err = mn8Interpreter.getErr( Thread.currentThread());
}
    :   (result = statement 
        exception
        catch [mn8ExitEvent ex] {
            if (ex.getType() == mn8ExitEvent.RETURN_EVENT ) {
                    _t = ASTNULL;
                    readyToReturn = true;
                    return ex.getEventValue();
            } else {
                    _t = ASTNULL;
                    readyToReturn = true;
                    throw ex;
            }
        } catch [mn8Warning ex] {
            if( ex.lineNr == -1 ) {
                ex.lineNr = _curentLineNr;
            }
            if( _t != null ) { _t = _t.getNextSibling(); }
            new ErrorConcept(ex.type, ex.getId(), ex.getSimpleMessage(), ex.lineNr);        
        }                     
        )*
    ;
    exception
    catch [mn8Error ex] {
            if( ex.lineNr == -1 ) {
                ex.lineNr = _curentLineNr;
        }
        if( _t != null ) { _t = _t.getNextSibling(); }
        result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;        
    }             


statement returns [Concept result]
{ result = null; 
if( readyToReturn) { throw new mn8ExitEvent(mn8ExitEvent.EXIT_EVENT); }
}
    : (  result = statementBlock
    |   result = expression
    |   print
    |   switchBlock
    |   whileDoLoop
    |   doWhileLoop
    |   ifBlock
	|	toStatement
    |   findFirstStatement
    |   findLastStatement
    |   exitStatement
    |   result = returnStatement
    |   eachBlock
            {  Thread.yield();} )
    ;


exitStatement
{ Concept i = new NilConcept(); }
    :   #(EXIT (i= expression)?)
        {   setLineNr( #EXIT.getLine());
            if( i instanceof IntegerConcept )  {
                throw new mn8ExitEvent(mn8ExitEvent.EXIT_EVENT, i);
            }
            else {
                throw new mn8ExitEvent(mn8ExitEvent.EXIT_EVENT);
            }
        }
    ;


concept returns [Concept result]
{ Concept concept = null; result = null;}
    : concept = identOrConstant 
        {  result = concept;}
    ;


findFirstStatement
{ Series in= null; Concept result= null; Concept var= null; Vector breakEx = null; }
    : #(FIND_FIRST i:IDENT in=iterationSource (breakEx = bex:breakExpression)? (cnd:CONDITION)? )
        {   SeriesConcept tmpSeries = new SeriesConcept();
            setLineNr( #FIND_FIRST.getLine());
            var = resolveIdentifier( #i );
            if( bex != null ) {
                _eachBySignature.pop();
            }
            if( cnd == null && bex == null){
                if( in.getLength() >= 1 ) {
                    result = in.elementAt(1);
                } else {
                    result = new NilConcept();
                }
                _stack.insertInstance( #i.getText(), (Concept)result);
            }
            else {              
                long idx = in.getIndex();
                in.setIndex(0);
                if( cnd != null ){
                    while (in.hasNext()) {
                        var = in.next();                        
                        _stack.insertInstance( #i.getText(), (Concept)var);
                        if( condition( cnd) ){
                            tmpSeries.add(var);
                        }
                    }
                } else {
                    if( in instanceof SeriesConcept )
                        tmpSeries = (SeriesConcept)in;
                    else {
                        while (in.hasNext()) {
                            tmpSeries.add( in.next() );                                         
                        }
                    }
                }
                // we sort it to math the break by expressions
                if( bex!=null && breakEx != null && breakEx.size() > 0)
                    tmpSeries = sort(tmpSeries, breakEx);           
                
                if( tmpSeries.getLength() >= 1){
                    result = (Concept)tmpSeries.getVector().elementAt(0);
                    _stack.insertInstance( #i.getText(), (Concept)result);
                } else {
                    result = new NilConcept();
                    _stack.insertInstance( #i.getText(), result );
                }
                in.setIndex(idx);
            }
        }
    ;


findLastStatement
{ Series in= null; Concept result= null; Concept var= null; Vector breakEx = null; }
    : #(FIND_LAST i:IDENT in=iterationSource (breakEx = bex:breakExpression)? (cnd:CONDITION)?)
        {   SeriesConcept tmpSeries = new SeriesConcept();
            setLineNr( #FIND_LAST.getLine());
            var = resolveIdentifier( #i );
            if( bex != null ) {
                _eachBySignature.pop();
            }
            if( cnd == null && bex == null){
                if( in.getLength() >= 1 ){
                    result = in.elementAt(in.getLength());
                } else {
                    result = new NilConcept();
                }
                _stack.insertInstance( #i.getText(), result);
            }
            else {
                long idx = in.getIndex();
                in.setIndex(0);
                if( cnd != null ){
                    while (in.hasNext()) {
                        var = in.next();
                        _stack.insertInstance( #i.getText(), (Concept)var);
                        if( condition( cnd) ){
                            tmpSeries.add(var);
                        }
                    }
                } else {
                    if( in instanceof SeriesConcept )
                        tmpSeries = (SeriesConcept)in;
                    else
                        while (in.hasNext()) 
                            tmpSeries.add( in.next() );                                         
                }

                // we sort it to math the break by expressions
                if( bex!=null && breakEx != null && breakEx.size() > 0)
                    tmpSeries = sort(tmpSeries, breakEx);           
                
                if( tmpSeries.getLength() >= 1){
                    result = (Concept)tmpSeries.getVector().elementAt( tmpSeries.getLength() - 1);
                    _stack.insertInstance( #i.getText(), (Concept)result);
                } else {
                    result = new NilConcept();
                    _stack.insertInstance( #i.getText(), result );
                }

                in.setIndex(idx);
            }
        }
    ;


eachBlock
{ SeriesConcept in= null; Concept result= null; Concept var= null; Vector breakEx =null; }
    : #(EACH i:IDENT in= iterationSource (breakEx = bex:breakExpression)? (cnd:CONDITION)? blk:BLOCK)
        {   
            SeriesConcept tmpSeries = null;
            var = resolveIdentifier( #i );
            setLineNr( #EACH.getLine());

            //we extract the elements which match the condition first
            if( cnd == null ) {
                tmpSeries = in;
            } else {
                Vector tmpVect = new Vector();
                tmpSeries = in;
                long idx = tmpSeries.getIndex();
                tmpSeries.setIndex(0);
                Concept value = null;
                while ( tmpSeries.hasNext() ) {
                    value = tmpSeries.next();
                    _stack.insertInstance( #i.getText(), value);
                    if( cnd == null || condition( cnd ) ){
                        tmpVect.add(value);
                    }                
                }
                tmpSeries = new SeriesConcept( tmpVect );
                tmpSeries.setIndex(idx);
            }
            
            // we sort it to math the break by expressions
            if( breakEx != null && breakEx.size() > 0 && tmpSeries.getVector().size() > 0){
                 sort(tmpSeries, breakEx);          
            }

            Eacher each = new Eacher(tmpSeries.getVector(), 0, this, #i, in, #blk, breakEx);
            if( bex != null ) {
                _eachLevel.push(each);
            }

            each.doEachBlock();            

            if( bex != null ) {
                _eachLevel.pop();
                _eachBySignature.pop();
            }
        }
    ;


iterationSource returns [SeriesConcept result]
{ Concept expr = null; result = null; }
    : #(SOURCE expr = expression)
        {
            if( expr != null && expr instanceof Series ){
                result = (SeriesConcept) expr;
            }
            else {
                result = new SeriesConcept();
                ((SeriesConcept)result).add(expr);
            }
        }
	| expr = fromExpression
		{
			if( expr.extendsConcept(new StringConcept("Series")).getValue()) {
				return (SeriesConcept) expr;
			} else {
				result = new SeriesConcept();
				result.add( expr);
			}
		}
    ;


breakExpression returns [Vector result]
{ result = new Vector(); AST node = null;}
    : #(BREAK { _eachBySignature.push(""); }  (node = byExpression { result.add(node); addByToSignatureStack(getIdentifierSignature(node));} )* )
    ;


byExpression returns [AST node]
{node = null;}
    : #(BY bm:byMarker )
        { node = bm;  }
    ;


byMarker
    :   descendingBy
    |   ascendingBy
    ;


descendingBy
    : #( DESCENDING i:IDENT)
    ;


ascendingBy
    : #( ASCENDING i:IDENT)
    ;


byIterator [Concept on] returns [Concept result]
{ result = null; }
    :   result = descendingByIterator[on]
    |   result = ascendingByIterator[on]
    ;


descendingByIterator [Concept on] returns [Concept result]
{ result = null; }
    :  #( DESCENDING i:IDENT )
        { result = postfixedConceptValue( #i.getFirstChild(), on, #i); }
    ;


ascendingByIterator [Concept on] returns [Concept result]
{ result = null; }
    :  #( ASCENDING i:IDENT )
        { result = postfixedConceptValue( #i.getFirstChild(), on, #i); }
    ;


switchBlock
    { boolean done = false; 
      Concept equalsWith = null;
    }
    : #( SWITCH { setLineNr( #SWITCH.getLine());} equalsWith = expression 
            ( {done==false}? done = switchBody[equalsWith] )+ )        
    ;


switchBody [Concept equalsWith] returns [boolean done]
   { done = false; }
    :   #(CASE { setLineNr( #CASE.getLine());} done = caseConditional[true, equalsWith])
    |   #(ELSE_BLOCK { setLineNr( #ELSE_BLOCK.getLine());} code:BLOCK 
            { statementBlock(code);} )
    ;


caseConditional [ boolean forWhat, Concept equalsWith ] returns [boolean yes] 
    {   yes = true; }
    : expr:CONDITION block:BLOCK
        {
            setLineNr( #expr.getLine());
            yes = caseCondition( expr, equalsWith );
            if ( forWhat == yes ) {
                statementBlock(block);
            }
        }
    ;


caseCondition [Concept equalsWith] returns [boolean status] 
    { status = false; Concept result = null;}
    :  #(CONDITION result = expr:expression) 
        { 
            setLineNr( #CONDITION.getLine());
            status = ((LogicalConcept) executeOp( "==", 
                                                (JavaConcept) equalsWith, 
                                                (JavaConcept) expression(expr),
                                                expr.getLine())).getValue(); }
    ;


whileDoLoop
    : #(WHILE cnd:CONDITION )
        { while( conditional(cnd, true)) { Thread.yield(); } } 
    ;


doWhileLoop
    : #(DO blk:BLOCK cnd:CONDITION )
        { do {
                statementBlock(blk);
          } while( condition(cnd)); }
    ;


ifBlock
    { boolean done = false; }
    : #(IF ( {done==false}? done = ifThenBody )+) 
    ;


ifThenBody returns [boolean done]
    { done = false; }
    :   #(IF_BLOCK done = conditional[true])
    |   #(ELIF_BLOCK done = conditional[true])
    |   #(ELSE_BLOCK code:BLOCK 
            { statementBlock(code);} )
    ;


condition returns [boolean status] 
    { status = false; }
    :  c:CONDITION
        {   AST expr = c.getFirstChild();
            setLineNr( #c.getLine());
            try {
                status = checkExpression( expr ); 
            } catch ( NotLogicalExpressionException ex) {
                ex.scriptName = _scriptName;
                if( mn8RuntimeFlags.isDebug()) {
                    ex.printStackTrace();
                }
                new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr); 
            }                   
        }
    ;


conditional [ boolean forWhat ] returns [boolean yes] 
    {   yes = true; expr = null; #expr=null; }
    : expr:CONDITION block:BLOCK
        {
            yes = condition( expr );
            if ( forWhat == yes ) {
                statementBlock(block);
            }
        }
    ;


statementBlock returns [Concept result]
{ result = null; } 
    : #(BLOCK 
            { _stack.pushScope(new Scope(_stack.getCurrentScope())); }
            (result = statement)* 
            { _stack.popScope(); }
        )
    ;


returnStatement returns[ Concept result ]
{ result = null; }
    : #(RETURN result=expression)
        { 
            _t = ASTNULL; 
            throw new mn8ExitEvent( mn8ExitEvent.RETURN_EVENT, result);
        }
    ;


toStatement
{ MapConcept toOptions = new MapConcept() ; Concept val = null; Concept uriConcept = null; }
	: #(TO val = expression uriConcept=expression (toOptions=optionList[toOptions])?)
		{ 
          setLineNr( #TO.getLine());
          URI uri = new URI(uriConcept.toTXT());
          Concept handler = uri.getURIHandler();
          SeriesConcept params = new SeriesConcept();
          params.add(toOptions);
          executeMethod("initialize:Map", handler, params);
          executeMethod("openConnection:", handler, new SeriesConcept());
          params = new SeriesConcept();
          params.add(val);
          executeMethod("setContent:Concept", handler, params);
          executeMethod("closeConnection:", handler, new SeriesConcept());
		}
	; 


fromExpression returns [Concept value]
{ MapConcept fromOptions = new MapConcept() ; Concept uriConcept = null; value= null; }
	: #(FROM uriConcept=expression (fromOptions=optionList[fromOptions])?)
		{ 
          setLineNr( #FROM.getLine());
          URI uri = new URI(uriConcept.toTXT());
		  Concept handler = uri.getURIHandler();
          SeriesConcept params = new SeriesConcept();
          params.add(fromOptions);
          executeMethod("initialize:Map", handler, params);
          executeMethod("openConnection:", handler, new SeriesConcept());
          value = executeMethod("getContent:", handler, new SeriesConcept());
          executeMethod("closeConnection:", handler, new SeriesConcept());
		}
	; 


optionList [MapConcept map] returns [MapConcept opt] 
{ opt = map; }
	: #(OPTIONS (optionItem[opt])+)
	;


optionItem [MapConcept opt]
{ Concept value = null; }
	: #(ASSIGN key:STRING_LITERAL value=identOrConstant)
		{ setLineNr( #ASSIGN.getLine());opt.add(new StringConcept(#key.getText().toLowerCase()), value); }
	;


print
    { Concept data = null; 
        if ( debug ) System.err.println("print");
    }
    : #(PRINT #(ELIST (
                    data = expression
                    { 
                        if ( data!= null ) {
                            StringConcept result = (StringConcept) executeMethod( "toTXT:", data, null);
                            _out.print( result.toString() ); 
                        }
                    }
                )* 
            )
            (c:SEMI)?
            { if( c == null ) {
                    _out.print(mn8Interpreter.EOL);
                }
            }
        ) 
    ;

                            
expression returns [Concept result]
{ 
    result = new NilConcept(); 
    Concept ex1, ex2;    
} 
    : result = primaryExpression
	| result = fromExpression	
    | #(as:ASSIGN (id:IDENT | attr:ATTR | elem:ELEM | th:THIS ) result=expression) 
        {   setLineNr(#as.getLine()); 
            if( th != null ) {
                AST first = th.getFirstChild();
                if ( first != null ) {
                    switch (first.getType()) {
                        case mn8TokenTypes.ATTR : {
                            attr = first;
                            break;
                        }
                        case mn8TokenTypes.ELEM : {
                            elem = first;
                            break;
                        }
                    }
                }
            }
            result = assign(as, id, attr, elem, result); 
        }
    | #(TYPEOF pi1:IDENT ex1 = id1:expression)
        {  try {
            setLineNr(#TYPEOF.getLine());
            if( #pi1.getText().startsWith("$") ) {
                    String type = null;
                    
                    if( ex1 != null ) {
                        if( !ex1.getConceptType().toString().equalsIgnoreCase("string")) {
                            type = ex1.getConceptType().toString();
                        } else {
                            type = ((StringConcept)ex1).toString();
                        }
                    } else {
                        type = id1.getText();
                    }
                    if( ! type.equalsIgnoreCase("nil")) {
                        result =  executeStaticMethod("create:", type, new SeriesConcept());
                        _stack.insertInstance( #pi1.getText(), result);
                        _stack.setForcedType(#pi1.getText(), type);
                    } else {
                        result = new NilConcept();
                        if( _stack.isInstance( #pi1.getText())) {
                            _stack.setForcedType(#pi1.getText(), type);
                        }
                        _stack.insertInstance( #pi1.getText(), result);
                    }


                if( type.toLowerCase().equals("attribute") ) {
                    String nam = #pi1.getText().startsWith("$") ? #pi1.getText().substring(1) : #pi1.getText();
                    _stack.insertInstance( #pi1.getText(), (Concept)result.clone());
                }

                if( type.toLowerCase().equals("element") ) {
                    String nam = #pi1.getText().startsWith("$") ? #pi1.getText().substring(1) : #pi1.getText();
                    _stack.insertInstance( #pi1.getText(), (Concept)result.clone());
                }
            }
            else 
                throw new RecognitionException("Canot force type to an concept type.", "mn8Warning", #TYPEOF.getLine());
            } catch (RuntimeException ex) {
                ex.printStackTrace();
                throw new RecognitionException( ex.getMessage(), _scriptName, _curentLineNr);
            }
        }
    | #(i:FIRST IDENT) 
        {   setLineNr(#i.getLine());
            Vector positions = (Vector) _firstOfTable.get( getIdentifierSignature( #i));
            int eachPos = getByEachIndex( getIdentifierSignature(#i));
            if( positions != null && eachPos != -1) {
                Eacher eacher = (Eacher)_eachLevel.elementAt(eachPos);
                if ( positions.contains("" + eacher.getCurentIndex() )) {
                    result = new LogicalConcept(true);
                } else {
                    result = new LogicalConcept(false);
                }
            } 
            else result = new LogicalConcept(false);
        }

    | #(j:LAST IDENT) 
        {   setLineNr(#j.getLine());
            Vector positions = (Vector) _firstOfTable.get( getIdentifierSignature( #j));
            int eachPos = getByEachIndex( getIdentifierSignature(#j));
            if( positions != null && eachPos != -1) {
                Eacher eacher = (Eacher)_eachLevel.elementAt(eachPos);
                if ( positions.contains("" + (eacher.getCurentIndex() + 1)) || eacher.isLastItem() ){
                    result = new LogicalConcept(true);
                } else {
                    result = new LogicalConcept(false);
                }
            } 
            else result = new LogicalConcept(true);
        }

    | #(opPlus:PLUS ex1 = expression ex2 = expression) 
        { setLineNr(#opPlus.getLine()); result = executeOp("+", (JavaConcept)ex1, (JavaConcept)ex2, #opPlus.getLine()); }

    | #(opMinus:MINUS ex1 = expression ex2 = expression) 
        {  setLineNr(#opMinus.getLine()); result = executeOp("-", (JavaConcept)ex1, (JavaConcept)ex2, #opMinus.getLine()); }

    | #(opSTAR:STAR ex1 = expression ex2 = expression) 
        {  setLineNr(#opSTAR.getLine()); result = executeOp("*", (JavaConcept)ex1, (JavaConcept)ex2, #opSTAR.getLine()); }   

    | #(opDIV:DIV ex1 = expression ex2 = expression) 
        {  setLineNr(#opDIV.getLine()); result = executeOp("/", (JavaConcept)ex1, (JavaConcept)ex2, #opDIV.getLine()); }
   
    | #(opGT:GT ex1 = expression ex2 = expression) 
        { setLineNr(#opGT.getLine()); result = executeOp(">", (JavaConcept)ex1, (JavaConcept)ex2, #opGT.getLine()); }

    | #(opGE:GE ex1 = expression ex2 = expression) 
        {  setLineNr(#opGE.getLine()); result = executeOp(">=", (JavaConcept)ex1, (JavaConcept)ex2, #opGE.getLine()); }

    | #(opLT:LT ex1 = expression ex2 = expression) 
        {  setLineNr(#opLT.getLine()); result = executeOp("<", (JavaConcept)ex1, (JavaConcept)ex2, #opLT.getLine()); }

    | #(opLE:LE ex1 = expression ex2 = expression) 
        { setLineNr(#opLE.getLine()); result = executeOp("<=", (JavaConcept)ex1, (JavaConcept)ex2, #opLE.getLine()); }

    | #(opAND:LAND ex1 = expression 
            { 
                if( ex1 instanceof LogicalConcept && !((LogicalConcept)ex1).getValue()) {
                    result = new LogicalConcept(false);
                    _t = opAND.getNextSibling();
                    break;
                }
            }
            ex2 = expression 
        {   setLineNr(#opAND.getLine()); 
            result = executeOp("and", (JavaConcept)ex1, (JavaConcept)ex2, #opAND.getLine()); 
        }
        )

    | #(opOR:LOR ex1 = expression 
            {   
                if( ex1 instanceof LogicalConcept && ((LogicalConcept)ex1).getValue()) {
                    result = new LogicalConcept(true);
                    _t = opOR.getNextSibling();
                    break;
                }
            }
            ex2 = expression
        {  
            setLineNr(#opOR.getLine()); 
            result = executeOp("or", (JavaConcept)ex1, (JavaConcept)ex2, #opOR.getLine()); 
        }
        )

    | #(opNOT:LNOT ex1 = expression) 
        {  setLineNr(#opNOT.getLine()); result = executeOp("not", (JavaConcept)ex1, #opNOT.getLine()); }

    | #(opEQUAL:EQUAL ex1 = expression ex2 = expression) 
        {  setLineNr(#opEQUAL.getLine()); result = executeOp("==", (JavaConcept)ex1, (JavaConcept)ex2, #opEQUAL.getLine()); }   

    | #(opNOT_EQUAL:NOT_EQUAL ex1 = expression ex2 = expression) 
        { 
          setLineNr(#opNOT_EQUAL.getLine());
          result = executeOp("==", (JavaConcept)ex1, (JavaConcept)ex2, #opNOT_EQUAL.getLine()); 
          if( result instanceof LogicalConcept )
            result =  new LogicalConcept( !((LogicalConcept)result).getValue() );
        }   

    | #(opPlusAssign:PLUS_ASSIGN toPlus:IDENT ex1 = expression) {
            setLineNr(#opPlusAssign.getLine());
            Concept varId = resolveIdentifier(toPlus);
            result = executeOp("+", (JavaConcept)varId, (JavaConcept)ex1, #opPlusAssign.getLine());
            result = assign(opPlusAssign, toPlus, null, null, result);
        }

    | #(opMinusAssign:MINUS_ASSIGN toMinus:IDENT ex1 = expression) {
            setLineNr(#opMinusAssign.getLine());
            Concept varId = resolveIdentifier(toMinus);
            result = executeOp("-", (JavaConcept)varId, (JavaConcept)ex1, #opMinusAssign.getLine());
            result = assign(opMinusAssign, toMinus, null, null, result);
        }

    | #(opStarAssign:STAR_ASSIGN toStar:IDENT ex1 = expression) {
            setLineNr(#opStarAssign.getLine());
            Concept varId = resolveIdentifier(toStar);
            result = executeOp("*", (JavaConcept)varId, (JavaConcept)ex1, #opStarAssign.getLine());
            result = assign(opStarAssign, toStar, null, null, result);
        }

    | #(opDivAssign:DIV_ASSIGN toDiv:IDENT ex1 = expression) {
            setLineNr(#opDivAssign.getLine());
            Concept varId = resolveIdentifier(toDiv);
            result = executeOp("/", (JavaConcept)varId, (JavaConcept)ex1, #opDivAssign.getLine());
            result = assign(opDivAssign, toDiv, null, null, result);
        }

    | #(opINC:INC ex1 = expression) 
        { setLineNr(#opINC.getLine()); result = executeOp("++", (JavaConcept)ex1, #opINC.getLine()); }   

    | #(opPOST_INC:POST_INC ex1 = expression) 
        { setLineNr(#opPOST_INC.getLine());
          result = (Concept) ex1.clone();
          executeOp("++", (JavaConcept)ex1, #opPOST_INC.getLine()); }   

    | #(opDEC:DEC ex1 = expression) 
        {setLineNr(#opDEC.getLine());  result = executeOp("--", (JavaConcept)ex1, #opDEC.getLine()); }   

    | #(opPOST_DEC:POST_DEC ex1 = expression) 
        { setLineNr(#opPOST_DEC.getLine());
          result = (Concept) ex1.clone();
          executeOp("--", (JavaConcept)ex1, #opPOST_DEC.getLine()); }   

    | #(UNARY_MINUS ex1= expression) {
            setLineNr(#UNARY_MINUS.getLine());
            if ( ex1 instanceof IntegerConcept) {
                result = new IntegerConcept( ((IntegerConcept)ex1).getLong() * -1);  
            } else if( ex1 instanceof RealConcept ) {
                result = new RealConcept( ((RealConcept)ex1).getFloat() * -1);
            } else {

               result = ex1;
               throw new RuntimeException("- can be applied only to Integer of Real");               
            }                        
        }
    ;



primaryExpression returns [Concept result]
{ result = null; 
  if ( debug ) System.err.println("primary expression");
}
    : result = identifier
    | result = constants
    | result = range
	| result = directMethodReference
    ;



range returns [SeriesConcept result]
    { result = new SeriesConcept(); 
      Concept from = new NilConcept(); 
      Concept to = new NilConcept(); 
      Concept step = null;  
    }
    : #(r:RANGE from = identOrConstant to = identOrConstant ( step = identOrConstant )? )
        {  String type = null;

            if ( (type = rangeCompareTypes( from, to)) == null ) {
                throw new RecognitionException("Range must be the same type!", "mn8Warning", r.getLine());
            }
            if( type.equals("Character") && 
                step != null &&
                !step.getConceptType().toString().equals("Integer") ) {
                throw new RecognitionException("Can not make a range on Character with non Integer step", "mn8Warning", r.getLine());               
            }
            
            if( type.equals("Integer") ) {
                if( step == null ){
                    result = new SeriesConcept( (IntegerConcept) from,  
                                                (IntegerConcept) to,    
                                                new IntegerConcept(1));
                }
            else {
                if( step.getConceptType().toString().equals("Real") ) {
                        result = new SeriesConcept( (IntegerConcept) from, 
                                                    (IntegerConcept) to, 
                                                    (RealConcept) step);
                    }
                else 
                    if (step.getConceptType().toString().equals("Integer") ){
                        result = new SeriesConcept( (IntegerConcept) from, 
                                                    (IntegerConcept) to, 
                                                    (IntegerConcept) step);
                    }   
                    else {
                        throw new RecognitionException("The step must be of type Real or Integer", "mn8Warning", r.getLine());              
                    }
                }
            }

            if( type.equals("Real") ) {
                if( step == null ){
                    result = new SeriesConcept( (RealConcept) from,  
                                                (RealConcept) to,   
                                                new IntegerConcept(1));
                }
            else {
                if( step.getConceptType().toString().equals("Real") ) {
                        result = new SeriesConcept( (RealConcept) from, 
                                                    (RealConcept) to, 
                                                    (RealConcept) step);
                    }
                else 
                    if (step.getConceptType().toString().equals("Integer") ){
                        result = new SeriesConcept( (RealConcept) from, 
                                                    (RealConcept) to, 
                                                    (IntegerConcept) step);
                    }   
                    else {
                        throw new RecognitionException("The step must be of type Real or Integer", "mn8Warning", r.getLine());              
                    }
                }
            }

            if( type.equals("Character") ) {
                if( step == null ){
                    result = new SeriesConcept( (CharacterConcept) from,  
                                                (CharacterConcept) to,  
                                                new IntegerConcept(1));
                }
            else {
                if( step.getConceptType().toString().equals("Integer") ) {
                        result = new SeriesConcept( (CharacterConcept) from, 
                                                    (CharacterConcept) to, 
                                                    (IntegerConcept) step);
                    }
                else {
                        throw new RecognitionException("The step must be of Integer", "mn8Warning", r.getLine());               
                }
            }
        }
    }
    ;


identOrConstant returns [Concept result]
{ result = new NilConcept(); }
    : result = constants
    | result = identifier
    ;


directAttributeReference returns [Concept result] 
{ result = null; }
	:#(ATTR
		{ 
                setLineNr( #ATTR.getLine());
                try {
                    result =  attributeOnConcept(#ATTR, null, null);
                    if( #ATTR.getFirstChild() != null ) {
                        result = postfixedConceptValue(#ATTR.getFirstChild(), result, #ATTR);
                    }
                } catch (AttributeNotFoundException ex) {
                    ex.lineNr = _curentLineNr;
                    ex.scriptName = _scriptName;
                    result = new NilConcept();
                    if( mn8RuntimeFlags.isDebug()) {
                        ex.printStackTrace();
                    }
                    result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
                } catch (NotStaticAttributeException ex) {
                    ex.lineNr = _curentLineNr;
                    ex.scriptName = _scriptName;
                    result = new NilConcept();
                    if( mn8RuntimeFlags.isDebug()) {
                        ex.printStackTrace();
                    }
                    result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
                }
            })
	;


directElementReference returns [Concept result] 
{ result = null; }
	: #(ELEM
		{ 
                setLineNr(#ELEM.getLine());
                try {
                    result =  elementOnConcept(#ELEM, null, null);
                    if( #ELEM.getFirstChild() != null ) {
                        result = postfixedConceptValue(#ELEM.getFirstChild(), result, #ELEM);
                    }
                } catch (MethodNotFoundException mex) {
                    mex.lineNr = _curentLineNr;
                    mex.scriptName = _scriptName;
                    result = new NilConcept();
                    if( mn8RuntimeFlags.isDebug()) {
                        mex.printStackTrace();
                    }
                    new ErrorConcept(mex.type, mex.id, mex.getSimpleMessage(), mex.lineNr);                 
                } catch (NotStaticMethodException mex) {
                    mex.lineNr = _curentLineNr;
                    mex.scriptName = _scriptName;
                    result = new NilConcept();
                    if( mn8RuntimeFlags.isDebug()) {
                        mex.printStackTrace();
                    }
                    new ErrorConcept(mex.type, mex.id, mex.getSimpleMessage(), mex.lineNr); 
                }
		})	
	;


directMethodReference returns [Concept result]
{ result = null; }
	:#( DOT result = postfixedConceptValue[null, #DOT] )
    ;


variableOrTypeReference returns [Concept result]
{ result = null; }
    :   #(IDENT { result = resolveIdentifier( #IDENT ); 
                setLineNr( #IDENT.getLine());}
			result = postfixedConceptValue[result, #IDENT]
		)
	;


identifier returns [Concept result]
{ result = null; }
	:	result = variableOrTypeReference
	|	result = directAttributeReference
	|	result = directElementReference
    ;


constants returns [Concept result]
{ result = null; }
    : result = stringConstant
    | result = characterConstant
    | result = integerConstant
    | result = realConstant
    | result = trueKeyword
    | result = falseKeyword
    | result = nilKeyword
	| result = thisKeyword
    | result = superKeyword
    ;


stringConstant returns [Concept result]
{ result = null; }
    : #( STRING_LITERAL
            { result = new StringConcept(#STRING_LITERAL.getText());
            setLineNr( #STRING_LITERAL.getLine());}
            result = postfixedConceptValue[result, null]
       )
    ;


integerConstant returns [Concept result]
{ result = null; }
    : #( NUM_INT
            { result = new IntegerConcept(#NUM_INT.getText()); 
            setLineNr( #NUM_INT.getLine());}
            result = postfixedConceptValue[result, null]
       )
    ;


characterConstant returns [Concept result]
{ result = null; }
    : #( CHAR_LITERAL
            { result = new CharacterConcept(#CHAR_LITERAL.getText().charAt(0)); 
            setLineNr( #CHAR_LITERAL.getLine());}
            result = postfixedConceptValue[result, null]
       )
    ;


realConstant returns [Concept result]
{ result = null; }
    : #( NUM_REAL
            { result = new RealConcept(#NUM_REAL.getText()); 
            setLineNr( #NUM_REAL.getLine());}
            result = postfixedConceptValue[result, null]
       )
    ;



nilKeyword returns [Concept result]
{ result = null; }
    : #( NIL
            { result = new NilConcept(); 
            setLineNr( #NIL.getLine());}
            result = postfixedConceptValue[result, null]
       )
    ;


trueKeyword returns [Concept result]
{ result = null; }
    : #( TRUE
            { result = new LogicalConcept(true); 
            setLineNr( #TRUE.getLine());}
            result = postfixedConceptValue[result, null]
       )
    ;


falseKeyword returns [Concept result]
{ result = null; }
    : #( FALSE
            { result = new LogicalConcept(false); 
            setLineNr( #FALSE.getLine());}
            result = postfixedConceptValue[result, null]
       )
    ;


thisKeyword returns [Concept result]
{ result = null; }
    : #( THIS
            { 
                setLineNr( #THIS.getLine());
                if( _thisMethod != null &&  !_thisMethod.isStatic().getValue() && _thisConcept != null )
				result = _thisConcept ;
                else {
                    result = new NilConcept();
                    throw new RecognitionException("Can not use this in a static method !", "mn8Warning", #THIS.getLine());
                }
             }
            result = postfixedConceptValue[result, #THIS ]
       )
    ;


superKeyword returns [Concept result]
{ result = null; SeriesConcept param=null;}
    : #( SUPER //(param = parameters)? 
            {
                setLineNr( #SUPER.getLine());
                if ( superList == null ) {
                    superList = new Vector();
                }
                if( param == null || param.getVector().size() == 0) {
                    if( _thisConcept != null ) {
                       superList.add( _thisConcept.getInheritedConcepts().getVector().elementAt(_thisConcept.getInheritedConcepts().getVector().size()-1));
                    } 
                }else {
                    if( param.getVector().size() > 1 ) {
                        if( mn8RuntimeFlags.isVerbose() || mn8RuntimeFlags.isDebug() ) {
                            System.err.println("To many parameters to super, only first considered");
                        }
                    }
                    if( mn8Loader.isConceptAvailable( ((StringConcept)param.getVector().elementAt(0)).toString()) ) {
                        if( _thisConcept.getInheritedConcepts().contains( (StringConcept)param.getVector().elementAt(0)).getValue()) {
                            superList.add(param.getVector().elementAt(0));
                        } else {

                        System.err.println( _thisConcept.getConceptType().toString() 
                                + " does not inherit concept: " +  ((StringConcept)param.getVector().elementAt(0)).toString() 
                                + " in : " + _thisConcept.getConceptType().toString()  + " line: " + #SUPER.getLine()); 
                        }
                    } else {

                        System.err.println("Unable to find concept" + ((StringConcept)param.getVector().elementAt(0)).toString() +
                            " in : " + _thisConcept.getConceptType().toString() + " line: " + #SUPER.getLine()); 
                    }
                }
                
            }
            result = methodOnConcept[null, #SUPER ]
       )
    ;


postfixedConceptValue [Concept concept, AST parent] returns [Concept result] 
{ result = concept;}
    :   (result = oneDeepPostfixedConceptValue[result, parent])*
    ;


oneDeepPostfixedConceptValue[ Concept concept, AST parent] returns [Concept result]
{ result = concept;}
	: 	result = methodOnConcept[result, parent]
	|	result = elementOnConcept[result, parent]
	|	result = attributeOnConcept[result, parent]
	;


methodOnConcept [Concept on, AST parent] returns [Concept result]
    { result = on; String appendName= null; SeriesConcept param = null; }
    : #(METH (param = parameters)? {
                setLineNr(#METH.getLine());
                try {
                if ( (appendName = #METH.getText())!= null ){

                    mn8Method method = null;    
                    String methodSig = null;
                    if( param != null ) {
                        methodSig = "" + appendName + ":" ;
                        for( int  i = 0; i < param.getVector().size(); i++ ) 
                            methodSig += ( i > 0 ? "," : "") + 
                                ((Concept)param.getVector().elementAt(i)).getConceptType().getValue();
                    }
                    else {
                        methodSig = "" + appendName + ":";
                    }   
                
                    if ( parent != null && parent.getText().equalsIgnoreCase("super") ) {
                        String conc = ((StringConcept)superList.elementAt(0)).toString();
                        result = executeInheritedMethod(conc, methodSig, _thisConcept, param);
                        superList = null;                        
                        parent = null;
                    } else if ( on == null && parent != null && parent.getText().equalsIgnoreCase("dot") ) {
                        String conceptType;
                        if (_thisConcept != null ) {
                                conceptType = _thisConcept.getConceptType().toString();
                                result = executeMethod(methodSig, _thisConcept , param);
                        } else if( _thisMethod != null ) {
                                conceptType = _thisMethod.getDeclaringConcept().toString();
                                result = executeStaticMethod(methodSig, conceptType , param);
                        } else {
                                conceptType = _scriptName;
                                result = executeStaticMethod(methodSig, conceptType , param);
                        }

                    } else {

                        if( on != null ) {
                            result = executeMethod(methodSig, on, param);
                        }
                        else { 
                            if( parent != null ){
                                if( parent.getText().startsWith("$") ) {
                                    result = executeMethod(methodSig,  on,  param );
                                } else {
                                    result = executeStaticMethod(methodSig,  parent.getText(),  param );
                                } 
                            } else {
                                // hmmm on = null parent = null what's this static method on current concept
                                if( _thisMethod.isStatic().getValue() ) {
                                    result = executeStaticMethod( methodSig, 
                                        _thisMethod.getDeclaringConcept().toString(),
                                        param);
                                } else {
                                    if( _thisConcept == null ) {
                                            throw new NotStaticMethodException(_thisMethod.getDeclaringConcept().toString(), #METH.getText(), #METH.getLine());
                                    } else {
                                        result = executeMethod(methodSig,  _thisConcept,  param );
                                    }
                                }
                            }
                         }   
                    }	
                    }
                } catch (MethodNotFoundException mex) {
                    mex.lineNr = _curentLineNr;
                    mex.scriptName = _scriptName;
                    result = new NilConcept();
                    if( mn8RuntimeFlags.isDebug()) {
                        mex.printStackTrace();
                    }
                    new ErrorConcept(mex.type, mex.id, mex.getSimpleMessage(), mex.lineNr);                 
                } catch (NotStaticMethodException mex) {
                    mex.lineNr = _curentLineNr;
                    mex.scriptName = _scriptName;
                    result = new NilConcept();
                    if( mn8RuntimeFlags.isDebug()) {
                        mex.printStackTrace();
                    }
                    new ErrorConcept(mex.type, mex.id, mex.getSimpleMessage(), mex.lineNr); 
                }
            })
    ;


elementOnConcept [Concept on, AST parent] returns [Concept result]
    { result = on; }
    : ELEM {FieldDefinition elField = null;
            try {
                setLineNr(#ELEM.getLine());
                if( (on == null && parent == null )  || (parent != null && parent.getText().equalsIgnoreCase("super"))) {
                    elField = getElementField( #ELEM.getText(), _thisConcept, 
                        _thisMethod.getDeclaringConcept().toString(), #ELEM.getLine());
                    result = getElementValue( elField, _thisConcept,
                        _thisMethod.getDeclaringConcept().toString(), #ELEM.getLine());
                } else {
                    elField = getElementField( #ELEM.getText(), on, 
                        parent.getText(), #ELEM.getLine());
                    result = getElementValue( elField, on,
                        parent.getText(), #ELEM.getLine());
                }
            } catch (ElementNotFoundException ex) {
                ex.lineNr = _curentLineNr;
                ex.scriptName = _scriptName;
                result = new NilConcept();
                if( mn8RuntimeFlags.isDebug()) {
                    ex.printStackTrace();
                }
                result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
            } catch (NotStaticElementException ex) {
                ex.lineNr = _curentLineNr;
                ex.scriptName = _scriptName;
                result = new NilConcept();
                if( mn8RuntimeFlags.isDebug()) {
                    ex.printStackTrace();
                }
                result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
            }
		}
    ;


attributeOnConcept [Concept on, AST parent]  returns [Concept result]
    { result = on;}
    : ATTR {FieldDefinition attrField = null;
            try {
                setLineNr(#ATTR.getLine());
                if( (on == null && parent == null) || (parent != null && parent.getText().equalsIgnoreCase("super"))) {
                    attrField = getAttributeField( #ATTR.getText(), _thisConcept, 
                        _thisMethod.getDeclaringConcept().toString(), #ATTR.getLine());
                    result = getAttributeValue( attrField, _thisConcept,
                        _thisMethod.getDeclaringConcept().toString(), #ATTR.getLine());
                } else {
                    if( parent == null ) {
                        attrField = getAttributeField( #ATTR.getText(), on, #ATTR.getLine());
                    } else {
                        attrField = getAttributeField( #ATTR.getText(), on, parent.getText(), #ATTR.getLine());
                    }
                    
                    if( parent == null ) {
                        result = getAttributeValue( attrField, on, null , #ATTR.getLine());
                    } else {
                        result = getAttributeValue( attrField, on, parent.getText(), #ATTR.getLine());
                    }
                }
                _previousElem = null;
            } catch (FieldNotFoundException ex) {
                ex.lineNr = _curentLineNr;
                ex.scriptName = _scriptName;
                result = new NilConcept();
                if( mn8RuntimeFlags.isDebug()) {
                    ex.printStackTrace();
                }
                result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
            } catch (AttributeNotFoundException ex) {
                ex.lineNr = _curentLineNr;
                ex.scriptName = _scriptName;
                result = new NilConcept();
                if( mn8RuntimeFlags.isDebug()) {
                    ex.printStackTrace();
                }
                result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
            } catch (NotStaticAttributeException ex) {
                ex.lineNr = _curentLineNr;
                ex.scriptName = _scriptName;
                result = new NilConcept();
                if( mn8RuntimeFlags.isDebug()) {
                    ex.printStackTrace();
                }
                result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
            }
		}
    ;


postfixPaths[Concept on, String conceptType] returns [FieldDefinition field]
{ field=null;}
	:	( 	field = attributeFieldOnConcept[on, conceptType]
		|	field = elementFieldOnConcept[on, conceptType]
		)*
	;


attributeFieldOnConcept[Concept on, String conceptType] returns [FieldDefinition field]
{ field = null; }
	: ATTR 
		{
            setLineNr(#ATTR.getLine());
            try {                
                field = getAttributeField(#ATTR.getText(), on, conceptType, #ATTR.getLine()); _previousElem = null; 
            } catch (FieldNotFoundException ex) {
                ex.lineNr = _curentLineNr;
                ex.scriptName = _scriptName;
                if( mn8RuntimeFlags.isDebug()) {
                    ex.printStackTrace();
                }
                field = (FieldDefinition) (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
            }                
        }
	;

elementFieldOnConcept[Concept on, String conceptType] returns [FieldDefinition field]
{ field = null; }
	: ELEM 
		{ 
            setLineNr(#ELEM.getLine());
            try{
                field = getElementField(#ELEM.getText(), on, conceptType, #ELEM.getLine()); 
            } catch (FieldNotFoundException ex) {
                ex.lineNr = _curentLineNr;
                ex.scriptName = _scriptName;
                if( mn8RuntimeFlags.isDebug()) {
                    ex.printStackTrace();
                }
                field = (FieldDefinition) (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
            }
        }
	;


parameters returns [SeriesConcept result]
    { result = new SeriesConcept(); Concept exresult; }
    : #(ELIST (exresult = expression { result.getVector().add(exresult); } )*)
    ;
