// $ANTLR 2.7.1: "mn8TreeWalker.g" -> "mn8TreeWalker.java"$

package org.media.mn8.parser;

import org.media.mn8.*;
import org.media.mn8.event.*;
import org.media.mn8.concepts.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Stack;
import java.lang.Thread;
import antlr.*;

import java.io.PrintStream;

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


/** 
 * The final Tree Walker for mn8. This is responsible
 * of the interpretation.<br>
 * This class is automaticaly generated by 
 * <a href="http://www.antlr.org">ANTLR</a>.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.85 $ $Date: 2002/06/05 14:55:15 $
 */
public class mn8TreeWalker extends antlr.TreeParser
       implements mn8TreeWalkerTokenTypes
 {

    boolean debug = mn8RuntimeFlags.isDebug();
	boolean verbose = mn8RuntimeFlags.isVerbose();
    private ScopeStack _stack = null;
    private Hashtable  _firstOfTable = new Hashtable();
    public  static int lineNr = -1;
    public  boolean readyToReturn = false;
	private mn8Concept _thisConcept  = null;
	private mn8ScriptMethod _thisMethod = null;
    private Vector superList = null;
    private String _scriptName = mn8Loader.getScriptName();
    private ElementConcept _previousElem = null;
    private int _curentLineNr = 0;
    private Stack _eachLevel = new Stack();
    private Stack _eachBySignature = new Stack();
    private PrintStream _out = null;
    private PrintStream _err = null;

    public void exit() {
        readyToReturn = true;
    }


    public void reportWarning( String message ) {
        System.err.println("__debug:" + message);
    }


    public void reportError( String message ) {
        System.err.println("__debug:" + message);
    }

    
    private void setLineNr(int lineNr) {
        this.lineNr = lineNr;
       _curentLineNr = lineNr;
    }


    private void addByToSignatureStack(String bySig) {
         _eachBySignature.setElementAt(_eachBySignature.peek().toString() + " " + bySig + " ",
                                       _eachBySignature.size()-1);
    }
    

    private int getByEachIndex( String bySig ) {
        for( int i = _eachBySignature.size() -1; i >= 0 ; i--) {
            if( _eachBySignature.elementAt(i).toString().indexOf(" " + bySig + " ") >= 0){
                return i;
            }
        }
        return -1;
    }
    
    public ScopeStack getStack() {
        return _stack;
    }

    
    boolean checkExpression( AST expr ) throws RecognitionException {
        Concept concept = expression( expr );
        if( concept instanceof LogicalConcept ) {
            return ((LogicalConcept) concept).getValue();
        } else { 
            LogicalConcept logValue = null;
            if( concept.hasConceptMethod(new StringConcept("toLogicalConcept:")).getValue()) {
                logValue = (LogicalConcept) executeMethod("toLogicalConcept:", concept, null);
            }
            if(  logValue != null ) {
                return logValue.getValue();
            }
            else {
                throw new NotLogicalExpressionException (concept.getConceptType().getValue(), expr.getLine());
            }  
        }        
    }


    Concept executeOp(String op, JavaConcept op1, JavaConcept op2, int line) 
                                                            throws RecognitionException {
        Concept result = new NilConcept(); 
        mn8Method method = getConceptDefinition(op1).getConceptOperator(op + ":" 
                                        + op2.getConceptType().getValue());
        if( method == null ) {
            throw new RecognitionException("Unsuported operation: " +  
                                           op1.getConceptType().getValue() + " " + op + " "  +
                                           op2.getConceptType().getValue(), "", line );
        } else {            
            SeriesConcept param = new SeriesConcept();
            param.getVector().add(op2);
            result = method.invoke( op1, (SeriesConcept)param.clone() );
            return result;
        }
    }


    Concept executeOp(String op, JavaConcept op1, int line) 
                                                            throws RecognitionException {
        Concept result = new NilConcept(); 
        mn8Method method = getConceptDefinition(op1).getConceptOperator(op + ":");
        if( method == null ) {
            throw new RecognitionException("Unsuported operation: " +  
                                           op1.getConceptType().getValue() + " " + op,
                                           "", line );
        } else {            
            SeriesConcept param = new SeriesConcept();
            result = method.invoke( op1, (SeriesConcept)param.clone() );
            return result;
        }
    }

    
    public static ConceptDefinition getConceptDefinition(Concept forConcept) {
        return mn8Loader.getConceptDefinition( forConcept.getConceptType().getValue() );
    }


    public Concept executeStaticMethod( String methodSig, String concetType, SeriesConcept param) {
        return executeStaticMethod(methodSig, concetType, param, _curentLineNr);
    }


    public static Concept executeStaticMethod (String methodSig, String conceptType, SeriesConcept param, int lineNr) {
        Concept result = null;
        ConceptDefinition concDef = mn8Loader.getConceptDefinition( conceptType );
		mn8Method method = null;

		if( !methodSig.trim().toLowerCase().startsWith("create:") ) {
			method = concDef.getConceptMethod( methodSig.toLowerCase() );
		} else {
            Concept instance = mn8Loader.getConceptDefinition(conceptType).getConceptInstance();
            return executeMethod(methodSig, instance, param, lineNr);
		}


        if( method != null && method.isStatic().getValue()) {
            method.setLineNr(lineNr);
            result = method.invoke( conceptType,  param == null ? null : (SeriesConcept)param.clone() );          
            return result;
        } else {
            throw new NotStaticMethodException( conceptType, methodSig);
        }     
    }
    

    public Concept executeMethod(String methodSig, Concept on, SeriesConcept param) {
        return executeMethod( methodSig, on, param, _curentLineNr);
    }


    public static Concept executeMethod(String methodSig, Concept on, SeriesConcept param, int lineNr) {
        Concept result = null;
		mn8Method method = null;

		if( !methodSig.trim().toLowerCase().startsWith("create:") ) {
			method = getConceptDefinition(on).getConceptMethod( methodSig.toLowerCase() );
		} else {
			method = getConceptDefinition(on).getConceptConstructor( methodSig.toLowerCase() );
		}

        if( method != null ) {
            method.setLineNr(lineNr);
            result = method.invoke( on,  param == null ? null : (SeriesConcept)param.clone() );           
            return result;
        } else {
            throw new MethodNotFoundException( on.getConceptType().toString(), methodSig);
        }
    }


    public Concept executeInheritedMethod(String inhConceptType, String methodSig, Concept on, SeriesConcept param) {
        Concept result = null;
		mn8Method method = null;

		if( methodSig.trim().toLowerCase().startsWith("create:") ) {
            method = mn8Loader.getConceptDefinition(inhConceptType).getConceptConstructor( methodSig.toLowerCase() );
		} else {
            method = mn8Loader.getConceptDefinition(inhConceptType).getConceptMethod( methodSig.toLowerCase() );
        }

        if( method != null ) {
            method.setLineNr(_curentLineNr);
            result = method.invoke( on,  param == null ? null : (SeriesConcept)param.clone() );           
            return result;
        } else {
            throw new MethodNotFoundException( on.getConceptType().toString(), methodSig);
        }
    }
    
    
    public Concept resolveIdentifier( AST i) {
        Concept result = null;
        if( verbose ) _err.println("Resolving identifier :" + i.getText());           
        if( i.getText().startsWith("$") ) {
            if( _stack.isInstance( i.getText() ))
                result = _stack.getInstance( i.getText());
            else {
                _stack.insertInstance( i.getText(), new NilConcept() );
                result = _stack.getInstance( i.getText());
            }
        } 
        return result;
    }


    public void cleanFirstOfTableElements(Vector by) {
        if( by == null) return;

        for(int i = 0 ; i < by.size() ; i++)
            _firstOfTable.remove( getIdentifierSignature( (AST) by.elementAt(i)));
    }


    private boolean isAscending( AST node ) {
        if( node.getText().toLowerCase().equals("ascending") )
            return true;
        else 
            return false;
    }


    private String getIdentifierSignature ( AST node ) {
        String result = null;
        AST child = node.getFirstChild();
        result = child.getText();
        child = child.getFirstChild();
        while( child != null ) {
            if( child.getType() == mn8TokenTypes.METH )
                result += "." + child.getText();

            if( child.getType() == mn8TokenTypes.ELEM )
                result += "/" + child.getText();

            if( child.getType() == mn8TokenTypes.ATTR )
                result += "@" + child.getText();

            child = child.getNextSibling();
        }
        return result;
    }


    private SeriesConcept sort(SeriesConcept what, Vector by) throws RecognitionException {
        Vector sortVect = what.getVector();
        if( sortVect == null || sortVect.size() < 2 ) {
            return what;
        }

        if( isAscending( (AST)by.elementAt(0) )) {
            sortVect = quickSort(sortVect, by, 0, 0, sortVect.size() -1);
        } else  {
            sortVect = quickSortDescending(sortVect, by, 0, 0, sortVect.size()-1);
        }

        sortVect= deepSort(sortVect, by, 0, 0, sortVect.size()-1);
        computeFirstOfPositions(sortVect, by, 0);
        return new SeriesConcept(sortVect);
    }


    private Vector quickSort(Vector what, Vector by, int byPos, int left, int right) throws RecognitionException {

        if( left >= right ) return what;

        if(right == left + 1 ) {
            if( compareMoreThan(byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(left)), 
                                byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(right)))) {
                quickSortSwap(what, left, right);                
            }
            return what;
        } 

        // The pivot is left
        Concept o1 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(left));
        quickSortSwap(what, left, right);
        int upTo = left;
        int downTo = right - 1;
        
        do {
            // get me the first one from the left which is greater than pivot
            while( upTo <= downTo && compareLessThanOrEqual(byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(upTo)), o1)) {
                upTo++;
            }
            
            // get me the first one from right which is less or equals than pivot
            while( upTo <= downTo && compareMoreThan( byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(downTo)), o1)) {
                downTo-- ;
            }
                    
            if( upTo < downTo ) {
                quickSortSwap(what, downTo, upTo);
            }
        } while ( upTo < downTo );

        quickSortSwap(what, right, upTo);
        what = quickSort(what, by, byPos, left, upTo-1);
        what = quickSort(what, by, byPos, upTo+1, right);
        return what;
    }


    private Vector quickSortDescending(Vector what, Vector by, int byPos, int left, int right) 
                                                                throws RecognitionException {

        if( left >= right ) return what;

        if(right == left + 1 ) {
            if( compareLessThan(byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(left)), 
                                byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(right)))) {
                quickSortSwap(what, left, right);                
            }
            return what;
        } 

        // The pivot is left
        Concept o1 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(left));
        quickSortSwap(what, left, right);
        int upTo = left;
        int downTo = right - 1;
        
        do {
            // get me the first one from the left which is less or equals than pivot
            while( upTo <= downTo && compareMoreThan(byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(upTo)), o1)) {
                upTo++;
            }
            
            // get me the first one from right which is more than pivot
            while( upTo <= downTo && compareLessThanOrEqual( byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(downTo)), o1)) {
                downTo-- ;
            }            
        
            if( upTo < downTo ) {
                quickSortSwap(what, downTo, upTo);
            }
        } while ( upTo < downTo );

        quickSortSwap(what, right, upTo);
        what = quickSortDescending(what, by, byPos, left, upTo-1);
        what = quickSortDescending(what, by, byPos, upTo+1, right);

        return what;
   }


    private Vector quickSortSwap(Vector vector, int pos1, int pos2) {
        Object obj = vector.elementAt(pos1);
        vector.setElementAt(vector.elementAt(pos2), pos1);
        vector.setElementAt(obj, pos2);
        return vector;
    }


    private Vector deepSort( Vector what, Vector by, int byPos, int left, int right)  throws RecognitionException {
        if( byPos > by.size() - 1 || what.size() < 2 )
            return what;

        Concept c1 = null;
        Concept c2 = null;
        int start = left;
        int stop;

        while ( start < right - 1) {
            stop = start;
            c1 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(start));

            do {
                stop++;
                c2 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(stop));
            } while ( stop < right && compareEqual(c1, c2) );

            if( stop > start + 1) {
                int endPos = stop - 1;
                if( compareEqual(c1, c2) ) {
                    endPos = stop;
                }

                if( byPos < by.size() -1){
                    if( isAscending( (AST)by.elementAt(byPos + 1) )) {
                        what = quickSort(what, by, byPos+1, start, endPos);
                        what = deepSort( what, by, byPos+1, start, endPos);
                    } else  {
                        what = quickSortDescending(what, by, byPos+1, start, endPos);
                        what = deepSort( what, by, byPos+1, start, endPos);
                    }
                }
            } 
            start = stop;
        }
        return what;
    }


    private void computeFirstOfPositions (Vector what, Vector by, int byPos ) throws RecognitionException {
        Vector firstOfPositions = new Vector();
        Concept c1 = null;
        Concept c2 = null;
        int start = 0;
        int stop;

        while ( start < what.size() ) {
            stop = start;
            c1 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(start));
            firstOfPositions.add(""+start);

            do {
                stop++;
                if( stop < what.size() ) {
                    c2 = byIterator((AST) by.elementAt(byPos), (Concept)what.elementAt(stop));
                }
            } while ( stop < what.size()  && compareEqual(c1, c2) );

            start = stop;
        }

        _firstOfTable.put( getIdentifierSignature( (AST) by.elementAt(byPos)), firstOfPositions);

        if( byPos < by.size() -1 ) {
            computeFirstOfPositions(what, by, ++byPos);
        }
    }
    

    private boolean compareLessThan(Object obj1, Object obj2) throws RecognitionException{
        return ((LogicalConcept)executeOp("<", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue();
    }


    private boolean compareMoreThan(Object obj1, Object obj2) throws RecognitionException{
        return ((LogicalConcept)executeOp(">", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue();
    }


    private boolean compareLessThanOrEqual(Object obj1, Object obj2) throws RecognitionException {
        return ( ((LogicalConcept)executeOp("<", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue() ||
                 ((LogicalConcept)executeOp("==", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue());

    }


    private boolean compareEqual(Object obj1, Object obj2) throws RecognitionException {
        return ((LogicalConcept)executeOp("==", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue();
    }



    private boolean compareMoreThanOrEqual(Object obj1, Object obj2) throws RecognitionException {
        return ( ((LogicalConcept)executeOp(">", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue() ||
                 ((LogicalConcept)executeOp("==", (JavaConcept) obj1, (JavaConcept) obj2, 99)).getValue());

    }

        
    private String rangeCompareTypes( Concept from, Concept to ){
        if( from.getConceptType().toString().equals( to.getConceptType().toString())) {
            return from.getConceptType().toString();
        } 
        else {
            return null;
        }
    }


	private FieldDefinition getElementField( String elName, Concept on, int ifErrorLine) {
		FieldDefinition field = null;
        if( elName.startsWith("$") && _stack.isInstance(elName) ) {
            elName = _stack.getInstance(elName).toTXT().toString();
        }
		if( on.hasConceptElement( elName)){
			field  = on.getConceptElementField( elName );
			return field;
		}else {
            if( on != null &&  Helper.isElement(on) && ((Element)on).getElementName().equalsIgnoreCase(elName)) {
                ElementConcept elem = (ElementConcept) on;
                _previousElem = elem;
                return new DummyFieldConcept( elem.getElementName(),
                                              elem,
                                              false,
                                              elem.getElementLabel(),
                                              elem.getConceptType().toString());                
            }
            throw new ElementNotFoundException( on.getConceptType().toString(), elName, ifErrorLine);
		}					
	}

	
	private FieldDefinition getStaticElementField( String elName, String conceptType, int ifErrorLine ) {
		FieldDefinition field = null;
		if( mn8Loader.getConceptDefinition(conceptType).hasConceptElement( elName )){
			field  = mn8Loader.getConceptDefinition(conceptType).getConceptElementField( elName );
			if( field.isStatic() ) {
				return field;
			} else {
                throw new NotStaticElementException( conceptType , elName, ifErrorLine);
            }
		}else {
            throw new ElementNotFoundException( conceptType , elName, ifErrorLine);
		}					
	}


	private FieldDefinition getElementField( String elName, Concept on, String conceptType, int ifErrorLine ) {
		if( on != null ) {			// not static
			return getElementField( elName, on, ifErrorLine);
		} else { 					// static 
			return getStaticElementField( elName, conceptType, ifErrorLine);
		}		
	}


	private void setElementValue( FieldDefinition elField, Concept on, String conceptType, Concept value, int ifErrorLine ) {
		if( on != null ) {
			Element element = (Element)elField.getValue(on);
			element.setElementValue(value);
			elField.setValue(on, (ElementConcept)element);
		} else if ( elField.isStatic() ) {
			Element element = (Element)elField.getValue(null);
			element.setElementValue(value);
			elField.setValue(null, (ElementConcept)element);
		} else {
                throw new NotStaticElementException( conceptType , elField.getName(), ifErrorLine);
		}
	}


	private Concept getElementValue( FieldDefinition elField, Concept on, String conceptType, int ifErrorLine ) {
		mn8Method method = null;
		if( on != null ) {
			try {
				method = on.getConceptDefinition().getConceptMethod("get" + elField.getName().toLowerCase() + ":");
			} catch (RuntimeException rex) {}
			if( method == null ) {				
                Element element = (Element)elField.getValue(on);
                return element.getElementValue();
			} else {
				return method.invoke(on, null);
			}
		} else if ( elField.isStatic() ) {
			try {
				method = mn8Loader.getConceptDefinition(conceptType).getConceptMethod("get" + elField.getName().toLowerCase() +  ":");
			} catch (RuntimeException rex) {}
			if( method == null ) {
                Element element = (Element)elField.getValue(null);
                return element.getElementValue();
			} else {
				return method.invoke(on, null);
			}                
		} else {
            throw new NotStaticElementException( conceptType , elField.getName(), ifErrorLine);
		}
	}


	private FieldDefinition getAttributeField( String atName, Concept on, int ifErrorLine) {
		FieldDefinition field = null;

		if( on.hasConceptAttribute( atName )){
			field  = on.getConceptAttributeField( new StringConcept(atName) );
			return field;
		}else {
            if( _previousElem != null && _previousElem.hasConceptAttribute(new StringConcept(atName)).getValue()) {
                return _previousElem.getConceptAttributeField(new StringConcept(atName));
            }
            throw new AttributeNotFoundException( on.getConceptType().toString(), atName, ifErrorLine);
		}					
	}

	
	private FieldDefinition getStaticAttributeField( String atName, String conceptType, int ifErrorLine ) {
		FieldDefinition field = null;
		if( mn8Loader.getConceptDefinition(conceptType).hasConceptAttribute( atName )){
			field  = mn8Loader.getConceptDefinition(conceptType).getAttributeField( atName );
			if( field.isStatic() ) {
				return field;
			} else { 
                throw new NotStaticAttributeException( conceptType, atName, ifErrorLine);
            }
		}else {
            throw new AttributeNotFoundException( conceptType, atName, ifErrorLine);
		}					
	}


	private FieldDefinition getAttributeField( String atName, Concept on, String conceptType, int ifErrorLine ) {
		if( on != null ) {			// not static
			return getAttributeField( atName, on, ifErrorLine);
		} else { 					// static 
			return getStaticAttributeField( atName, conceptType, ifErrorLine);
		}		
	}


	private void setAttributeValue( FieldDefinition attrField, Concept on, String conceptType, Concept value, int ifErrorLine ) {
		mn8Method method = null;
		if( on != null ) {
			try {
                if( !( attrField instanceof DummyFieldConcept ))
				method = on.getConceptDefinition().getConceptMethod("set" 
                    + attrField.getName().toLowerCase() + ":" + value.getConceptType().toString().toLowerCase());
			} catch (RuntimeException rex) {}

			if( method == null ) {
				Attribute attribute = (Attribute)attrField.getValue(on);
				attribute.setAttributeValue(value);
				attrField.setValue(on, (AttributeConcept)attribute);
			} else {
				SeriesConcept param = new SeriesConcept();
				param.add(value);
				method.invoke(on, param);
			}
		} else if ( attrField.isStatic() ) {
			try {
				method = mn8Loader.getConceptDefinition(conceptType).getConceptMethod("set" 
							+ attrField.getName().toLowerCase() + ":" + value.getConceptType().toString().toLowerCase());
			} catch (RuntimeException rex) {}
			
			if( method == null ) {
				Attribute attribute = (Attribute)attrField.getValue(null);
				attribute.setAttributeValue(value);
				attrField.setValue(null, (AttributeConcept)attribute);
			} else {
				SeriesConcept param = new SeriesConcept();
				param.add(value);
				method.invoke(on, param);
			}
		} else {
            throw new NotStaticAttributeException(conceptType, attrField.getName(), ifErrorLine);
		}
	}


	private Concept getAttributeValue( FieldDefinition attrField, Concept on, String conceptType, int ifErrorLine ) {
		mn8Method method = null;
		if( on != null ) {
			try {
                if( !(attrField instanceof DummyFieldConcept))
				    method = on.getConceptDefinition().getConceptMethod("get" + attrField.getName().toLowerCase() + ":");
			} catch (RuntimeException rex) {}

			if( method == null ) {
				Attribute attribute = (Attribute)attrField.getValue(on);
				return attribute.getAttributeValue();
			} else {
				return method.invoke(on, null);
			}
		} else if ( attrField.isStatic() ) {
			try {
				method = mn8Loader.getConceptDefinition(conceptType).getConceptMethod("get" + attrField.getName().toLowerCase() +  ":");
			} catch (RuntimeException rex) {}

			if( method == null ) {
				Attribute attribute = (Attribute)attrField.getValue(null);
				return attribute.getAttributeValue();
			} else {
				return method.invoke(on, null);
			}
		} else {
            throw new NotStaticAttributeException(conceptType, attrField.getName(), ifErrorLine);
		}
	}


    private Concept assign( AST as, AST id, AST attr, AST elem, Concept result) throws RecognitionException {
			if( elem != null ) {
				FieldDefinition initialElem = getElementField(elem.getText(), _thisConcept, 
					                                          _thisMethod.getDeclaringConcept().toString(), 
													          elem.getLine());
				if( elem.getFirstChild() == null ) {
					setElementValue( initialElem, _thisConcept,
									 _thisMethod.getDeclaringConcept().toString(), (Concept)result.clone(), elem.getLine());
				}
				else {
					Concept on = null ;
					String conceptType = elem.getText();

					if( (on = getElementValue(initialElem, _thisConcept, _thisMethod.getDeclaringConcept().toString(), elem.getLine())) != null ) 
						conceptType = on.getConceptType().toString();

					// if it is composed line $test/name@initials we must anvigate and 
					// then resolve and assign
					AST firstItem = elem.getFirstChild();
					AST parent  = elem;
					while( firstItem.getNextSibling() != null ) {					
						on = oneDeepPostfixedConceptValue(firstItem, on, parent);
						parent = firstItem;
						firstItem = firstItem.getNextSibling();
					}
					
					conceptType  = parent.getText();
					FieldDefinition field = postfixPaths( firstItem, on, conceptType );
					if( field.isAttribute() )
						setAttributeValue( field, on, conceptType, (Concept)result.clone(), as.getLine() );
					else if( field.isElement() )
						setElementValue( field, on, conceptType, (Concept)result.clone(), as.getLine() );
				}
			}


			if( attr != null ) {
				FieldDefinition initialAttrib = getAttributeField(attr.getText(), _thisConcept, 
					                                              _thisMethod.getDeclaringConcept().toString(), 
													              attr.getLine());

				if( attr.getFirstChild() == null ) {
					setAttributeValue( initialAttrib, _thisConcept,
									   _thisMethod.getDeclaringConcept().toString(), (Concept)result.clone(), attr.getLine());
				} else {
					Concept on = null ;
					String conceptType = attr.getText();

					if( (on = getAttributeValue(initialAttrib, _thisConcept, _thisMethod.getDeclaringConcept().toString(), attr.getLine())) != null ) 
						conceptType = on.getConceptType().toString();

					// if it is composed line $test/name@initials we must anvigate and 
					// then resolve and assign
					AST firstItem = attr.getFirstChild();
					AST parent  = attr;
					while( firstItem.getNextSibling() != null ) {					
						on = oneDeepPostfixedConceptValue(firstItem, on, parent);
						parent = firstItem;
						firstItem = firstItem.getNextSibling();
					}
					
					conceptType  = parent.getText();
					FieldDefinition field = postfixPaths( firstItem, on, conceptType );
					if( field.isAttribute() )
						setAttributeValue( field, on, conceptType, (Concept)result.clone(), as.getLine() );
					else if( field.isElement() )
						setElementValue( field, on, conceptType, (Concept)result.clone(), as.getLine() );
				}
			}
			
			if( id != null ) {
				if( id.getFirstChild() != null ) {
					Concept on = null ;
					String conceptType = id.getText();

					if( (on = resolveIdentifier(id)) != null ) 
						conceptType = on.getConceptType().toString();

					// if it is composed line $test/name@initials we must anvigate and 
					// then resolve and assign
					AST firstItem = id.getFirstChild();
					AST parent  = id;
					while( firstItem.getNextSibling() != null ) {					
						on = oneDeepPostfixedConceptValue(firstItem, on, parent);
						parent = firstItem;
						firstItem = firstItem.getNextSibling();
					}
					
					conceptType  = parent.getText();
					FieldDefinition field = postfixPaths( firstItem, on, conceptType );
					if( field.isAttribute() ) {
						setAttributeValue( field, on, conceptType, (Concept)result.clone(), as.getLine() );
					}
					else if( field.isElement() ){
						setElementValue( field, on, conceptType, (Concept)result.clone(), as.getLine() );
					}
			}
			else if( id.getFirstChild() == null ) { 
					if( result == null )
						_stack.insertInstance( id.getText(), new NilConcept());                
					else 
						_stack.insertInstance( id.getText(), (Concept)result.clone());

					result = _stack.getInstance( id.getText() );
				
			}	
        }
        return result;
    }

public mn8TreeWalker() {
	tokenNames = _tokenNames;
}

	public final Concept  interpretationUnit(AST _t,
		 mn8Concept concept, mn8ScriptMethod thisMethod, ScopeStack scopeStack
	) throws RecognitionException {
		Concept result;
		
		AST interpretationUnit_AST_in = (AST)_t;
		
		result = null;
			_thisConcept = concept;
		if( concept != null ) {
			  _stack = concept.getScopeStack();
		} else {
		_stack = scopeStack;
		}
		_thisMethod = thisMethod;
		_out = mn8Interpreter.getOut( Thread.currentThread());
		_err = mn8Interpreter.getErr( Thread.currentThread());
		
		
		try {      // for error handling
			{
			_loop3:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					try {      // for error handling
						result=statement(_t);
						_t = _retTree;
					}
					catch (mn8ExitEvent ex) {
						
						if (ex.getType() == mn8ExitEvent.RETURN_EVENT ) {
						_t = ASTNULL;
						readyToReturn = true;
						return ex.getEventValue();
						} else {
						_t = ASTNULL;
						readyToReturn = true;
						throw ex;
						}
						
					}
					catch (mn8Warning ex) {
						
						if( ex.lineNr == -1 ) {
						ex.lineNr = _curentLineNr;
						}
						if( _t != null ) { _t = _t.getNextSibling(); }
						new ErrorConcept(ex.type, ex.getId(), ex.getSimpleMessage(), ex.lineNr);        
						
					}
				}
				else {
					break _loop3;
				}
				
			} while (true);
			}
		}
		catch (mn8Error ex) {
			
			if( ex.lineNr == -1 ) {
			ex.lineNr = _curentLineNr;
			}
			if( _t != null ) { _t = _t.getNextSibling(); }
			result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;        
			
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  statement(AST _t) throws RecognitionException {
		Concept result;
		
		AST statement_AST_in = (AST)_t;
		result = null; 
		if( readyToReturn) { throw new mn8ExitEvent(mn8ExitEvent.EXIT_EVENT); }
		
		
		try {      // for error handling
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case BLOCK:
			{
				result=statementBlock(_t);
				_t = _retTree;
				break;
			}
			case UNARY_MINUS:
			case POST_INC:
			case POST_DEC:
			case ELEM:
			case IDENT:
			case STRING_LITERAL:
			case ATTR:
			case ASSIGN:
			case TYPEOF:
			case STAR:
			case FIRST:
			case LAST:
			case FROM:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case STAR_ASSIGN:
			case DIV_ASSIGN:
			case LOR:
			case LAND:
			case NOT_EQUAL:
			case EQUAL:
			case LT:
			case GT:
			case LE:
			case GE:
			case PLUS:
			case MINUS:
			case DIV:
			case INC:
			case DEC:
			case LNOT:
			case RANGE:
			case DOT:
			case NUM_INT:
			case SUPER:
			case THIS:
			case TRUE:
			case FALSE:
			case CHAR_LITERAL:
			case NUM_REAL:
			case NIL:
			{
				result=expression(_t);
				_t = _retTree;
				break;
			}
			case PRINT:
			{
				print(_t);
				_t = _retTree;
				break;
			}
			case SWITCH:
			{
				switchBlock(_t);
				_t = _retTree;
				break;
			}
			case WHILE:
			{
				whileDoLoop(_t);
				_t = _retTree;
				break;
			}
			case DO:
			{
				doWhileLoop(_t);
				_t = _retTree;
				break;
			}
			case IF:
			{
				ifBlock(_t);
				_t = _retTree;
				break;
			}
			case TO:
			{
				toStatement(_t);
				_t = _retTree;
				break;
			}
			case FIND_FIRST:
			{
				findFirstStatement(_t);
				_t = _retTree;
				break;
			}
			case FIND_LAST:
			{
				findLastStatement(_t);
				_t = _retTree;
				break;
			}
			case EXIT:
			{
				exitStatement(_t);
				_t = _retTree;
				break;
			}
			case RETURN:
			{
				result=returnStatement(_t);
				_t = _retTree;
				break;
			}
			case EACH:
			{
				eachBlock(_t);
				_t = _retTree;
				Thread.yield();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  statementBlock(AST _t) throws RecognitionException {
		Concept result;
		
		AST statementBlock_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t65 = _t;
			AST tmp1_AST_in = (AST)_t;
			match(_t,BLOCK);
			_t = _t.getFirstChild();
			_stack.pushScope(new Scope(_stack.getCurrentScope()));
			{
			_loop67:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					result=statement(_t);
					_t = _retTree;
				}
				else {
					break _loop67;
				}
				
			} while (true);
			}
			_stack.popScope();
			_t = __t65;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  expression(AST _t) throws RecognitionException {
		Concept result;
		
		AST expression_AST_in = (AST)_t;
		AST as = null;
		AST id = null;
		AST attr = null;
		AST elem = null;
		AST th = null;
		AST pi1 = null;
		AST id1 = null;
		AST i = null;
		AST j = null;
		AST opPlus = null;
		AST opMinus = null;
		AST opSTAR = null;
		AST opDIV = null;
		AST opGT = null;
		AST opGE = null;
		AST opLT = null;
		AST opLE = null;
		AST opAND = null;
		AST opOR = null;
		AST opNOT = null;
		AST opEQUAL = null;
		AST opNOT_EQUAL = null;
		AST opPlusAssign = null;
		AST toPlus = null;
		AST opMinusAssign = null;
		AST toMinus = null;
		AST opStarAssign = null;
		AST toStar = null;
		AST opDivAssign = null;
		AST toDiv = null;
		AST opINC = null;
		AST opPOST_INC = null;
		AST opDEC = null;
		AST opPOST_DEC = null;
		
		result = new NilConcept(); 
		Concept ex1, ex2;    
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ELEM:
			case IDENT:
			case STRING_LITERAL:
			case ATTR:
			case RANGE:
			case DOT:
			case NUM_INT:
			case SUPER:
			case THIS:
			case TRUE:
			case FALSE:
			case CHAR_LITERAL:
			case NUM_REAL:
			case NIL:
			{
				result=primaryExpression(_t);
				_t = _retTree;
				break;
			}
			case FROM:
			{
				result=fromExpression(_t);
				_t = _retTree;
				break;
			}
			case ASSIGN:
			{
				AST __t89 = _t;
				as = _t==ASTNULL ? null :(AST)_t;
				match(_t,ASSIGN);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case IDENT:
				{
					id = (AST)_t;
					match(_t,IDENT);
					_t = _t.getNextSibling();
					break;
				}
				case ATTR:
				{
					attr = (AST)_t;
					match(_t,ATTR);
					_t = _t.getNextSibling();
					break;
				}
				case ELEM:
				{
					elem = (AST)_t;
					match(_t,ELEM);
					_t = _t.getNextSibling();
					break;
				}
				case THIS:
				{
					th = (AST)_t;
					match(_t,THIS);
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				result=expression(_t);
				_t = _retTree;
				_t = __t89;
				_t = _t.getNextSibling();
				setLineNr(as.getLine()); 
				if( th != null ) {
				AST first = th.getFirstChild();
				if ( first != null ) {
				switch (first.getType()) {
				case mn8TokenTypes.ATTR : {
				attr = first;
				break;
				}
				case mn8TokenTypes.ELEM : {
				elem = first;
				break;
				}
				}
				}
				}
				result = assign(as, id, attr, elem, result); 
				
				break;
			}
			case TYPEOF:
			{
				AST __t91 = _t;
				AST tmp2_AST_in = (AST)_t;
				match(_t,TYPEOF);
				_t = _t.getFirstChild();
				pi1 = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				id1 = _t==ASTNULL ? null : (AST)_t;
				ex1=expression(_t);
				_t = _retTree;
				_t = __t91;
				_t = _t.getNextSibling();
				try {
				setLineNr(tmp2_AST_in.getLine());
				if( pi1.getText().startsWith("$") ) {
				String type = null;
				
				if( ex1 != null ) {
				if( !ex1.getConceptType().toString().equalsIgnoreCase("string")) {
				type = ex1.getConceptType().toString();
				} else {
				type = ((StringConcept)ex1).toString();
				}
				} else {
				type = id1.getText();
				}
				if( ! type.equalsIgnoreCase("nil")) {
				result =  executeStaticMethod("create:", type, new SeriesConcept());
				_stack.insertInstance( pi1.getText(), result);
				_stack.setForcedType(pi1.getText(), type);
				} else {
				result = new NilConcept();
				if( _stack.isInstance( pi1.getText())) {
				_stack.setForcedType(pi1.getText(), type);
				}
				_stack.insertInstance( pi1.getText(), result);
				}
				
				
				if( type.toLowerCase().equals("attribute") ) {
				String nam = pi1.getText().startsWith("$") ? pi1.getText().substring(1) : pi1.getText();
				_stack.insertInstance( pi1.getText(), (Concept)result.clone());
				}
				
				if( type.toLowerCase().equals("element") ) {
				String nam = pi1.getText().startsWith("$") ? pi1.getText().substring(1) : pi1.getText();
				_stack.insertInstance( pi1.getText(), (Concept)result.clone());
				}
				}
				else 
				throw new RecognitionException("Canot force type to an concept type.", "mn8Warning", tmp2_AST_in.getLine());
				} catch (RuntimeException ex) {
				ex.printStackTrace();
				throw new RecognitionException( ex.getMessage(), _scriptName, _curentLineNr);
				}
				
				break;
			}
			case FIRST:
			{
				AST __t92 = _t;
				i = _t==ASTNULL ? null :(AST)_t;
				match(_t,FIRST);
				_t = _t.getFirstChild();
				AST tmp3_AST_in = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				_t = __t92;
				_t = _t.getNextSibling();
				setLineNr(i.getLine());
				Vector positions = (Vector) _firstOfTable.get( getIdentifierSignature( i));
				int eachPos = getByEachIndex( getIdentifierSignature(i));
				if( positions != null && eachPos != -1) {
				Eacher eacher = (Eacher)_eachLevel.elementAt(eachPos);
				if ( positions.contains("" + eacher.getCurentIndex() )) {
				result = new LogicalConcept(true);
				} else {
				result = new LogicalConcept(false);
				}
				} 
				else result = new LogicalConcept(false);
				
				break;
			}
			case LAST:
			{
				AST __t93 = _t;
				j = _t==ASTNULL ? null :(AST)_t;
				match(_t,LAST);
				_t = _t.getFirstChild();
				AST tmp4_AST_in = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				_t = __t93;
				_t = _t.getNextSibling();
				setLineNr(j.getLine());
				Vector positions = (Vector) _firstOfTable.get( getIdentifierSignature( j));
				int eachPos = getByEachIndex( getIdentifierSignature(j));
				if( positions != null && eachPos != -1) {
				Eacher eacher = (Eacher)_eachLevel.elementAt(eachPos);
				if ( positions.contains("" + (eacher.getCurentIndex() + 1)) || eacher.isLastItem() ){
				result = new LogicalConcept(true);
				} else {
				result = new LogicalConcept(false);
				}
				} 
				else result = new LogicalConcept(true);
				
				break;
			}
			case PLUS:
			{
				AST __t94 = _t;
				opPlus = _t==ASTNULL ? null :(AST)_t;
				match(_t,PLUS);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t94;
				_t = _t.getNextSibling();
				setLineNr(opPlus.getLine()); result = executeOp("+", (JavaConcept)ex1, (JavaConcept)ex2, opPlus.getLine());
				break;
			}
			case MINUS:
			{
				AST __t95 = _t;
				opMinus = _t==ASTNULL ? null :(AST)_t;
				match(_t,MINUS);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t95;
				_t = _t.getNextSibling();
				setLineNr(opMinus.getLine()); result = executeOp("-", (JavaConcept)ex1, (JavaConcept)ex2, opMinus.getLine());
				break;
			}
			case STAR:
			{
				AST __t96 = _t;
				opSTAR = _t==ASTNULL ? null :(AST)_t;
				match(_t,STAR);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t96;
				_t = _t.getNextSibling();
				setLineNr(opSTAR.getLine()); result = executeOp("*", (JavaConcept)ex1, (JavaConcept)ex2, opSTAR.getLine());
				break;
			}
			case DIV:
			{
				AST __t97 = _t;
				opDIV = _t==ASTNULL ? null :(AST)_t;
				match(_t,DIV);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t97;
				_t = _t.getNextSibling();
				setLineNr(opDIV.getLine()); result = executeOp("/", (JavaConcept)ex1, (JavaConcept)ex2, opDIV.getLine());
				break;
			}
			case GT:
			{
				AST __t98 = _t;
				opGT = _t==ASTNULL ? null :(AST)_t;
				match(_t,GT);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t98;
				_t = _t.getNextSibling();
				setLineNr(opGT.getLine()); result = executeOp(">", (JavaConcept)ex1, (JavaConcept)ex2, opGT.getLine());
				break;
			}
			case GE:
			{
				AST __t99 = _t;
				opGE = _t==ASTNULL ? null :(AST)_t;
				match(_t,GE);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t99;
				_t = _t.getNextSibling();
				setLineNr(opGE.getLine()); result = executeOp(">=", (JavaConcept)ex1, (JavaConcept)ex2, opGE.getLine());
				break;
			}
			case LT:
			{
				AST __t100 = _t;
				opLT = _t==ASTNULL ? null :(AST)_t;
				match(_t,LT);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t100;
				_t = _t.getNextSibling();
				setLineNr(opLT.getLine()); result = executeOp("<", (JavaConcept)ex1, (JavaConcept)ex2, opLT.getLine());
				break;
			}
			case LE:
			{
				AST __t101 = _t;
				opLE = _t==ASTNULL ? null :(AST)_t;
				match(_t,LE);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t101;
				_t = _t.getNextSibling();
				setLineNr(opLE.getLine()); result = executeOp("<=", (JavaConcept)ex1, (JavaConcept)ex2, opLE.getLine());
				break;
			}
			case LAND:
			{
				AST __t102 = _t;
				opAND = _t==ASTNULL ? null :(AST)_t;
				match(_t,LAND);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				
				if( ex1 instanceof LogicalConcept && !((LogicalConcept)ex1).getValue()) {
				result = new LogicalConcept(false);
				_t = opAND.getNextSibling();
				break;
				}
				
				ex2=expression(_t);
				_t = _retTree;
				setLineNr(opAND.getLine()); 
				result = executeOp("and", (JavaConcept)ex1, (JavaConcept)ex2, opAND.getLine()); 
				
				_t = __t102;
				_t = _t.getNextSibling();
				break;
			}
			case LOR:
			{
				AST __t103 = _t;
				opOR = _t==ASTNULL ? null :(AST)_t;
				match(_t,LOR);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				
				if( ex1 instanceof LogicalConcept && ((LogicalConcept)ex1).getValue()) {
				result = new LogicalConcept(true);
				_t = opOR.getNextSibling();
				break;
				}
				
				ex2=expression(_t);
				_t = _retTree;
				
				setLineNr(opOR.getLine()); 
				result = executeOp("or", (JavaConcept)ex1, (JavaConcept)ex2, opOR.getLine()); 
				
				_t = __t103;
				_t = _t.getNextSibling();
				break;
			}
			case LNOT:
			{
				AST __t104 = _t;
				opNOT = _t==ASTNULL ? null :(AST)_t;
				match(_t,LNOT);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t104;
				_t = _t.getNextSibling();
				setLineNr(opNOT.getLine()); result = executeOp("not", (JavaConcept)ex1, opNOT.getLine());
				break;
			}
			case EQUAL:
			{
				AST __t105 = _t;
				opEQUAL = _t==ASTNULL ? null :(AST)_t;
				match(_t,EQUAL);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t105;
				_t = _t.getNextSibling();
				setLineNr(opEQUAL.getLine()); result = executeOp("==", (JavaConcept)ex1, (JavaConcept)ex2, opEQUAL.getLine());
				break;
			}
			case NOT_EQUAL:
			{
				AST __t106 = _t;
				opNOT_EQUAL = _t==ASTNULL ? null :(AST)_t;
				match(_t,NOT_EQUAL);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				ex2=expression(_t);
				_t = _retTree;
				_t = __t106;
				_t = _t.getNextSibling();
				
				setLineNr(opNOT_EQUAL.getLine());
				result = executeOp("==", (JavaConcept)ex1, (JavaConcept)ex2, opNOT_EQUAL.getLine()); 
				if( result instanceof LogicalConcept )
				result =  new LogicalConcept( !((LogicalConcept)result).getValue() );
				
				break;
			}
			case PLUS_ASSIGN:
			{
				AST __t107 = _t;
				opPlusAssign = _t==ASTNULL ? null :(AST)_t;
				match(_t,PLUS_ASSIGN);
				_t = _t.getFirstChild();
				toPlus = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t107;
				_t = _t.getNextSibling();
				
				setLineNr(opPlusAssign.getLine());
				Concept varId = resolveIdentifier(toPlus);
				result = executeOp("+", (JavaConcept)varId, (JavaConcept)ex1, opPlusAssign.getLine());
				result = assign(opPlusAssign, toPlus, null, null, result);
				
				break;
			}
			case MINUS_ASSIGN:
			{
				AST __t108 = _t;
				opMinusAssign = _t==ASTNULL ? null :(AST)_t;
				match(_t,MINUS_ASSIGN);
				_t = _t.getFirstChild();
				toMinus = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t108;
				_t = _t.getNextSibling();
				
				setLineNr(opMinusAssign.getLine());
				Concept varId = resolveIdentifier(toMinus);
				result = executeOp("-", (JavaConcept)varId, (JavaConcept)ex1, opMinusAssign.getLine());
				result = assign(opMinusAssign, toMinus, null, null, result);
				
				break;
			}
			case STAR_ASSIGN:
			{
				AST __t109 = _t;
				opStarAssign = _t==ASTNULL ? null :(AST)_t;
				match(_t,STAR_ASSIGN);
				_t = _t.getFirstChild();
				toStar = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t109;
				_t = _t.getNextSibling();
				
				setLineNr(opStarAssign.getLine());
				Concept varId = resolveIdentifier(toStar);
				result = executeOp("*", (JavaConcept)varId, (JavaConcept)ex1, opStarAssign.getLine());
				result = assign(opStarAssign, toStar, null, null, result);
				
				break;
			}
			case DIV_ASSIGN:
			{
				AST __t110 = _t;
				opDivAssign = _t==ASTNULL ? null :(AST)_t;
				match(_t,DIV_ASSIGN);
				_t = _t.getFirstChild();
				toDiv = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t110;
				_t = _t.getNextSibling();
				
				setLineNr(opDivAssign.getLine());
				Concept varId = resolveIdentifier(toDiv);
				result = executeOp("/", (JavaConcept)varId, (JavaConcept)ex1, opDivAssign.getLine());
				result = assign(opDivAssign, toDiv, null, null, result);
				
				break;
			}
			case INC:
			{
				AST __t111 = _t;
				opINC = _t==ASTNULL ? null :(AST)_t;
				match(_t,INC);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t111;
				_t = _t.getNextSibling();
				setLineNr(opINC.getLine()); result = executeOp("++", (JavaConcept)ex1, opINC.getLine());
				break;
			}
			case POST_INC:
			{
				AST __t112 = _t;
				opPOST_INC = _t==ASTNULL ? null :(AST)_t;
				match(_t,POST_INC);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t112;
				_t = _t.getNextSibling();
				setLineNr(opPOST_INC.getLine());
				result = (Concept) ex1.clone();
				executeOp("++", (JavaConcept)ex1, opPOST_INC.getLine());
				break;
			}
			case DEC:
			{
				AST __t113 = _t;
				opDEC = _t==ASTNULL ? null :(AST)_t;
				match(_t,DEC);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t113;
				_t = _t.getNextSibling();
				setLineNr(opDEC.getLine());  result = executeOp("--", (JavaConcept)ex1, opDEC.getLine());
				break;
			}
			case POST_DEC:
			{
				AST __t114 = _t;
				opPOST_DEC = _t==ASTNULL ? null :(AST)_t;
				match(_t,POST_DEC);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t114;
				_t = _t.getNextSibling();
				setLineNr(opPOST_DEC.getLine());
				result = (Concept) ex1.clone();
				executeOp("--", (JavaConcept)ex1, opPOST_DEC.getLine());
				break;
			}
			case UNARY_MINUS:
			{
				AST __t115 = _t;
				AST tmp5_AST_in = (AST)_t;
				match(_t,UNARY_MINUS);
				_t = _t.getFirstChild();
				ex1=expression(_t);
				_t = _retTree;
				_t = __t115;
				_t = _t.getNextSibling();
				
				setLineNr(tmp5_AST_in.getLine());
				if ( ex1 instanceof IntegerConcept) {
				result = new IntegerConcept( ((IntegerConcept)ex1).getLong() * -1);  
				} else if( ex1 instanceof RealConcept ) {
				result = new RealConcept( ((RealConcept)ex1).getFloat() * -1);
				} else {
				
				result = ex1;
				throw new RuntimeException("- can be applied only to Integer of Real");               
				}                        
				
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final void print(AST _t) throws RecognitionException {
		
		AST print_AST_in = (AST)_t;
		AST c = null;
		Concept data = null; 
		if ( debug ) System.err.println("print");
		
		
		try {      // for error handling
			AST __t83 = _t;
			AST tmp6_AST_in = (AST)_t;
			match(_t,PRINT);
			_t = _t.getFirstChild();
			AST __t84 = _t;
			AST tmp7_AST_in = (AST)_t;
			match(_t,ELIST);
			_t = _t.getFirstChild();
			{
			_loop86:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_1.member(_t.getType()))) {
					data=expression(_t);
					_t = _retTree;
					
					if ( data!= null ) {
					StringConcept result = (StringConcept) executeMethod( "toTXT:", data, null);
					_out.print( result.toString() ); 
					}
					
				}
				else {
					break _loop86;
				}
				
			} while (true);
			}
			_t = __t84;
			_t = _t.getNextSibling();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case SEMI:
			{
				c = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			if( c == null ) {
			_out.print(mn8Interpreter.EOL);
			}
			
			_t = __t83;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void switchBlock(AST _t) throws RecognitionException {
		
		AST switchBlock_AST_in = (AST)_t;
		boolean done = false; 
		Concept equalsWith = null;
		
		
		try {      // for error handling
			AST __t41 = _t;
			AST tmp8_AST_in = (AST)_t;
			match(_t,SWITCH);
			_t = _t.getFirstChild();
			setLineNr( tmp8_AST_in.getLine());
			equalsWith=expression(_t);
			_t = _retTree;
			{
			int _cnt43=0;
			_loop43:
			do {
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==ELSE_BLOCK||_t.getType()==CASE))&&(done==false)) {
					done=switchBody(_t,equalsWith);
					_t = _retTree;
				}
				else {
					if ( _cnt43>=1 ) { break _loop43; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt43++;
			} while (true);
			}
			_t = __t41;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void whileDoLoop(AST _t) throws RecognitionException {
		
		AST whileDoLoop_AST_in = (AST)_t;
		AST cnd = null;
		
		try {      // for error handling
			AST __t51 = _t;
			AST tmp9_AST_in = (AST)_t;
			match(_t,WHILE);
			_t = _t.getFirstChild();
			cnd = (AST)_t;
			match(_t,CONDITION);
			_t = _t.getNextSibling();
			_t = __t51;
			_t = _t.getNextSibling();
			while( conditional(cnd, true)) { Thread.yield(); }
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void doWhileLoop(AST _t) throws RecognitionException {
		
		AST doWhileLoop_AST_in = (AST)_t;
		AST blk = null;
		AST cnd = null;
		
		try {      // for error handling
			AST __t53 = _t;
			AST tmp10_AST_in = (AST)_t;
			match(_t,DO);
			_t = _t.getFirstChild();
			blk = (AST)_t;
			match(_t,BLOCK);
			_t = _t.getNextSibling();
			cnd = (AST)_t;
			match(_t,CONDITION);
			_t = _t.getNextSibling();
			_t = __t53;
			_t = _t.getNextSibling();
			do {
			statementBlock(blk);
			} while( condition(cnd));
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void ifBlock(AST _t) throws RecognitionException {
		
		AST ifBlock_AST_in = (AST)_t;
		boolean done = false;
		
		try {      // for error handling
			AST __t55 = _t;
			AST tmp11_AST_in = (AST)_t;
			match(_t,IF);
			_t = _t.getFirstChild();
			{
			int _cnt57=0;
			_loop57:
			do {
				if (_t==null) _t=ASTNULL;
				if ((((_t.getType() >= IF_BLOCK && _t.getType() <= ELIF_BLOCK)))&&(done==false)) {
					done=ifThenBody(_t);
					_t = _retTree;
				}
				else {
					if ( _cnt57>=1 ) { break _loop57; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt57++;
			} while (true);
			}
			_t = __t55;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void toStatement(AST _t) throws RecognitionException {
		
		AST toStatement_AST_in = (AST)_t;
		MapConcept toOptions = new MapConcept() ; Concept val = null; Concept uriConcept = null;
		
		try {      // for error handling
			AST __t71 = _t;
			AST tmp12_AST_in = (AST)_t;
			match(_t,TO);
			_t = _t.getFirstChild();
			val=expression(_t);
			_t = _retTree;
			uriConcept=expression(_t);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case OPTIONS:
			{
				toOptions=optionList(_t,toOptions);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t71;
			_t = _t.getNextSibling();
			
			setLineNr( tmp12_AST_in.getLine());
			URI uri = new URI(uriConcept.toTXT());
			Concept handler = uri.getURIHandler();
			SeriesConcept params = new SeriesConcept();
			params.add(toOptions);
			executeMethod("initialize:Map", handler, params);
			executeMethod("openConnection:", handler, new SeriesConcept());
			params = new SeriesConcept();
			params.add(val);
			executeMethod("setContent:Concept", handler, params);
			executeMethod("closeConnection:", handler, new SeriesConcept());
					
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void findFirstStatement(AST _t) throws RecognitionException {
		
		AST findFirstStatement_AST_in = (AST)_t;
		AST i = null;
		AST bex = null;
		AST cnd = null;
		Series in= null; Concept result= null; Concept var= null; Vector breakEx = null;
		
		try {      // for error handling
			AST __t11 = _t;
			AST tmp13_AST_in = (AST)_t;
			match(_t,FIND_FIRST);
			_t = _t.getFirstChild();
			i = (AST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			in=iterationSource(_t);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case BREAK:
			{
				bex = _t==ASTNULL ? null : (AST)_t;
				breakEx=breakExpression(_t);
				_t = _retTree;
				break;
			}
			case 3:
			case CONDITION:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case CONDITION:
			{
				cnd = (AST)_t;
				match(_t,CONDITION);
				_t = _t.getNextSibling();
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t11;
			_t = _t.getNextSibling();
			SeriesConcept tmpSeries = new SeriesConcept();
			setLineNr( tmp13_AST_in.getLine());
			var = resolveIdentifier( i );
			if( bex != null ) {
			_eachBySignature.pop();
			}
			if( cnd == null && bex == null){
			if( in.getLength() >= 1 ) {
			result = in.elementAt(1);
			} else {
			result = new NilConcept();
			}
			_stack.insertInstance( i.getText(), (Concept)result);
			}
			else {              
			long idx = in.getIndex();
			in.setIndex(0);
			if( cnd != null ){
			while (in.hasNext()) {
			var = in.next();                        
			_stack.insertInstance( i.getText(), (Concept)var);
			if( condition( cnd) ){
			tmpSeries.add(var);
			}
			}
			} else {
			if( in instanceof SeriesConcept )
			tmpSeries = (SeriesConcept)in;
			else {
			while (in.hasNext()) {
			tmpSeries.add( in.next() );                                         
			}
			}
			}
			// we sort it to math the break by expressions
			if( bex!=null && breakEx != null && breakEx.size() > 0)
			tmpSeries = sort(tmpSeries, breakEx);           
			
			if( tmpSeries.getLength() >= 1){
			result = (Concept)tmpSeries.getVector().elementAt(0);
			_stack.insertInstance( i.getText(), (Concept)result);
			} else {
			result = new NilConcept();
			_stack.insertInstance( i.getText(), result );
			}
			in.setIndex(idx);
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void findLastStatement(AST _t) throws RecognitionException {
		
		AST findLastStatement_AST_in = (AST)_t;
		AST i = null;
		AST bex = null;
		AST cnd = null;
		Series in= null; Concept result= null; Concept var= null; Vector breakEx = null;
		
		try {      // for error handling
			AST __t15 = _t;
			AST tmp14_AST_in = (AST)_t;
			match(_t,FIND_LAST);
			_t = _t.getFirstChild();
			i = (AST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			in=iterationSource(_t);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case BREAK:
			{
				bex = _t==ASTNULL ? null : (AST)_t;
				breakEx=breakExpression(_t);
				_t = _retTree;
				break;
			}
			case 3:
			case CONDITION:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case CONDITION:
			{
				cnd = (AST)_t;
				match(_t,CONDITION);
				_t = _t.getNextSibling();
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t15;
			_t = _t.getNextSibling();
			SeriesConcept tmpSeries = new SeriesConcept();
			setLineNr( tmp14_AST_in.getLine());
			var = resolveIdentifier( i );
			if( bex != null ) {
			_eachBySignature.pop();
			}
			if( cnd == null && bex == null){
			if( in.getLength() >= 1 ){
			result = in.elementAt(in.getLength());
			} else {
			result = new NilConcept();
			}
			_stack.insertInstance( i.getText(), result);
			}
			else {
			long idx = in.getIndex();
			in.setIndex(0);
			if( cnd != null ){
			while (in.hasNext()) {
			var = in.next();
			_stack.insertInstance( i.getText(), (Concept)var);
			if( condition( cnd) ){
			tmpSeries.add(var);
			}
			}
			} else {
			if( in instanceof SeriesConcept )
			tmpSeries = (SeriesConcept)in;
			else
			while (in.hasNext()) 
			tmpSeries.add( in.next() );                                         
			}
			
			// we sort it to math the break by expressions
			if( bex!=null && breakEx != null && breakEx.size() > 0)
			tmpSeries = sort(tmpSeries, breakEx);           
			
			if( tmpSeries.getLength() >= 1){
			result = (Concept)tmpSeries.getVector().elementAt( tmpSeries.getLength() - 1);
			_stack.insertInstance( i.getText(), (Concept)result);
			} else {
			result = new NilConcept();
			_stack.insertInstance( i.getText(), result );
			}
			
			in.setIndex(idx);
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void exitStatement(AST _t) throws RecognitionException {
		
		AST exitStatement_AST_in = (AST)_t;
		Concept i = new NilConcept();
		
		try {      // for error handling
			AST __t7 = _t;
			AST tmp15_AST_in = (AST)_t;
			match(_t,EXIT);
			_t = _t.getFirstChild();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case UNARY_MINUS:
			case POST_INC:
			case POST_DEC:
			case ELEM:
			case IDENT:
			case STRING_LITERAL:
			case ATTR:
			case ASSIGN:
			case TYPEOF:
			case STAR:
			case FIRST:
			case LAST:
			case FROM:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case STAR_ASSIGN:
			case DIV_ASSIGN:
			case LOR:
			case LAND:
			case NOT_EQUAL:
			case EQUAL:
			case LT:
			case GT:
			case LE:
			case GE:
			case PLUS:
			case MINUS:
			case DIV:
			case INC:
			case DEC:
			case LNOT:
			case RANGE:
			case DOT:
			case NUM_INT:
			case SUPER:
			case THIS:
			case TRUE:
			case FALSE:
			case CHAR_LITERAL:
			case NUM_REAL:
			case NIL:
			{
				i=expression(_t);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t7;
			_t = _t.getNextSibling();
			setLineNr( tmp15_AST_in.getLine());
			if( i instanceof IntegerConcept )  {
			throw new mn8ExitEvent(mn8ExitEvent.EXIT_EVENT, i);
			}
			else {
			throw new mn8ExitEvent(mn8ExitEvent.EXIT_EVENT);
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final  Concept  returnStatement(AST _t) throws RecognitionException {
		 Concept result ;
		
		AST returnStatement_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t69 = _t;
			AST tmp16_AST_in = (AST)_t;
			match(_t,RETURN);
			_t = _t.getFirstChild();
			result=expression(_t);
			_t = _retTree;
			_t = __t69;
			_t = _t.getNextSibling();
			
			_t = ASTNULL; 
			throw new mn8ExitEvent( mn8ExitEvent.RETURN_EVENT, result);
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result ;
	}
	
	public final void eachBlock(AST _t) throws RecognitionException {
		
		AST eachBlock_AST_in = (AST)_t;
		AST i = null;
		AST bex = null;
		AST cnd = null;
		AST blk = null;
		SeriesConcept in= null; Concept result= null; Concept var= null; Vector breakEx =null;
		
		try {      // for error handling
			AST __t19 = _t;
			AST tmp17_AST_in = (AST)_t;
			match(_t,EACH);
			_t = _t.getFirstChild();
			i = (AST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			in=iterationSource(_t);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case BREAK:
			{
				bex = _t==ASTNULL ? null : (AST)_t;
				breakEx=breakExpression(_t);
				_t = _retTree;
				break;
			}
			case BLOCK:
			case CONDITION:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case CONDITION:
			{
				cnd = (AST)_t;
				match(_t,CONDITION);
				_t = _t.getNextSibling();
				break;
			}
			case BLOCK:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			blk = (AST)_t;
			match(_t,BLOCK);
			_t = _t.getNextSibling();
			_t = __t19;
			_t = _t.getNextSibling();
			
			SeriesConcept tmpSeries = null;
			var = resolveIdentifier( i );
			setLineNr( tmp17_AST_in.getLine());
			
			//we extract the elements which match the condition first
			if( cnd == null ) {
			tmpSeries = in;
			} else {
			Vector tmpVect = new Vector();
			tmpSeries = in;
			long idx = tmpSeries.getIndex();
			tmpSeries.setIndex(0);
			Concept value = null;
			while ( tmpSeries.hasNext() ) {
			value = tmpSeries.next();
			_stack.insertInstance( i.getText(), value);
			if( cnd == null || condition( cnd ) ){
			tmpVect.add(value);
			}                
			}
			tmpSeries = new SeriesConcept( tmpVect );
			tmpSeries.setIndex(idx);
			}
			
			// we sort it to math the break by expressions
			if( breakEx != null && breakEx.size() > 0 && tmpSeries.getVector().size() > 0){
			sort(tmpSeries, breakEx);          
			}
			
			Eacher each = new Eacher(tmpSeries.getVector(), 0, this, i, in, blk, breakEx);
			if( bex != null ) {
			_eachLevel.push(each);
			}
			
			each.doEachBlock();            
			
			if( bex != null ) {
			_eachLevel.pop();
			_eachBySignature.pop();
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final Concept  concept(AST _t) throws RecognitionException {
		Concept result;
		
		AST concept_AST_in = (AST)_t;
		Concept concept = null; result = null;
		
		try {      // for error handling
			concept=identOrConstant(_t);
			_t = _retTree;
			result = concept;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  identOrConstant(AST _t) throws RecognitionException {
		Concept result;
		
		AST identOrConstant_AST_in = (AST)_t;
		result = new NilConcept();
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case STRING_LITERAL:
			case NUM_INT:
			case SUPER:
			case THIS:
			case TRUE:
			case FALSE:
			case CHAR_LITERAL:
			case NUM_REAL:
			case NIL:
			{
				result=constants(_t);
				_t = _retTree;
				break;
			}
			case ELEM:
			case IDENT:
			case ATTR:
			{
				result=identifier(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final SeriesConcept  iterationSource(AST _t) throws RecognitionException {
		SeriesConcept result;
		
		AST iterationSource_AST_in = (AST)_t;
		Concept expr = null; result = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case SOURCE:
			{
				AST __t23 = _t;
				AST tmp18_AST_in = (AST)_t;
				match(_t,SOURCE);
				_t = _t.getFirstChild();
				expr=expression(_t);
				_t = _retTree;
				_t = __t23;
				_t = _t.getNextSibling();
				
				if( expr != null && expr instanceof Series ){
				result = (SeriesConcept) expr;
				}
				else {
				result = new SeriesConcept();
				((SeriesConcept)result).add(expr);
				}
				
				break;
			}
			case FROM:
			{
				expr=fromExpression(_t);
				_t = _retTree;
				
							if( expr.extendsConcept(new StringConcept("Series")).getValue()) {
								return (SeriesConcept) expr;
							} else {
								result = new SeriesConcept();
								result.add( expr);
							}
						
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Vector  breakExpression(AST _t) throws RecognitionException {
		Vector result;
		
		AST breakExpression_AST_in = (AST)_t;
		result = new Vector(); AST node = null;
		
		try {      // for error handling
			AST __t25 = _t;
			AST tmp19_AST_in = (AST)_t;
			match(_t,BREAK);
			_t = _t.getFirstChild();
			_eachBySignature.push("");
			{
			_loop27:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==BY)) {
					node=byExpression(_t);
					_t = _retTree;
					result.add(node); addByToSignatureStack(getIdentifierSignature(node));
				}
				else {
					break _loop27;
				}
				
			} while (true);
			}
			_t = __t25;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  fromExpression(AST _t) throws RecognitionException {
		Concept value;
		
		AST fromExpression_AST_in = (AST)_t;
		MapConcept fromOptions = new MapConcept() ; Concept uriConcept = null; value= null;
		
		try {      // for error handling
			AST __t74 = _t;
			AST tmp20_AST_in = (AST)_t;
			match(_t,FROM);
			_t = _t.getFirstChild();
			uriConcept=expression(_t);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case OPTIONS:
			{
				fromOptions=optionList(_t,fromOptions);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t74;
			_t = _t.getNextSibling();
			
			setLineNr( tmp20_AST_in.getLine());
			URI uri = new URI(uriConcept.toTXT());
					  Concept handler = uri.getURIHandler();
			SeriesConcept params = new SeriesConcept();
			params.add(fromOptions);
			executeMethod("initialize:Map", handler, params);
			executeMethod("openConnection:", handler, new SeriesConcept());
			value = executeMethod("getContent:", handler, new SeriesConcept());
			executeMethod("closeConnection:", handler, new SeriesConcept());
					
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return value;
	}
	
	public final AST  byExpression(AST _t) throws RecognitionException {
		AST node;
		
		AST byExpression_AST_in = (AST)_t;
		AST bm = null;
		node = null;
		
		try {      // for error handling
			AST __t29 = _t;
			AST tmp21_AST_in = (AST)_t;
			match(_t,BY);
			_t = _t.getFirstChild();
			bm = _t==ASTNULL ? null : (AST)_t;
			byMarker(_t);
			_t = _retTree;
			_t = __t29;
			_t = _t.getNextSibling();
			node = bm;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return node;
	}
	
	public final void byMarker(AST _t) throws RecognitionException {
		
		AST byMarker_AST_in = (AST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case DESCENDING:
			{
				descendingBy(_t);
				_t = _retTree;
				break;
			}
			case ASCENDING:
			{
				ascendingBy(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void descendingBy(AST _t) throws RecognitionException {
		
		AST descendingBy_AST_in = (AST)_t;
		AST i = null;
		
		try {      // for error handling
			AST __t32 = _t;
			AST tmp22_AST_in = (AST)_t;
			match(_t,DESCENDING);
			_t = _t.getFirstChild();
			i = (AST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			_t = __t32;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void ascendingBy(AST _t) throws RecognitionException {
		
		AST ascendingBy_AST_in = (AST)_t;
		AST i = null;
		
		try {      // for error handling
			AST __t34 = _t;
			AST tmp23_AST_in = (AST)_t;
			match(_t,ASCENDING);
			_t = _t.getFirstChild();
			i = (AST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			_t = __t34;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final Concept  byIterator(AST _t,
		Concept on
	) throws RecognitionException {
		Concept result;
		
		AST byIterator_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case DESCENDING:
			{
				result=descendingByIterator(_t,on);
				_t = _retTree;
				break;
			}
			case ASCENDING:
			{
				result=ascendingByIterator(_t,on);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  descendingByIterator(AST _t,
		Concept on
	) throws RecognitionException {
		Concept result;
		
		AST descendingByIterator_AST_in = (AST)_t;
		AST i = null;
		result = null;
		
		try {      // for error handling
			AST __t37 = _t;
			AST tmp24_AST_in = (AST)_t;
			match(_t,DESCENDING);
			_t = _t.getFirstChild();
			i = (AST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			_t = __t37;
			_t = _t.getNextSibling();
			result = postfixedConceptValue( i.getFirstChild(), on, i);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  ascendingByIterator(AST _t,
		Concept on
	) throws RecognitionException {
		Concept result;
		
		AST ascendingByIterator_AST_in = (AST)_t;
		AST i = null;
		result = null;
		
		try {      // for error handling
			AST __t39 = _t;
			AST tmp25_AST_in = (AST)_t;
			match(_t,ASCENDING);
			_t = _t.getFirstChild();
			i = (AST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			_t = __t39;
			_t = _t.getNextSibling();
			result = postfixedConceptValue( i.getFirstChild(), on, i);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final boolean  switchBody(AST _t,
		Concept equalsWith
	) throws RecognitionException {
		boolean done;
		
		AST switchBody_AST_in = (AST)_t;
		AST code = null;
		done = false;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case CASE:
			{
				AST __t45 = _t;
				AST tmp26_AST_in = (AST)_t;
				match(_t,CASE);
				_t = _t.getFirstChild();
				setLineNr( tmp26_AST_in.getLine());
				done=caseConditional(_t,true, equalsWith);
				_t = _retTree;
				_t = __t45;
				_t = _t.getNextSibling();
				break;
			}
			case ELSE_BLOCK:
			{
				AST __t46 = _t;
				AST tmp27_AST_in = (AST)_t;
				match(_t,ELSE_BLOCK);
				_t = _t.getFirstChild();
				setLineNr( tmp27_AST_in.getLine());
				code = (AST)_t;
				match(_t,BLOCK);
				_t = _t.getNextSibling();
				statementBlock(code);
				_t = __t46;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return done;
	}
	
	public final boolean  caseConditional(AST _t,
		 boolean forWhat, Concept equalsWith 
	) throws RecognitionException {
		boolean yes;
		
		AST caseConditional_AST_in = (AST)_t;
		AST expr = null;
		AST block = null;
		yes = true;
		
		try {      // for error handling
			expr = (AST)_t;
			match(_t,CONDITION);
			_t = _t.getNextSibling();
			block = (AST)_t;
			match(_t,BLOCK);
			_t = _t.getNextSibling();
			
			setLineNr( expr.getLine());
			yes = caseCondition( expr, equalsWith );
			if ( forWhat == yes ) {
			statementBlock(block);
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return yes;
	}
	
	public final boolean  caseCondition(AST _t,
		Concept equalsWith
	) throws RecognitionException {
		boolean status;
		
		AST caseCondition_AST_in = (AST)_t;
		AST expr = null;
		status = false; Concept result = null;
		
		try {      // for error handling
			AST __t49 = _t;
			AST tmp28_AST_in = (AST)_t;
			match(_t,CONDITION);
			_t = _t.getFirstChild();
			expr = _t==ASTNULL ? null : (AST)_t;
			result=expression(_t);
			_t = _retTree;
			_t = __t49;
			_t = _t.getNextSibling();
			
			setLineNr( tmp28_AST_in.getLine());
			status = ((LogicalConcept) executeOp( "==", 
			(JavaConcept) equalsWith, 
			(JavaConcept) expression(expr),
			expr.getLine())).getValue();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return status;
	}
	
	public final boolean  ifThenBody(AST _t) throws RecognitionException {
		boolean done;
		
		AST ifThenBody_AST_in = (AST)_t;
		AST code = null;
		done = false;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case IF_BLOCK:
			{
				AST __t59 = _t;
				AST tmp29_AST_in = (AST)_t;
				match(_t,IF_BLOCK);
				_t = _t.getFirstChild();
				done=conditional(_t,true);
				_t = _retTree;
				_t = __t59;
				_t = _t.getNextSibling();
				break;
			}
			case ELIF_BLOCK:
			{
				AST __t60 = _t;
				AST tmp30_AST_in = (AST)_t;
				match(_t,ELIF_BLOCK);
				_t = _t.getFirstChild();
				done=conditional(_t,true);
				_t = _retTree;
				_t = __t60;
				_t = _t.getNextSibling();
				break;
			}
			case ELSE_BLOCK:
			{
				AST __t61 = _t;
				AST tmp31_AST_in = (AST)_t;
				match(_t,ELSE_BLOCK);
				_t = _t.getFirstChild();
				code = (AST)_t;
				match(_t,BLOCK);
				_t = _t.getNextSibling();
				statementBlock(code);
				_t = __t61;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return done;
	}
	
	public final boolean  conditional(AST _t,
		 boolean forWhat 
	) throws RecognitionException {
		boolean yes;
		
		AST conditional_AST_in = (AST)_t;
		AST expr = null;
		AST block = null;
		yes = true; expr = null; expr=null;
		
		try {      // for error handling
			expr = (AST)_t;
			match(_t,CONDITION);
			_t = _t.getNextSibling();
			block = (AST)_t;
			match(_t,BLOCK);
			_t = _t.getNextSibling();
			
			yes = condition( expr );
			if ( forWhat == yes ) {
			statementBlock(block);
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return yes;
	}
	
	public final boolean  condition(AST _t) throws RecognitionException {
		boolean status;
		
		AST condition_AST_in = (AST)_t;
		AST c = null;
		status = false;
		
		try {      // for error handling
			c = (AST)_t;
			match(_t,CONDITION);
			_t = _t.getNextSibling();
			AST expr = c.getFirstChild();
			setLineNr( c.getLine());
			try {
			status = checkExpression( expr ); 
			} catch ( NotLogicalExpressionException ex) {
			ex.scriptName = _scriptName;
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr); 
			}                   
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return status;
	}
	
	public final MapConcept  optionList(AST _t,
		MapConcept map
	) throws RecognitionException {
		MapConcept opt;
		
		AST optionList_AST_in = (AST)_t;
		opt = map;
		
		try {      // for error handling
			AST __t77 = _t;
			AST tmp32_AST_in = (AST)_t;
			match(_t,OPTIONS);
			_t = _t.getFirstChild();
			{
			int _cnt79=0;
			_loop79:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==ASSIGN)) {
					optionItem(_t,opt);
					_t = _retTree;
				}
				else {
					if ( _cnt79>=1 ) { break _loop79; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt79++;
			} while (true);
			}
			_t = __t77;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return opt;
	}
	
	public final void optionItem(AST _t,
		MapConcept opt
	) throws RecognitionException {
		
		AST optionItem_AST_in = (AST)_t;
		AST key = null;
		Concept value = null;
		
		try {      // for error handling
			AST __t81 = _t;
			AST tmp33_AST_in = (AST)_t;
			match(_t,ASSIGN);
			_t = _t.getFirstChild();
			key = (AST)_t;
			match(_t,STRING_LITERAL);
			_t = _t.getNextSibling();
			value=identOrConstant(_t);
			_t = _retTree;
			_t = __t81;
			_t = _t.getNextSibling();
			setLineNr( tmp33_AST_in.getLine());opt.add(new StringConcept(key.getText().toLowerCase()), value);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final Concept  primaryExpression(AST _t) throws RecognitionException {
		Concept result;
		
		AST primaryExpression_AST_in = (AST)_t;
		result = null; 
		if ( debug ) System.err.println("primary expression");
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ELEM:
			case IDENT:
			case ATTR:
			{
				result=identifier(_t);
				_t = _retTree;
				break;
			}
			case STRING_LITERAL:
			case NUM_INT:
			case SUPER:
			case THIS:
			case TRUE:
			case FALSE:
			case CHAR_LITERAL:
			case NUM_REAL:
			case NIL:
			{
				result=constants(_t);
				_t = _retTree;
				break;
			}
			case RANGE:
			{
				result=range(_t);
				_t = _retTree;
				break;
			}
			case DOT:
			{
				result=directMethodReference(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  identifier(AST _t) throws RecognitionException {
		Concept result;
		
		AST identifier_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case IDENT:
			{
				result=variableOrTypeReference(_t);
				_t = _retTree;
				break;
			}
			case ATTR:
			{
				result=directAttributeReference(_t);
				_t = _retTree;
				break;
			}
			case ELEM:
			{
				result=directElementReference(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  constants(AST _t) throws RecognitionException {
		Concept result;
		
		AST constants_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case STRING_LITERAL:
			{
				result=stringConstant(_t);
				_t = _retTree;
				break;
			}
			case CHAR_LITERAL:
			{
				result=characterConstant(_t);
				_t = _retTree;
				break;
			}
			case NUM_INT:
			{
				result=integerConstant(_t);
				_t = _retTree;
				break;
			}
			case NUM_REAL:
			{
				result=realConstant(_t);
				_t = _retTree;
				break;
			}
			case TRUE:
			{
				result=trueKeyword(_t);
				_t = _retTree;
				break;
			}
			case FALSE:
			{
				result=falseKeyword(_t);
				_t = _retTree;
				break;
			}
			case NIL:
			{
				result=nilKeyword(_t);
				_t = _retTree;
				break;
			}
			case THIS:
			{
				result=thisKeyword(_t);
				_t = _retTree;
				break;
			}
			case SUPER:
			{
				result=superKeyword(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final SeriesConcept  range(AST _t) throws RecognitionException {
		SeriesConcept result;
		
		AST range_AST_in = (AST)_t;
		AST r = null;
		result = new SeriesConcept(); 
		Concept from = new NilConcept(); 
		Concept to = new NilConcept(); 
		Concept step = null;  
		
		
		try {      // for error handling
			AST __t118 = _t;
			r = _t==ASTNULL ? null :(AST)_t;
			match(_t,RANGE);
			_t = _t.getFirstChild();
			from=identOrConstant(_t);
			_t = _retTree;
			to=identOrConstant(_t);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ELEM:
			case IDENT:
			case STRING_LITERAL:
			case ATTR:
			case NUM_INT:
			case SUPER:
			case THIS:
			case TRUE:
			case FALSE:
			case CHAR_LITERAL:
			case NUM_REAL:
			case NIL:
			{
				step=identOrConstant(_t);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t118;
			_t = _t.getNextSibling();
			String type = null;
			
			if ( (type = rangeCompareTypes( from, to)) == null ) {
			throw new RecognitionException("Range must be the same type!", "mn8Warning", r.getLine());
			}
			if( type.equals("Character") && 
			step != null &&
			!step.getConceptType().toString().equals("Integer") ) {
			throw new RecognitionException("Can not make a range on Character with non Integer step", "mn8Warning", r.getLine());               
			}
			
			if( type.equals("Integer") ) {
			if( step == null ){
			result = new SeriesConcept( (IntegerConcept) from,  
			(IntegerConcept) to,    
			new IntegerConcept(1));
			}
			else {
			if( step.getConceptType().toString().equals("Real") ) {
			result = new SeriesConcept( (IntegerConcept) from, 
			(IntegerConcept) to, 
			(RealConcept) step);
			}
			else 
			if (step.getConceptType().toString().equals("Integer") ){
			result = new SeriesConcept( (IntegerConcept) from, 
			(IntegerConcept) to, 
			(IntegerConcept) step);
			}   
			else {
			throw new RecognitionException("The step must be of type Real or Integer", "mn8Warning", r.getLine());              
			}
			}
			}
			
			if( type.equals("Real") ) {
			if( step == null ){
			result = new SeriesConcept( (RealConcept) from,  
			(RealConcept) to,   
			new IntegerConcept(1));
			}
			else {
			if( step.getConceptType().toString().equals("Real") ) {
			result = new SeriesConcept( (RealConcept) from, 
			(RealConcept) to, 
			(RealConcept) step);
			}
			else 
			if (step.getConceptType().toString().equals("Integer") ){
			result = new SeriesConcept( (RealConcept) from, 
			(RealConcept) to, 
			(IntegerConcept) step);
			}   
			else {
			throw new RecognitionException("The step must be of type Real or Integer", "mn8Warning", r.getLine());              
			}
			}
			}
			
			if( type.equals("Character") ) {
			if( step == null ){
			result = new SeriesConcept( (CharacterConcept) from,  
			(CharacterConcept) to,  
			new IntegerConcept(1));
			}
			else {
			if( step.getConceptType().toString().equals("Integer") ) {
			result = new SeriesConcept( (CharacterConcept) from, 
			(CharacterConcept) to, 
			(IntegerConcept) step);
			}
			else {
			throw new RecognitionException("The step must be of Integer", "mn8Warning", r.getLine());               
			}
			}
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  directMethodReference(AST _t) throws RecognitionException {
		Concept result;
		
		AST directMethodReference_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t126 = _t;
			AST tmp34_AST_in = (AST)_t;
			match(_t,DOT);
			_t = _t.getFirstChild();
			result=postfixedConceptValue(_t,null, tmp34_AST_in);
			_t = _retTree;
			_t = __t126;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  directAttributeReference(AST _t) throws RecognitionException {
		Concept result;
		
		AST directAttributeReference_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t122 = _t;
			AST tmp35_AST_in = (AST)_t;
			match(_t,ATTR);
			_t = _t.getFirstChild();
			
			setLineNr( tmp35_AST_in.getLine());
			try {
			result =  attributeOnConcept(tmp35_AST_in, null, null);
			if( tmp35_AST_in.getFirstChild() != null ) {
			result = postfixedConceptValue(tmp35_AST_in.getFirstChild(), result, tmp35_AST_in);
			}
			} catch (AttributeNotFoundException ex) {
			ex.lineNr = _curentLineNr;
			ex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
			} catch (NotStaticAttributeException ex) {
			ex.lineNr = _curentLineNr;
			ex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
			}
			
			_t = __t122;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  directElementReference(AST _t) throws RecognitionException {
		Concept result;
		
		AST directElementReference_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t124 = _t;
			AST tmp36_AST_in = (AST)_t;
			match(_t,ELEM);
			_t = _t.getFirstChild();
			
			setLineNr(tmp36_AST_in.getLine());
			try {
			result =  elementOnConcept(tmp36_AST_in, null, null);
			if( tmp36_AST_in.getFirstChild() != null ) {
			result = postfixedConceptValue(tmp36_AST_in.getFirstChild(), result, tmp36_AST_in);
			}
			} catch (MethodNotFoundException mex) {
			mex.lineNr = _curentLineNr;
			mex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			mex.printStackTrace();
			}
			new ErrorConcept(mex.type, mex.id, mex.getSimpleMessage(), mex.lineNr);                 
			} catch (NotStaticMethodException mex) {
			mex.lineNr = _curentLineNr;
			mex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			mex.printStackTrace();
			}
			new ErrorConcept(mex.type, mex.id, mex.getSimpleMessage(), mex.lineNr); 
			}
					
			_t = __t124;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  postfixedConceptValue(AST _t,
		Concept concept, AST parent
	) throws RecognitionException {
		Concept result;
		
		AST postfixedConceptValue_AST_in = (AST)_t;
		result = concept;
		
		try {      // for error handling
			{
			_loop151:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==ELEM||_t.getType()==METH||_t.getType()==ATTR)) {
					result=oneDeepPostfixedConceptValue(_t,result, parent);
					_t = _retTree;
				}
				else {
					break _loop151;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  variableOrTypeReference(AST _t) throws RecognitionException {
		Concept result;
		
		AST variableOrTypeReference_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t128 = _t;
			AST tmp37_AST_in = (AST)_t;
			match(_t,IDENT);
			_t = _t.getFirstChild();
			result = resolveIdentifier( tmp37_AST_in ); 
			setLineNr( tmp37_AST_in.getLine());
			result=postfixedConceptValue(_t,result, tmp37_AST_in);
			_t = _retTree;
			_t = __t128;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  stringConstant(AST _t) throws RecognitionException {
		Concept result;
		
		AST stringConstant_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t132 = _t;
			AST tmp38_AST_in = (AST)_t;
			match(_t,STRING_LITERAL);
			_t = _t.getFirstChild();
			result = new StringConcept(tmp38_AST_in.getText());
			setLineNr( tmp38_AST_in.getLine());
			result=postfixedConceptValue(_t,result, null);
			_t = _retTree;
			_t = __t132;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  characterConstant(AST _t) throws RecognitionException {
		Concept result;
		
		AST characterConstant_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t136 = _t;
			AST tmp39_AST_in = (AST)_t;
			match(_t,CHAR_LITERAL);
			_t = _t.getFirstChild();
			result = new CharacterConcept(tmp39_AST_in.getText().charAt(0)); 
			setLineNr( tmp39_AST_in.getLine());
			result=postfixedConceptValue(_t,result, null);
			_t = _retTree;
			_t = __t136;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  integerConstant(AST _t) throws RecognitionException {
		Concept result;
		
		AST integerConstant_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t134 = _t;
			AST tmp40_AST_in = (AST)_t;
			match(_t,NUM_INT);
			_t = _t.getFirstChild();
			result = new IntegerConcept(tmp40_AST_in.getText()); 
			setLineNr( tmp40_AST_in.getLine());
			result=postfixedConceptValue(_t,result, null);
			_t = _retTree;
			_t = __t134;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  realConstant(AST _t) throws RecognitionException {
		Concept result;
		
		AST realConstant_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t138 = _t;
			AST tmp41_AST_in = (AST)_t;
			match(_t,NUM_REAL);
			_t = _t.getFirstChild();
			result = new RealConcept(tmp41_AST_in.getText()); 
			setLineNr( tmp41_AST_in.getLine());
			result=postfixedConceptValue(_t,result, null);
			_t = _retTree;
			_t = __t138;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  trueKeyword(AST _t) throws RecognitionException {
		Concept result;
		
		AST trueKeyword_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t142 = _t;
			AST tmp42_AST_in = (AST)_t;
			match(_t,TRUE);
			_t = _t.getFirstChild();
			result = new LogicalConcept(true); 
			setLineNr( tmp42_AST_in.getLine());
			result=postfixedConceptValue(_t,result, null);
			_t = _retTree;
			_t = __t142;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  falseKeyword(AST _t) throws RecognitionException {
		Concept result;
		
		AST falseKeyword_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t144 = _t;
			AST tmp43_AST_in = (AST)_t;
			match(_t,FALSE);
			_t = _t.getFirstChild();
			result = new LogicalConcept(false); 
			setLineNr( tmp43_AST_in.getLine());
			result=postfixedConceptValue(_t,result, null);
			_t = _retTree;
			_t = __t144;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  nilKeyword(AST _t) throws RecognitionException {
		Concept result;
		
		AST nilKeyword_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t140 = _t;
			AST tmp44_AST_in = (AST)_t;
			match(_t,NIL);
			_t = _t.getFirstChild();
			result = new NilConcept(); 
			setLineNr( tmp44_AST_in.getLine());
			result=postfixedConceptValue(_t,result, null);
			_t = _retTree;
			_t = __t140;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  thisKeyword(AST _t) throws RecognitionException {
		Concept result;
		
		AST thisKeyword_AST_in = (AST)_t;
		result = null;
		
		try {      // for error handling
			AST __t146 = _t;
			AST tmp45_AST_in = (AST)_t;
			match(_t,THIS);
			_t = _t.getFirstChild();
			
			setLineNr( tmp45_AST_in.getLine());
			if( _thisMethod != null &&  !_thisMethod.isStatic().getValue() && _thisConcept != null )
							result = _thisConcept ;
			else {
			result = new NilConcept();
			throw new RecognitionException("Can not use this in a static method !", "mn8Warning", tmp45_AST_in.getLine());
			}
			
			result=postfixedConceptValue(_t,result, tmp45_AST_in );
			_t = _retTree;
			_t = __t146;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  superKeyword(AST _t) throws RecognitionException {
		Concept result;
		
		AST superKeyword_AST_in = (AST)_t;
		result = null; SeriesConcept param=null;
		
		try {      // for error handling
			AST __t148 = _t;
			AST tmp46_AST_in = (AST)_t;
			match(_t,SUPER);
			_t = _t.getFirstChild();
			
			setLineNr( tmp46_AST_in.getLine());
			if ( superList == null ) {
			superList = new Vector();
			}
			if( param == null || param.getVector().size() == 0) {
			if( _thisConcept != null ) {
			superList.add( _thisConcept.getInheritedConcepts().getVector().elementAt(_thisConcept.getInheritedConcepts().getVector().size()-1));
			} 
			}else {
			if( param.getVector().size() > 1 ) {
			if( mn8RuntimeFlags.isVerbose() || mn8RuntimeFlags.isDebug() ) {
			System.err.println("To many parameters to super, only first considered");
			}
			}
			if( mn8Loader.isConceptAvailable( ((StringConcept)param.getVector().elementAt(0)).toString()) ) {
			if( _thisConcept.getInheritedConcepts().contains( (StringConcept)param.getVector().elementAt(0)).getValue()) {
			superList.add(param.getVector().elementAt(0));
			} else {
			
			System.err.println( _thisConcept.getConceptType().toString() 
			+ " does not inherit concept: " +  ((StringConcept)param.getVector().elementAt(0)).toString() 
			+ " in : " + _thisConcept.getConceptType().toString()  + " line: " + tmp46_AST_in.getLine()); 
			}
			} else {
			
			System.err.println("Unable to find concept" + ((StringConcept)param.getVector().elementAt(0)).toString() +
			" in : " + _thisConcept.getConceptType().toString() + " line: " + tmp46_AST_in.getLine()); 
			}
			}
			
			
			result=methodOnConcept(_t,null, tmp46_AST_in );
			_t = _retTree;
			_t = __t148;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  methodOnConcept(AST _t,
		Concept on, AST parent
	) throws RecognitionException {
		Concept result;
		
		AST methodOnConcept_AST_in = (AST)_t;
		result = on; String appendName= null; SeriesConcept param = null;
		
		try {      // for error handling
			AST __t154 = _t;
			AST tmp47_AST_in = (AST)_t;
			match(_t,METH);
			_t = _t.getFirstChild();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ELIST:
			{
				param=parameters(_t);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			
			setLineNr(tmp47_AST_in.getLine());
			try {
			if ( (appendName = tmp47_AST_in.getText())!= null ){
			
			mn8Method method = null;    
			String methodSig = null;
			if( param != null ) {
			methodSig = "" + appendName + ":" ;
			for( int  i = 0; i < param.getVector().size(); i++ ) 
			methodSig += ( i > 0 ? "," : "") + 
			((Concept)param.getVector().elementAt(i)).getConceptType().getValue();
			}
			else {
			methodSig = "" + appendName + ":";
			}   
			
			if ( parent != null && parent.getText().equalsIgnoreCase("super") ) {
			String conc = ((StringConcept)superList.elementAt(0)).toString();
			result = executeInheritedMethod(conc, methodSig, _thisConcept, param);
			superList = null;                        
			parent = null;
			} else if ( on == null && parent != null && parent.getText().equalsIgnoreCase("dot") ) {
			String conceptType;
			if (_thisConcept != null ) {
			conceptType = _thisConcept.getConceptType().toString();
			result = executeMethod(methodSig, _thisConcept , param);
			} else if( _thisMethod != null ) {
			conceptType = _thisMethod.getDeclaringConcept().toString();
			result = executeStaticMethod(methodSig, conceptType , param);
			} else {
			conceptType = _scriptName;
			result = executeStaticMethod(methodSig, conceptType , param);
			}
			
			} else {
			
			if( on != null ) {
			result = executeMethod(methodSig, on, param);
			}
			else { 
			if( parent != null ){
			if( parent.getText().startsWith("$") ) {
			result = executeMethod(methodSig,  on,  param );
			} else {
			result = executeStaticMethod(methodSig,  parent.getText(),  param );
			} 
			} else {
			// hmmm on = null parent = null what's this static method on current concept
			if( _thisMethod.isStatic().getValue() ) {
			result = executeStaticMethod( methodSig, 
			_thisMethod.getDeclaringConcept().toString(),
			param);
			} else {
			if( _thisConcept == null ) {
			throw new NotStaticMethodException(_thisMethod.getDeclaringConcept().toString(), tmp47_AST_in.getText(), tmp47_AST_in.getLine());
			} else {
			result = executeMethod(methodSig,  _thisConcept,  param );
			}
			}
			}
			}   
			}	
			}
			} catch (MethodNotFoundException mex) {
			mex.lineNr = _curentLineNr;
			mex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			mex.printStackTrace();
			}
			new ErrorConcept(mex.type, mex.id, mex.getSimpleMessage(), mex.lineNr);                 
			} catch (NotStaticMethodException mex) {
			mex.lineNr = _curentLineNr;
			mex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			mex.printStackTrace();
			}
			new ErrorConcept(mex.type, mex.id, mex.getSimpleMessage(), mex.lineNr); 
			}
			
			_t = __t154;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  oneDeepPostfixedConceptValue(AST _t,
		 Concept concept, AST parent
	) throws RecognitionException {
		Concept result;
		
		AST oneDeepPostfixedConceptValue_AST_in = (AST)_t;
		result = concept;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case METH:
			{
				result=methodOnConcept(_t,result, parent);
				_t = _retTree;
				break;
			}
			case ELEM:
			{
				result=elementOnConcept(_t,result, parent);
				_t = _retTree;
				break;
			}
			case ATTR:
			{
				result=attributeOnConcept(_t,result, parent);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  elementOnConcept(AST _t,
		Concept on, AST parent
	) throws RecognitionException {
		Concept result;
		
		AST elementOnConcept_AST_in = (AST)_t;
		result = on;
		
		try {      // for error handling
			AST tmp48_AST_in = (AST)_t;
			match(_t,ELEM);
			_t = _t.getNextSibling();
			FieldDefinition elField = null;
			try {
			setLineNr(tmp48_AST_in.getLine());
			if( (on == null && parent == null )  || (parent != null && parent.getText().equalsIgnoreCase("super"))) {
			elField = getElementField( tmp48_AST_in.getText(), _thisConcept, 
			_thisMethod.getDeclaringConcept().toString(), tmp48_AST_in.getLine());
			result = getElementValue( elField, _thisConcept,
			_thisMethod.getDeclaringConcept().toString(), tmp48_AST_in.getLine());
			} else {
			elField = getElementField( tmp48_AST_in.getText(), on, 
			parent.getText(), tmp48_AST_in.getLine());
			result = getElementValue( elField, on,
			parent.getText(), tmp48_AST_in.getLine());
			}
			} catch (ElementNotFoundException ex) {
			ex.lineNr = _curentLineNr;
			ex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
			} catch (NotStaticElementException ex) {
			ex.lineNr = _curentLineNr;
			ex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
			}
					
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final Concept  attributeOnConcept(AST _t,
		Concept on, AST parent
	) throws RecognitionException {
		Concept result;
		
		AST attributeOnConcept_AST_in = (AST)_t;
		result = on;
		
		try {      // for error handling
			AST tmp49_AST_in = (AST)_t;
			match(_t,ATTR);
			_t = _t.getNextSibling();
			FieldDefinition attrField = null;
			try {
			setLineNr(tmp49_AST_in.getLine());
			if( (on == null && parent == null) || (parent != null && parent.getText().equalsIgnoreCase("super"))) {
			attrField = getAttributeField( tmp49_AST_in.getText(), _thisConcept, 
			_thisMethod.getDeclaringConcept().toString(), tmp49_AST_in.getLine());
			result = getAttributeValue( attrField, _thisConcept,
			_thisMethod.getDeclaringConcept().toString(), tmp49_AST_in.getLine());
			} else {
			if( parent == null ) {
			attrField = getAttributeField( tmp49_AST_in.getText(), on, tmp49_AST_in.getLine());
			} else {
			attrField = getAttributeField( tmp49_AST_in.getText(), on, parent.getText(), tmp49_AST_in.getLine());
			}
			
			if( parent == null ) {
			result = getAttributeValue( attrField, on, null , tmp49_AST_in.getLine());
			} else {
			result = getAttributeValue( attrField, on, parent.getText(), tmp49_AST_in.getLine());
			}
			}
			_previousElem = null;
			} catch (FieldNotFoundException ex) {
			ex.lineNr = _curentLineNr;
			ex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
			} catch (AttributeNotFoundException ex) {
			ex.lineNr = _curentLineNr;
			ex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
			} catch (NotStaticAttributeException ex) {
			ex.lineNr = _curentLineNr;
			ex.scriptName = _scriptName;
			result = new NilConcept();
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			result = (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
			}
					
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final SeriesConcept  parameters(AST _t) throws RecognitionException {
		SeriesConcept result;
		
		AST parameters_AST_in = (AST)_t;
		result = new SeriesConcept(); Concept exresult;
		
		try {      // for error handling
			AST __t164 = _t;
			AST tmp50_AST_in = (AST)_t;
			match(_t,ELIST);
			_t = _t.getFirstChild();
			{
			_loop166:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_1.member(_t.getType()))) {
					exresult=expression(_t);
					_t = _retTree;
					result.getVector().add(exresult);
				}
				else {
					break _loop166;
				}
				
			} while (true);
			}
			_t = __t164;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return result;
	}
	
	public final FieldDefinition  postfixPaths(AST _t,
		Concept on, String conceptType
	) throws RecognitionException {
		FieldDefinition field;
		
		AST postfixPaths_AST_in = (AST)_t;
		field=null;
		
		try {      // for error handling
			{
			_loop160:
			do {
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case ATTR:
				{
					field=attributeFieldOnConcept(_t,on, conceptType);
					_t = _retTree;
					break;
				}
				case ELEM:
				{
					field=elementFieldOnConcept(_t,on, conceptType);
					_t = _retTree;
					break;
				}
				default:
				{
					break _loop160;
				}
				}
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return field;
	}
	
	public final FieldDefinition  attributeFieldOnConcept(AST _t,
		Concept on, String conceptType
	) throws RecognitionException {
		FieldDefinition field;
		
		AST attributeFieldOnConcept_AST_in = (AST)_t;
		field = null;
		
		try {      // for error handling
			AST tmp51_AST_in = (AST)_t;
			match(_t,ATTR);
			_t = _t.getNextSibling();
			
			setLineNr(tmp51_AST_in.getLine());
			try {                
			field = getAttributeField(tmp51_AST_in.getText(), on, conceptType, tmp51_AST_in.getLine()); _previousElem = null; 
			} catch (FieldNotFoundException ex) {
			ex.lineNr = _curentLineNr;
			ex.scriptName = _scriptName;
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			field = (FieldDefinition) (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
			}                
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return field;
	}
	
	public final FieldDefinition  elementFieldOnConcept(AST _t,
		Concept on, String conceptType
	) throws RecognitionException {
		FieldDefinition field;
		
		AST elementFieldOnConcept_AST_in = (AST)_t;
		field = null;
		
		try {      // for error handling
			AST tmp52_AST_in = (AST)_t;
			match(_t,ELEM);
			_t = _t.getNextSibling();
			
			setLineNr(tmp52_AST_in.getLine());
			try{
			field = getElementField(tmp52_AST_in.getText(), on, conceptType, tmp52_AST_in.getLine()); 
			} catch (FieldNotFoundException ex) {
			ex.lineNr = _curentLineNr;
			ex.scriptName = _scriptName;
			if( mn8RuntimeFlags.isDebug()) {
			ex.printStackTrace();
			}
			field = (FieldDefinition) (new ErrorConcept(ex.type, ex.id, ex.getSimpleMessage(), ex.lineNr)).result;
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return field;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"CONCEPT_DEFINITION",
		"METHOD_DEFINITION",
		"IMPLEMENTS_CLAUSE",
		"BLOCK",
		"ARRAY_DECLARATOR",
		"TYPE",
		"UNARY_MINUS",
		"UNARY_PLUS",
		"ATTRIDENT",
		"ELMETIDENTIFIER",
		"EXPR",
		"ELIST",
		"OLIST",
		"METHOD_CALL",
		"POST_INC",
		"POST_DEC",
		"CONDITION",
		"IF_BLOCK",
		"ELSE_BLOCK",
		"ELIF_BLOCK",
		"FIND_FIRST",
		"FIND_LAST",
		"SOURCE",
		"ELEM",
		"METH",
		"DEBUG_INFO",
		"\"define\"",
		"IDENT",
		"LBRACK",
		"RBRACK",
		"\"label\"",
		"STRING_LITERAL",
		"\"extends\"",
		"COMMA",
		"\"static\"",
		"ATTR",
		"NOT",
		"QUESTION",
		"ASSIGN",
		"\"typeof\"",
		"STAR",
		"COLON",
		"LPAREN",
		"RPAREN",
		"\"to\"",
		"\"exit\"",
		"\"return\"",
		"\"switch\"",
		"\"case\"",
		"\"find\"",
		"\"first\"",
		"\"last\"",
		"\"where\"",
		"\"each\"",
		"\"do\"",
		"\"in\"",
		"\"break\"",
		"\"by\"",
		"\"ascending\"",
		"\"descending\"",
		"\"while\"",
		"\"if\"",
		"\"then\"",
		"\"elif\"",
		"\"else\"",
		"\"print\"",
		"SEMI",
		"\"from\"",
		"\"options\"",
		"PLUS_ASSIGN",
		"MINUS_ASSIGN",
		"STAR_ASSIGN",
		"DIV_ASSIGN",
		"\"or\"",
		"\"and\"",
		"NOT_EQUAL",
		"EQUAL",
		"LT",
		"GT",
		"LE",
		"GE",
		"PLUS",
		"MINUS",
		"DIV",
		"INC",
		"DEC",
		"\"not\"",
		"RANGE",
		"DOT",
		"SEP",
		"NUM_INT",
		"\"super\"",
		"\"this\"",
		"\"true\"",
		"\"false\"",
		"CHAR_LITERAL",
		"NUM_REAL",
		"\"nil\"",
		"EOL",
		"\"timeout\"",
		"\"include\"",
		"LCURLY",
		"RCURLY",
		"MOD",
		"MOD_ASSIGN",
		"LCONT",
		"SL_COMMENT",
		"ESC",
		"WS",
		"VOCAB",
		"HEX_DIGIT",
		"EXPONENT"
	};
	
	private static final long _tokenSet_0_data_[] = { 490642257180624000L, 274341035683L, 0L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long _tokenSet_1_data_[] = { 54074568252064768L, 274341035648L, 0L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	}
	
