/* 
 * $COPYRIGHT$
 * $Id: CookieLoader.java,v 1.1 2001/12/24 19:12:30 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Szabo Csaba      Created
 */
package org.media.mn8.protocol.http;

import java.io.InputStream;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;


/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.1 $ $Date: 2001/12/24 19:12:30 $
 */
public class CookieLoader extends DefaultHandler {

    private Cookie cookie;
    private String errorMsg;
    private String parent;
    
    
    public CookieLoader() {
    }
    
    
    protected CookieLoader( Cookie cookie ) {
        this.cookie   = cookie;
        this.errorMsg = null;
        this.parent   = "";
    }
    
    
    public String errorMsg () {
        return errorMsg;
    }
    
    
    public Cookie getCookie( InputStream src , Cookie cook ) {
        SAXParserFactory factory = SAXParserFactory.newInstance();
        DefaultHandler   handler = new CookieLoader( cook ); 
	
        try {
            SAXParser parser = factory.newSAXParser();
            parser.parse(src, handler);
            return cook;
        }
        catch ( Exception e ) {
            errorMsg = "Unable to parser XML.\n" + e.getMessage();
            return null;
        }
    }
    
    
    public void startElement( String uri, String name, String qname, Attributes attrs ) throws SAXException {
        parent = qname.trim();
    }
    
    
    public void endElement( String uri, String name, String qname ) throws SAXException {
    }
    

    public void characters( char ch[], int start, int length ) throws SAXException {
        String str = new String(ch, start, length);
	
        if ( str.trim().length() > 0 ) {
            if ( parent.equalsIgnoreCase("domain") )
                cookie.setDomain( ( cookie.getDomain() != null ) ? cookie.getDomain() + str : str );
            if ( parent.equalsIgnoreCase("path") ) 
                cookie.setPath( ( cookie.getPath() != null ) ? cookie.getPath() + str : str );
            if ( parent.equalsIgnoreCase("secure") ) 
                cookie.setSecure( ( cookie.getSecure() != null ) ? cookie.getSecure() + str : str );
            if ( parent.equalsIgnoreCase("expires") ) 
                cookie.setExpires( ( cookie.getExpires() != null ) ? cookie.getExpires() + str : str );
            if ( parent.equalsIgnoreCase("name") )
                cookie.setName( ( cookie.getName() != null ) ? cookie.getName() + str : str );
            if ( parent.equalsIgnoreCase("value") )   
                cookie.setValue( ( cookie.getValue() != null ) ? cookie.getValue() + str : str );
        }
    }
    
    
    public void ignorableWhitespace( char ch[], int start, int length ) throws SAXException {
        characters(ch, start, length);
    }	    
}
