/* 
 * $COPYRIGHT$
 * $Id: CookieTest.java,v 1.1 2001/12/24 19:12:35 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Szabo Csaba      Created
 */
package org.media.mn8.protocol.http;


import java.net.*;
import java.util.*;
import java.io.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.1 $ $Date: 2001/12/24 19:12:35 $
 */
public class CookieTest {

    public static void main( String args[] ) {
        if( args.length != 1 ) {
            System.out.println( "Usage: java CookieTest url" );
        }
        else {
            try {
                CookieTest ct = new CookieTest();
                URL u = new URL( args[0] );
                System.out.println( "Connecting ..." );
                ct.connectToURL( u );
            }
            catch( MalformedURLException ex ) {
                System.err.println( "Malformed url: " + args[0] );
            }
        }
    }


    public void connectToURL( URL u ) {
        try {
            URLConnection uconn = u.openConnection();
            uconn.connect();

            Cookie cookie = new Cookie( getCookie( uconn ) , u.getHost() );

            BufferedInputStream bufIn = new BufferedInputStream( uconn.getInputStream()	);
            for (;;) {
                int data = bufIn.read();
                if (data == -1) break; else System.out.print ( (char) data);
            }
	
            if ( cookie != null ) 
                System.out.println( "\nCookie\n" + cookie.toXMLString() );
            else 
                System.out.println( "Cookie: None" );
        }
        catch( IOException ex ) {
            System.err.println( "Couldn't connect to " + u.toString() );
        }
    }


    private String getCookie( URLConnection urlconn ) {
        int    i = 1;
        String hdrKey;
        String hdrString = null;
	
        while( ( hdrKey = urlconn.getHeaderFieldKey( i ) ) != null ) {
            if( hdrKey.equalsIgnoreCase( "set-cookie" ) ) {
                hdrString = urlconn.getHeaderField( i );
            }
            i++;
        }

        return hdrString;
    }
} 
