/* 
 * $COPYRIGHT$
 * $Id: DomainNameFilter.java,v 1.1 2002/03/06 13:01:25 atech Exp $
 *
 * Date        Author            Changes 
 * IAN 29 2002 Szabo Csaba       Created
 */

package org.media.mn8.protocol.http;

import java.io.File;
import java.io.FilenameFilter;


/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.1 $ $Date: 2002/03/06 13:01:25 $
 */

    
public class DomainNameFilter implements FilenameFilter {
    
    private String _filterName = null;
    
    
    public DomainNameFilter( String fName ) {
	_filterName = fName.toLowerCase();
    }
    
    
    public boolean accept( File dir, String name ) {
	if ( name != null ) {
	    String _name = name.trim().toLowerCase();
	    int      poz = -1;
	    
	    if ( ( poz = _name.indexOf("[") ) != -1 ) _name = _name.substring( 0, poz );
	    if ( _name.startsWith(".") ) _name = _name.substring(1);
	    if ( _filterName.endsWith( _name ) ) return true; else return false;
	}
	else return false;
    }
}
