/* 
 * $COPYRIGHT$
 * $Id: ExplorerCookie.java,v 1.1 2001/12/24 19:12:47 neuro Exp $
 *
 * Date        Author            Changes 
 * Nov 02 2001 Antal Attila      Created
 */
package org.media.mn8.protocol.http;

import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Enumeration;


/** 
 * @author <a href="mailto:atech@nolimits.ro">Antal Attila</a>
 * @version $Revision: 1.1 $ $Date: 2001/12/24 19:12:47 $
 */
public class ExplorerCookie extends DefaultCookie {


    public void writeCookiesToXML( String  src, String dest ) {
        File file = new File(src);
        String[] files = file.list();
        if ( !src.substring( src.length()-1 ).equals( File.separator ) )
            src = src + File.separator;
        for ( int i = 0; i < files.length; i++ ) {
            if ( files[i].indexOf(".txt") > 0 ) readCookieFile( src + files[i], dest );
        }
    }


    private void readCookieFile( String src, String dest ) {
        InputStream    is = null;
        BufferedReader br;
        String line, domain = "";
        Cookie cook = new Cookie();
        int cnt = 1;
        try {
            is = new FileInputStream( src );
            br = new BufferedReader(new InputStreamReader(is));	
            while ( ( line = br.readLine() ) != null ) {
                if ( !line.trim().startsWith("#")  && line.trim().length() > 0 ) {
                    switch (cnt) {
                    case 1:
                        cook.setName(line);
                        break;
                    case 2:
                        cook.setValue(line);
                        break;
                    case 3: 
                        if ( line.indexOf("/") > -1 ) { 
                            domain = line.substring( 0, line.indexOf("/") );
                            cook.setPath( line.substring( line.indexOf("/") ) );
                        }
                        else {
                            domain = line;
                            cook.setPath( "/" );
                        }
                        cook.setDomain( domain );
                        break;
                    case 4:
                        if ( line.equals("0") ) line = "FALSE";
                        else line = "TRUE";
                        cook.setSecure(line);
                        break;
                    case 5:
                        break;			
                    case 6:
                        break;
                    case 7:
                        line = line + "000";
                        cook.setExpires(line);
                        break;
                    case 8:
                        break;
                    case 9:
                        Vector cookies = new Vector();
                        cookies.addElement( cook );
                        writeCookiesToXML(domain, cookies, dest);
                        cnt = 0;
                        cook = new Cookie();
                        break;
                    }
                    cnt++;
                }
            }
        }
        catch (FileNotFoundException e) {
            System.out.println("ERROR:" + e.getMessage() );
        }
        catch (IOException e) {
            System.out.println("ERROR:" + e.getMessage() );
        }
    }
    
}
