/* 
 * $COPYRIGHT$
 * $Id: KonquerorCookie.java,v 1.1 2001/12/24 19:12:53 neuro Exp $
 *
 * Date        Author            Changes 
 * Nov 02 2001 Antal Attila      Created
 */
package org.media.mn8.protocol.http;


import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Enumeration;


/** 
 * @author <a href="mailto:atech@nolimits.ro">Antal Attila</a>
 * @version $Revision: 1.1 $ $Date: 2001/12/24 19:12:53 $
 */
public class KonquerorCookie extends DefaultCookie {


    public void writeCookiesToXML( String  src, String dest ) {
        readCookieFile( src, dest );
    }


    private Cookie cookieLine( String line, String domain ) {
        Cookie cook = new Cookie();
        StringTokenizer st = new StringTokenizer( line );
        int cnt = 1;

        while (st.hasMoreTokens()) {
            String token = st.nextToken();
            switch (cnt) {
            case 1: break;// host
            case 2: break;// domain, not safe
            case 3: 
                token = token.substring( 1, token.length()-1 );
                cook.setPath(token);
                break;
            case 4:
                token = token + "000";
                cook.setExpires(token);
                break;
            case 5: break;// prot
            case 6: cook.setName(token);break;
            case 7: cook.setValue(token);break;
            case 8:
                if ( token.equals("0") ) token = "FALSE";
                else token = "TRUE";
                cook.setSecure(token);
                break;
            }
            cnt++;
        }
        cook.setDomain(domain);
        return cook;
    }


    private void readCookieFile( String src, String dest ) {
        InputStream    is = null;
        BufferedReader br;
        String line, domain = "";
        try {
            is = new FileInputStream( src );
            br = new BufferedReader(new InputStreamReader(is));	
            while ( ( line = br.readLine() ) != null )
                if ( !line.trim().startsWith("#")  && line.trim().length() > 0 ) {
                    if (line.trim().startsWith("[")) {
                        domain = line.substring( 1, line.indexOf("]") );
                    }
                    else {
                        Vector cookies = new Vector();
                        cookies.addElement( cookieLine( line, domain ) );
                        writeCookiesToXML(domain, cookies, dest);			
                    }
                }
        }
        catch (FileNotFoundException e) {
            System.out.println("ERROR:" + e.getMessage() );
        }
        catch (IOException e) {
            System.out.println("ERROR:" + e.getMessage() );
        }
    }
    
}
