/* 
 * $COPYRIGHT$
 * $Id: LinkExtractor.java,v 1.3 2002/04/23 17:51:28 crow Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.protocol.http;

import java.util.Vector;
import java.util.Enumeration;
import java.net.URL;
import java.net.MalformedURLException;
import org.media.mn8.concepts.AttributeSeries;
import org.media.mn8.concepts.AttributeConcept;
import org.media.mn8.concepts.StringConcept;
import org.media.mn8.mn8RuntimeFlags;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/04/23 17:51:28 $
 */
public class LinkExtractor extends TagExtractor {

    Vector links = new Vector();
    AttributeConcept href = new AttributeConcept("href", "href", new StringConcept());
    int idx = -1;
    URL url = null;
    public URL baseURL = null;

    public Vector getLinks( String pageContent ){
        parsePage( pageContent );
        return links;
    }


    public void tagFound( String tag ) {
        if( tag.trim().toLowerCase().startsWith("a ") &&
            tag.trim().toLowerCase().indexOf("href") != -1 ) {
            AttributeSeries attrs = getAttributes("a", tag);
	    for ( Enumeration e = attrs.getVector().elements(); e.hasMoreElements(); ) {
		AttributeConcept attr = (AttributeConcept)e.nextElement();
		if ( attr.getName().toString().equals("href") ) {
		    if( baseURL == null ) {
			links.add( attr.getAttributeValue() );
		    }
		    else {
                	try {
                    	    url = new URL( baseURL, attr.getAttributeValue().toTXT().toString());
                            links.add(new StringConcept(url.toString()));
                	} catch (MalformedURLException ex) {
                    	    if( mn8RuntimeFlags.isVerbose() || mn8RuntimeFlags.isDebug() ) {
                        	System.err.println(ex.getMessage());
                    	    }
                	}
		    }
		}
	    }
        }
    }


    public void textFound(String text) {
    }
}
