/* 
 * $COPYRIGHT$
 * $Id: NetscapeCookie.java,v 1.1 2001/12/24 19:13:12 neuro Exp $
 *
 * Date        Author            Changes 
 * Nov 02 2001 Antal Attila      Created
 */
package org.media.mn8.protocol.http;

import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Enumeration;


/** 
 * @author <a href="mailto:atech@nolimits.ro">Antal Attila</a>
 * @version $Revision: 1.1 $ $Date: 2001/12/24 19:13:12 $
 */
public class NetscapeCookie extends DefaultCookie {


    public void writeCookiesToXML( String src, String dest ) {
        Vector domains = getDomains(src);
	
        for ( Enumeration e = domains.elements(); e.hasMoreElements(); ) {
            String domain = (String)e.nextElement();
            Vector cookies = readCookie(domain, src);
            writeCookiesToXML(domain, cookies, dest);
        } 
    }


    private Cookie cookieLine( String line ) {
        Cookie     cook = new Cookie();
        StringBuffer sb = new StringBuffer();
        int cnt = 1;
        int poz = 0;
	
        while ( poz < line.length() ) {
            char ch = line.charAt( poz++ );
	    
            if ( Character.isWhitespace( ch ) ) {
                switch ( cnt ) {
                case 1: cook.setDomain( sb.toString() );break;
                case 3: cook.setPath( sb.toString() );break;
                case 4: cook.setSecure( sb.toString() );break;
                case 5: cook.setExpires( sb.toString() + "000" );break;
                case 6: cook.setName( sb.toString() );break;
                case 7: cook.setValue( sb.toString() );break;
                }
                sb = new StringBuffer();cnt++;
            }
            else sb.append(ch);
        }
	
        return cook;
    }


    private boolean isExist( Vector vector, String element ) {
        boolean ret = false;

        for ( Enumeration e = vector.elements(); e.hasMoreElements(); ) {
            String domain = (String) e.nextElement();
            if ( element.equals(domain) ) return true;
        }
	
        return ret;
    }


    private Vector readCookieFile( String domain, String src, String type ) {
        InputStream    is = null;
        BufferedReader br;
        String       line;
        Vector    objects = new Vector();
	
        try {
            is = new FileInputStream( src );
            br = new BufferedReader(new InputStreamReader(is));	
            while ( ( line = br.readLine() ) != null )
                if ( !line.trim().startsWith("#")  && line.trim().length() > 0 ) {
                    int i=0;
                    while ( !Character.isWhitespace( line.charAt(i) ) && i < (line.length()-1) ) i++;
                    String _domain = line.substring( 0, i );
                    if ( type.equals("domains") ) {
                        if ( !isExist( objects, _domain ) ) objects.addElement( _domain );
                    }
                    else {
                        if ( _domain.equals( domain ) ) objects.addElement( cookieLine( line + "\n" ) );
                    }
                }
        }
        catch (FileNotFoundException e) {
            System.out.println("ERROR:" + e.getMessage() );
        }
        catch (IOException e) {
            System.out.println("ERROR:" + e.getMessage() );
        }
        return objects;
    }


    private Vector getDomains( String src ) {
        return readCookieFile( null, src, "domains");
    }


    private Vector readCookie ( String domain, String src ) {
        return readCookieFile( domain, src, "cooks");
    }
}
