/* 
 * $COPYRIGHT$
 * $Id: OptGroupControl.java,v 1.1 2002/01/31 20:35:43 crow Exp $
 *
 * Date        Author            Changes 
 * IAN 29 2002 Szabo Csaba       Created
 */

package org.media.mn8.protocol.http;

import java.util.Vector;
import java.util.Enumeration;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.1 $ $Date: 2002/01/31 20:35:43 $
 */

public class OptGroupControl extends DefaultAttributes 
			     implements DefaultControl {
    
    private static final String attrNames[] = {"disabled", "label"};
    
    //option group attlist
    private String label;

    private Vector options;

    private String attrList = "";
    
    
    public OptGroupControl() {
	options = new Vector();
    }
    
    
    public void setLabel( String label ) {
	this.label = label;
	attrList += getAttrPair ( "label", label ); 
    }
    

    public boolean isSendable() {
	return true;
    }


    public String getName() {
	return label;
    }


    public Vector getValues() {
	Vector result = new Vector();

	for ( Enumeration e = options.elements(); e.hasMoreElements(); ) {
	    Vector values = ( (OptionControl)e.nextElement() ).getValues();

	    for ( Enumeration e1 = values.elements(); e1.hasMoreElements(); ) {
		String value = (String)e1.nextElement();
		result.add( value );
	    }
	}

	return result;
    }


    public String toXMLString() {
	StringBuffer sb = new StringBuffer("<OPTGROUP " + getAttrList().trim() + ">");
	
	for ( Enumeration e = options.elements(); e.hasMoreElements(); ) 
	    sb.append("\n            " + ((OptionControl)e.nextElement()).toXMLString());
    	sb.append("\n        </OPTGROUP>");
	
	return sb.toString();
    }
    

    public String toString() {
	StringBuffer ret = new StringBuffer( "OPTGROUP : \n" + getAttrList().replace(' ', '\n') );
		 
	for ( Enumeration e = options.elements(); e.hasMoreElements(); ) {
	    Object obj = e.nextElement();
	    ret.append( "\n\n" + ((OptionControl)obj).toString() );
	}
												     
	return  ret.toString();
    }


    public void parse( String tag ) {
	super.parse( tag );
		 
	if ( tag == null || tag.trim().length() < 1 ) return;
			 
	String attrs = getAttrsFromTag( tag );
				 
	if ( attrs.trim().length() > 0 ) {
	    for ( int i = 0; i < attrNames.length; i++ ) {
		String value = super.getValueOf( attrs, attrNames[i] );
								     
		if ( value != null ) {
		    if ( attrNames[i].equals("label") ) label = value;
            	    attrList += getAttrPair( attrNames[i], value );
		}
	    }
	}
    }    

    
    public String getAttrList() {
        return attrList + super.getAttrList();
    }
		   
		   
    public void addOption( OptionControl opt ) {
	options.addElement( opt );
    }  
     
     
    public String getControlType() {
        return "OPTGROUP";
    }
    
    
    public boolean equals( DefaultControl control ) {
	OptGroupControl ogcontrol = (OptGroupControl)control;
	
	if ( ogcontrol.label != null && ogcontrol.label.equals( label ) ) return true;
	 
	return false;
    }
}
