/* 
 * $COPYRIGHT$
 * $Id: OptionControl.java,v 1.1 2002/01/31 20:35:53 crow Exp $
 *
 * Date        Author            Changes 
 * IAN 29 2002 Szabo Csaba       Created
 */

package org.media.mn8.protocol.http;

import java.util.Vector;

/** 
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba</a>
 * @version $Revision: 1.1 $ $Date: 2002/01/31 20:35:53 $
 */

public class OptionControl extends DefaultAttributes 
			   implements DefaultControl {
    
    private static final String attrNames[] = {
	     "selected", "disabled", "label", "value"
	    };		   
    
    //option element
    private String optValue;
    
    //option attlist
    private String value;
    private String selected;

    private String attrList = ""; 
    
    
    public OptionControl() {
    }
    
    
    public void setValue( String value ) {
	this.value = value;
	attrList += getAttrPair ( "value", value ); 
    }
    
    
    public void setSelected( String sel ) {
	this.selected = sel;
	attrList += getAttrPair ( "selected", sel ); 
    }
    
    
    public void setOptValue( String attr ) {
	optValue = attr;
    }
    

    public boolean isSendable() {
	return true;
    }
    
    
    public String getName() {
	return null;
    }

    
    public Vector getValues() {
	Vector result = new Vector();
	result.add(value);
	return result;
    }


    public String toXMLString() {
	String ret = "<OPTION " + getAttrList().trim() + ">";
	
	if ( optValue != null && optValue.trim().length() > 0 ) 
	    ret += "<![CDATA[ " + optValue + " ]]>";
	ret += "</OPTION>";
	
	return ret;
    }
    

    public String toString() {
	return  "OPTION  : \n" + getAttrList().replace(' ', '\n') +
	        "\nOPTVALUE: " + optValue;
    }
    
    
    public void parse( String tag ) {
	super.parse( tag );
		 
	if ( tag == null || tag.trim().length() < 1 ) return;
			 
	String attrs = getAttrsFromTag( tag );
	
	if ( attrs.trim().length() > 0 ) {
	    for ( int i = 0; i < attrNames.length; i++ ) {
		String value = super.getValueOf( attrs, attrNames[i] );
						     
		if ( value != null ) {
	    	    if ( attrNames[i].equals("value") )  this.value = value;
	    	    if ( attrNames[i].equals("selected") ) selected = value;
													 
	    	    attrList += getAttrPair ( attrNames[i], value );
		}
	    }
	}
	if ( selected == null ) attrList += getAttrPair ( "selected", "false" ); 
    } 
    
    
    public String getAttrList() {
        return attrList + super.getAttrList();
    }
     
     
    public String getControlType() {
	return "OPTION";
    }
    
    
    public boolean equals( DefaultControl control ) {
	return true;
    }
}
