/* 
 * $COPYRIGHT$
 * $Id: ConnectorInterface.java,v 1.1 2002/04/09 16:47:46 crow Exp $
 *
 * Date        Author            Changes 
 * APR 08 2002 Szabo Csaba       Created
 */
package org.media.mn8.protocol.jabber;

import java.io.*;

/**
 * The interface for all connectors which handle creating the input and output stream
 */
public abstract class ConnectorInterface {

    /**
     * The name of the host being connected to
     */
    protected String hostname;


    /**
     * Constructor
     *
     * @param _hostname The name of the host being connected to
     */
    public ConnectorInterface( String _hostname ) {
        hostname = _hostname;
    }


    /**
     * Method to get the name of the host being connected to
     *
     * @return The hostname being connected to
     */
    public String getHostname() {
        return hostname;
    }


    /**
     * Method to return the input stream of the connection
     *
     * @return The input stream
     */
    public abstract InputStream openInputStream() throws IOException;


    /**
     * Method to return the output stream of the connection
     *
     * @return The output stream
     */
    public abstract OutputStream openOutputStream() throws IOException;
}
