/* 
 * $COPYRIGHT$
 * $Id: JabberListener.java,v 1.3 2002/04/28 14:23:37 neuro Exp $
 *
 * Date        Author            Changes 
 * APR 08 2002 Szabo Csaba       Created
 */
package org.media.mn8.protocol.jabber;

/**
 * The interface classes that listen for jabber messages should implement
 */
public interface JabberListener {

    /**
     * Method called once the stream has been set up
     */
    void beginConversation();


    /**
     * Method to handle an incomming block.
     *
     * @param data The incomming block
     */
    void blockArrived( JabberDataBlock data );

   
    /**
     * Method called when the stream is terminated for some reason
     *
     * @param exception The exception that caused the termination. May be
     *  null if the connection was terminated normally.
     */
    void connectionTerminated( Exception e );
}
