/* 
 * $COPYRIGHT$
 * $Id: Iq.java,v 1.1 2002/04/09 16:47:46 crow Exp $
 *
 * Date        Author            Changes 
 * APR 08 2002 Szabo Csaba       Created
 */
package org.media.mn8.protocol.jabber.datablocks;

import org.media.mn8.protocol.jabber.*;
import java.util.*;

/**
 * Class representing the iq message block
 */
public class Iq extends JabberDataBlock {
  
    /**
     * Constructor.
     */
    public Iq( ) {
        super( );
    }


    /**
     * Constructor. Sets the message type and constructs an empty IQ message
     */
    public Iq( String type ) {
        setAttribute( "type", type );
    }


    /**
     * Constructor including an Attribute list
     *
     * @param _parent The parent of this datablock
     * @param _attributes The list of element attributes
     */
    public Iq( JabberDataBlock _parent, Hashtable _attributes ) {
        super( _parent, _attributes );
    }


    /**
     * Method to return the tag name
     *
     * @return Always the string "iq".
     */
    public String getTagName() {
        return "iq";
    }


    /**
     * Construct a reply message
     *
     * @return A message object destined for the sender of this message.
     */
    public Iq constructReply() {
        if( attributes == null ) return null;
        Iq reply = new Iq( );
        super.constructReply( reply );
        return reply;
    }
}
