/* 
 * $COPYRIGHT$
 * $Id: Roster.java,v 1.1 2002/04/09 16:47:46 crow Exp $
 *
 * Date        Author            Changes 
 * APR 08 2002 Szabo Csaba       Created
 */
package org.media.mn8.protocol.jabber.datablocks;

import org.media.mn8.protocol.jabber.*;
import java.util.*;

/**
 * Class representing the presence message block.
 */
public class Roster extends Iq {

    /**
     * Constructor.
     *
     * @param _parent The parent of this datablock
     * @param _attributes The list of element attributes
     */
    public Roster( JabberDataBlock _parent, Hashtable _attributes ) {
        super( _parent, _attributes );
    }


    /**
     * Default constructor for outgoing presence messages.
     */
    public Roster() {
        super( null, null );
    }


    /**
     * Method to fill this presence object with the information neccessary
     * to indicate the client is available.
     */
    public void setRequestRoster() {
        setAttribute( "type", "get" );
        setAttribute( "id", "rosterget" );
        JabberDataBlock query = new JabberDataBlock( "query", this, null );
        query.setAttribute( "xmlns", "jabber:iq:roster" );
        addChild( query );
    }
}
