/* 
 * $COPYRIGHT$
 * $Id: seConnector.java,v 1.1 2002/04/09 16:47:46 crow Exp $
 *
 * Date        Author            Changes 
 * APR 08 2002 Szabo Csaba       Created
 */
package org.media.mn8.protocol.jabber;

import java.io.*;
import java.net.*;

/**
 * Class for getting a connection to the server under java 2 standard edition.
 */
public class seConnector extends ConnectorInterface {
    /**
     * The socket connected to the Jabber server
     */
    private Socket serverConnection;
    

    /**
     * Constructor
     *
     * @param hostname The host to connect to
     * @param port The port to connect to
     */
    public seConnector( String hostname, int port ) throws IOException {
        super( hostname );
        serverConnection = new Socket( hostname, port );
    }


    /**
     * Method to return the input stream of the connection
     *
     * @return The input stream
     */
    public InputStream openInputStream() throws IOException {
        return serverConnection.getInputStream();
    }


    /**
     * Method to return the output stream of the connection
     *
     * @return The output stream
     */
    public OutputStream openOutputStream() throws IOException {
        return serverConnection.getOutputStream();
    }
}
