/* 
 * $COPYRIGHT$
 * $Id: XMLEventListener.java,v 1.2 2002/04/11 12:03:30 neuro Exp $
 *
 * Date        Author            Changes 
 * APR 08 2002 Szabo Csaba       Created
 */
package org.media.mn8.protocol.jabber.xmlparser;

import java.util.*;

/**
 * Interface for classes wishing to listen to events generated by the parser.
 */
public interface XMLEventListener {
  
    /**
     * Method called when an tag start is encountered.
     *
     * @param name Tag name.
     * @param attributes The tags attributes.
     */
    void tagStarted( String name, Hashtable attributes );
    
    
    /**
     * Method called when some plain text between two tags is encountered.
     *
     * @param text The plain text in question.
     */
    void plaintextEncountered( String text );
  

    /**
     * The method called when a tag end is encountered.
     *
     * @param name The name of the tag that has just ended.
     */
    void tagEnded( String name );
}
