/*
 * $COPYRIGHT$
 * $Id: SMTPURLConnection.java,v 1.1 2002/01/29 14:00:16 crow Exp $
 *
 * Date           Author         Changes
 * IAN 28 2002    Szabo Csaba    Created
 */

package org.media.mn8.protocol.smtp;

import java.io.*;
import java.net.*;
import java.util.Hashtable;
import java.util.Vector;
import java.util.StringTokenizer;

import java.net.MalformedURLException;

import com.oroinc.net.smtp.*;

/**
 * This class implements a connection to the new "pop3"
 * URL scheme.
 */

class SMTPURLConnection extends URLConnection {
    private static final String DEF_HOST     = "localhost";
    private static final    int DEF_PORT     = 25;

    private String host;
    private int    port;

    private boolean connected = false;
    private URL url;

    /**
     * Given a URL will instantiate a SMTPURLConnection
     * object.
     * @param getURL The URL to contact.
     */
    SMTPURLConnection( URL getURL ) {
        super( getURL );
        try {
            url = new URL( URLDecoder.decode( getURL.toString() ) );
        }
        catch ( Exception e) {
            System.out.println("Can't decode the URL: " + getURL.toString() );
        }
    }


    public void connect() throws IOException {

        if ( url.getHost().length() == 0 ) host = DEF_HOST;
        else host = url.getHost();

        if ( url.getPort() < 1 ) port = DEF_PORT;
        else port = url.getPort();

        getConnection( host, port );
    }


    public synchronized OutputStream getOutputStream() throws IOException {
        if ( !connected ) connect();
        return new ByteArrayOutputStream( );
    }


    private void getConnection( String host, int port ) throws IOException {
	SMTPClient client = new SMTPClient( );
		
	try {                                                                    
	    client.connect( host, port );
	    
	    if( !SMTPReply.isPositiveCompletion( client.getReplyCode() ) ) {
		client.disconnect();
		throw new IOException ("SMTP server refused connection.");
            }
	    
	    if ( !client.login() ) throw new IOException("Login failed");
	} 
	catch( IOException e ) {
	   if( client.isConnected() ) {
	       try {
		   client.disconnect();
	       } catch( IOException f ) { }
	   }
	   throw new IOException("Could not connect to server.");
  	}
       
	connected = true;
    }
}
