/*
 * $COPYRIGHT$
 * $Id: TestXmlrpcURL.java,v 1.1 2001/12/14 00:12:25 neuro Exp $
 *
 * Date           Author         Changes
 * sept 28 2001  Antal Attila    Created
 */
package org.media.mn8.protocol.xmlrpc;


import java.net.*;
import java.io.*;


/**
 * This is an application which uses our new xmlrpc
 * protocol handler to obtain information.
 */
public class TestXmlrpcURL {
    
    /**
     * The method launches the application.
     * @param args Arguments which are the query string.
     */
    public static void main (String args[]) {

        TestXmlrpcURL app = new TestXmlrpcURL ( args );
    }
    
    /**
     * This constructor does all of the work of obtaining
     * the data from the server.
     * @param args The tokens of the query string.
     */
    public TestXmlrpcURL( String args[] ) {
        URL url;
        URLConnection con;
        BufferedReader input;
        String nextLine;

        String protocol = "xmlrpc:";
        String url1 = "//guest:guest@localhost:10300/url.executeSep?sep=" + 
            "<request    reqno='1'     >< fetch><union><intersect> \n" +          
            "<compare subtree='xmlrpctest.7'>" +                                
            "<path/><value></value></compare>" +                                
            "</intersect></union></fetch></request>" +
            "&db=XMLDB&user=guest&hash=74f459661a03946a";

        String url2 = "//guest:guest@localhost:10300/url.echo?x=Test";
  
        String _url = URLEncoder.encode( url1 );

        try {
            url = new URL( protocol + _url );
            con = url.openConnection();

            input = new BufferedReader( new InputStreamReader ( con.getInputStream() ) );
            while( ( nextLine = input.readLine() ) != null) System.out.println( nextLine );
            input.close();
        } 
        catch ( MalformedURLException e ) {
            System.err.println("Mailformed URL: " + e);
        } 
        catch ( IOException e ) {
            System.err.println("Failed I/O: " + e);

        }
    }
}
