/* 
 * $COPYRIGHT$
 * $Id: ServletRequestDefinition.java,v 1.3 2002/06/03 11:37:45 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.servlet;


import org.media.mn8.*;
import org.media.mn8.concepts.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/06/03 11:37:45 $
 */

public class ServletRequestDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private ServletRequestDefinition _reference = new ServletRequestDefinition();
    
    private ServletRequestDefinition() {
        super();
        try {            
            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getAuthType:",
                                        "getAuthType:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getSession:",
                                        "getSession:", "ServletRequest", "ServletSession"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getSession:org.media.mn8.concepts.LogicalConcept",
                                        "getSession:Logical", "ServletRequest", "ServletSession"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getContextPath:",
                                        "getContextPath:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getPathInfo:",
                                        "getPathInfo:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getPathTranslated:",
                                        "getPathTranslated:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getQueryString:",
                                        "getQueryString:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getRemoteUser:",
                                        "getRemoteUser:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getRequestedSessionId:",
                                        "getRequestedSessionId:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getRequestURI:",
                                        "getRequestURI:", "ServletRequest", "String"));



            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getServletPath:",
                                        "getServletPath:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getCharacterEncoding:",
                                        "getCharacterEncoding:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getContentType:",
                                        "getContentType:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getCookies:",
                                        "getCookies:", "ServletRequest", "Series"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getLocales:",
                                        "getLocales:", "ServletRequest", "Series"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getProtocol:",
                                        "getProtocol:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getRemoteAddr:",
                                        "getRemoteAddr:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getRemoteHost:",
                                        "getRemoteHost:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getScheme:",
                                        "getScheme:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getServerName:",
                                        "getServerName:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getServerPort:",
                                        "getServerPort:", "ServletRequest", "Integer"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "isSecure:",
                                        "isSecure:", "ServletRequest", "Logical"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getContentLength:",
                                        "getContentLength:", "ServletRequest", "Integer"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getUserPrincipalName:",
                                        "getUserPrincipalName:", "ServletRequest", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "isRequestedSessionIdFromCookie:",
                                        "isRequestedSessionIdFromCookie:", "ServletRequest", "Logical"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "isRequestedSessionIdFromURL:",
                                        "isRequestedSessionIdFromURL:", "ServletRequest", "Logical"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "isRequestedSessionIdValid:",
                                        "isRequestedSessionIdValid:", "ServletRequest", "Logical"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "isUserInRole:org.media.mn8.concepts.StringConcept",
                                        "isUserInRole:String", "ServletRequest", "Logical"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getMethod:",
                                        "getMethod:", "ServletRequest", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getHeaders:",
                                        "getHeaders:", "ServletRequest", "Map"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getParameters:",
                                        "getParameters:", "ServletRequest", "Map"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getRealPath:org.media.mn8.concepts.StringConcept",
                                        "getRealPath:String", "ServletRequest", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getMimeType:org.media.mn8.concepts.StringConcept",
                                        "getMimeType:String", "ServletRequest", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletRequestConcept",
                                        "getResourceURL:org.media.mn8.concepts.StringConcept",
                                        "getResourceURL:String", "ServletRequest", "String"));


        }catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new ServletRequestConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("ServletRequest");
    }


    public StringConcept getConceptType() {
        return new StringConcept("ServletRequest");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



