/* 
 * $COPYRIGHT$
 * $Id: ServletResponseDefinition.java,v 1.2 2002/05/21 14:07:31 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.servlet;


import org.media.mn8.*;
import org.media.mn8.concepts.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/05/21 14:07:31 $
 */

public class ServletResponseDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private ServletResponseDefinition _reference = new ServletResponseDefinition();
    
    private ServletResponseDefinition() {
        super();
        try {
            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "setContentType:org.media.mn8.concepts.StringConcept",
                                        "setContentType:String", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "sendRedirect:org.media.mn8.concepts.StringConcept",
                                        "sendRedirect:String", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "addCookie:org.media.mn8.concepts.CookieConcept",
                                        "addCookie:Cookie", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "containsHeader:org.media.mn8.concepts.StringConcept",
                                        "containsHeader:String", "ServletResponse", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "encodeURL:org.media.mn8.concepts.StringConcept",
                                        "encodeURL:String", "ServletResponse", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "encodeRedirectURL:org.media.mn8.concepts.StringConcept",
                                        "encodeRedirectURL:String", "ServletResponse", "String"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "setHeader:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "setHeader:String,String", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "addHeader:org.media.mn8.concepts.StringConcept,org.media.mn8.concepts.StringConcept",
                                        "addHeader:String,String", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "setContentLength:org.media.mn8.concepts.IntegerConcept",
                                        "setContentLength:Integer", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "setStatus:org.media.mn8.concepts.IntegerConcept",
                                        "setStatus:Integer", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "sendError:org.media.mn8.concepts.IntegerConcept",
                                        "sendError:Integer", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "sendError:org.media.mn8.concepts.IntegerConcept,org.media.mn8.concepts.StringConcept",
                                        "sendError:Integer,String", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "setBufferSize:org.media.mn8.concepts.IntegerConcept",
                                        "setBufferSize:Integer", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "reset:",
                                        "reset:", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "flushBuffer:",
                                        "flushBuffer:", "ServletResponse", null));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "isCommitted:",
                                        "isCommitted:", "ServletResponse", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "getBufferSize:",
                                        "getBufferSize:", "ServletResponse", "Integer"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletResponseConcept",
                                        "getCharacterEncoding:",
                                        "getCharacterEncoding:", "ServletResponse", "String"));

        }catch (Exception ex) {
            ex.printStackTrace();
        }        
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new ServletResponseConcept();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("ServletResponse");
    }


    public StringConcept getConceptType() {
        return new StringConcept("ServletResponse");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



