/* 
 * $COPYRIGHT$
 * $Id: ServletSessionDefinition.java,v 1.2 2002/05/21 14:07:08 neuro Exp $
 *
 * Date        Author            Changes 
 * Jul 03 2001 Remus Pereni      Created
 */
package org.media.mn8.servlet;


import org.media.mn8.*;
import org.media.mn8.concepts.*;

/** 
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/05/21 14:07:08 $
 */

public class ServletSessionDefinition extends ConceptConceptDefinition {
    
    static private SeriesConcept _inheritedConcepts = new SeriesConcept("Concept");
    static private ServletSessionDefinition _reference = new ServletSessionDefinition();
    
    private ServletSessionDefinition() {
        super();
        try {            
            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletSession",
                                        "getCreationTime:",
                                        "getCreationTime:", "ServletSession", "Integer"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletSession",
                                        "getLastAccessedTime:",
                                        "getLastAccessedTime:", "ServletSession", "Integer"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletSession",
                                        "getMaxInactiveInterval:",
                                        "getMaxInactiveInterval:", "ServletSession", "Integer"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletSession",
                                        "setMaxInactiveInterval:org.media.mn8.concepts.IntegerConcept",
                                        "setMaxInactiveInterval:Integer", "ServletSession", null));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletSession",
                                        "getId:",
                                        "getId:", "ServletSession", "String"));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletSession",
                                        "isNew:",
                                        "isNew:", "ServletSession", "Logical"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletSession",
                                        "getAttributes:",
                                        "getAttributes:", "ServletSession", "Map"));

            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletSession",
                                        "setAttributes:org.media.mn8.concepts.MapConcept",
                                        "setAttributes:Map", "ServletSession", null));


            putMethod(new mn8JavaMethod("org.media.mn8.servlet.ServletSession",
                                        "invalidate:",
                                        "invalidate:", "ServletSession", null));

        }catch (Exception ex) { 
            ex.printStackTrace(); 
        }
    }
    
    public static ConceptDefinition getReference() {
        return _reference;
    }


    public Concept getConceptInstance() {
        return new ServletSession();
    }


    public StringConcept getConceptLabel() {
        return new StringConcept("ServletSession");
    }


    public StringConcept getConceptType() {
        return new StringConcept("ServletSession");
    }


    public SeriesConcept getInheritedConcepts() {
        return _inheritedConcepts;
    }
}



