/* 
 * $COPYRIGHT$
 * $Id: mn8SystemServlet.java,v 1.1 2002/06/05 00:17:49 neuro Exp $
 *
 * Date        Author            Changes 
 * May 16 2002 Remus Pereni      Created
 */
package org.media.mn8.servlet;

import javax.servlet.http.*;
import javax.servlet.*;
import java.io.IOException;
import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.OutputStream;

import javax.activation.MimetypesFileTypeMap;
/**
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.1 $ $Date: 2002/06/05 00:17:49 $
 */
public class mn8SystemServlet  {
    private HttpServletRequest _request;
    private HttpServletResponse _response;
    private ServletConfig _config;

    public mn8SystemServlet( ServletConfig config, HttpServletRequest request, HttpServletResponse response ) {
        _request = request;
        _response = response;
        _config = config;
    }


    public void serve() throws IOException {
        try {
            if( _request.getPathTranslated() != null ) {
                File path = new File(_request.getPathTranslated());
                if( path.exists() && path.isFile() ) {
                    String mimeType = _config.getServletContext().getMimeType( path.getAbsolutePath());
                    if( mimeType == null ) {
                        mimeType = MimetypesFileTypeMap.getDefaultFileTypeMap().getContentType( path ); 
                    }
                    if( mimeType != null ) {
                        _response.setContentType(mimeType);
                    }
                    _response.setContentLength( (int)path.length());
                    OutputStream os = null;
                    InputStream is = null;

                    try {
                        os = _response.getOutputStream();
                        is = new FileInputStream(path);
                        while ( is.available() > 0 ) {
                            os.write( is.read());
                        }
                    } catch (SecurityException sex) {
                        _response.sendError(403, sex.getMessage());
                    } catch (IOException ex) {
                        _response.sendError(500, ex.getMessage());
                    } finally {
                        if( os != null ) {
                            os.flush();
                            os.close();
                        }
                        
                        if( is != null ) {
                            is.close();
                        }
                    }

                } else if( path.exists() && path.isDirectory() ) {
                    _response.sendError(403, "Directory listing forbidden on this server.");
                } else {
                    _response.sendError(404, "The requested URL was not found on this server.");
                }
            }
        } catch (Exception rex) {
            _response.sendError(500, rex.getMessage());
        }
    }
}
