/*
 * $COPYRIGHT$
 * $Id: CLIHelper.java,v 1.2 2001/12/01 20:20:07 neuro Exp $
 *
 * Date         Author          Changes
 * May 28 2001  Szabo Csaba     Created
 * Nov 10 2001  Remus Pereni    Imported from DS and adjusted for mn8
 */
       
package org.media.mn8.util;

import org.media.mn8.MessageFormatter;

import java.util.Properties;
import java.util.StringTokenizer;
import java.io.InputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader; 
import java.io.IOException;
import java.io.Writer;
import java.io.OutputStreamWriter;

/**
 * @author <a href="mailto:crow@nolimits.ro">Szabo Csaba </a>
 * @version $Revision: 1.2 $ $Date: 2001/04/21 15:00:00
 * @see java.lang.String
 */    
public class CLIHelper {

    private static final String MESSAGES_RESOURCE_FILE = "conf/res/mn8messages.properties";
    
    protected boolean help    = false;
    protected final String opArg = "-?;--help;";
    

    protected CLIHelper() {
    }

    
    private InputStream getInputStream( String fileName ) throws Exception {
        Class  _class = Class.forName("org.media.mn8.Main");
        return _class.getResourceAsStream( fileName );
    }

    
    protected String getUsage( String fileName ) {
        StringBuffer       sb = new StringBuffer();
        BufferedReader reader = null;
        
        try {
            reader = new BufferedReader( new InputStreamReader( 
							       getInputStream ( fileName ) ) );
            String line;
            while ( ( line = reader.readLine() ) != null ) 
                sb.append ( line + "\n" );
            reader.close();
        }
        catch ( Exception e ) {
            System.err.println( "Unable to load help file : " + fileName );
        }
        
        return sb.toString();
    }

    
    protected String[] getArguments( String str ) {
        StringTokenizer st = new StringTokenizer( str.replace('"', ' ').replace('\'', ' ') );   
        String       arg[] = new String [ st.countTokens() ];
        int          count = 0;
        
        while ( st.hasMoreTokens() ) arg[ count++ ] = st.nextToken();        
        return arg;
    }

    
    protected void setArgs( ArgParser parser ) {
        String    arg;
        if( (arg = parser.getValue("-?")) != null ||
            (arg = parser.getValue("--help")) != null ) help = true;
    }

    
    protected String validate( String usage ) {
        if( help ) return  usage ;
        else return "";
    }
}
