/* 
 * $COPYRIGHT$
 * $Id: ConceptNavPatterns.java,v 1.1 2001/10/22 20:25:02 neuro Exp $
 *
 * Date        Author            Changes 
 * May 15 2001 Remus Pereni      Created
 */
package org.media.mn8.util;


/**
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.1 $ $Date: 2001/10/22 20:25:02 $
 */
public class ConceptNavPatterns {

    
    public static boolean isAbsolutePath( String path) {
        if( path != null && path.indexOf("/") == 0)
            return true;
        else 
            return false;
    }


    public static boolean isRelativePath( String path ) {
        return !isAbsolutePath( path );
    }


    public static boolean isAttribute(String pathItem ) {
        if( pathItem.indexOf("@") == 0 ||
            pathItem.indexOf("/@") == 0 )
            return true;
        else 
            return false;
    }

    
    /**
     * Removes the attribute identifier from a path item, ex: from @attr 
     * will result attr, and from /@attr will still result attr.
     * @param pathItem a string as resulted from getFirstItem
     * @return the name of the attribute or null if it is not an attribute.
     */
    public static String getAttributeName( String pathItem ) {
        if( pathItem.startsWith("/@") )
            return pathItem.substring(2);
        if( pathItem.startsWith("@") )
            return pathItem.substring(1);
        return null;
    }


    public static String getElementName( String pathItem ) {
        if( pathItem.startsWith("/") )
            return pathItem.substring(1);
        return pathItem;
    }


    public static String getFirstItem( String path ) {
        String firstItem = null;
        String remainingItems = null;
        int startIdx = 1;

        if( path.startsWith("/@") )
            startIdx = 2;

        if( path.indexOf("/", startIdx) < path.indexOf("@", startIdx) &&
            path.indexOf("/", startIdx) != -1 ) {
            return  path.substring(0, path.indexOf("/", startIdx));
        }
        else 
            if( path.indexOf("@", startIdx) != -1 ) {
                return path.substring(0, path.indexOf("@", startIdx));
            }
            else if( path.indexOf("/", startIdx) != -1 ) {
                return path.substring(0, path.indexOf("/", startIdx));
            }            
            else {
                return path;
            }
    }


    public static String getRemainingItems( String path ) {
        String first = getFirstItem( path );
        if( first.length() == path.length() )
            return null;
        else 
            return path.substring( first.length());
    }

}
