/* 
 * $COPYRIGHT$
 * $Id: StreamResolver.java,v 1.1 2001/05/24 11:13:12 neuro Exp $
 *
 * Date        Author            Changes 
 * May 23 2001 Remus Pereni      Created
 */
package org.media.mn8.util;


import java.io.InputStream;
import java.io.PrintStream;
import java.io.IOException;


/**
 * Class meant to resolve divers types of input and 
 * output streams. The treams can be speciffied as:
 * <ul>
 * <li><b>"System.out", "System.err", "System.in"</b> in which
 * case the respective streams will be returned.</li>
 * <li><b>"file://url of file"</b> in which case the a
 * srem will be created and asociated with that file.</li>
 * <li><b>"Classname.methodname(parameters)" in which case a new
 * instance of the class will be created and the methodname with 
 * the parameters will be used to extract the stream</li>
 * </ul>
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.1 $ $Date: 2001/05/24 11:13:12 $
 */
public class StreamResolver {
    
    public static PrintStream resolveOutputStream( String specs ) {

        if ( specs.toLowerCase().equals("system.out") )
            return System.out;
        
        if ( specs.toLowerCase().equals("system.err") )
            return System.err;

        return null;
    }


    public static InputStream resolveInputStream (String specs) {
        if ( specs.toLowerCase().equals("system.in") )
            return System.in;        

        return null;
    }

}
