/* 
 * $COPYRIGHT$
 * $Id: MemoryContextTest.java,v 1.2 2001/05/18 19:51:15 neuro Exp $
 *
 * Date        Author            Changes 
 * May 04 2001 Remus Pereni      Created
 */
package org.media.naming;

import javax.naming.*;
import java.util.*;

/**
 * Simple calss to show the MemoryContext usage mode.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2001/05/18 19:51:15 $
 */
public class MemoryContextTest {

    private static Context _context;


    public MemoryContextTest () {
        Hashtable env = new Hashtable();
        env.put(Context.INITIAL_CONTEXT_FACTORY,
                "org.media.naming.MemoryContextFactory");

        env.put(Context.PROVIDER_URL,
                "env:/");

        try {
            _context = new InitialContext(env);        
        } catch (NamingException nex) {
            nex.printStackTrace();
            System.exit(0);
        }
    }

    public static Context getContext() {
        return _context;
    }

    public static void main (String args[] ) {
        MemoryContextTest mctx = new MemoryContextTest();
        Context ctx = mctx.getContext();
        try {
            System.out.println("Name in name space: " + ctx.getNameInNamespace());
            
            NamingEnumeration nenum = ctx.list("");
            System.out.println("In context we have: ");
            while ( nenum.hasMore() ) {
                System.out.println("Object: " + nenum.next().toString());
            }
            Context sbctx =  ctx.createSubcontext("env");
            System.out.println("created a subcontext with the name: env");
            nenum = ctx.list("");
            System.out.println("In context we have: ");
            while ( nenum.hasMore() ) {
                System.out.println("Object: " + nenum.next().toString());
            }

            Properties  prop = System.getProperties();
            Enumeration enum = prop.propertyNames();
            String name;
            while (enum.hasMoreElements()) {
                name = (String)enum.nextElement();
                sbctx.rebind(name, prop.getProperty(name));
            }

            nenum = sbctx.list("");
            System.out.println("In context we have: ");
            NameClassPair obj;
            while ( nenum.hasMore() ) {
                obj = (NameClassPair)nenum.next();
                System.out.println(obj.getName() +
                 " ->" + sbctx.lookup(obj.getName()));
//                 if (obj.getClass().isInstance(""))
//                     System.out.println("String: " + (String)obj);
//                 else
//                     System.out.println("Object: " + obj.toString());                

            }
            System.out.println("Name in name space: " + sbctx.getNameInNamespace());

        } catch (NamingException nex) {
            nex.printStackTrace();
            System.exit(0);
        }


    }


}
