/* 
 * $COPYRIGHT$
 * $Id: AllTests.java,v 1.14 2002/03/14 15:40:03 neuro Exp $
 *
 * Date        Author            Changes 
 * Apr 08 2001 Remus Pereni      Created
 */
package org.media.mn8.test;

import junit.framework.*;
/**
 * Class meant to run all the Test Suites related to mn8 project.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.14 $ $Date: 2002/03/14 15:40:03 $
 * @see String
 */
public class AllTests extends TestCase {

    public AllTests (String name){
        super (name);
    }

    public static Test suite () {
        TestSuite suite= new TestSuite("All JUnit Tests for mn8");
        
        suite.addTest (org.media.mn8.test.util.AllUtilTestSuite.suite());
        suite.addTest (org.media.mn8.test.parser.AllParserTestSuite.suite());
        suite.addTest (org.media.mn8.test.LogManagerTestCase.suite());        
        suite.addTest (org.media.mn8.test.mn8LoaderTestCase.suite());        
        suite.addTest (org.media.naming.test.AllNamingTestCase.suite());       
        suite.addTest (org.media.mn8.test.NamingManagerTestCase.suite());
        suite.addTest (org.media.mn8.test.conf.AllConfTestSuite.suite());
        suite.addTest (org.media.mn8.test.concepts.AllConceptsTestSuite.suite());
        
        return suite;
    }
    
    public static void main (String[] args) {
        if (args.length > 0 && args[0].equals("-gui")) {
            junit.swingui.TestRunner.run (AllTests.class);
        } 
        else {
            junit.textui.TestRunner.run (suite());
        } // end of else
    }

}
