/* 
 * $COPYRIGHT$
 * $Id: ConceptTestCase.java,v 1.2 2002/03/25 11:18:16 atech Exp $
 *
 * Date        Author            Changes 
 * May 10 2001 Remus Pereni      Created
 */
package org.media.mn8.test.concepts;

import junit.framework.*;
import org.media.mn8.*;
import org.media.mn8.concepts.*;


/**
 * Class implementing a Test Case for the mnuLoader class.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.2 $ $Date: 2002/03/25 11:18:16 $
 */
public class ConceptTestCase extends TestCase {

    private static ConceptDefinition _conceptDefinition =
                                            mn8Loader.getConceptDefinition("Concept"); 
    private static Concept _concept = null;


    public ConceptTestCase (String name){
        super (name);
    }


    public static Test suite () {
        TestSuite suite = new TestSuite();
        suite.addTest(new ConceptTestCase("Concept_conceptDefinitionRetrieval"));
        suite.addTest(new ConceptTestCase("Concept_getConceptInstance"));
        suite.addTest(new ConceptTestCase("Concept_getConceptType"));
        suite.addTest(new ConceptTestCase("Concept_getConceptLabel"));
        suite.addTest(new ConceptTestCase("Concept_getInheritedConcepts"));
        suite.addTest(new ConceptTestCase("Concept_extendsConcept"));
        return suite;
    }


    public void Concept_conceptDefinitionRetrieval() {
        assertNotNull( _conceptDefinition );
    }


    public void Concept_getConceptInstance() {
        _concept = _conceptDefinition.getConceptInstance();
        assertNotNull( _concept );
        _concept = _concept.getConceptInstance();
        assertNotNull( _concept );
    }


    public void Concept_getConceptType() {
        assertTrue( _concept.getConceptType().getValue().equals("Concept"));
    }


    public void Concept_getConceptLabel() {
        assertTrue( _concept.getConceptLabel().getValue().equals(""));
    }


    public void Concept_getInheritedConcepts() {
        assertEquals( _concept.getInheritedConcepts().getValue().size(), 0);
    }


    public void Concept_extendsConcept() {
        assertEquals( _concept.extendsConcept(new StringConcept("Concept")).getValue()
                     , true);
        assertEquals( _concept.extendsConcept(new StringConcept("String")).getValue()
                     , false );
    }

    
    public static void main (String[] args) {
        junit.textui.TestRunner.run (suite());
    }
}
