/* 
 * $COPYRIGHT$
 * $Id: StringTestCase.java,v 1.3 2002/03/25 11:18:16 atech Exp $
 *
 * Date        Author            Changes 
 * May 10 2001 Remus Pereni      Created
 */
package org.media.mn8.test.concepts;

import junit.framework.*;
import org.media.mn8.*;
import org.media.mn8.concepts.*;


/**
 * Class implementing a Test Case for the String concept.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/03/25 11:18:16 $
 */
public class StringTestCase extends TestCase {

    private static ConceptDefinition _conceptDefinition =
                                            mn8Loader.getConceptDefinition("String"); 
    private static Concept _concept = null;


    public StringTestCase (String name){
        super (name);
    }


    public static Test suite () {
        TestSuite suite = new TestSuite();
        suite.addTest(new StringTestCase("String_conceptDefinitionRetrieval"));
        suite.addTest(new StringTestCase("String_getConceptInstance"));
        suite.addTest(new StringTestCase("String_getConceptType"));
        suite.addTest(new StringTestCase("String_getConceptLabel"));
        suite.addTest(new StringTestCase("String_getInheritedConcepts"));
        suite.addTest(new StringTestCase("String_extendsConcept"));
        return suite;
    }


    public void String_conceptDefinitionRetrieval() {
        assertNotNull( _conceptDefinition );
    }


    public void String_getConceptInstance() {
        _concept = _conceptDefinition.getConceptInstance();
        assertNotNull( _concept );
        _concept = _concept.getConceptInstance();
        assertNotNull( _concept );
    }


    public void String_getConceptType() {
        assertTrue( _concept.getConceptType().getValue().equals("String"));
    }


    public void String_getConceptLabel() {
        assertTrue( _concept.getConceptLabel().getValue().equals("String"));
    }


    public void String_getInheritedConcepts() {
        assertEquals( _concept.getInheritedConcepts().getValue().size(), 1);
    }


    public void String_extendsConcept() {
        assertEquals( _concept.extendsConcept(new StringConcept("Concept")).getValue()
                     , true);
        assertEquals( _concept.extendsConcept(new StringConcept("String")).getValue()
                     , true );
        assertEquals( _concept.extendsConcept(new StringConcept("Integer")).getValue()
                     , false );
    }

    
    public static void main (String[] args) {
        junit.textui.TestRunner.run (suite());
    }
}
