/* 
 * $COPYRIGHT$
 * $Id: NamingConfTestCase.java,v 1.3 2002/03/25 11:18:16 atech Exp $
 *
 * Date        Author            Changes 
 * May 04 2001 Remus Pereni      Created
 */
package org.media.mn8.test.conf;

import junit.framework.*;
import org.media.mn8.conf.NamingConf;
import java.util.Hashtable;

/**
 * Class meant to run all the Test Cases related to mn8 naming config.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.3 $ $Date: 2002/03/25 11:18:16 $
 */
public class NamingConfTestCase extends TestCase {
    
    private static NamingConf _namingConf;
    

    public NamingConfTestCase (String name){
        super (name);
    }



    public static Test suite () {
        TestSuite suite = new TestSuite();
        suite.addTest(new NamingConfTestCase("namingConfCreate"));
        suite.addTest(new NamingConfTestCase("namingConfReadInitFactory"));
        suite.addTest(new NamingConfTestCase("namingConfEnvLoad"));
        return suite;
    }
    
    public void namingConfCreate () {
        try {
            _namingConf = NamingConf.getReference();
            if (_namingConf != null) assertTrue(true);
            else assertTrue(false);
        } catch (RuntimeException ex){
            ex.printStackTrace();
            assertTrue (false);
        }
    }

    public void namingConfReadInitFactory () {
        Hashtable _env = _namingConf.getInitialContextProperties();        
        if ( _env != null &&
             _env.contains("org.media.naming.MemoryContextFactory") &&
             _env.contains("env:/"))
            assertTrue (true);
        else assertTrue (false);
    }


    public void namingConfEnvLoad () {
        Hashtable _env = _namingConf.getEnvProperties();        
        if ( _env != null)  assertTrue (true);
        else assertTrue (false);
    }


}
