/* 
 * $COPYRIGHT$
 * $Id: mn8LoaderTestCase.java,v 1.4 2002/03/25 11:18:16 atech Exp $
 *
 * Date        Author            Changes 
 * May 10 2001 Remus Pereni      Created
 */
package org.media.mn8.test;

import junit.framework.*;
import java.io.*;
import org.media.mn8.*;
import org.media.mn8.concepts.*;


/**
 * Class implementing a Test Case for the mnuLoader class.
 * @author <a href="mailto:remus@nolimits.ro">Remus Pereni</a>
 * @version $Revision: 1.4 $ $Date: 2002/03/25 11:18:16 $
 */
public class mn8LoaderTestCase extends TestCase {

    public mn8LoaderTestCase (String name){
        super (name);
    }


    public static Test suite () {
        return new TestSuite (mn8LoaderTestCase.class);
    }

    public void testInstantiateConceptByName() {
        boolean result = true;
        JavaConcept concept;
        concept = mn8Loader.instantiateConcept( "String");

      if ( !concept.getConceptType().getValue().equals("String"))
        result = false;

        assertTrue(result);
    }

    public void testIsConceptAvailable() {
        boolean result = true;
        
        result = mn8Loader.isConceptAvailable("String");
        result = !mn8Loader.isConceptAvailable("Ubahj_jhjkasdh_jdsjdhf");
        assertTrue(result);
    }


    public static void main (String[] args) {
        junit.textui.TestRunner.run (suite());
    }
}
